/***************************************************************************
 * RCS INFORMATION:
 *
 *	$RCSfile: qs.c,v $
 *	$Author: sanjeev $	$Locker:  $		$State: Exp $
 *	$Revision: 1.5 $	$Date: 1995/04/02 00:45:57 $
 *
 ***************************************************************************
 * DESCRIPTION:
 *
 ***************************************************************************
 * REVISION HISTORY:
 *
 * $Log: qs.c,v $
 * Revision 1.5  1995/04/02  00:45:57  sanjeev
 * changes for separating Converse
 *
 * Revision 1.4  1995/03/26  00:22:54  sanjeev
 * fixed 2 bugs
 *
 * Revision 1.3  1995/03/24  20:43:50  milind
 * common functions for fifo/lifo/fifolifo
 *
 ***************************************************************************/
static char ident[] = "@(#)$Header: /home/kale/milind/RCS/qs.c,v 1.5 1995/04/02 00:45:57 sanjeev Exp $";

/*
#include "chare.h"
*/
#include <stdio.h>
#include "machine.h"
#include "queue.h"

static Element **
AllocBlock(len)
unsigned int len;
{
	Element ** blk;

	blk = (Element **) AllocFn(len*sizeof(Element *));
	if ( blk == NULL )
		CkPrintf("ERROR : Unable to allocate memory in qs\n") ;
	return blk;
}

static void
SpillBlock(srcblk, destblk, first, len)
Element **srcblk, **destblk;
unsigned int first, len;
{
	memcpy(destblk, &srcblk[first], (len-first)*sizeof(Element *));
	memcpy(&destblk[len-first],srcblk,first*sizeof(Element *));
}

Queue *
QueueCreate()
{
	Queue *queue;

	queue = (Queue *) AllocFn(sizeof(Queue));
	if ( queue == NULL )
		CkPrintf("ERROR : Unable to allocate memory in qs\n") ;
	queue->blk = AllocBlock(BLK_LEN);
	queue->blklen = BLK_LEN;
	queue->first = 0;
	queue->len = 0;
	queue->maxlen = 0;
	return queue;
}

unsigned int
QueueLength(queue)
Queue *queue;
{
	return queue->len;
}

unsigned int
QueueMaxLength(queue)
Queue *queue;
{
	return queue->maxlen;
}

Boolean
QueueEmpty(queue)
Queue *queue;
{
	return (queue->len==0);
}

void
QueueAddToBack(queue, element)
Queue *queue;
Element *element;
{
	if(queue->len==queue->blklen)
	{
		Element **blk;

		queue->blklen *= 3;
		blk = AllocBlock(queue->blklen);
		SpillBlock(queue->blk, blk, queue->first, queue->len);
		FreeFn(queue->blk);
		queue->blk = blk;
		queue->first = 0;
	}
	queue->blk[(queue->first+queue->len++)%queue->blklen] = element;
	if(queue->len>queue->maxlen)
		queue->maxlen = queue->len;
}

void
QueueAddToFront(queue, element)
Queue *queue;
Element *element;
{
	if(queue->len==queue->blklen)
	{
		Element **blk;

		queue->blklen *= 3;
		blk = AllocBlock(queue->blklen);
		SpillBlock(queue->blk, blk, queue->first, queue->len);
		FreeFn(queue->blk);
		queue->blk = blk;
		queue->first = 0;
	}
	queue->first = (queue->first + queue->blklen - 1) % queue->blklen;
	queue->len++;
	queue->blk[queue->first] = element;
	if(queue->len>queue->maxlen)
		queue->maxlen = queue->len;
}

void
QueueRemoveFromBack(queue, element)
Queue *queue;
Element **element;
{
	*element = (Element *) 0;
	if(queue->len)
		*element=queue->blk[(queue->first+queue->len--)%queue->blklen];
}

void
QueueRemoveFromFront(queue, element)
Queue *queue;
Element **element;
{
	*element = (Element *) 0;
	if(queue->len)
	{
		*element = queue->blk[queue->first++];
		queue->first = (queue->first+queue->blklen)%queue->blklen;
		queue->len--;
	}
}




typedef unsigned int    PVECTOR;

PVECTOR *
QueueMyPriority(queue)
Queue *queue;
{
}

PVECTOR *
QueueMySecondPriority(queue)
Queue *queue;
{
}
