#ifndef lint
static char yysccsid[] = "@(#)yaccpar	1.8 (Berkeley) 01/02/91\n\
 Modified 5/15/91 by J. Roskind to support graphic debugging modes";
#endif
#define YYBYACC 1
#line 2 "t.y"

/*  Copyright (C) 1989-1991 James A. Roskind, All rights reserved. 
    This grammar was developed  and  written  by  James  A.  Roskind. 
    Copying  of  this  grammar  description, as a whole, is permitted 
    providing this notice is intact and applicable  in  all  complete 
    copies.   Translations as a whole to other parser generator input 
    languages  (or  grammar  description  languages)   is   permitted 
    provided  that  this  notice is intact and applicable in all such 
    copies,  along  with  a  disclaimer  that  the  contents  are   a 
    translation.   The reproduction of derived text, such as modified 
    versions of this grammar, or the output of parser generators,  is 
    permitted,  provided  the  resulting  work includes the copyright 
    notice "Portions Copyright (c)  1989,  1990  James  A.  Roskind". 
    Derived products, such as compilers, translators, browsers, etc., 
    that  use  this  grammar,  must also provide the notice "Portions 
    Copyright  (c)  1989,  1990  James  A.  Roskind"  in   a   manner 
    appropriate  to  the  utility,  and in keeping with copyright law 
    (e.g.: EITHER displayed when first invoked/executed; OR displayed 
    continuously on display terminal; OR via placement in the  object 
    code  in  form  readable in a printout, with or near the title of 
    the work, or at the end of the file).  No royalties, licenses  or 
    commissions  of  any  kind are required to copy this grammar, its 
    translations, or derivative products, when the copies are made in 
    compliance with this notice. Persons or corporations that do make 
    copies in compliance with this notice may charge  whatever  price 
    is  agreeable  to  a  buyer, for such copies or derivative works. 
    THIS GRAMMAR IS PROVIDED ``AS IS'' AND  WITHOUT  ANY  EXPRESS  OR 
    IMPLIED  WARRANTIES,  INCLUDING,  WITHOUT LIMITATION, THE IMPLIED 
    WARRANTIES  OF  MERCHANTABILITY  AND  FITNESS  FOR  A  PARTICULAR 
    PURPOSE.

    James A. Roskind
    Independent Consultant
    516 Latania Palm Drive
    Indialantic FL, 32903
    (407)729-4348
    jar@hq.ileaf.com


    ---end of copyright notice---
*/

/*

1) template support: Not  done:  pending  syntax  specification  from 
ANSI.  (This looks like a major effort, as ANSI has decided to extend 
the  "TYPEDEFname"-feedback-to-the-lexer-hack  to  support   template 
names as a new kind of terminal token.)

2)  exception  handling:  Not done: pending syntax specification from 
ANSI (but it doesn't look hard)

done: 3) Support nested types, including identifier::name,  where  we 
realize  that  identifier was a hidden type.  Force the lexer to keep 
pace in this situation.   This  will  require  an  extension  of  the 
yacc-lex feedback loop.

done: 4) Support nested types even when derivations are used in class 
definitions.

done: 6) Allow declaration specifiers to be left out of  declarations 
at file and structure scope so that operator conversion functions can 
be  declared and/or defined.  Note that checking to see that it was a 
function type that does not require declaration_specifiers is  now  a 
constraint  check,  and  not  a  syntax  issue.  Within function body 
scopes, declaration specifiers are required, and this is critical  to 
distinguishing expressions.

*/

#line 152 "t.y"
/*************** Includes and Defines *****************************/
#define YYDEBUG_LEXER_TEXT (yylval) /* our lexer loads this up each time.
				     We are telling the graphical debugger
				     where to find the spelling of the 
				     tokens.*/
#define YYDEBUG 1        /* get the pretty debugging code to compile*/
#define YYSTYPE  char *  /* interface with flex: should be in header file */



#include "t.h" 

StackStruct *StackTop=NULL ;
StackStruct *GlobalStack=NULL ;

AggState *PermanentAggTable[MAXAGGS] ;  
int PermanentAggTableSize = 0 ;
/* this table is only added to, never deleted from. It stores the objects
   defined in an aggregate type. 					  */
					

/* These tables just hold lists of Chares,BOCs,Accs ... */
ChareInfo * ChareTable[MAXCHARES] ;
ChareInfo * BOCTable[MAXCHARES] ;
MsgStruct MessageTable[MAXMSGS] ;
AccStruct * AccTable[MAXACCS] ;
AccStruct * MonoTable[MAXACCS] ;
char * DTableTable[MAXDTABLES] ;
char * ReadTable[MAXREADS] ;
char * ReadMsgTable[MAXREADS] ;
FunctionStruct FunctionTable[MAX_FUNCTIONS] ;
int charecount = -1 ;
int boccount = -1 ;
int TotalEntries = 0 ;
int TotalMsgs = 0 ;
int TotalAccs = 0 ;
int TotalMonos = 0 ;
int TotalDTables = 0 ;
int TotalReadMsgs = 0 ;
int TotalReads = 0 ;
int TotalFns = 0 ;

/* This table is used to distinguish between typedefs and idents */
SymEntry SymTable[MAXSYMBOLS] ;
int TotalSyms = 0 ;

/* the following three tables store all handle identifiers and their types */
HandleEntry ChareHandleTable[MAXIDENTS] ;
HandleEntry BOCHandleTable[MAXIDENTS] ;
HandleEntry AccHandleTable[MAXIDENTS] ;
HandleEntry MonoHandleTable[MAXIDENTS] ;
HandleEntry WrOnHandleTable[MAXIDENTS] ;
int ChareHandleTableSize = 0 ;
int BOCHandleTableSize = 0 ;
int AccHandleTableSize = 0 ;
int MonoHandleTableSize = 0 ;
int WrOnHandleTableSize = 0 ;

/* char modname[MAX_NAME_LENGTH] ;  */

char OutBuf[MAX_OUTBUF_SIZE] ;

int CurrentLine=1 ;
int CurrentScope = 0 ; 	/* 1 means file scope, > 1 means inside a block */
char CurrentFileName[MAX_NAME_LENGTH] = {'\0'} ;
int CurrentAccess = -1, CurrentAggType = -1, CurrentStorage = -1 ;
int CurrentCharmType = -1 ;
int CurrentCharmNameIndex = -1 ;
char CurrentTypedef[MAX_NAME_LENGTH] = {'\0'} ;
char CurrentDeclType[MAX_NAME_LENGTH] = {'\0'} ;
char CurrentAggName[MAX_NAME_LENGTH] = {'\0'} ;
char CurrentChare[MAX_NAME_LENGTH] = {'\0'} ; 
char CurrentEP[MAX_NAME_LENGTH] = {'\0'} ;
char CurrentFn[MAX_NAME_LENGTH] = {'\0'} ;
char CurrentMsgParm[MAX_NAME_LENGTH] = {'\0'} ;
char CurrentSharedHandle[MAX_NAME_LENGTH] = {'_','C','K','_','N','O','T','A','C','C','H','A','N','D','L','E'} ;
AccStruct *CurrentAcc ;
ChareInfo *CurrentCharePtr ;
char CurrentAssOp[5] ;
char CurrentAsterisk[5] ;
char *EpMsg=NULL ;
char SendEP[MAX_NAME_LENGTH] ;
char SendChare[MAX_NAME_LENGTH] ;
char SendPe[MAX_NAME_LENGTH] ;
char LastChare[MAX_NAME_LENGTH] ;
char LastEP[MAX_NAME_LENGTH] ;
char LastArg[MAX_NAME_LENGTH] ;
char *ParentArray[MAX_PARENTS] ;
int SendType = -1 ;
int main_argc_argv = FALSE ;
int foundargs = FALSE ;
int numparents = 0 ;
int SendMsgBranchPoss = FALSE ;
int FoundHandle = FALSE ;
int FilledAccMsg = FALSE ;
int FoundConstructorBody = FALSE ;
int IsMonoCall = FALSE ;
int IsAccCall = FALSE ;
int FoundParms = FALSE ;
int FoundLocalBranch = FALSE ;
int AddedScope = 0 ;
int FoundGlobalScope = 0 ;
int FoundTable = FALSE ;
int FoundVarSize = FALSE ;
int FoundReadOnly = FALSE ;
int StructScope = FALSE ;
int AccFnScope = -1 ;
int FoundAccFnDef = FALSE ;
/*
int MonoFnScope = -1 ;
int FoundMonoFnDef = FALSE ;
*/
int MakeGraph = FALSE ;
int InsideChareCode = FALSE ;

int ErrVal = FALSE ;

char CoreName[MAX_NAME_LENGTH] ;
int shouldprint=1 ;
char prevtoken[256] ;
FILE *outfile, *headerfile, *graphfile ;

extern int FoundLBrace, FoundRBrace ;

extern char *CheckSendError() ;
extern char *Mystrstr() ;
extern EP *SearchEPList() ;
extern char *Concat2() ;
extern char *Concat3() ;

#line 209 "y.tab.c"
#define CHARE 257
#define BRANCHED 258
#define MESSAGE 259
#define HANDLE 260
#define ENTRY 261
#define DOUBLEARROW 262
#define ALL_NODES 263
#define LOCAL 264
#define ACCUMULATOR 265
#define MONOTONIC 266
#define READONLY 267
#define WRITEONCE 268
#define AUTO 269
#define DOUBLE 270
#define INT 271
#define STRUCT 272
#define BREAK 273
#define ELSE 274
#define LONG 275
#define SWITCH 276
#define CASE 277
#define ENUM 278
#define REGISTER 279
#define TYPEDEF 280
#define CHAR 281
#define EXTERN 282
#define RETURN 283
#define UNION 284
#define CONST 285
#define FLOAT 286
#define SHORT 287
#define UNSIGNED 288
#define WCHAR_TOKEN 289
#define CONTINUE 290
#define FOR 291
#define SIGNED 292
#define VOID 293
#define DEFAULT 294
#define GOTO 295
#define SIZEOF 296
#define VOLATILE 297
#define DO 298
#define IF 299
#define STATIC 300
#define WHILE 301
#define NEW 302
#define DELETE 303
#define THIS 304
#define OPERATOR 305
#define CLASS 306
#define PUBLIC 307
#define PROTECTED 308
#define PRIVATE 309
#define VIRTUAL 310
#define FRIEND 311
#define INLINE 312
#define UNDERSCORE_INLINE 313
#define OVERLOAD 314
#define IDENTIFIER 315
#define STRINGliteral 316
#define FLOATINGconstant 317
#define INTEGERconstant 318
#define CHARACTERconstant 319
#define OCTALconstant 320
#define HEXconstant 321
#define TYPEDEFname 322
#define ARROW 323
#define ICR 324
#define DECR 325
#define LS 326
#define RS 327
#define LE 328
#define GE 329
#define EQ 330
#define NE 331
#define ANDAND 332
#define OROR 333
#define ELLIPSIS 334
#define CLCL 335
#define DOTstar 336
#define ARROWstar 337
#define MULTassign 338
#define DIVassign 339
#define MODassign 340
#define PLUSassign 341
#define MINUSassign 342
#define LSassign 343
#define RSassign 344
#define ANDassign 345
#define ERassign 346
#define ORassign 347
#define YYERRCODE 256
short yylhs[] = {                                        -1,
    1,    1,    1,    1,    1,    2,    2,    3,    3,    3,
    6,    6,    6,    6,    6,    6,   10,   10,   10,   10,
   10,   10,   16,   16,   16,   19,   19,   19,   17,   17,
   17,   17,   17,   17,   17,   17,   17,   17,   17,   17,
   17,   17,   17,   17,   17,   17,   17,   17,   17,   17,
   17,   17,   17,   17,   17,   17,   17,   17,   17,   17,
   23,   23,   24,   24,   24,   24,   26,   24,   28,   29,
   24,   24,   24,   30,   24,   31,   24,   32,   24,   24,
   24,   24,   24,   24,   27,   27,   27,   27,   27,   25,
   25,   35,   35,   35,   35,   35,   35,   35,   35,   35,
   35,   35,   38,   38,   38,   38,   39,   39,   41,   41,
   43,   43,   43,   43,   44,   44,   44,   40,   40,   40,
   36,   36,   45,   45,   45,   45,   46,   46,   47,   47,
   47,   48,   48,   48,   48,   49,   49,   49,   50,   50,
   50,   51,   51,   51,   51,   51,   52,   52,   52,   53,
   53,   54,   54,   55,   55,   56,   56,   57,   57,   58,
   58,   33,   33,   22,   22,   22,   22,   22,   22,   22,
   22,   22,   22,   22,    9,    9,   59,   60,   60,   61,
   61,   61,   61,   61,   61,   68,   63,   69,   63,   70,
   63,   63,   63,   63,   74,   62,   76,   62,   77,   62,
   78,   62,   79,   62,   80,   62,   62,   62,   62,   62,
   62,   62,   81,   81,   81,   81,   81,   81,   81,   83,
   83,   83,   83,   86,   86,   86,   86,   71,   71,   71,
   82,   82,   82,   82,   72,   72,   72,   75,   75,   75,
   75,   34,   34,   34,   18,   18,   93,   93,   94,   94,
   94,   90,   90,   90,   90,   90,   12,   12,   12,   12,
   12,   64,   64,   64,   64,   64,   65,   65,   65,   11,
   11,   11,   91,   91,   91,   91,   91,   91,   13,   13,
   13,   13,   13,   92,   92,   92,   92,   92,   92,   92,
   92,   92,   92,   14,   14,   14,   14,   14,   14,   14,
   14,   14,   14,   96,   96,   95,   95,  102,  104,  105,
   97,   97,   99,   99,   99,   99,  101,  101,  101,  110,
  110,  111,  111,  111,  115,  115,  113,  113,  114,  114,
  114,  114,  106,  106,  106,  106,  106,  106,  106,  106,
  103,  103,  116,  116,  116,  116,  116,  116,  116,  116,
  116,  116,  118,  118,  118,  118,  118,  118,  117,  123,
  117,  117,  117,  117,  117,  117,  117,  117,  117,  117,
  124,  124,  124,  124,  124,  124,  124,  127,  127,  127,
  127,  127,  127,  127,  127,  127,  127,  127,  127,  127,
  128,  128,  128,  128,  128,  128,  128,  128,  121,  121,
  125,  129,  125,  122,  130,  122,   98,   98,  100,  131,
  131,  132,  132,  133,  133,  134,  134,  135,  135,  136,
  136,  136,  136,  139,  139,  139,  139,  138,  138,  138,
  138,  138,  141,  141,  140,  140,  140,  140,  140,  143,
  143,  143,  143,  142,  142,  142,  142,  142,  142,  142,
  142,  142,  142,  142,  142,  142,  142,  142,  142,   37,
   37,   37,   37,   37,   37,   37,   37,   37,   37,   67,
   67,  137,  145,  145,  145,  146,  146,  147,  147,  147,
  147,  147,  147,  147,  148,  148,  148,  156,  157,  149,
  158,  158,  155,  155,  150,  151,  151,  151,  159,  159,
  160,  152,  161,  152,  152,  162,  152,  163,  152,  152,
  164,  152,  153,  153,  153,  153,  154,  154,    0,    0,
  165,  165,  165,  165,  165,  165,  169,  170,  165,  168,
  166,  166,  167,  167,  167,  174,  119,  175,  119,  176,
  119,  177,  119,  178,  119,  179,  119,  180,  119,  181,
  119,  182,  119,  183,  119,  186,  172,  187,  172,  188,
  172,  189,  172,  190,  172,  191,  172,  192,  172,  193,
  172,  185,  185,  195,  173,  173,  171,  171,  120,  120,
  196,  196,  196,  197,  196,  198,  196,  199,  196,  196,
  200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
  200,  200,  200,  200,  200,  200,  200,  200,  200,  201,
  201,  201,  201,  201,  201,  194,  194,  204,  204,  205,
  205,  205,  205,  205,  205,  205,  205,   73,   73,  206,
  206,  206,  126,  126,  126,   88,   88,   88,  207,  207,
   87,   87,   87,   87,   87,   87,   87,  208,  208,  208,
  208,   84,   84,   66,   66,   89,   89,   89,  209,  209,
  209,  184,  184,  184,  210,  210,  210,  211,  211,  144,
  144,  144,   85,   85,  212,  212,  212,  202,  202,  202,
  202,  203,  203,  203,  203,   21,   21,   21,   20,   20,
  213,  213,  109,  109,  107,  107,  214,  108,   42,   42,
   42,    4,    4,    5,    5,  215,  215,    7,    7,    8,
    8,  216,   15,   15,   15,  112,  112,
};
short yylen[] = {                                         2,
    1,    1,    1,    1,    1,    1,    2,    1,    1,    3,
    1,    1,    1,    1,    1,    3,    1,    1,    1,    1,
    1,    1,    2,    3,    3,    0,    2,    2,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    2,    2,    1,    1,    1,
    0,    1,    1,    4,    3,    4,    0,    4,    0,    0,
    5,    2,    2,    0,    7,    0,    4,    0,    7,    3,
    3,    4,    4,    4,    1,    1,    4,    4,    4,    1,
    3,    1,    2,    2,    2,    2,    2,    2,    2,    2,
    4,    1,    5,    8,    2,    5,    1,    2,    3,    3,
    0,    1,    2,    2,    2,    3,    4,    0,    2,    3,
    1,    4,    1,    2,    5,    4,    1,    2,    1,    3,
    3,    1,    3,    3,    3,    1,    3,    3,    1,    3,
    3,    1,    3,    3,    3,    3,    1,    3,    3,    1,
    3,    1,    3,    1,    3,    1,    3,    1,    3,    1,
    5,    1,    3,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    3,    1,    0,    1,    2,
    2,    2,    2,    2,    2,    0,    4,    0,    4,    0,
    5,    2,    2,    3,    0,    4,    0,    4,    0,    4,
    0,    4,    0,    4,    0,    5,    2,    2,    2,    2,
    2,    3,    1,    1,    4,    5,    1,    2,    2,    6,
    7,    7,    7,    4,    5,    6,    7,    1,    2,    2,
    4,    5,    6,    7,    1,    1,    1,    1,    1,    1,
    1,    1,    2,    2,    1,    2,    1,    1,    1,    1,
    1,    2,    2,    2,    2,    2,    2,    2,    2,    2,
    2,    2,    2,    2,    2,    2,    1,    2,    2,    1,
    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
    2,    2,    2,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    0,    0,    0,
    8,    5,    2,    4,    3,    3,    0,    2,    2,    1,
    3,    1,    3,    3,    0,    1,    0,    1,    1,    1,
    1,    1,    1,    1,    1,    2,    3,    1,    2,    2,
    0,    2,    2,    2,    2,    1,    1,    2,    2,    2,
    2,    2,    3,    3,    4,    2,    2,    3,    3,    0,
    4,    3,    1,    4,    2,    2,    2,    2,    2,    3,
    3,    3,    3,    3,    3,    3,    1,    6,    6,    6,
    6,    4,    4,    6,    6,    6,    6,    4,    4,    1,
    5,    6,    6,    6,    5,    6,    6,    6,    0,    2,
    1,    0,    4,    2,    0,    4,    4,    4,    2,    1,
    2,    1,    2,    2,    4,    1,    1,    0,    2,    3,
    4,    5,    4,    2,    3,    4,    3,    1,    2,    2,
    3,    1,    1,    2,    1,    2,    3,    4,    3,    1,
    2,    1,    2,    1,    2,    2,    2,    1,    2,    2,
    2,    2,    2,    2,    2,    2,    2,    2,    2,    1,
    1,    1,    1,    1,    2,    2,    2,    2,    2,    0,
    1,    2,    3,    4,    1,    1,    3,    1,    1,    1,
    1,    1,    1,    1,    3,    4,    3,    0,    0,    5,
    1,    2,    0,    2,    2,    3,    5,    3,    3,    3,
    0,    6,    0,    6,    7,    0,    8,    0,   10,    8,
    0,    6,    3,    2,    2,    3,    1,    1,    0,    2,
    1,    1,    1,    2,    2,    2,    0,    0,    6,    2,
    2,    2,    1,    1,    1,    0,    3,    0,    4,    0,
    4,    0,    4,    0,    4,    0,    4,    0,    4,    0,
    4,    0,    4,    0,    4,    0,    3,    0,    4,    0,
    4,    0,    4,    0,    4,    0,    4,    0,    4,    0,
    4,    2,    1,    0,    5,    4,    2,    2,    2,    2,
    4,    6,    5,    0,    6,    0,    8,    0,    7,    1,
    5,    5,    5,    5,    5,    6,    6,    6,    6,    6,
    6,    6,    6,    6,    7,    7,    7,    7,    1,    6,
    7,    6,    7,    6,    7,    0,    1,    2,    3,    4,
    3,    4,    3,    4,    3,    3,    2,    1,    1,    1,
    1,    1,    1,    2,    1,    1,    2,    2,    3,    4,
    1,    4,    4,    4,    4,    2,    2,    3,    4,    4,
    4,    3,    3,    1,    1,    1,    2,    2,    2,    3,
    4,    1,    2,    2,    4,    3,    4,    1,    1,    1,
    1,    1,    1,    1,    2,    3,    4,    1,    1,    2,
    2,    3,    3,    3,    4,    1,    1,    1,    3,    2,
    1,    2,    2,    3,    1,    1,    0,    2,    1,    1,
    2,    1,    2,    1,    2,    2,    1,    2,    1,    2,
    1,    2,    1,    2,    2,    1,    1,
};
short yydefred[] = {                                    519,
    0,    0,    0,    0,  338,  688,    0,    0,  251,  287,
  300,  294,  333,  297,  410,  288,  285,  295,    0,  334,
  249,  298,  296,  302,  299,  301,  303,  250,  286,    0,
  335,  293,  289,  291,  292,  290,    0,    0,    0,  686,
  687,    0,    0,    8,    9,    0,    0,    0,    0,    0,
  707,    0,    0,    0,    0,    0,  523,    0,    0,    0,
    0,    0,    0,    0,  654,    0,    0,  242,  245,  270,
  267,  304,  305,    0,    0,    0,  691,    0,    0,  533,
    0,  520,  521,  522,    0,    0,  534,  535,  556,  656,
  662,    0,    0,  704,  713,  185,  336,    0,  339,  340,
  530,   58,   59,  695,    0,   45,   49,   50,   41,   42,
   51,   52,   53,   54,   43,   44,   48,   46,  165,  166,
  167,  168,  169,  170,  171,  172,  173,  174,    0,   29,
   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,
   40,   47,    0,   60,  164,    0,    0,    0,    0,    0,
    0,   23,    0,   55,  306,  307,    0,    0,    0,  284,
    0,    0,    0,    0,    0,  628,    0,  210,  213,  214,
    0,  217,  630,  635,  276,  281,    0,    0,  632,  564,
  629,  636,  641,  696,    0,    0,    0,  706,    0,    0,
  659,  674,    0,  183,  264,  272,  261,  253,  260,  275,
  283,  546,  258,    0,  209,  254,  259,  562,    0,    0,
  211,  277,  282,    0,  566,    0,    0,  257,  280,    0,
    0,    0,  193,  228,  243,  246,  271,  268,  570,  658,
  664,    0,  657,  663,    0,  252,  274,    0,  192,  247,
  244,  248,  262,  263,  568,  411,    0,  180,    0,  181,
  182,  266,  184,  265,  269,  531,    0,  540,    0,  207,
    0,  558,    0,  208,  560,  256,  255,  278,    0,  308,
    0,    0,    0,    0,    0,    0,  714,    0,    0,    0,
    0,    0,  705,    0,  409,  527,  526,  524,  525,  532,
    0,  693,  698,  337,   56,   57,   25,    0,    0,    0,
   24,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  219,    0,  647,  638,    0,
  218,  646,  637,    0,    0,    0,    0,  692,    0,   10,
    0,    0,    0,  107,  127,   13,    6,    2,    1,    5,
    3,    4,    0,    0,    0,  432,    0,    0,    0,    0,
    0,    0,   14,    0,  709,  711,   63,   11,   12,    0,
    0,    0,    0,    0,    0,    0,   90,    0,    0,  123,
    0,  102,    0,    0,  129,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  162,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  675,    0,
    0,  121,    0,  177,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  574,    0,
    0,  230,  229,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  205,  212,    0,    0,    0,  190,  194,
  488,  537,    0,    0,    0,    0,    0,    0,    0,    0,
  319,  332,  329,  331,  330,    0,    0,  717,    0,    0,
    0,  320,  322,    0,    0,  416,  417,    0,    0,    0,
  341,    0,    0,    0,  689,    0,  694,    0,  519,    0,
    0,    0,    0,    0,  491,    0,    0,  573,    0,  557,
   27,   28,    0,    0,    0,  652,    0,    0,    0,    0,
    0,    0,    0,    0,  653,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  202,  471,  549,    0,
    0,  565,  661,    0,  669,  667,    0,    0,  100,    0,
    0,    0,    0,    0,  455,  672,  456,  467,  670,  671,
    0,   93,   94,    0,    0,    0,    0,    0,    0,    0,
    0,  175,    0,    0,    0,  420,   97,   96,    0,   98,
   99,    7,    0,  453,  454,  466,    0,  457,  458,  468,
    0,    0,    0,  459,  469,   95,   76,   72,   73,    0,
    0,    0,    0,  665,    0,  450,  449,    0,  433,    0,
    0,    0,  430,    0,    0,    0,  105,  108,  128,    0,
  124,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  446,  447,  445,  451,  452,  465,  708,
  710,    0,    0,    0,  429,  436,    0,    0,    0,  676,
    0,    0,  547,  200,  545,  563,    0,  204,  551,    0,
    0,    0,    0,  618,    0,    0,  567,  189,  555,  571,
  187,  553,  569,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  493,  541,  196,  539,  576,
  559,  198,  543,  561,    0,  328,    0,  326,    0,  309,
  408,    0,    0,  414,    0,    0,  407,    0,  201,  199,
  203,  188,  186,  195,  197,  492,  572,  224,    0,    0,
    0,    0,    0,    0,    0,  634,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  475,  472,  215,    0,  424,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  681,  680,    0,    0,    0,   16,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   65,    0,    0,    0,
    0,    0,   70,   91,  163,  421,  434,    0,    0,  437,
    0,    0,  431,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  130,  131,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  423,  439,   80,   81,  677,    0,
    0,  627,    0,    0,  575,  619,    0,    0,    0,  206,
  191,    0,  323,  321,  324,  341,    0,  419,    0,  312,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  342,    0,    0,  346,  347,  363,  377,  390,
    0,  225,    0,  650,  649,  651,  640,  645,  643,  644,
  642,    0,    0,    0,    0,    0,    0,    0,  232,  476,
    0,  216,  425,    0,  427,  101,    0,    0,    0,   82,
  684,    0,  683,    0,    0,  176,  122,   84,   83,   85,
   86,    0,    0,   77,    0,    0,   66,    0,   74,   64,
   68,    0,  441,  443,  422,  438,    0,    0,  115,    0,
  114,  113,    0,  110,    0,  109,  126,    0,    0,  621,
    0,  623,    0,  626,  625,    0,  231,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  484,  494,  478,  479,  480,  481,
  482,  483,    0,    0,    0,  415,    0,    0,    0,    0,
    0,    0,  548,    0,  401,  367,    0,  580,  590,  609,
  348,    0,    0,  631,  366,    0,  368,    0,  356,    0,
  357,  352,  349,  350,    0,    0,    0,    0,  538,    0,
  369,    0,  579,    0,  365,  351,  345,    0,  343,    0,
  344,  529,    0,    0,  220,    0,  226,    0,  233,    0,
    0,  473,  426,    0,    0,  685,    0,    0,    0,   78,
    0,   71,    0,  106,  103,  116,  119,    0,    0,  125,
  161,  620,  622,  624,  515,    0,    0,    0,    0,  514,
    0,    0,  517,  518,    0,    0,    0,    0,    0,    0,
    0,  495,    0,  490,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  404,    0,    0,    0,
    0,    0,  371,    0,  373,  372,    0,  362,  353,  354,
    0,    0,    0,    0,    0,    0,    0,  374,  376,  375,
  359,    0,  370,    0,  358,  223,  222,  221,  227,  234,
  474,  477,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  120,  117,    0,    0,  498,    0,  516,    0,    0,
    0,    0,  487,  513,    0,    0,    0,    0,    0,    0,
    0,  485,  311,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  383,    0,    0,  382,  400,    0,  361,
    0,    0,    0,    0,    0,  389,    0,    0,  388,  364,
  355,   87,    0,    0,    0,   79,   75,    0,  500,  499,
  486,  511,    0,    0,    0,    0,  503,  501,    0,    0,
  403,    0,    0,    0,    0,  581,  584,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  391,    0,
    0,    0,    0,    0,  406,    0,    0,    0,  395,    0,
    0,    0,    0,  104,    0,    0,    0,    0,    0,  497,
    0,    0,    0,    0,  593,    0,    0,  393,    0,    0,
    0,  592,    0,    0,  594,    0,    0,  595,    0,    0,
    0,  591,    0,    0,  392,  394,  583,  588,  381,  379,
  380,  378,  397,  396,  398,  387,  385,  386,  384,  512,
    0,    0,  506,    0,  504,  502,  602,  614,    0,  610,
    0,  612,    0,  585,  601,  597,    0,  603,  598,    0,
  604,  599,    0,  582,  586,  600,  596,    0,    0,    0,
    0,    0,  505,  615,  611,  613,  606,  607,  608,    0,
  605,  589,  508,  510,  507,  587,    0,  509,
};
short yydgoto[] = {                                       1,
  353,  354,  532,  355,  356,  357,  358,  359,  951,  595,
  360,   47,   48,  400,  401,   51,  152,  363,  297,  666,
  364,  154,  556,  365,  748,  582,  904,  583,  912, 1031,
  766, 1116,  552,  368,  369,  370,  371,  372,  373,  924,
  597,  403,  789,  790,  375,  376,  377,  378,  379,  380,
  381,  382,  383,  384,  385,  386,  387,  388,  405,  954,
  955,   58,   59,  389,  390,  166,  517,  427,  424,  675,
  223,  391,  699,  444,  392,  448,  410,  324,  416,  671,
  168,  169,  170,  171,  536,  172,  173,  174,   65,   66,
   67,   68,  241,   69,   70,   71,   72,   73,   74,   75,
  270,  465,  695,  836, 1065,  177,   77,  406,  178,  461,
  462,  463,  685,  464,  689,  853,  854,  855,   80,  857,
 1083,  975, 1087,  858,  976,  179,  859,  860, 1066, 1084,
   81,  468,  469,  470,  694,  192,  518,  395,  525,  396,
  593,  397,  780,  538,  736,  881,  956,  957,  958,  959,
  960,  961,  962,  963,  832,  676,  964,  489, 1047, 1242,
 1241, 1312, 1327, 1235,   82,   83,   84,   85,  479,  861,
   86,   87,   88,  257,  445,  443,  449,  411,  409,  325,
  417,  428,  425,  187,  490,  291,  447,  450,  412,  329,
  421,  429,  426,  419,  655,  978, 1251, 1320, 1309,  979,
  980,  539,  540,  420,  654,  181,  182,  183,   90,   91,
  526,  193,   92,   93,   94,   95,
};
short yysindex[] = {                                      0,
19234,   66, -253, -199,    0,    0, -170, -164,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, -161,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 8741,
    0,    0,    0,    0,    0,    0,    0,10200,21696,    0,
    0, -100,   67,    0,    0, 1174,10359, 7926,19918,21102,
    0,20005,21696, 3477,20082,  -51,    0,  136,  177, 2858,
 3392,  208, 4162,21731,    0,10359, 7926,    0,    0,    0,
    0,    0,    0,  217,  163,  -28,    0, 3184, 4578,    0,
   80,    0,    0,    0,19166,  255,    0,    0,    0,    0,
    0,  -17,   62,    0,    0,    0,    0,   14,    0,    0,
    0,    0,    0,    0,  837,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  382,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  349,    0,    0, 2663,  837, 4040,  837, 4040,
  837,    0,15008,    0,    0,    0,  380, 3294,  380,    0,
   77,21763,  135,21822, 4312,    0,    0,    0,    0,    0,
  152,    0,    0,    0,    0,    0,  380, 6599,    0,    0,
    0,    0,    0,    0,  124,  425,  443,    0,13589,16161,
    0,    0,  398,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,14072,    0,
    0,    0,    0,  450,    0,    0,21696,    0,    0,21866,
 4500,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  837,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,21898,    0,21934,    0,
    0,    0,    0,    0,    0,    0,  372,    0,    0,    0,
  450,    0,    0,    0,    0,    0,    0,    0, 5652,    0,
  405,  410,    0,    0,  380, 3294,    0,    0,    0,  837,
  380,  209,    0,  405,    0,    0,    0,    0,    0,    0,
22936,    0,    0,    0,    0,    0,    0, 2663,11914, 1861,
    0, 1912,13589,  536,  770,21966,22003, 4978,  798,  556,
  583,  628,13589,  588,22033,    0,  152,    0,    0,22063,
    0,    0,    0,  626,  372,13589,  653,    0,22936,    0,
  158,  174,18541,    0,    0,    0,    0,    0,    0,    0,
    0,    0,20907,18647,18647,    0,15212,  837,18716,18716,
18831,18716,    0,  391,    0,    0,    0,    0,    0, 7926,
20197,20974,19376,18716,  501,  369,    0,19444, 1165,    0,
   72,    0,12819,  562,    0,16361, -135, 1255,   45,  355,
  196,  406,  673,  649,  632,  441,  -25,    0, 7926, 7926,
17977,17977, 4870, 6548,  728,  -27,  626,  759,    0,  766,
  790,    0,  533,    0,  748, 4870, 6548,18251,  372,  626,
  372,22936,20646,20286,21043,  626,  372, 2438,    0,  801,
22936,    0,    0,  626,  372,22936,  626,  372,22936,22107,
  460,22174, 5433,    0,    0,22204,21934, 5584,    0,    0,
    0,    0,  372,  626,  372,  372,22936,  626,  372,22936,
    0,    0,    0,    0,    0, 1283,    0,    0, 3184, 3294,
  807,    0,    0,  547,  744,    0,    0,  753,  844,  831,
    0,    0,  380,  837,    0,    0,    0,  772,    0,21168,
20499,21168,20361,20433,    0,21898,21898,    0,22936,    0,
    0,    0,  388,18251,14743,    0,  858,  770,  798,  872,
  877,  158,22264,22294,    0,  885,  543,  549,  558,  624,
18251,  839,  842,  998, 1062,16451,    0,    0,    0,  664,
18251,    0,    0,14803,    0,    0,  398,15212,    0,  658,
12914,  158,17977, 2979,    0,    0,    0,    0,    0,    0,
18251,    0,    0, 5990,  704,  837, 4040,  837,15483, 8447,
 7543,    0,  890,  837,18336,    0,    0,    0,  759,    0,
    0,    0,13027,    0,    0,    0,13097,    0,    0,    0,
13878,21455, 3385,    0,    0,    0,    0,    0,    0,16520,
15752,  859,  646,    0,18251,    0,    0,18251,    0,  837,
23164,   11,    0,15212, 6616, 6868,    0,    0,    0,16655,
    0,18251,18251,18251,18251,18251,18251,18251,18251,18251,
18251,18251,18251,18251,18251,18251,18251,18251,18251,18251,
18251,18251,13993,    0,    0,    0,    0,    0,    0,    0,
    0, 6548,  837,23164,    0,    0,16814,18251,16949,    0,
 6548,  848,    0,    0,    0,    0,  858,    0,    0,  907,
  948,17018,  956,    0,  372, 2438,    0,    0,    0,    0,
    0,    0,    0,22346, 1070,22366, 6962,13589,22417,22445,
  626,22204,22204, 7236,  626,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 4614,    0, 8090,    0, 4614,    0,
    0,  405,18251,    0,18973,    0,    0,19234,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  764,21043,
  966,  971,  981,  158,  158,    0, 1146, 1163, 1369, 1398,
  986,13589,  993,13589, 1013,13589, 1021,    0,  828,    0,
    0,    0,    0,16451,    0,    0,    0,  863,    0,   74,
 1026, 1032,13027,  837,    0,    0,15578,  873, 1036, 1038,
 1043,    0,    0,13209,18336,14439,    0,18251,13392,13499,
14333,18716, 1045,  837,  942,23028,    0,  996,  962, 1006,
   55,23028,    0,    0,    0,    0,    0,  626,  626,    0,
  837,23164,    0, 1000, 1092,17108, 6616, 8959, 1106, 1057,
 1106,18251,   68,    0,    0, -135, -135, -135, 1255, 1255,
   45,   45,  355,  355,  355,  355,  196,  196,  406,  673,
  649,  632,  441,  190,    0,    0,    0,    0,    0,17308,
17398,    0, 1053,17467,    0,    0,22523,22534, 1079,    0,
    0,14922,    0,    0,    0,    0,  831,    0, 9377,    0,
 3693,19523, 9780,19637,19727, 5615, 5711, 1095, 8590,21532,
 6699, 1104,    0,  220,  446,    0,    0,    0,    0,    0,
 1039,    0,18251,    0,    0,    0,    0,    0,    0,    0,
    0,18251, 1138,18251, 1144,18251, 1166,18251,    0,    0,
    5,    0,    0,   78,    0,    0,  118,  618, 4578,    0,
    0,  158,    0,13392,15683,    0,    0,    0,    0,    0,
    0,  835, 2877,    0, 7135, 7240,    0,  921,    0,    0,
    0,23028,    0,    0,    0,    0,13288, 1106,    0,  173,
    0,    0,17602,    0,18251,    0,    0,18251,18251,    0,
 1233,    0, 1328,    0,    0, 1334,    0, 1122, 1151,18251,
18251, 1134, 1176, 1156,  409,14922, 1151, 1187,    0,21253,
 1185,20569,21335, 1179,    0,    0,    0,    0,    0,    0,
    0,    0, 1197, 1150,19039,    0,  158,14161,18251,22595,
 7335, 1202,    0, 1202,    0,    0, 1202,    0,    0,    0,
    0,    0,    0,    0,    0, 1202,    0, 1202,    0, 1202,
    0,    0,    0,    0,14254,22615, 7724, 1202,    0, 1202,
    0, 1202,    0, 1202,    0,    0,    0,21532,    0,21568,
    0,    0, 1356, 1376,    0, 1403,    0, 1477,    0, 1506,
15868,    0,    0,15992,13696,    0, 1186, 1188, 1192,    0,
 1011,    0,14567,    0,    0,    0,    0, 1524,  189,    0,
    0,    0,    0,    0,    0,17707,14922, 1278, 1294,    0,
15103,14922,    0,    0, 1296, 1041,14922,17777,17892,18357,
18067,    0,14922,    0, 1248, 1350,20782,  837,19801,20848,
19317,  169,18013,  798, 1343, 1345,    0,22676, 1202,22696,
 1202, 1096,    0, 1373,    0,    0, 1202,    0,    0,    0,
20782,  798, 1394,22763, 1202,22783, 1202,    0,    0,    0,
    0, 1202,    0, 1202,    0,    0,    0,    0,    0,    0,
    0,    0, 1467,  837, 7926,23028,23028,14439,16253,14439,
 1401,    0,    0, 1428, 1542,    0,14922,    0,   64,21253,
 1402,18251,    0,    0, 1433, 1201, 1439, 1460, 1451,15284,
16065,    0,    0,18251,  837, 1489, 1491, 1500, 1199,  837,
 1504,  837, 1512,  837, 1520,  110,  837, 1536, 1541,  497,
  837, 1483, 1485,    0, 1496, 1511,    0,    0,18251,    0,
 1543, 1566,  497, 1515, 1519,    0, 1531, 1548,    0,    0,
    0,    0,  837, 7926, 7926,    0,    0, 1106,    0,    0,
    0,    0,18251, 1454,18182,14922,    0,    0, 2343,15393,
    0, 1289,  212,  837,  837,    0,    0, 1344,  837, 1363,
  837, 1393,  837,  837, 1438,  837, 1202, 1202,    0, 1540,
 1202, 1202, 1202, 1202,    0,  212, 1202, 1202,    0, 1202,
 1202, 1202, 1202,    0,14922, 1550,18251, 1583, 1552,    0,
14922,14922,  971, 3990,    0,  372, 1546,    0, 1555, 1577,
  372,    0,  372, 1579,    0,  372, 1585,    0,  372, 1590,
 1592,    0,  372, 1596,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
18251, 1600,    0, 1587,    0,    0,    0,    0,  372,    0,
  372,    0,  372,    0,    0,    0,  372,    0,    0,  372,
    0,    0,  372,    0,    0,    0,    0,  372,  372, 1615,
14922, 1602,    0,    0,    0,    0,    0,    0,    0,  372,
    0,    0,    0,    0,    0,    0,14922,    0,
};
short yyrindex[] = {                                      0,
 1335,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,13789,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1335,
    0,    0,    0,    0,    0,    0,11665, 1339,    0,    0,
    0,    0,  119,    0,    0,22844, 2026, 2520,    0,    0,
    0, 1335,    0,    0, 1335,    0,    0,    0,    0,11527,
22864, 1556,    0,    0,    0, 2264, 2628,    0,    0,    0,
    0,    0,    0,14612,14672, 1557,    0, 1405,  894,    0,
    0,    0,    0,    0, 1335,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,10847,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 6694,11105,11196,11289,11547,
11638,    0, 6007,    0,    0,    0,    0, 1406,    0,    0,
  176,    0,  723,    0,    0,    0,  789,    0,    0,    0,
  809,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1335, 1335,
    0,    0,   70,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  864,    0,    0,    0,    0, 1335,  931,
    0,    0,    0,    4,    0,10261,    0,    0,    0,    0,
    0,  941,    0,    0,    0,    0,    0,    0,    0,    0,
    0,10352,    0,    0, 8019,    0,    0,  949,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  969,    0,
   30,    0, 1024,    0,    0,    0,    0,    0, 1335,    0,
    0,    0, 9052, 9144,    0, 1407,    0,11976, 9455,10663,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1335,    0,    0,    0,    0,    0,    0, 6694, 6694,    0,
    0, 1406, 1335, 1046, 1339,    0,    0,    0,    0,    0,
    0,    0, 1335, 1083,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  541,    0, 1335,    0,    0, 1335,    0,
  691, 8669, 1335,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   26, 1335, 1335,    0, 1335,  146, 1335, 1335,
 1335, 1335,    0,12003,    0,    0,    0,    0,    0, 3140,
  213,  219,   96, 1335,12231,    0,    0,  211, 3040,    0,
    0,    0, 1335,    0,    0, 1335, 2409, 1724, 1828, 4649,
 1374,  153, 1670,  671,  918,  603,  735,    0, 4924, 5381,
  240,  252, 1004,  894,    0, 1645,  122, 1339,    0,    0,
    0,    0,    0,    0,    0,  650,  919, 1335,    0,  541,
    0, 1335,  329,  213,  219,  541,    0, 1335,    0, 1564,
 1335,    0,    0,  541,    0, 1335,  541,    0, 1335,    0,
 1069,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  541,    0,    0, 1335,  541,    0, 1335,
    0,    0,    0,    0,    0, 2015,   59,    0,    0,    0,
 1565,    0,    0, 2525,    0,    0,    0,    0, 1567,   48,
    0, 9547,    0,10754,    0, 9858,    0,    0,    0, 1339,
    0,    0, 1335, 1335,    0,    0,    0,    0, 1335,    0,
    0,    0,    0, 1335, 1335,    0,    0, 1339,    0,    0,
    0,  200,    0,    0,    0,    0, 1112, 1116, 1119,    0,
 1335, 1339,    0, 1339,    0, 1335,    0,    0,    0,    0,
 1335,    0,    0, 1335,    0,    0,14508, 1335,    0,    0,
 1335,  731,  357,  475,    0,    0,    0,    0,    0,    0,
 1335,    0,    0,   -6,    0, 2708, 6167,18454, 1648, 1649,
    1,    0,    0,18810, 1650,    0,    0,    0, 4177,    0,
    0,    0, 1335,    0,    0,    0, 1335,    0,    0,    0,
 1335,  357,  475,    0,    0,    0,    0,    0,    0, 1335,
 1335,    0,    0,    0, 1335,    0,    0, 1335,    0,  146,
 1335,    0,    0, 1335,12638, 6359,    0,    0,    0, 1335,
    0, 1335, 1335, 1335, 1335, 1335, 1335, 1335, 1335, 1335,
 1335, 1335, 1335, 1335, 1335, 1335, 1335, 1335, 1335, 1335,
 1335, 1335, 1335,    0,    0,    0,    0,    0,    0,    0,
    0, 1027,  146, 1335,    0,    0, 1335, 1335, 1335,    0,
 1361,    0,    0,    0,    0,    0,  184,    0,    0, 1360,
 1339, 1335,    0,    0,    0, 1335,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1335,    0,    0,
  541,    0,    0,    0,  541,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1335,    0, 1335,    0, 1335,    0,
    0, 1578, 1335,    0, 1335, 9950,    0,  -82,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   26,
 1171,    0,    0,  615,  639,    0, 1339,    0, 1339,    0,
 1217, 1335, 1220, 1335, 1239, 1335, 1242,18901,    0,  815,
  957,  975, 1034, 1335,    0,    0,    0,    0,    0,    0,
    0,    0, 1335, 7349,12455,12543,    7,    0,    0,    0,
    0,    0,    0, 1335, 1656, 1661,    0, 1335, 1335, 1335,
 1335, 1335,    0, 8127,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  126,  133,    0,
  146, 1335,    0,    0,    0, 1335,12638,12638,12598,12570,
12598, 1335,    0,    0,    0, 3726, 5619, 6784, 2154, 4323,
 3561, 3803, 4998, 5482, 6050, 6178, 1476, 2350, 1855, 2019,
 1300, 1522, 1333,    0,    0,    0,    0,    0,    0, 1335,
 1335,    0,    0, 1335,    0,    0,    0,    0,    0,    0,
    0,  137,    0,    0,    0,    0,   48,    0, 1339,    0,
21637,    0,    0, 1335, 1335,17189,21660, 1556,    0,    0,
21404,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1335,    0,    0,    0,    0,    0,    0,    0,
    0, 1335,    0, 1335,    0, 1335,    0, 1335,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   34,  919,    0,
    0,  498,    0, 1335,    7,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1335,12598,    0,    0,
    0,    0, 1335,    0, 1335,    0,    0, 1335, 1335,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1335,
  -31,    0,    0,    0,    0,  -31,    0,    0,12414,  -19,
  251,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  -65,    0,    3, 1335, 1335,    0,
    0,  473,    0,  616,    0,    0, 1108,    0,    0,    0,
    0,  655, 1272,    0,    0, 1164,    0,  851,    0,  898,
    0,    0,    0,    0, 1335,    0,    0,  473,    0,  616,
    0, 1108,    0, 1229,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1335,    0,    0,   35, 1335,    0,    0,    0,    0,    0,
    0,    0, 1335,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1335,  -31,    0,    0,    0,
  -31,  -31,    0,    0,    0,    0,  -31,   39, 1335, 1335,
 1335,    0,  -31,    0,    0,    0,  329,   27,  227,  239,
  585,    0,  320,    0,    0,    0,    0,    0, 1264,    0,
 1322,    0,    0,    0,    0,    0,  591,    0,    0,    0,
  329,    0,    0,    0, 1264,    0, 1322,    0,    0,    0,
    0,  591,    0,  470,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   -6, 1648, 1649,
    0,    0,    0,    0,    0,    0,  -31,    0,    0, 1339,
    0,  -31,    0,    0,    0,12731,    0,    0, 1339, 1335,
 1335,    0,    0, 1335,  763,  184,  581,  587, 1586,   27,
  609,   27,  629,   27,  645,    0,   27,  657,    0, 1326,
   27, 1339,    0,    0, 1339,    0,    0,    0, 1335,    0,
  184,    0, 1326, 1339,    0,    0, 1339,    0,    0,    0,
    0,    0,12076,    0,12103,    0,    0,12598,    0,    0,
    0,    0,  -31,    0, 1335,  -31,    0,    0, 1339, 1335,
    0, 1586, 1077,   27,   27,    0,    0, 1586,   27, 1586,
   27, 1586,   27,   27, 1586,   27, 1354, 1355,    0, 1586,
 1396, 1420, 1456, 1472,    0, 1077, 1354, 1355,    0, 1396,
 1420, 1456, 1472,    0,  -31,    0,   39,    0,    0,    0,
  -31,  -31,    0, 1339,    0,    0, 1586,    0, 1586, 1586,
    0,    0,    0, 1586,    0,    0, 1586,    0,    0, 1586,
 1586,    0,    0, 1586,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   39,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  -31,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  -31,    0,
};
short yygindex[] = {                                   1231,
    0,    0, 7697, 6229, 7045,    0,    0,    0,  104, 1685,
   49,  -26,  -16,  899, 2906,    0,    0, 1799,  328, 5047,
 4245, 1347, 1214,    0, 5733,    0, -731,    0,    0,    0,
    0,    0, 8100, 2869, 7962, -256, -191,    0,    0, -769,
  802, 1349, -311,    0, -371,    0, 1014, 1023, 1063, 1015,
 1061, 1101, 1102, 1105, 1103, 1100,    0, -189, -317, -882,
   12,    0,    0,   24, 3118, 7536,  534,    0,    0,    0,
  -11, 1128,  316,    0, 1572,    0,    0,    0,    0,    0,
  -18,  -49,    0, 3773, 5474,    0, 7422,  468, 4374,    0,
 -659, 6102,  -33, 5016,  -29,  -44,    0,    0,  -21,  -15,
 1651,    0,  889,    0,    0, 2498,  -57, 3428,   -1,    0,
 1047, -394,    0, -444,    0,    0,    0,    0, -574,    0,
22187, -701,    0,    0, -171, 2948,    0,    0,    0,    0,
  -14, 1442,    0, 1040,  893,   15, -331, -503,    0,    0,
 -386, -493, -597,  856, -716,    0, -670,    0, 4478,    0,
    0,    0,    0,  791,    0,    0,    0,    0,  788,    0,
    0,    0,    0,    0,    0, 1654, 1655,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   19,  437,    0,    0,    0,    0,    0,
    0,    0,    0,  107,    0,  896,    0,    0,    0,    0,
    0,  578,  722,    0, 1090,    0,    0,    0,    0,    0,
    0, 1415,  -77,    0,  -72,  -22,
};
#define YYTABLESIZE 23498
short yytable[] = {                                      79,
  404,  282,  224,  148,  601,  224,  283,  228,  155,  635,
  244,  686,   57,  149,  156,  159,  634,  880,  273,   89,
  741,  926,  227,  285,   60,  243,  252,  178,  158,  269,
  205,  211,  267,  268,  462,  851,  816,  622,  518,  592,
  911,  464,  528,  239,  260,  264,  633,  678, 1021,   46,
   79,  781,   97,   79,  782,  277,  180,   98, 1049,  310,
  402,  633,  577,  633,  214,  636,  462,  208,  215,  462,
  229,  231,  234,  245,  633,   61,  276,  261,  147,  178,
  282,  262,  265,   79,   61,   61,  462,  607,  578,  608,
  642,  418,  557,  558,  560,  561,  287,  779,  758,  273,
  282,  285,  716,   89, 1192,  283,  189,  576,   60,  673,
  673,  758,  590,  673,  883,  591,  303,  591, 1023,  328,
  856,  782,   96,  227,   96,  633,  616,  673,  673, 1022,
  673,  155,  516,   46,  516,   99,  464,  156,  159,  464,
  779,  100,  989,  991,  300,  316,  321,  910, 1035,   61,
 1214,  302,  616,  782,  101,  553,  464,  190, 1024,  655,
  928,  591,  435,  189,  330,  435,  440,  190, 1131,  440,
  224,  224,  418,  442,  313, 1138,  442,  655,  516,  247,
 1032,  716,  231,  234,  916,   61,   61,  394,  407,   61,
  150,  326,  673,  150,  248,  178,  150,  495,  282,  224,
  602,  603,  284,   61,   61,  783,   61,   79,  422,  423,
  150,  150,  591,  524,  190,  150,  758,  472,  404,  633,
  249,  188,  282,  476,  282,  190,  246,  672,  435,  516,
  794,  795,  758,  758,  633,  250,  633,  440,  231,  234,
  633,  655,  190,  633,  672,  150,  150,  929,  190, 1194,
  852,  448,  697,  461,  448,  613,  461,  614,  633,  463,
  633,  489,  463, 1008,  190, 1036,  256,  460,   61,  697,
  461,  448, 1082,  461,  269, 1056,  150,  150, 1009,  463,
  444, 1123,  463,  444,  791,  271,  104,  461,  779,  158,
  833,  179,  460,  184,  835,  460,  300,  300,  633,  463,
  444,  394,  485,  697, 1112,  851,  589,  621, 1105,  179,
 1236,  394,  460,  290,   60,  696,  282,  292,  228,  294,
  547,  283,  633,  244,  394,  231,  234,  158,  696,  282,
  548,  407,  740,  227,  283,  697,  742,  696,  243,   46,
  485,  697,  407,  407,  589,  394,  148,  407,  407,  407,
  407,  155,   60,  167, 1282,  252,  149,  156,  159,  462,
  696,   79,  407,  460,  204,  210,   79,  446,  696,  697,
  277,  158,  462,  697,  407,  838, 1126,   46,  259,  263,
  460, 1133,  282,  277, 1186, 1187, 1136,  224,  224,  462,
  856,  632, 1142,  696,  104,  546,  293,  679, 1310,  778,
  679,  184,  785,  673,  641,  589,  407,  589,  884,  584,
  158,  589,  585,  316,  321,  696,  460,  679, 1234,  158,
  927,  147,  295,  485,  158,  422,  423,  158,  708,  464,
  697,  585,  485,  224,  224,   60,  277,  485,  228,  244,
  485,  296,  778,  589,   60,  158,  913,  914,  158,   60,
  545,  589,   60,  227,  243,  435, 1191,  460,  485,  440,
   46,  485,  205,  211, 1076,  331,  442,  260,  264,   46,
   60,  697,  239,   60,   46,  921,  922,   46,    9,   61,
  301,   79,   79,  332,  150,  150,  150,  158,  408, 1010,
  576, 1076,  407,  158,  441,   46,   21,  783,   46,  668,
  706,  547,  589,  404, 1011,  897,  228,  418,   28,  407,
  696,  548,   60,  399,  407,  678,  399,  672,  678,  407,
  852,  227,  158,  611,  612, 1240,  394,  405,  399,   79,
  405,  399,  471,  633,  696,  678,  495,   46,  682,  407,
  580,  682,  300,  477,  448,  697,  461,  300,  300,  302,
  190,  887,  463,  300,  282,  592, 1040, 1082,  682,  283,
  461,   79,  434,  282, 1280,   79,  227,  547,  283,   79,
 1285, 1286,  463,  444,  155,  494,  546,  548,  407,  407,
  156,  159,  722,  407,  470,  460,  407,  190,  724,  158,
  778,  581,  394,  300,  302,  628,  507,  726,  407,  470,
  407,  407,  407,  407,  407,  407,  407,  407,  407,  407,
  407,  407,  407,  407,  407,  407,  407,  407,  407,  407,
  407,   79, 1048,  508,  670,  491,  492,  511,  464,  311,
  671,  545,  158,  190,  399,  407,  407,  407,  576,  190,
 1324,  670,  546,  158,  545,  464,  158,  671,  190,  399,
  407, 1077,  466,  460,  460,  648, 1328, 1025,  648,  399,
  158,  158,  462,  696,  728,  158,  394,  585,  509,  466,
  985,  987,  468,  648,  399,  648,  311, 1001, 1005,  639,
  609,  610,  639,  460,  771,  460,  516,  460,  469,  468,
  679,  407,  521,   79,  104,  158,   79,  639,  628,  639,
  465,  184,  887,  793,  737,  469,  562,  585,  190,   57,
  617,  154,  405,  628,  154,  628,   89,  465,  846,  466,
  394,   60,  394, 1053,  394,  814,  467,  158,  154,  154,
 1054,  660,  407,  154,  660,  615,  616,  648,  631, 1041,
 1156,   79,  618,  841,  757,  889,   46,  758,  660,  660,
  404,  660,   79,  300,  300,  619,  407,   79,   79,  302,
  407,  639,  577,  154,  906,  522,  655,  897,  633,  783,
  906,  655,  620,  501,  655,  160, 1072,  628,  160,  404,
  158,  655,  311,  655,  407,  300,  300,  311,  655,  655,
  407,  655,  160,  160,  154,  154,  700,  701,  637,  228,
  244,  704,  705, 1072,  862,  638,  652,  585,  678,  495,
  496,  282,  252,  660,  227,  243,  283,  268,  407,  407,
   61,   61,  407,  652,  578,  579, 1201,  160,  282,  639,
  394,  682,  201,  283,  598,  599, 1103,  495,  505,  246,
  640, 1121,   79,   79,  656,  655,  545,  201,  646,  201,
  687, 1225,  631,  655,  652,   60,  688,  657,  645,  160,
  190,  407,  660,  598,  599,  663,  690,  631,  879,  631,
  407,  585,  407,  645,  407,  645,  407,  691,  495,  730,
   46,  495,  731,  681,  576,   61,  684,  692,  190,  920,
  148,  693,   79,  889,  399,  155,  697,  311,  711,   49,
  149,  156,  159,  882,  772,  652,  585,  199,  405,  399,
  906,  548,  714,  890,  670,  158,  585,  715,  464,  697,
  671,  407,  199,  407,  199,  721,  407,  407,  150,  190,
  762,  631,  190,  205,  211,  158,  158,  645,  407,  407,
  819,  399,  466,  644,  394,  197,  820,  203,  553,  648,
  218,  699,  699,  236,  404,  405,  399,  658,  156,  598,
  661,  156,  468,   79,  266,  147,   79,  407,  773,   60,
  501,  501,  639,  554,  203,  156,  156,  678,  469,  404,
  156,  682,  899,   49,  188,  585,  544,  821,  846,  203,
  465,  203,  186,   79,   46,  824,  653,  545,  501,  188,
  643,  188,  154,  154,  154,  863,  547,  186,  553,  186,
  156,  864,  195,  841,  652,  643,  548,  643,  644,  407,
  552,  865,  407,  394,  660,  872,  228,  195, 1039,  195,
  501,  158,  874,  644,  501,  644,  907,  495,  732,  585,
  917,  227,  156,  585,  407,  394,  197,  653,  203,  394,
  394,  218,  876,  550,  908,  394,  407,  889,  889,  889,
  878,  394, 1132,  554,  655,  652,  885,  197,  160,   79,
   60,  552,  886,  653,   60,   60,  891,  642,  892,  643,
   60,  546,  197,  893,  197,  898,   60,  361,  190,  634,
  501,  538,  642,  934,  642,   46,  585,  644,  909,   46,
   46,  495,  733,    9,  634,   46,  634,  414,  750,  495,
  330,   46,  655,  547,  906,  906,  300,  300,  300,  937,
  399,   21,  585,  548,  653,  394,  659,  655,   63,  655,
  407,  501,  918,   28,   61,   61,  311,  311,   79,  889,
  750,  659,  407,  659,  750,  923,  542,  925,  750, 1125,
   60,  399,  190,  994,  973,  648,  642,  983,  986,  639,
  190, 1007,  660, 1012,  999, 1004,  399,  407,  634, 1027,
  648,  700,  648,  547,  639,   46,  639,  660, 1015,  660,
 1045,  585, 1030,  548, 1017,  495,  868,  585,  546,  481,
 1046,  407, 1050,  407,  394,  700,  700,  300,   79,   61,
  750,  361,  495,  869,  830,  659, 1019,  399,  831,  585,
  501,  361,   63, 1052,  650, 1051,  566,  570,  575,   60,
  700,  700,  399,  587,  361,  145, 1058,  481,  758,  650,
  632,  650,  194,  394,  648,  407,  190, 1062,  639,  394,
  394,  660,  300,  545,   46,  549,  626,  629,  546,  156,
  156,  156,  751,  190, 1063, 1207,  418, 1206,   60,  203,
  649,  218, 1082,  651,   60,   60,  236,  700,  701,  566,
  570,  150,  399, 1042, 1064,  649,  585,  649,  651,  407,
  651,  699,  640,   46,  751,  661,  550,  399,  751,   46,
   46,  606,  751,  650,  501,  501,  604,  640, 1239,  640,
  661,  605,  661,  545,  701,  699,  699,  399, 1246,  394,
  481, 1113,  203, 1114, 1253,  360, 1256, 1115, 1259,  481,
  750, 1263,  399, 1102,  481,  394, 1268,  481,  701,  701,
  360,  750,  360, 1117,   60, 1127,  750,  750,  750,  649,
  155, 1135,  651,  155,  751,  481,  418, 1245,  481,   56,
   60,  542, 1128, 1289, 1134, 1291, 1293,  155,  155,   46,
 1297,  640,  155, 1300,  661,  399, 1303, 1305, 1043,  399,
 1308,  585, 1143,  159, 1044,   46,  159,  585,   56,  203,
  399,  218,  236, 1160,  399, 1161,  647,  481,  752,  753,
  159,  159,  155,  414,  544,  159, 1106,  399,  399,  585,
   56,  418, 1252,   56,  566,  570,  575, 1144,  495,  870,
  629,  147,  399,  399,  147, 1168, 1107,  147,  486,  585,
  418, 1255,  414,  155,  155,  159,  549,  752,  753,  361,
 1169,  147,  147,   56, 1173,  501,  147,  495,  871,  399,
    9, 1188,   10, 1108,  646,  197,  585,  203,  648,  218,
  418, 1258,   16,   17,  399,  160,  486,  159,   21,  190,
 1193,  361,  501,  399,  751,  361,  147,  147, 1189,  414,
   28,  750, 1195,   29, 1196,  751,  649,  651,  399, 1197,
  751,  751,  751,   32,   33,   34,   35,   36,  190,  414,
 1025,  496,  549,  475,  218,  418, 1262,  147,  147,  399,
 1198,   56,  119,  120,  121,  122,  123,  124,  125,  126,
  127,  128, 1237,  148,  399,  399,  148, 1109,  645,  148,
  585,  414,  495, 1221,  495, 1222,  311,  311,  311, 1203,
  399, 1204,  414,  148,  148,  495, 1223,  374,  148,  486,
 1205,  190,  643,  452, 1209,  501, 1110,  501,  486,  585,
  495, 1224, 1211,  486,  495, 1230,  486,   56,  495, 1231,
 1213,  501,  157,  501, 1122,  157,  361,  585,  148,  148,
  495, 1232,   64,  190,  486,  190, 1216,  486,  644,  157,
  157, 1217, 1190, 1226,  157,  758,  190,  495, 1233,  453,
  454,  455, 1284,  842,  642,  758,   49,  418, 1267,  148,
  148,  190,  753,  418, 1288,  190, 1227,  501, 1281,  190,
  752,  753,  418, 1290,  157,  751,  486,  796,  797,  798,
  361,  190,  361, 1283,  361,  803,  804,  805,  806,  799,
  800,  155,  155,  155,  418, 1292,  418, 1296,  190,   56,
 1311,  361,  418, 1299, 1147, 1313,  157,  418, 1302,  418,
 1304,  374,  361,  418, 1307, 1323,   64,  361,  361,  414,
 1325,  374,  701,  701,  902,  159,  159,  501, 1147,  697,
  902,  801,  802,  696,  374,  807,  808,   56,  536,  317,
  414,  530,  699,  700,  701,  428,  617,  318,  461,  463,
  460,  412,  530,  530,  695,  374,  679,  530,  530,  530,
  530,  678,  413,  147,  147,  147,  147,  147,  616,  698,
  152,   56,  530,  152,  146,  588,   56,  809, 1034,  810,
  813,   56,  812,  811,  965,  478,  272,  152,  152,  966,
  952,  837,  152,  834, 1057, 1055,   11,   12,  288,  289,
  203,   14,  218,  236, 1003,  826,  527,   18,    0,    0,
  753,    0,   22,   23,   24,   25,    0,    0,   26,   27,
   56,  136,  152,  152,  136,    0,  136,  136,  136,   56,
    0,    0,    0,    0,   56,    0,    0,   56,    0,    0,
    0,  136,  136,  136,    0,  136,  136,    0, 1148,    0,
    0,    0,  361,  152,  152,   56,    0,    0,   56,   52,
    0,    0,    0,  776,    0,  148,  148,  148,  148,  148,
  902,    0, 1148,    0,    0,  150,  136,  136,    0,    0,
    0,    0,  849,    0,    0,   63,    0,    0,  153,    0,
    0,   56,   56,    0,    0,    0,    0,   56,    0,    0,
    0,    0,    0,   56,  952,    0,  815,  136,  136,    0,
  203,    0,  232,  157,  157,  157,    0,    0,    0,    0,
    0,    0,  487,  842,    0,  139, 1069,    0,  139,    0,
    0,  139,   56,    0,    0,    0,  374,    0,    0,  374,
    0,    0,    0,   52,    0,  139,  139,  139,    0,  139,
  139,    0,  151, 1069,    0,  151,    0,    0,  151,   56,
  487,    0,  280,    0,    0,    0,    0,    0,    0,    0,
    0,  374,  151,  151,    0,  374,    0,  151,  555,   56,
  139,  139,    0,  361, 1151, 1153, 1155,    0, 1158,    0,
    0, 1119,    0,    0,    0,    0,    0,    0,    0,   56,
    0,    0,  374,    0,   56,  952,    0,  151,  151,  952,
  952,  139,  139,  280,    0,  952,    0,    0,    0,  486,
    0,  952,    0,  232,    0,    0,    0,  203,    0,  218,
    0,   56,    0,    0,  566,  570,    0,    0,  151,  151,
    0,    0,   56,  487,    0,    0,    0,    0,    0,    0,
    0,    0,  487,    0,  915,    0,    0,  487,    0,    0,
  487,  152,  152,  152,    0,    0,    0,    0,    0,    0,
    0, 1182,    0,    0,  902,  902,  374,  203,  487,  232,
    0,  487,    0,    0,    0,  952,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  549,    0,
    0,    0,    0,   56,    0,    0,   56,    0,    0,  136,
  136,  136,  136,  136,  136,  136,  136,  136,    0,  153,
  487,    0,  153,  238,    0,  238,  238,  238,    0,  238,
  374,    0,  374,  486,  374,    0,  153,  153,  474,    0,
    0,  153,    0,  238,    0,    0,  238,    0,    0,  483,
    0,  374,  849,    0,  952,  530,    0,  232,  549,  555,
    0,    0,  374,    0,    0,    0,  232,  374,  374,   56,
  530,  153,  153,    0,    0,    0,  238,    3,    4,    5,
    0,    0,    0,    0,    0,    7,    8,  483,    0,    0,
   56,    0,   13,  952,    0,    0,    0,    0,    0,  952,
  952,    0,  153,  153,   20,  551,  474,    0,    0,    0,
    0,  238,    0,  139,  139,  139,  139,  139,  139,  139,
  139,  139,    0,    0,    0,  555,   31,    0,    3,    4,
    5,  596,    0,    0,  486,  104,    7,    8,  486,  486,
  374,    0,  184,   13,  486,    0,  151,  151,  151,    0,
  486,  137,   56,   56,  137,   20,  137,  137,  137,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  952,
  483,  137,  137,  137,    0,  137,  137,   31,    0,  483,
    0,    0,    0,    0,  483,  952,  104,  483,    0,    0,
    0,  232,    0,  279,    0,    0,  232,  776,    0,    0,
    0,    0,  374,  530,    0,  483,  137,  137,  483,    0,
    0,    0,    0,    0,  486,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   56,  850,    0,    0,   64,
    0,  327,  327,  327,    0,    0,    0,  137,  137,  327,
  327, 1149,  238,  238,  238,  238,  327,  483,    0,    0,
  238,  238,    0,    0,  374,    0,    0,  238,  327,    0,
    0,  235,    0,  235,  235,  235,    0,  235,    0,  238,
    0,    0,    0,   56,    0,    0,   56,    0,    0,    0,
  327,  235,    0,  486,  235,    0,  551,    0,    0,  327,
  238,  238,  232,    0,    0,    0,  327,    0,    0,    0,
  238,    0,    0,   56,    0,    0,    0,  238,    0,  327,
  153,  153,  153,    0,  235,    0,    0,    0, 1202,  238,
    0,    0,  486, 1208,    0, 1210,    0, 1212,  486,  486,
 1215,  232,  530,  374, 1220,    0,    0,    0,    0,    0,
   41,   56,  754,  496,   40,    0,    0,  149,  474,  235,
  149,    0,  551,  149,    0,  374,    0,    0,    0,  374,
  374,    0,    0,  487,    0,  374,    0,  149,  149,    0,
    0,  374,  149,    0,    0,    0, 1247, 1249, 1250,   56,
    0,    0, 1254,    0, 1257,    0, 1260, 1261,    0, 1264,
    0,  474,    0,  190,    0,    0,    0,    0,  486, 1247,
    0,    0,  149,  149,    0,  132,  132,    0,    0,  132,
  132,  132,  132,  132,  486,  132,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  232,  132,  132,  132,    0,
  132,  132,  232,  149,  149,  374,    0,  652,    0,  137,
  137,  137,  137,  137,  137,  137,  137,  137,  374,  530,
    0,    0,    0,  844,    0,    0,   52,    0,   76,    0,
    0,  132,  132,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  487,    0,  235,
  235,  235,  235,  235,    0,    0,    0,  157,  235,  235,
    0,    0,  132,  132,    0,  235,  850,    0,    0, 1073,
    0,    0,  474,    0,  374,  232,    0,  235,  374,   76,
    0,    0,   76,    0,  232,    0,    0,  241,    0,  241,
  241,  241,  474,  241,  903,    0, 1073,    0,  235,  235,
  903,    0,    0,    0,    0,  275,  281,  241,  235,  474,
  241,    0,   76,  374,    0,  235,  232,    0,    0,  374,
  374,    0,    0,    0,    0,    0,    0,  235,    0,    3,
    4,    5,    6,    0,  555,    0,    0,    7,    8,    9,
  241,    0,    0,    0,   13,    0,    0,    0,  487,    0,
    0,    0,  487,  487,    0,    0,   20,   21,  487,    0,
  483,    0,    0,    0,  487,    0,    0,    0,    0,   28,
    0,    0,    0,    0,    0,  241,    0,    0,   31,    0,
  157,    0,    0,    0,    0,  281,    0,  104,    0,  374,
    0,    0,    0,    0,  184,  237,    0,  237,  237,  237,
    0,  237,    0,    0,    0,  374,    0,    0,    0,  149,
  149,  149,  149,  149,    0,    0,   76,    0,  237,    0,
    0,    0,    0,  232,    3,    4,    5,    0,  487,    0,
   41,    0,    7,    8,   40,    0,   76,    0,    0,   13,
  903,  555,    0,    0,    0,  596,    0,    0,  237,    0,
    0,   20,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  132,  132,  132,  132,  132,  132,
  132,  132,  132,   31,  483,  239,    0,  239,  239,  239,
    0,    0,  650,  237,    0,    0,    0,    0,    0,  651,
    0,    0,    0,  844,    0,    0, 1071,  487,    0,  232,
    0,  555,    0,  473,    0,    0,  241,  241,  241,  241,
    0,  325,  325,  325,  241,  241,    0,    0,   76,  325,
  325,  241,    0, 1071,    0,  232,  325,    0,  239,  281,
   76,    0,    0,  241,    0,    0,  487,    0,  325,    0,
   76,    0,  487,  487,    0,    0,    0,    0,    0,    0,
    0,    0,  474,   76,  241,  241,   76,    0,    0,    0,
  325,  551,    0,    0,  241,    0,    0,    0,    0,  325,
    0,  241,    0,    0,   76,  483,  325,    0,    0,  483,
  483,    0,    0,  241,    0,  483,    0,    0,    0,  325,
   76,  483,    0,    0,    0,   76,  474,    0,    0,   55,
  157,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  487,  237,  237,  237,  237,  237,    0,    0,
  275,  281,  237,  237,    0,    0,    0,    0,  487,  237,
    0,    0,    0,    0,    0,    0,   50,    0,    0,   76,
    0,  237, 1183, 1184,  903,  903,  251,    0,   76,    3,
    4,    5,    6,   76,    0,  483,   76,    7,    8,    0,
    0,    0,  237,  237,   13,  151,    0,    0,  551,  232,
    0,    0,  237,  474,   76,    0,   20,   76,  474,  237,
  474,    0,  474,   55,    0,  474,    0,  219,    0,  474,
  237,  237,    0,    0,  239,  239,  239,  239,   31,    0,
    0,    0,  239,  239,    0,    0,    0,  104,    0,  239,
   76,   76,    0,    0,  184,    0,   76,    0,    0,    0,
   50,  239,   76,    0,  483,    0,    0,    0,  551,    0,
    0,  474,  474,  474,    0,    0,    0,  474,    0,  474,
    0,  474,  474,  239,  474,    0,   41,    0,  623,    0,
   40,   76,  239,    0,  474,   76,    0,    0,   76,  239,
    0,    0,    0,  483,    0,    0,    0,    0,    0,  483,
  483,    0,    0,    0,    0,    0,    0,    0,   76,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  219,    0,
   76,    0,    0,    0,   76,    0,    0,    0,   76,  190,
    0,    0,    0,    0,    0,    0,  121,  121,    0,    0,
  121,  121,  121,  121,  121,    0,  121,    0,   76,    0,
    0,   76,    0,  157,  362,    0,    0,  121,  121,  121,
    0,  121,  121,    0,   42,    0,    0,    0,    0,  483,
    0,  319,  323,    0,  415,    0,    0,    0,   61,    0,
   76,    0,    0,    0,    9,  483,   10,    0,    0,  473,
    0,   76,  121,  121,    0,    0,   16,   17,    0,  160,
    0,    0,   21,    9,    0,   10,    0,    0,    0,    0,
    0,    0,    0,    0,   28,   16,   17,   29,  160,  484,
    0,   21,    0,  121,  121,   76,    0,   32,   33,   34,
   35,   36,    0,   28,  458,    0,   29,  239,    0,  239,
  239,  239,    0,  239,    0,    0,   32,   33,   34,   35,
   36,    0,   76,    0,    0,   76,  482,  484,    0,    0,
  239,    0,   61,    0,    0,    0,    0,    0,  362,    0,
    0, 1028,    0,    0,    0,    0,    0,    0,  362,   76,
    0,   76,    0,   76,    0,    0,    0,    0,    0,    0,
  239,  362,    0,    0,  482,    3,    4,    5,    6,    0,
   76,    0,    0,    7,    8,    9,    0,    0,    0,    0,
   13,   76,  550,    0,  319,  323,   76,   76,   76,    0,
    0,    0,   20,   21,    0,  239,    0,    0,  219,    0,
    0,    0,    0,  237,    0,   28,    0,    0,  151,   76,
  484,    0,    0,   30,   31,    0,    0,    0,    0,  484,
  537,    0,    0,   37,  484,    0,    0,  484,    0,    0,
  502,    0,    0,    0,    0,    0,    0,    0,  565,  569,
    0,    0,    0,    0,    0,  484,    0,  482,  484,    0,
    0,    0,    0,  653,    0,    0,  482,    0,    0,   76,
    0,  482,    0,    0,  482,    0,    0,    0,  625,  628,
    0,   76,   76,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  482,    0,    0,  482,    0,  484,    0,    0,
  537,  565,  569,    0,    0,  121,  121,  121,  121,  121,
  121,  121,  121,  121,    0,  121,  121,    0,    0,  319,
  323,    0,    0,    0,    0,    0,    0,    0,  219,  237,
    0,   76,    0,    0,  482,    0,  239,  239,  239,  239,
  415,    0,    0,    0,  239,  239,    0,    0,   61,    0,
    0,  239,    0,    0,  157,    0,    0,    0,    0,    0,
    0,    0,   41,  239,  571,    0,   40,    0,   78,  415,
    0,    0,    0,  550,    0,    0,  362,    0,    0,    0,
    3,    4,    5,   76,  239,  239,   61,    0,    7,    8,
  253,    0,    0,    0,  239,   13,  219,   78,    0,    0,
    0,  239,   76,    0,  554,   76,    0,   20,  362,    0,
    0,    0,  362,  239,    0,  190,  415,    0,    0,   78,
  319,  323,   78,    0,    0,    0,    0,    0,    0,   31,
    0,    0,   76,    0,    0,    0,  415,    0,  104,  550,
    0,  219,    0,    0,    0,  274,    0,    0,    0,    0,
   42,    0,   78,    0,   41,    0,   39,    0,   40,    0,
    0,    0,   76,    0,    0,    0,    0,    0,  415,   61,
   76,    0,    0,    0,    0,    0,    0,    0,   61,  415,
    0,    0,    0,   61,   76,    0,   61,    0,   76,   76,
    3,    4,    5,    0,   76,    0,    0,    0,    7,    8,
   76,  653,    0,  845,   61,   13,   55,   61,   76,    0,
    0,    0,    0,  362,    0,    0,    0,   20,    0,    0,
   78,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  458,    0,  458,    0,  458,    0,    0,    0,  140,   31,
  843,  140,   42,   50,  140,    0,   61,    0,  104,    0,
    0,    0,    0,  319,  323,  279,  393,    0,  140,  140,
  140,    0,  140,  140,   76,    0,    0,  362,    0,  362,
    0,  362,    0,    0,  905,    0,   78,   76,    0,    0,
  905,    3,    4,    5,    6,  554,    0,    0,  362,    7,
    8,    9,    0,  140,  140,    0,   13,  537,    9,  362,
   10,    0,    0,    0,  362,  362,  415,    0,   20,   21,
   16,   17,    0,  160,    0,    0,   21,    0,    0,    0,
    0,   28,    0,    0,  140,  140,    0,  415,   28,   30,
   31,   29,    0,   76,  323,    0,  459,   76,    0,   37,
  484,   32,   33,   34,   35,   36,  184,    0,    0,    0,
    0,  554,    0,    0,    0,    0,    0,    0,   78,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  393,    0,   76,    3,    4,    5,    6,  953,   76,   76,
  393,    7,    8,    9,    0,    0,    0,    0,   13,  219,
  237,  981,    0,  393,    0,    0,   78,    0,    0,    0,
   20,   21,  133,  133,    0,    0,  133,  133,  133,  133,
  133,    0,  133,   28,  393,    0,    0,    0,    0,    0,
  905,   30,   31,  133,  133,  133,  977,  133,  133,    0,
   78,   37,    0,    0,    0,   78, 1002,    0,  184,  362,
   78,    0,    0,    0,    0,    0,    0,    0,   76,    0,
    0,    0,  847,    0,  484,   61,    0,    0,  133,  133,
    0,    0,  151,    0,   76,    0,    0,    0,    0,    0,
    0,    0,    0,  845,    0,    0,    0,    0,    0,   78,
  141,    0,    0,  141,    0,  459,  141,    0,   78,  133,
  133,  953,    0,   78,    0,    0,   78,    0,    0,    0,
  141,  141,  141,    0,  141,  141,    0,    0,    0,    0,
  843,    0,    0, 1070,   78,    0,    0,   78,    0,    0,
    0,    0,    0,    0,    0,    0,  140,  140,  140,  140,
  140,  140,  140,  140,  140,  141,  141,    0,    0,    0,
 1070,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   78,   78,    0,    0,    0,  484,   78,  319,  323,  484,
  484,    0,   78,    0,    0,  484,  141,  141,    0,    0,
  362,  484,    0,    0,  309,    0,  317,  317, 1120,    0,
    0,    0,    0,  319,  323,    0,    0,    0,    0,   61,
    0,   78,  953,    0,    0,  393,  953,  953,  393,    9,
    0,   10,  953,    0,    0,    0,    0,    0,  953,    0,
    0,   16,   17,    0,  160,    0,  219,   21,   78,    0,
    0,  309,    0, 1185,  905,  905,    0,    0,    0,   28,
  393,    0,   29,    0,  393,  484,    0,    0,   78,    0,
    0,    0,   32,   33,   34,   35,   36,    0,    0,    0,
    0,    0,    0,    0,  537,    0,  565,  569,   78,    0,
  628,  393,    0,   78,    0,    0,    0,   41,    0,  754,
  870,   40,  953,    0,    0,    0,    0,    0,  537,    0,
    0,    0,    0,    0,    0,  550,    0,    0,    0,    0,
   78,  133,  133,  133,  133,  133,  133,  133,  133,  133,
    0,   78,    0,   61,  484,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  499,    0,
  190,    0,  847,  459,    0,    0,    0,  513,  323,    0,
    0,    0,  515,    0,    0,  393,    0,    0,    0,    0,
    0,  953,    0,  484,    0,  550,    0,    0,    0,  484,
  484,    0,  459,    0,  459,    0,  459,    0,    0,    0,
    0,    0,   78,    0,    0,   78,    0,    0,  141,  141,
  141,  141,  141,  141,  141,  141,  141,    0,    0,    0,
  953,    0,    0,    0,    0,    0,  953,  953,    0,  393,
  554,  393,    0,  393,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   61,    0,    0,    0,   61,   61,
  393,    0,    0,    0,   61,    0,    0,    0,    0,  484,
   61,  393,    0,    0,    0,    0,  393,  393,   78,    0,
    0,    0,    0,    0,    0,  484,    0,    0,    0,   41,
    0,  209,  309,   40,  317,  317,    0,    0,    0,   78,
    0,    0,    0,  706,  706,    0,  953,  706,  706,  706,
  706,  706,  706,  706,    0,    0,    0,    0,    0,    0,
    0,    0,  953,    0,  706,  706,  706,  706,  706,  706,
    0,    0,    0,    0,   61,   54,    3,    4,    5,    6,
    0,    0,    0,    0,    7,    8,    9,  554,    0,  393,
    0,   13,    0,    0,    0,    0,    0,  706,    0,  706,
  706,   78,   78,   20,   21,  718,  720,    0,    0,    0,
    0,    0,  165,   54,    0,    0,   28,   42,    0,    0,
    0,    0,    0,  165,  165,   31,  221,   54,   54,  221,
  706,  706,    0,    0,  104,    0,    9,  165,  165,   11,
   12,  184,    0,   61,   14,    0,    0,  554,    0,    0,
   18,  393,    0,    0,   21,   22,   23,   24,   25,   54,
    0,   26,   27,    0,    0,    0,   28,    0,    0,    0,
    0,    0,    0,    0,   78,    0,    0,    0,    0,   41,
    0,  320,   61,   40,    0,    0,    0,    0,   61,   61,
  138,    0,    0,  138,    0,  138,  138,  138,    0,    0,
    0,    0,    0,  393,    0,    0,    0,    0,    0,    0,
  138,  138,  138,    0,  138,  138,    0,    0,    0,    0,
  299,    0,   78,    0,    0,   78,    0,  299,    0,    0,
    0,    0,    0,    0,    0,    0,  308,    0,  165,  165,
    0,    0,  186,    0,    0,  138,  138,  258,    3,    4,
    5,    6,   78,    0,    0,    0,    7,    8,   61,    0,
    0,    0,    0,   13,    0,    0,  499,   42,  706,    0,
    0,  513,  515,    0,   61,   20,  138,  138,    0,    0,
    0,    0,  393,  308,    0,    0,    0,    0,    0,    0,
   78,   54,    0,    0,  221,  221,   30,   31,    0,    0,
    0,    0,    0,    0,  393,    0,   37,    0,  393,  393,
    0,    0,    0,  161,  393,    0,    0,    0,    0,    0,
  393,  433,    0,  438,    0,    0,    0,    0,   78,  706,
  706,  706,  706,  706,  706,  706,  706,  706,  706,  706,
  706,  696,  706,  706,  706,  706,  706,  706,  706,  706,
  706,  706,  706,  706,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  312,    0,   41,    0,  217,
    0,   40,  299,  299,    0,    0,    0,    0,    0,    0,
  308,  308,  308,    0,  393,    0,    0,    0,    0,  308,
    0,    0,    0,    0,  308,    0,    0,  393,    3,    4,
    5,    6,    0,    0,    0,    0,    7,    8,    9,    0,
    0,    0,  312,   13,    0,    0,    0,  534,    0,    0,
  312,    0,    0,    0,    0,   20,   21,    0,    0,  718,
  720,    0,    0,    0,    0,  534,  534,  573,   28,    0,
    0,  974,  573,    0,  984,  984,   30,   31,    0,  280,
    0, 1000,  984,  393,    0,   42,   37,  393,    0,    0,
    0,    0,    0,  161,    0,  534,  534,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  138,  138,
  138,  138,  138,  138,  138,  138,  138,  534,  534,  534,
    0,    0,  393,    0,    0,    0,    0,    0,  393,  393,
    0,    0,    0,    0,  667,    0,  433,  433,    0,  186,
  674,  438,  438,    0,    0,    0,  142,    0,  312,  142,
    0,    0,  142,  312,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   42,    0,    0,  142,  142,  142,    0,
  142,  142,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  433,  433,  433,  438,  438,    0,
  433,  433,    0,    0,  442,    0,    0,    0,  393,    0,
 1074,  142,  142,    0,    0,    0,    0,  308,  308,    0,
    0,    0,    0,    0,  393,    0,    3,    4,    5,    6,
    0,    0,    0,    0,    7,    8,    9, 1092,  488,    0,
    0,   13,  142,  142,    0,  747,    0,  534,  534,    0,
  984,    0,    0,   20,   21,    0,    0,    0,  756,    0,
    0,    0,    0,  756,  756,  756,   28,    0,    0,  756,
    0,    0,  519,  312,   30,   31,  488,  747,    0,  312,
    0,  747,    0,    0,   37,  573,  573,  573,    0,    0,
    0,  184,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  309,  309,  309,    3,    4,    5,    0,    0,  788,
  788,    0,    7,    8,    0,    0,    0,    0,    0,   13,
 1163,    0, 1166,    0,    0,    0,    0,    0,    0,    0,
    0,   20,    0,    0,    0,    0, 1175,  534, 1178,    0,
    3,    4,    5,    0,    0,    0,  186,  186,    7,    8,
    0,    0,   30,   31,    0,   13,  643,    0,  645,  488,
    0,    0,  278,    0,  649,    0,    0,   20,  488,  279,
    0,    0,  659,  488,  186,  662,  488,    0,  667,    0,
  667,  667,  499,  667,  667,    0,  674,  674,  674,   31,
  677,    0,  679,  680,  488,    0,  683,  488,  104,    0,
    0,    0,    0,    0,    0,  457,  186,    0,    0,  674,
  186,    0,   54,    0,  186,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  534,    0,    0,    0,    0,    0,
    0,  236,    0,  236,  236,  236,  707,  236,    0,    0,
    0,    0,  720,    0,    0,    0,  142,  142,  142,  142,
  142,  142,  142,    0,  236,    0,    0,  747,    0,    0,
    0,  747,    0,    0,    0,   42,  186,    0,  895,  756,
  756,    0,    0,  895,  895,  756,    0,    0,    0,    0,
    0,    0,    0,    0,  236,   41,    0,  504,    0,   40,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  788,  788,    0,    0,  145,    0,  186,  145,    0,
    0,  145,  312,  312,    0,  186,    0,   53,    0,  236,
    0,    0,    0,  176,    0,  145,  145,  145,    0,  145,
  145,  196,  199,  201,  207,  213,    0,  226,    0,    0,
  242,  667,  667,    0,    0,  242,  255,    0,    0,    0,
    0,  242,  242,  971,  164,   53,  667,  667,  674,  674,
  145,  145,    0,  997,  667,  164,  164,    0,  220,   53,
   53,  220,    0,   42,    0,    0,    0,    0,    0,  164,
  164,    0,    0,    0,    0,    0,  186,    0,    0,    0,
  176,  145,  145,    0,    0,    0,    3,    4,    5,    0,
    0,   53,  825,    0,    7,    8,    0,    0,  895,  895,
    0,   13,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   20,    0,    0,    0,    0,    0,    0,
    0,    0,  196,  199,  201,  207,  213,    0,  226,    0,
    0,    0,    0,    0,   30,   31,    0,    0,    0,    0,
  236,  236,  236,  236,   37,    0,    0,    0,  236,  236,
    0,  274,  298,    0,  433,  236,  433,  433,    0,  298,
  186,  186,    0,    0,    0,    0,    0,  236,  307,  674,
  164,  164,  667,    0,  667,  667,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  236,  236,
    0,    0,    0,    0,    3,    4,    5,    6,  236,  667,
  667,  667,    7,    8,    9,  236,    0,  226,    0,   13,
    0,    0,  667,    0,  674,  307,    0,  236,    0,    0,
    0,   20,   21,   53,    0,    0,  220,  220,    0,    0,
    0,    0,    0,    0,   28,    0,    0,    0,    0,    0,
    0,    0,   30,   31,    0,    0,    0,    0,    0,    0,
    0,    0,   37,  432,    0,  437,    0,    0,    0,  502,
    0,    0,    0, 1141, 1141, 1141,    0,    0,    0,    0,
    0,  534,    0,  534,  534,  573,    0,  534,    0,    0,
    0,    0,  667,    0,  667,  145,  145,  145,  145,  145,
  145,  145,    0,    0,    0,  534,    0,    0,  667,    0,
  667,  186,    0,    0,  298,  298,    0,    0,    0,    0,
    0,    0,  307,  307,  307,    0,    0,    0,  176,    0,
    0,  307,  756,  756,  756,    0,  307,    0,  186,    0,
    0,    0,    0,    0,  433,  196,  207,  213,  226,    0,
    0,    0,    0,  242, 1141, 1141,    0,    0,    0,  533,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  242,  255,    0,  533,  533,  572,
    0,    0,    0,    0,  572,    0,    0,    0,  240,    0,
  240,  240,  240,    0,  240,    0,    0,    0,  176,  207,
  213,    0,  312,  312,  312,    0,    0,  533,  533,    0,
    0,  240,    0,  756, 1141,    0,    0,    0,    0,    0,
    0,  186,    0,  186,    0,    0,    0,    0,    0,  533,
  533,  533,    0,    0,    0,    0,    0,  186,    0,  186,
   41,  240,  670,    0,   40,    0,    0,    0,  432,  432,
    0,    0,  673,  437,  437,    0,    0,    0,  756,  226,
    0,    0,    0,    0,    0,  176,  207,  213,  226,  242,
    0,    0,    0,    0,    0,    0,  240,    0,    0,    0,
    0,    0,    0,  186,    0,    0,  191,    0,    0,  146,
    0,    0,  146,    0,    0,  146,  432,  432,  432,  437,
  437,    0,  432,  432,    0,    0,    0,    0,    0,  146,
  146,  146,    0,  146,  146,    0,    0,    0,    0,  307,
  307,    0,    0,    0,    0,    0,    0,    0,   42,  176,
    0,  196,  199,  201,  207,  213,  226,    0,    0,  255,
    0,    0,    0,  186,  146,  146,    0,  533,    0,  533,
  533,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  755,    0,    0,    0,    0,  755,  755,  755,    0,    0,
    0,  755,    0,    0,    0,  146,  146,    0,    0,  533,
    0,  226,    0,  533,    0,    0,    0,  572,  572,  572,
    0,   41,    0,  436,    0,   40,    0,    0,    0,    0,
    0,    0,    0,    0,  304,    0,  314,  240,  240,  240,
  240,  787,  787,    0,  327,  240,  240,    0,    0,    0,
    0,    0,  240,    0,    0,  134,  134,    0,  191,  134,
  134,  134,  134,  134,  240,  134,    0,    0,    0,  533,
    0,    0,    0,  992,    0,    0,  134,  134,  134,    0,
  134,  134,    0,    0,    0,  240,  240,    0,    0,    3,
    4,    5,    6,    0,    0,  240,    0,    7,    8,    9,
    0,    0,  240,    0,   13,    0,    0,    0,    0,   42,
    0,  134,  134,    0,  240,    0,   20,   21,  673,  673,
  673,    0,    0, 1287,    0,  176,    0,    0, 1294,   28,
 1295,    0,    0, 1298,    0,    0, 1301,   30,   31,    0,
 1306,  673,  134,  134,   53,    0,    0,   37,    0,    0,
    0,    0,    0,    0,  161,    0,  533,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1314,    0, 1315,  993,
 1316,    0,    0,    0, 1317,    0,    0, 1318,  497,    0,
 1319,    0,  506,    0,    0, 1321, 1322,    0,    0,  533,
  327,    0,    0,  533,    0,    0,    0, 1326,    0,    0,
  755,  755,  755,    0,  523,  755,  755,  755,    0,  146,
  146,  146,  146,  146,  146,  146,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  787,  787,    0,    0,    0,    0,    0,
    3,    4,    5,    6,    0,    0,    0,    0,    7,    8,
    9,    0,    0,    0,  176,   13,  196,  207,  213,  226,
  242,  242,  255,    0,    0,    0,  242,   20,   21,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   28,    9,    0,   10,    0,  970,  647,    0,   30,   31,
  673,  673,    0,   16,   17,  996,  160,    0,   37,   21,
    0,    0,    0,    0,  314,  184,    0,  451,    3,    4,
    5,   28,  452,    0,   29,    0,    7,    8,  226,    0,
  242,  366,    0,   13,   32,   33,   34,   35,   36,    0,
    0,    0,    0,    0,    0,   20,    0,    0,    0,    0,
  755,  755,    0,    0,  134,  134,  134,  134,  134,  134,
  134,  134,  134,    0,    0,    0,    0,   31,  453,  454,
  455,  456,    0,    0,    0,  176,  104,  207,  213,    0,
    0,  712,  713,  457,    0,  716,    0,    9,    0,   10,
  723,  725,  727,    0,    0,  497,  506,  497,  506,   16,
   17,    0,  160,    0,    0,   21,  432,    0,  432,  432,
    0,    0,    0,    0,  749,  191,    0,   28,    0,    0,
   29,  673,    0,    0,    0,    0,    0,    0,    0,    0,
   32,   33,   34,   35,   36,    0,    0,   41,    0,  754,
    0,   40,    0,    0,    0,  493,  749,    0,    0,    0,
  749,    0,    0,   26,  749,  510,   26,   26,    0,   26,
   26,   26,   26,   26,    0,    0,  673,    0,  520,    0,
    0,    0,    0,    0,   26,   26,   26,   26,   26,   26,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  190,    0,  176,    0,  207,  213,  226,  143,    0,    0,
  143,    0,    0,  143,    0,    0,  749,   26,    0,   26,
   26,    0,    0,    0,    0,    0,  176,  143,  143,  143,
    0,  143,  143,  533,    0,  533,  533,  572,    0,  533,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   26,
   26,   26,    0,  176,  207,  213,    0,  533,  191,  175,
    0,    0,  143,  143,    0,  176,    0,  195,  198,  200,
  206,  212,    0,  225,    0,    0,  240,    0,    0,    0,
    0,  240,  254,    0,  755,  755,  755,  240,  240,    0,
    0,    0,    0,  143,  143,    0,  432,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  866,  867,    0,
  712,  713,  712,  713,    0,    0,    0,    0,  226,  226,
  242,    0,    0,    0,  238,    0,  238,  238,  238,    0,
    0,    0,    0,    0,  176,  144,  749,    0,  144,    0,
    0,  144,    0,    0,    0,    0,  709,  749,    0,   44,
    0,    0,  749,  749,  749,  144,  144,  144,    0,  144,
  144,    0,    0,  729,    0,  755,    3,    4,    5,    6,
    0,    0,    0,  738,    7,    8,    9,  238,    0,  176,
    0,   13,    0,    0,    0,    0,   44,   44,   26,    0,
  144,  144,    0,   20,   21,    0,    0,   44,   44,    0,
   44,   44,   44,   44,    0,    0,   28,    0,    0,    0,
  755,   44,   44,    0,    0,   31,    0,    0,    0,  765,
    0,  144,  144,    0,  104,    0,    0,    0,    0,    0,
    0,  184,  768,   44,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  784,    0,    0,   26,
   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,
   26,  697,   26,   26,   26,   26,   26,   26,   26,   26,
   26,   26,   26,   26,    0,    0,    0,    0,    0,    0,
    0,  716,    0,    0,    0, 1026,    0,  749,    0,    0,
    0,  765,    0,    0,    0,    0,    0,  143,  143,  143,
  143,  143,  143,  143,  823,    0,    0,    0,    0,    0,
   44,    0,   44,   44,    0,  111,    0,    0,  111,  111,
  829,  111,  111,  111,    0,  111,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  111,  111,  111,  111,
  111,  111,    0,  238,  238,  238,  238,    0,    0,    0,
    0,  238,  238,    0,    0,    0,    0,   44,  238,    0,
  716,    0,    0,    0,  175,   44,    0,    0,   44,   44,
  238,  111,  111,    0,  873,    0,  875,    0,  877,    0,
    0,  195,  206,  212,  225,    0,    0,    0,    0,  240,
    0,    0,  238,    0,    0,   44,    0,   44,    0,    0,
    0,  238,  111,  111,    0,    0,    0,    0,  238,    0,
  240,  254,  765,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  144,  144,  144,  144,  144,
  144,  144,    0,    0,  175,  206,  212,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   44,   44,   44,    0,    0,    0,
 1146,    0,    0,   44,    0,    0,    0, 1159,   44,    0,
    0,    0,  931,  933,    0,    0,  936,    0,    0,    0,
    0,    0,    0,    0, 1171, 1172,    0,    0,    0,    0,
    0,   44,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  175,  206,  212,  225,  240,    0,    0,    0,   44,
   44,   44,    0,    0,    0, 1013,   44,    0,    0,    0,
    0,    0,    0,    0, 1014,    0, 1016,    0, 1018,    0,
 1020,    0,  497,    0,    0,    0,    0,    0,    0,   44,
   44,  630,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1218,  630,  712,  713,    0,  712,  713,
  280,   44,   44,   44,    0,    0, 1228,  712,  713,    0,
  712,  713,    0,   41,    0, 1038,    0,   40,   44,    0,
   44,   44,    0,    0,   44,   44,   44,    0,    0,    0,
    0,    0, 1243,   42,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  111,  111,  111,  111,  111,  111,
  111,  111,  111,  697,  111,  111,  111,  111,  111,  111,
  111,  111,  111,  111,  111,  111,  786,    0,   44,   44,
   44,   44,   44,    0,   44,   44,    0, 1243,    0,    0,
    0,    0,    0,    0,   42,    0,    0,    0,    0,    0,
   26,   44,   44,   26,   26,    0,   26,   26,   26,   26,
   26,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   26,   26,   26,   26,   26,   26, 1006,    0,  745,
    0,   44,   44,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   26,    0,   26,   26,    0,    0,
    0,  745,    0,  765,    0,  745,    0,    0,    0,   44,
   44,   44,    0,    0,    3,    4,    5,    0,    0,    0,
    0,  175,    7,    8,    0,    0,   26,   26,   26,   13,
  135,  135,    0,    0,  135,  135,  135,  135,  135,    0,
  135,   20,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  135,  135,  135,    0,  135,  135,    0,    0,    0,
    0,   44,   30,   31,    0,    3,    4,    5,    0,    0,
    0,    0,  278,    7,    8,    0,    0,    0,    0,  279,
   13,    0,    3,    4,    5,    6,  135,  135,    0,    0,
    7,    8,   20,    0,    0,    0,    0,   13,    0,    0,
    0,    0,   44,    0,   44,   44,    0,   44,   44,   20,
   44,   44,   44,   30,   31,   41,    0,  135,  135,   40,
    0,    0,    0,  278,    0,    0,    0,    0,    0,    0,
  184,   31,    0,   44,    0,    0,   44,    0,    0,    0,
  104,    0,    0,    0,    0,    0,    0,  184,   44,    0,
  175,    0,  195,  206,  212,  225,  240,  240,  254,    0,
    0,    0,  240,    0,    0,   26,    0,    0,  786,    0,
    0,    0,    0,    0,    0,    9,    0,   10,    0,    0,
    0,  745,    0,    0,    0,  745,    0,   16,   17,    0,
  160,    0,    0,   21,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  900,   28,    0,    0,   29,   41,
  900,  828,    0,   40,  225,    0,  240,    0,   32,   33,
   34,   35,   36,    0,    0,    0,   26,   26,   26,   26,
   26,   26,   26,   26,   26,   26,   26,   26,    0,   26,
   26,   26,   26,   26,   26,   26,   26,   26,   26,   26,
   26,    0,    0,    0,    0,   45,    0,    0,    0,    0,
    0,  175,    0,  206,  212,   44,   44,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   44,    0,    0,
   44,   44,   44,   44,    0,    0,    0,   44,   44,    0,
    0,    0,   45,   45,    0,    0,    0,   42,    0,    0,
    0,    0,    0,   45,   45,    0,   45,   45,   45,   45,
    0,    0,    0,    0,    0,    0,    0,   45,   45,  135,
  135,  135,  135,  135,  135,  135,  135,  135,    0,    0,
    0,    0,    0,    0,    3,    4,    5,    6,    0,   45,
    0,    0,    7,    8,    9,    0,    0,   11,   12,   13,
  900,    0,   14,    0,    0,   15,    0,    0,   18,    0,
    0,   20,   21,   22,   23,   24,   25,    0,    0,   26,
   27,    0,    0,    0,   28,    0,    0,    0,  175,    0,
  206,  212,  225,   31,    0,    0,    0,    0,   44,    0,
   44,   44,  104,    0,    0,    0,    0,    0,    0,  216,
    0,    0,  175,   44,    0,    0,   44,    0,   44,   44,
    0,    0,    0,    0,    0,    0,   45,    0,   45,   45,
    0,    0,    0,    0,    0,    0,    0,    0,    3,    4,
    5,    6,    0,   44,   44,   44,    7,    8,    9,    0,
    0,  175,    0,   13,    0,    0,   44,    0,   44,    0,
    0,    0,    0,    0,    0,   20,   21,    0,    0,    0,
    0,    0,    0,   45,    0,    0,    0,    0,   28,    0,
    0,   45,    0,    0,   45,   45,   30,   31,    0,    0,
    0,    0,    0,   41,    0,  672,   37,   40,    0,    0,
    0,    0,    0,  502,    0,  225,  240,  745,  745,  745,
    0,   45,    0,   45,    0,   44,    0,   44,   44,   44,
    0,   44,    0,    0,    0,    0,   44,    0,   44,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   44,
    0,    0,   44,    0,   44,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  900,  900,    0,    0,    0,    0,
   45,   45,   45,    0,    0,    0,    0,    0,   44,   45,
    0,   42,    0,    0,   45,   42,    0,    0,  745,  745,
    0,    0,   41,    0, 1080,    0,   40,    0,    0,    0,
    0,    0,    0,    0,    0,   80,   80,   45,   80,   61,
   80,   80,   61,   80,   80,   80,    0,    0,    0,    0,
    0,    9,    0,   10,    0,   45,   45,   45,   80,   61,
   80,   80,   45,   16,   17,    0,  160,    0,    0,   21,
    0,    0,    0,    0,    0,    0,    0,    0,  745,    0,
    0,   28,    0,    0,   29,   45,   45,  631,    0,   80,
    0,    0,   80,    0,   32,   33,   34,   35,   36,    0,
  631,    0,    0,    0,    0,    0,    0,   45,   45,   45,
   42,    0,    0,    0,    0,    0,    0,    0,    0, 1029,
    0,    0,   80,    0,   45,    0,   45,   45,    0,    0,
   45,   45,   45,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    3,    4,    5,    6,    3,    4,    5,    0,
    7,    8,    9,    0,    7,    8,    0,   13,    0,    0,
    0,   13,    0,    0,    0,    0,    0,    0,    0,   20,
   21,    0,    0,   20,   45,   45,   45,   45,   45,    0,
   45,   45,   28,    0,    0,    0,   62,    0,    0,    0,
   30,   31,    0,    0,   30,   31,    0,   45,   45,    0,
   37,    0,    0,    0,  278,    0,    0,  184,    0,    0,
    0,  184,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  746,    0,   45,   45,    0,
   41,    0,  761,  310,   40,  318,  322,  222,  230,  233,
  238,    3,    4,    5,    6,    0,    0,    0,    0,    7,
    8,    9,    0,    0,    0,    0,   13,  746,    0,    0,
   80,  746,    0,    0,    0,   45,   45,   45,   20,   21,
   62,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  310,   28,    0,  190,    0,    0,    0,    0,    0,   30,
   31,    0,    0,    0,    0,    0,    0,    0,    0,   37,
    0,    0,    0,    0,    0,    0,  502,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   45,    0,    0,
    0,   80,   80,   80,   80,   80,   80,   80,   80,   80,
   80,   80,   61,    0,   80,   80,   80,   80,   80,   80,
   80,   80,   80,   80,   80,   80,    0,   43,    0,  230,
  233,    0,    0,    0,    0,    0,    0,    0,   45,    0,
   45,   45,    0,   45,   45,    0,   45,   45,   45,    0,
    0,    0,    0,    0,    0,    0,    0,  500,  318,  322,
    0,    0,    0,    0,  163,  185,  310,    0,    0,   45,
    0,  310,   45,    0,    0,  163,  163,    0,  163,   43,
   43,  163,    0,    0,   45,  230,  233,    0,    0,  163,
  163,   41,    0, 1096,    0,   40,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   43,    0,    0,  439,    0,    0,  746,    0,    0,
    0,  746,    0,    0,    0,    0,    0,    0,    0,    3,
    4,    5,    6,    0,    0,    0,    0,    7,    8,    9,
  901,    0,   11,   12,   13,    0,  901,   14,    0,    0,
   15,    0,    0,   18,    0,    0,   20,   21,   22,   23,
   24,   25,    0,    0,   26,   27,    0,    0,    0,   28,
    0,    0,  230,  233,    0,    0,    0,    0,   31,   42,
    0,  310,    0,  318,  322,    0,    0,  104,  185,    0,
  163,  163,    0,    0,  216,    0,    0,    0,    0,    0,
    0,   45,   45,    0,    0,    0,    0,    0,  535,    0,
    0,    0,    0,   45,    0,    0,   45,   45,   45,   45,
    0,    0,    0,   45,   45,    0,  564,  568,  574,    0,
    0,    0,    0,  586,    0,  185,    0,    0,    0,    0,
    0,    0,    0,  185,    0,    0,  163,  163,    0,    0,
    0,    0,    0,    0,  500,  500,  624,  627,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  431,    0,  431,    0,    0,  535,  564,
  568,    0,    0,    0,    0,    0,  901,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  230,  233,    0,
    0,    0,  230,  233,    0,    0,    0,    0,    0,    0,
    3,    4,    5,    6,    0,    0,    0,    0,    7,    8,
    9,    0,    0,    0,   45,   13,   45,   45,    0,    0,
    0,    0,  185,   43,   43,    0,    0,   20,   21,   45,
    0,  185,   45,    0,   45,   45,  185,    0,  702,  703,
   28,    0,    0,    0,    0,    0,    0,    0,   30,   31,
    0,    0,    0,    0,    0,    0,    0,    0,   37,   45,
   45,   45,    0,    0,    0,  502,    0,    0,    0,    0,
    0,    0,   45,    0,   45,    0,  273,    0,  273,  273,
  273,    0,  273,    0,    0,    0,    0,    0,  230,  233,
    0,    0,    0,    0,    0,    0,  273,  273,    0,  273,
    0,    0,    0,    0,    0,  500,    0,  318,  322,    0,
  310,  310,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  746,  746,  746,    0,  230,  233,  273,
    0,   45,    0,   45,   45,   45,    0,   45,    0,    0,
    0,    0,   45,    0,   45,    0,  665,    0,  431,  431,
    0,    0,  665,  431,  431,   45,    0,    0,   45,    0,
   45,    0,    0,    0,  273,    0,    0,    0,    0,    0,
    0,  402,    0,    0,    0,    0,    0,    0,    0,    0,
  901,  901,    0,   81,   81,    0,   81,   61,   81,   81,
   61,   81,   81,   81,   45,    0,  431,  431,  431,  431,
  431,    0,  431,  431,  746,  746,   81,   61,   81,   81,
    0,    0,    9,    0,   10,    0,    0,    0,    0,  185,
  185,  230,  233,    0,   16,   17,    0,  160,  230,  233,
   21,    0,    0,    0,    0,    0,    0,   81,    0,    0,
   81,    0,   28,    0,    0,   29,    0,  665,    0,    0,
  848,    0,    0,   62,    0,   32,   33,   34,   35,   36,
    0,    0,    0,    0,  746,  535,    0,    0,  500,  500,
   81,    0,    0,    0,    0,    0,    0,    0,    0,  665,
    0,    0,    0,  665,    0,    0,    0,  665,    0,    0,
    0,    0,    0,    0,  273,  273,  273,  273,  273,    0,
    0,    0,  233,  273,  273,  273,    0,  273,  367,    0,
  273,    0,    0,    0,  529,    0,    0,  273,  273,    0,
  273,    0,  273,  273,    0,  542,  543,    0,    0,    0,
  402,  402,  402,  402,    0,  273,    0,    0,  273,  665,
    0,    0,    0,  273,  273,  402,    0,    0,  273,  273,
  273,  273,  273,  273,    0,    0,    0,  402,    0,    0,
  273,    0,    0,    0,    0,    0,    3,    4,    5,    0,
  452,    0,  273,  696,    7,    8,    0,    0,    0,    0,
  665,   13,    0,    0,    0,  665,  665,    0,  665,  402,
    0,    0,    0,   20,  972,    0,    0,  982,  982,  988,
  990,    0,    0,    0,  998,  982,    0,    0,   81, 1075,
    0, 1079, 1081,    0,   43,   31,  453,  454,  455,  456,
    0,    0,  367,    0,  104,    0,    0,    0,    0,    0,
    0,  457,  367,    0,    0,    0, 1093, 1095, 1097,    0,
    0,    0,    0,    0,    0,  367,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  665,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   81,
   81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
   61,    0,   81,   81,   81,   81,   81,   81,   81,   81,
   81,   81,   81,   81,    0,    0,    0,    0,    0,    0,
  310,  310,  310,    0,   41,    0,  760,    0,   40,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  500,
  848,  500,    0,    0,    0,  230,  233,    0,    0,    0,
    0,    0,    0,    0,    0,  500,    0,  500,    0,    0,
    0,    0,    0,  665,  665,    0,    0,    0,    0,    0,
    0,  230,  233,    0,    0,    0,    0,  190,    0,    0,
    0,    0,    0,  982,    0, 1104,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  500,  322,  402,  402,  402,  402,  402,  402,  402,
  402,  402,  402,  402,  402,  402,  402,  402,  402,  402,
  402,  402,  402,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  367,    0,    0,    0,    0,    0,    0,
    0,    0,  535,    0,  564,  568,  574,    0,  627,    0,
  367,    0,    0,    0,    0,  735,    0,    0,    0,    0,
  367,  500,    0,    0,    0,    0,  535,   41,    0,  995,
  367,   40,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  431,  969,  431,  431,
    0,    0,    0,    0,  402,    0,    0,    0,    0,    0,
    0,    0,  763,    0,  665,    0,  367,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  233,    0,    0,  367,
    0,    0,    0,    0,  774,    0,    0,  775,    0,    0,
    0,  665,    0,  367,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    3,    4,    5,    6,    0,  402,  666,
    0,    7,    8,    9,    0,   42,    0,    0,   13,    0,
    0,    0,    0,  402,    0,    0,    0,    0,    0,    0,
   20,   21,    0,    0,    0,    0,  367,  763,  367,    0,
    0,    0,    0,   28,    0,    0,    0,    0,    0,    0,
    0,  367,   31,  402,    0,  665,  665,  665,    0,    0,
    0,  104,    0,    0,    0,    0,    0,  367,  184,    0,
    0,    0,    0,  139,  665,    0,  665,  134,  136,    0,
  129,    0,  132,  130,  144,  131,  142,  133,    0,    0,
  665,  666,  665,    0,    0,    0,    0,    0,    0,    0,
  140,  145,  141,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  367,    0,  367,    0,  367,  431,    0,    0,    0,
    0,  143,    0,  735,  135,    0,  665,    0,    0,    0,
    0,    0,    0,    0,    0,  258,    3,    4,    5,    6,
    0,    0,    0,  367,    7,    8,  402,  896,  763,  367,
    0,   13,    0,    0,  137,    0,  138,    0,    0,    0,
    0,    0,    0,   20,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  402,
  402,    0,    0,    0,   30,   31,  665,    0,    0,    0,
    0,  402,    0,    0,   37,    0,    0,    0,    0,    0,
    0,  967,    0,    0,    0,    0,    0,    0,    0,  367,
  367,    0,    0,  367,  666,  666,  666,  666,    0,    0,
  402,    0,    0,  666,  666,  666,    0,  666,  666,  666,
  666,    0,    0,  666,    0,    0,  666,  666,  666,  666,
  666,    0,  666,  666,  666,  666,  666,  666,    0,    0,
  666,  666,  367,    0,    0,  666,    0,    0,  666,    0,
    0,  367,    0,  367,  666,  367,    0,  367,  666,  666,
  666,  666,  666,  666,    0,  402,    0,    0,    0,    0,
  666,    0,    0,    0,    0,    0,   41,    3,    4,    5,
   40,    0,    0,  666,    0,    7,    8,    9,    0,    0,
   11,   12,   13,    0,    0,   14,    0,    0,   15,    0,
    0,   18,  367,    0,   20,   21,   22,   23,   24,   25,
    0,    0,   26,   27,    0,    0,    0,   28,    0,    0,
    0,    0,  102,  103,    0,    0,   31,    0,    0,  786,
    0,    0,    0,    0,    0,  104,    0,    0,    0,    0,
    0,    0,  105,  106,  107,  108,  109,  110,  111,  112,
  113,  114,  115,  116,    0,    0,  117,  118,  119,  120,
  121,  122,  123,  124,  125,  126,  127,  128,  313,  313,
    0,  313,  313,  313,  313,  313,  313,  313,  313,    0,
    0,    0,  402,    0,    0,  402,    0,    0,    0,  313,
  313,  313,  313,  313,  313,    0,    0,    0,    0,    0,
  735,    0,    0,    0,  367,    0,    0,    0,    0,    0,
  402,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  313,    0,  313,  313,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  367,  763,
  367,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  313,  313,  313,  313,    0,    0,
  715,  715,    0,  715,  715,  715,  715,  715,  715,  715,
  715,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  715,  715,  715,  715,  715,  715,    0,    0,    0,
    0,    0,    0,    0,    0,    3,    4,    5,    6,    0,
    0,    0,    0,    7,    8,    9,    0,    0,    0,    0,
   13,    0,    0,    0,  715,    0,  715,  715,    0,    0,
    0,    0,   20,   21,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   28,    0,    0,    0,    0,
    0,    0,    0,    0,   31,    0,  715,  715,  715,  715,
    0,    0,    0,  104,    0,    0,    0,    0,    0,    0,
  184,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  313,  313,  313,
  313,  313,    0,  313,    0,    0,  313,  313,  313,    0,
  313,    0,    0,  313,    0,    0,    0,    0,    0,    0,
  313,  313,    0,  313,    0,  313,  313,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  313,    0,
    0,  313,    0,    0,    0,    0,  313,  313,    0,    0,
    0,  313,  313,  313,  313,  313,  313,    0,    0,    0,
    0,    0,    0,  313,  313,  313,  313,  313,  313,  313,
  313,  313,  313,  313,  313,  313,  692,  313,  313,  313,
  313,  313,  313,  313,  313,  313,  313,  313,  313,  715,
  715,  715,  715,  715,    0,  715,    0,    0,  715,  715,
  715,    0,  715,    0,   41,  715,  968,    0,   40,    0,
    0,    0,  715,  715,    0,  715,    0,  715,  715,    0,
    0,    0,    0,    0,  969,    0,    0,    0,    0,    0,
  715,    0,    0,  715,    0,    0,    0,    0,  715,  715,
    0,    0,    0,  715,  715,  715,  715,  715,  715,    0,
    0,    0,    0,    0,    0,  715,  715,  715,  715,  715,
  715,  715,  715,  715,  715,  715,  715,  715,  696,  715,
  715,  715,  715,  715,  715,  715,  715,  715,  715,  715,
  715,  712,  712,    0,  712,  712,  712,  712,  712,  712,
  712,  712,   42,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  712,  712,  712,  712,  712,  712,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  712,    0,  712,  712,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  712,  712,  712,
  712,    0,    0,  315,  315,    0,  315,  315,  315,  315,
  315,  315,  315,  315,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  315,  315,  315,  315,  315,  315,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    3,    4,    5,    6,  315,    0,  315,
  315,    7,    8,    9,    0,   10,    0,    0,   13,    0,
    0,    0,    0,    0,    0,   16,   17,    0,  160,    0,
   20,   21,    0,    0,    0,    0,    0,    0,    0,  315,
  315,  315,  315,   28,    0,    0,   29,    0,    0,    0,
    0,   30,   31,    0,    0,    0,   32,   33,   34,   35,
   36,   37,    0,    0,    0,    0,    0,    0,  967,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  712,  712,  712,  712,  712,    0,  712,    0,    0,  712,
  712,  712,    0,  712,    0,    0,  712,    0,    0,    0,
    0,    0,    0,  712,  712,    0,  712,    0,  712,  712,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  712,    0,    0,  712,    0,    0,    0,    0,  712,
  712,    0,    0,    0,  712,  712,  712,  712,  712,  712,
    0,    0,    0,    0,    0,    0,  712,  712,  712,  712,
  712,  712,  712,  712,  712,  712,  712,  712,  712,  696,
  712,  712,  712,  712,  712,  712,  712,  712,  712,  712,
  712,  712,  315,  315,  315,  315,  315,    0,  315,    0,
    0,  315,  315,  315,    0,  315,    0,   41,  315,  664,
    0,   40,    0,    0,    0,  315,  315,    0,  315,    0,
  315,  315,    0,    0,    0,    0,    0,  969,    0,    0,
    0,    0,    0,  315,    0,    0,  315,    0,    0,    0,
    0,  315,  315,    0,    0,    0,  315,  315,  315,  315,
  315,  315,    0,    0,    0,    0,    0,    0,  315,  315,
  315,  315,  315,  315,  315,  315,  315,  315,  315,  315,
  315,  692,  315,  315,  315,  315,  315,  315,  315,  315,
  315,  315,  315,  315,  316,  316,    0,  316,  316,  316,
  316,  316,  316,  316,  316,   42,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  316,  316,  316,  316,  316,
  316,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  316,    0,
  316,  316,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  316,  316,  316,  316,    0,    0,  314,  314,    0,  314,
  314,  314,  314,  314,  314,  314,  314,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  314,  314,  314,
  314,  314,  314,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    3,    4,    5,    6,
  314,    0,  314,  314,    7,    8,    9,    0,   10,    0,
    0,   13,    0,    0,    0,    0,    0,    0,   16,   17,
    0,  160,    0,   20,   21,    0,    0,    0,    0,    0,
    0,    0,  314,  314,  314,  314,   28,    0,    0,   29,
    0,    0,    0,    0,   30,   31,    0,    0,    0,   32,
   33,   34,   35,   36,   37,    0,    0,    0,    0,    0,
    0,  967,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  316,  316,  316,  316,  316,    0,  316,
    0,    0,  316,  316,  316,    0,  316,    0,    0,  316,
    0,    0,    0,    0,    0,    0,  316,  316,    0,  316,
    0,  316,  316,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  316,    0,    0,  316,    0,    0,
    0,    0,  316,  316,    0,    0,    0,  316,  316,  316,
  316,  316,  316,    0,    0,    0,    0,    0,    0,  316,
  316,  316,  316,  316,  316,  316,  316,  316,  316,  316,
  316,  316,  692,  316,  316,  316,  316,  316,  316,  316,
  316,  316,  316,  316,  316,  314,  314,  314,  314,  314,
    0,  314,    0,    0,  314,  314,  314,    0,  314,    0,
    0,  314,    0,    0,    0,    0,    0,    0,  314,  314,
    0,  314,    0,  314,  314,    0,    0,   41,    0,  162,
    0,   40,    0,    0,    0,    0,  314,    0,    0,  314,
    0,    0,    0,    0,  314,  314,    0,    0,    0,  314,
  314,  314,  314,  314,  314,    0,    0,    0,    0,    0,
    0,  314,  314,  314,  314,  314,  314,  314,  314,  314,
  314,  314,  314,  314,  692,  314,  314,  314,  314,  314,
  314,  314,  314,  314,  314,  314,  314,  279,  279,    0,
  279,  279,  279,  279,  279,  279,  279,  279,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  279,  279,
  279,  279,  279,  279,    0,   42,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  279,    0,  279,  279,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  279,  279,  279,  279,    0,  690,  690,
    0,  690,  690,  690,  690,  690,  690,  690,  690,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  690,
  690,  690,  690,  690,  690,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  690,    0,  690,  690,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    3,    4,    5,    6,
    0,    0,    0,    0,    7,    8,    9,    0,   10,    0,
    0,   13,    0,    0,  690,  690,  690,  690,   16,   17,
    0,  160,    0,   20,   21,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   28,    0,    0,   29,
    0,    0,    0,    0,   30,   31,    0,    0,    0,   32,
   33,   34,   35,   36,   37,    0,    0,  279,  279,  279,
  279,  161,  279,    0,    0,  279,  279,  279,    0,  279,
    0,    0,  279,    0,    0,    0,    0,    0,    0,  279,
  279,    0,  279,    0,  279,  279,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  279,    0,    0,
  279,    0,    0,    0,    0,  279,  279,    0,    0,    0,
  279,  279,  279,  279,  279,  279,    0,    0,    0,    0,
    0,    0,  279,  279,  279,  279,  279,  279,  279,  279,
  279,  279,  279,  279,  279,  696,  279,  279,  279,  279,
  279,  279,  279,  279,  279,  279,  279,  279,  690,  690,
  690,  690,    0,  690,    0,    0,  690,  690,    0,    0,
    0,    0,    0,  690,    0,    9,    0,   10,   11,   12,
    0,    0,    0,   14,    0,  690,    0,   16,   17,   18,
  160,    0,    0,   21,   22,   23,   24,   25,    0,    0,
   26,   27,    0,    0,    0,   28,  690,  690,   29,    0,
    0,    0,    0,    0,    0,    0,  690,    0,   32,   33,
   34,   35,   36,  690,  690,  690,  690,  690,  690,  690,
  690,  690,  690,  690,  690,  690,    0,  690,  690,  690,
  690,  690,  690,  690,  690,  690,  690,  690,  690,   61,
   61,    0,   61,   61,   61,   61,   61,   61,   61,   61,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   61,   61,   61,   61,   61,   61,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   61,    0,   61,   61,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   61,   61,   61,   61,    0,
   62,   62,    0,   62,   62,   62,   62,   62,   62,   62,
   62,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   62,   62,   62,   62,   62,   62,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   62,    0,   62,   62,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   62,   62,   62,   62,
    0,    0,    0,   21,   21,    0,   21,   21,   21,   21,
   21,   21,   21,   21,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   21,   21,   21,   21,   21,   21,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   61,
   61,   61,   61,    0,   61,    0,    0,   61,   61,    0,
    0,    0,    0,    0,   61,    0,    0,   21,    0,   21,
   21,    0,    0,    0,    0,    0,   61,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   61,   61,   21,
   21,   21,    0,    0,    0,    0,    0,   61,    0,    0,
    0,    0,    0,    0,   61,   61,   61,   61,   61,   61,
   61,   61,   61,   61,   61,   61,   61,    0,   61,   61,
   61,   61,   61,   61,   61,   61,   61,   61,   61,   61,
   62,   62,   62,   62,    0,   62,    0,    0,   62,   62,
    0,    0,    0,    0,    0,   62,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   62,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   62,   62,
    0,    0,    0,    0,    0,    0,    0,    0,   62,    0,
    0,    0,    0,    0,    0,   62,   62,   62,   62,   62,
   62,   62,   62,   62,   62,   62,   62,   62,    0,   62,
   62,   62,   62,   62,   62,   62,   62,   62,   62,   62,
   62,    0,    0,   21,   21,   21,   21,    0,   21,    0,
    0,   21,   21,    0,    0,    0,    0,    0,   21,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   21,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   17,   17,    0,   17,   17,   17,   17,   17,   17,
   17,   17,   21,    0,    0,    0,    0,    0,    0,    0,
    0,   21,   17,   17,   17,   17,   17,   17,   21,   21,
   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
   21,  696,   21,   21,   21,   21,   21,   21,   21,   21,
   21,   21,   21,   21,    0,   17,    0,   17,   17,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   17,   17,   17,
    0,    0,   18,   18,    0,   18,   18,   18,   18,   18,
   18,   18,   18,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   18,   18,   18,   18,   18,   18,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   18,    0,   18,   18,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   18,   18,
   18,    0,    0,    0,    0,   19,   19,    0,   19,   19,
   19,   19,   19,   19,   19,   19,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   19,   19,   19,   19,
   19,   19,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   17,   17,   17,   17,    0,   17,    0,    0,   17,
   17,    0,    0,    0,    0,    0,   17,    0,    0,   19,
    0,   19,   19,    0,    0,    0,    0,    0,   17,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   17,   19,   19,   19,    0,    0,    0,    0,    0,   17,
    0,    0,    0,    0,    0,    0,   17,   17,   17,   17,
   17,   17,   17,   17,   17,   17,   17,   17,   17,    0,
   17,   17,   17,   17,   17,   17,   17,   17,   17,   17,
   17,   17,   18,   18,   18,   18,    0,   18,    0,    0,
   18,   18,    0,    0,    0,    0,    0,   18,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   18,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   18,    0,    0,    0,    0,    0,    0,    0,    0,
   18,    0,    0,    0,    0,    0,    0,   18,   18,   18,
   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,
    0,   18,   18,   18,   18,   18,   18,   18,   18,   18,
   18,   18,   18,    0,    0,   19,   19,   19,   19,    0,
   19,    0,    0,   19,   19,    0,    0,    0,    0,    0,
   19,    0,    0,    0,  236,    0,  236,    0,  236,    0,
    0,    0,   19,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   20,   20,    0,   20,   20,   20,   20,
   20,   20,   20,   20,   19,    0,    0,    0,    0,    0,
    0,    0,    0,   19,   20,   20,   20,   20,   20,   20,
   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
   19,   19,   19,    0,   19,   19,   19,   19,   19,   19,
   19,   19,   19,   19,   19,   19,    0,   20,    0,   20,
   20,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  236,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   20,
   20,   20,    0,    0,   22,   22,    0,   22,   22,   22,
   22,   22,   22,   22,   22,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   22,   22,   22,   22,   22,
   22,  702,  702,    0,  702,  702,  702,  702,  702,  702,
  702,  702,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  702,  702,  702,  702,  702,  702,   22,    0,
   22,   22,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  702,    0,  702,  702,    0,
   22,   22,   22,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  236,  236,  236,  236,  236,  702,  702,  702,
    0,  236,  236,    0,    0,    0,    0,    0,  236,    0,
    0,    0,    0,   20,   20,   20,   20,    0,   20,    0,
  236,   20,   20,    0,    0,    0,    0,    0,   20,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   20,  236,  236,    0,    0,    0,    0,    0,    0,    0,
    0,  236,    0,    0,    0,    0,    0,    0,  236,    0,
    0,    0,   20,    0,    0,    0,    0,    0,    0,    0,
    0,   20,    0,    0,    0,    0,    0,    0,   20,   20,
   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,
   20,    0,   20,   20,   20,   20,   20,   20,   20,   20,
   20,   20,   20,   20,   22,   22,   22,   22,    0,   22,
    0,    0,   22,   22,    0,    0,    0,    0,    0,   22,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   22,    0,    0,    0,    0,  702,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   22,    0,    0,    0,    0,    0,    0,
    0,   41,   22,    0,    0,   40,    0,    0,    0,   22,
   22,   22,   22,   22,   22,   22,   22,   22,   22,   22,
   22,   22,    0,   22,   22,   22,   22,   22,   22,   22,
   22,   22,   22,   22,   22,    0,    0,  702,  702,  702,
  702,  702,  702,  702,  702,  702,  702,  702,  702,  695,
  702,  702,  702,  702,  702,  702,  702,  702,  702,  702,
  702,  702,  703,  703,    0,  703,  703,  703,  703,  703,
  703,  703,  703,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  703,  703,  703,  703,  703,  703,   15,
   15,    0,   15,   15,   15,   15,   15,   15,   15,   15,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   15,   15,   15,   15,   15,   15,  703,    0,  703,  703,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   15,    0,   15,   15,    0,  703,  703,
  703,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   89,   89,    0,   89,   89,   89,   89,   89,
   89,   89,   89,    0,    0,    0,   15,   15,    0,    0,
    0,    0,    0,   89,   89,   89,   89,   89,   89,   88,
   88,    0,   88,   88,   88,   88,   88,   88,   88,   88,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   88,   88,   88,   88,   88,   88,   89,    0,   89,   89,
    3,    4,    5,    6,    0,    0,    0,    0,    7,    8,
    9,    0,    0,    0,    0,   13,    0,    0,    0,    0,
    0,    0,    0,   88,    0,   88,   88,   20,   21,   89,
   89,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   28,    0,    0,    0,    0,    0,    0,    0,    0,   31,
    0,    0,    0,    0,    0,    0,   88,   88,  104,    0,
    0,    0,    0,    0,    0,  184,    0,  703,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   15,    0,    0,   92,   92,    0,
    0,   92,   92,   92,   92,   92,   67,   92,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   92,   92,
   92,   92,   92,   92,    0,    0,    0,    0,  703,  703,
  703,  703,  703,  703,  703,  703,  703,  703,  703,  703,
  695,  703,  703,  703,  703,  703,  703,  703,  703,  703,
  703,  703,  703,   92,   92,   15,   15,   15,   15,   15,
   15,   15,   15,   15,   15,   15,   15,   89,   15,   15,
   15,   15,   15,   15,   15,   15,   15,   15,   15,   15,
    0,    0,    0,    0,   92,   92,    0,    0,    0,    0,
    0,    0,    0,    0,   88,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   89,   89,
   89,   89,   89,   89,   89,   89,   89,   89,   89,   89,
    0,   89,   89,   89,   89,   89,   89,   89,   89,   89,
   89,   89,   89,    0,    0,   88,   88,   88,   88,   88,
   88,   88,   88,   88,   88,   88,   88,    0,   88,   88,
   88,   88,   88,   88,   88,   88,   88,   88,   88,   88,
  702,  702,    0,  702,    0,  702,  702,  702,  702,  702,
  702,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  517,  702,  702,  702,  702,  702,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  709,  709,    0,    8,    8,  709,  709,  709,  709,
  709,  709,    0,    0,  702,    0,    0,  702,    0,    0,
    0,    0,    0,    0,  709,  709,  709,  709,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  702,    0,    0,
    0,    0,    0,    0,    0,    8,    0,    0,  709,    0,
    0,    0,    0,   69,    0,    0,   92,   92,   92,   92,
   92,   92,   92,   92,   92,    0,   92,   92,   92,   92,
   92,   92,   92,   92,   92,   92,   92,   92,  709,  711,
  711,    0,    9,    9,  711,  711,  711,  711,  711,  711,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  711,  711,  711,  711,  112,  112,    0,  112,
  112,  112,  112,  112,  112,    0,  112,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  112,  112,  112,
  112,  112,  112,    9,  118,  118,  711,    0,  118,  118,
  118,  118,  118,    0,  118,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  118,  118,  118,  118,  118,
  118,    0,  112,  112,    0,    0,  711,    0,    0,    0,
    0,    0,    0,    0,  111,  702,    0,  111,  111,    0,
  111,  111,  111,    0,  111,    0,    0,    0,    0,    0,
  118,  118,    0,  112,  112,  111,  111,  111,  111,  111,
  111,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  709,    0,    0,    0,
    0,  118,  118,    0,    0,    0,    0,    0,    0,    0,
  111,  111,    0,    0,    0,    0,  702,  702,  702,  702,
  702,  702,  702,  702,  702,  702,  702,    0,  695,  702,
  702,  702,  702,  702,  702,  702,  702,  702,  702,  702,
  702,  111,  111,  496,    0,    0,    0,    0,  496,    0,
  496,    0,  496,  496,    0,  496,    0,  709,  709,  709,
  709,  709,  709,  709,  709,  709,  709,  709,    0,  496,
  709,  709,  709,  709,  709,  709,  709,  709,  709,  709,
  709,  709,    0,    0,  711,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  496,    0,  496,  496,    0,  594,    0,
    0,    0,    0,    0,    0,  711,  711,  711,  711,  711,
  711,  711,  711,  711,  711,  711,    0,    0,  711,  711,
  711,  711,  711,  711,  711,  711,  711,  711,  711,  711,
    0,    0,    0,    0,    0,  112,  112,  112,  112,  112,
  112,  112,  112,  112,    0,  112,  112,  112,  112,  112,
  112,  112,  112,  112,  112,  112,  112,    0,    0,    0,
    0,    0,    0,  118,  118,  118,  118,  118,  118,  118,
  118,  118,    0,  118,  118,  118,  118,  118,  118,  118,
  118,  118,  118,  118,  118,    0,  352,    0,    0,    0,
    0,   41,    0,  743,  744,   40,  349,    0,  350,    0,
    0,    0,    0,  111,  111,  111,  111,  111,  111,  111,
  111,  111,    0,  111,  111,  111,  111,  111,  111,  111,
  111,  111,  111,  111,  111,    0,  496,  496,  496,  496,
  496,    0,    0,    0,    0,  496,  496,  496,    0,  496,
  496,  496,  496,  496,  190,  496,  496,  496,  496,  496,
  496,  496,  496,  496,  496,  496,  496,  496,  496,  496,
  496,  496,  496,  496,  496,  496,  496,  496,  496,  496,
  496,  496,  496,  496,  496,  496,  496,    0,    0,  351,
  496,  496,  496,  496,  496,  496,  496,  496,  496,  496,
  496,  496,  496,    0,  496,  496,    0,    0,    0,  352,
    0,    0,    0,    0,   41,  496,  743,  348,   40,  349,
    0,  350,    0,    0,    0,    3,    4,    5,    0,    0,
    0,    0,    0,    7,    8,    9,    0,    0,   11,   12,
   13,    0,    0,   14,    0,    0,   15,    0,    0,   18,
    0,    0,   20,   21,   22,   23,   24,   25,    0,    0,
   26,   27,    0,    0,    0,   28,    0,  190,    0,    0,
    0,    0,    0,    0,   31,    0,    0,    0,    0,  352,
    0,    0,    0,  104,   41,    0,  743,  764,   40,  349,
  105,  350,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  351,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    3,    4,    5,    6,    0,    0,    0,    0,    7,    8,
    9,    0,   10,   11,   12,   13,    0,  190,   14,    0,
    0,   15,   16,   17,   18,  160,    0,   20,   21,   22,
   23,   24,   25,    0,    0,   26,   27,    0,    0,  333,
   28,    0,    0,   29,    0,  334,  335,  336,   30,   31,
    0,    0,  351,   32,   33,   34,   35,   36,   37,  337,
  338,  339,  340,  341,  342,  343,    0,  344,  345,    0,
    0,  352,    0,    0,    0,    0,   41,  346,  894,  744,
   40,  349,    0,  350,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    3,    4,    5,    6,    0,    0,    0,
    0,    7,    8,    9,    0,   10,   11,   12,   13,  190,
    0,   14,    0,    0,   15,   16,   17,   18,  160,    0,
   20,   21,   22,   23,   24,   25,    0,    0,   26,   27,
    0,    0,  333,   28,    0,    0,   29, 1033,  334,  335,
  336,   30,   31,    0,  351,    0,   32,   33,   34,   35,
   36,   37,  337,  338,  339,  340,  341,  342,  343,    0,
  344,  345,    0,    3,    4,    5,    6,    0,    0,    0,
  346,    7,    8,    9,    0,   10,   11,   12,   13,    0,
    0,   14,    0,    0,   15,   16,   17,   18,  160,    0,
   20,   21,   22,   23,   24,   25,    0,    0,   26,   27,
    0,    0,  333,   28,    0,    0,   29,    0,  334,  335,
  336,   30,   31,    0,    0,    0,   32,   33,   34,   35,
   36,   37,  337,  338,  339,  340,  341,  342,  343,    0,
  344,  345,    0,    0,  352,    0,    0,    0,    0,   41,
  346,  894,  348,   40,  349,    0,  350,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    3,    4,    5,    6,    0,
    0,    0,    0,    7,    8,    9,    0,   10,   11,   12,
   13,    0,  190,   14,    0,    0,   15,   16,   17,   18,
  160,    0,   20,   21,   22,   23,   24,   25,    0,    0,
   26,   27,    0,    0,  333,   28,    0,    0,   29,    0,
  334,  335,  336,   30,   31,    0,    0,  351,   32,   33,
   34,   35,   36,   37,  337,  338,  339,  340,  341,  342,
  343,  352,  344,  345,    0,    0,   41,    0,  894,  764,
   40,  349,  346,  350,    3,    4,    5,    0,    0,    0,
    0,    0,    7,    8,    9,    0,    0,   11,   12,   13,
    0,    0,   14,    0,    0,   15,    0,    0,   18,    0,
    0,   20,   21,   22,   23,   24,   25,    0,    0,   26,
   27,    0,    0,    0,   28,    0,    0,    0,    0,  190,
    0,    0,    0,   31,    0,    0,    0,    0,    0,    0,
    0,    0,  104,    0,    0,    0,    0,    0,    0,  105,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  352,    0,    0,  351,    0,   41,    0,  347,  348,
   40,  349,    0,  350,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    3,    4,
    5,    6,    0,    0,    0,    0,    7,    8,    9,    0,
   10,   11,   12,   13,    0,    0,   14,    0,    0,   15,
   16,   17,   18,  160,    0,   20,   21,   22,   23,   24,
   25,    0,    0,   26,   27,    0,    0,  333,   28,    0,
    0,   29,    0,  334,  335,  336,   30,   31,    0,    0,
    0,   32,   33,   34,   35,   36,   37,  337,  338,  339,
  340,  341,  342,  343,  351,  344,  345,    0,    0,    0,
    0,    0,    0,    0,    0,  346,    0,    0,  352,    0,
    0,    0,    0,   41,    0,  347,  744,   40,  349,    0,
  350,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    3,    4,    5,    6,    0,
    0,    0,    0,    7,    8,    9,    0,   10,   11,   12,
   13,    0,    0,   14,    0,    0,   15,   16,   17,   18,
  160,    0,   20,   21,   22,   23,   24,   25,    0,    0,
   26,   27,    0,    0,  333,   28,    0,    0,   29,    0,
  334,  335,  336,   30,   31,    0,    0,    0,   32,   33,
   34,   35,   36,   37,  337,  338,  339,  340,  341,  342,
  343,  351,  344,  345,    0,    0,  284,    0,  284,    0,
  284,    0,  346,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    3,    4,    5,    6,    0,
    0,    0,    0,    7,    8,    9,    0,   10,   11,   12,
   13,    0,    0,   14,    0,    0,   15,   16,   17,   18,
  160,    0,   20,   21,   22,   23,   24,   25,    0,    0,
   26,   27,    0,    0,  333,   28,    0,    0,   29,    0,
  334,  335,  336,   30,   31,    0,    0,    0,   32,   33,
   34,   35,   36,   37,  337,  338,  339,  340,  341,  342,
  343,    0,  344,  345,  284,   41,    0,  571,  348,   40,
    0,    0,  346,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    3,    4,    5,    6,    0,    0,    0,    0,
    7,    8,    9,    0,   10,   11,   12,   13,  190,    0,
   14,    0,    0,   15,   16,   17,   18,  160,    0,   20,
   21,   22,   23,   24,   25,    0,    0,   26,   27,    0,
    0,  333,   28,    0,    0,   29,    0,  334,  335,  336,
   30,   31,    0,   42,    0,   32,   33,   34,   35,   36,
   37,  337,  338,  339,  340,  341,  342,  343,    0,  344,
  345,    0,    0,    0,    0,    0,    0,    0,    0,  346,
   41,    0,  623,  348,   40,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  284,  284,  284,  284,    0,
    0,    0,    0,  284,  284,  284,    0,  284,  284,  284,
  284,    0,    0,  284,    0,    0,  284,  284,  284,  284,
  284,    0,  284,  284,  284,  284,  284,  284,    0,    0,
  284,  284,    0,  190,    0,  284,    0,    0,  284,    0,
    0,    0,    0,  284,  284,    0,    0,    0,  284,  284,
  284,  284,  284,  284,    0,    0,    0,    0,    0,   41,
  284,  306,  348,   40,    0,    0,    0,    0,   42,    0,
    0,    0,    0,  284,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    3,    4,    5,    6,    0,    0,
    0,    0,    7,    8,    9,    0,   10,   11,   12,   13,
    0,    0,   14,    0,    0,   15,   16,   17,   18,  160,
    0,   20,   21,   22,   23,   24,   25,    0,    0,   26,
   27,    0,    0,    0,   28,    0,    0,   29,    0,    0,
    0,    0,   30,   31,    0,    0,    0,   32,   33,   34,
   35,   36,   37,    0,    0,    0,    0,   42,   41,  710,
  664, 1068,   40,    0,    0,    0,    0,    0,    0,    0,
    0,  346,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    3,
    4,    5,    6,    0,    0,    0,    0,    7,    8,    9,
    0,   10,   11,   12,   13,    0,    0,   14,    0,    0,
   15,   16,   17,   18,  160,    0,   20,   21,   22,   23,
   24,   25,    0,    0,   26,   27,   42,    0,    0,   28,
    0,   41,   29,  664, 1068,   40,    0,   30,   31,    0,
    0,    0,   32,   33,   34,   35,   36,   37,    0,    0,
    0,    0,    0,    0,  710,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  346,    0,    3,    4,
    5,    6,    0,    0,    0,    0,    7,    8,    9,    0,
   10,   11,   12,   13,    0,    0,   14,    0,    0,   15,
   16,   17,   18,  160,    0,   20,   21,   22,   23,   24,
   25,    0,    0,   26,   27,    0,    0,    0,   28,    0,
   41,   29,  761,  348,   40,    0,   30,   31,    0,   42,
    0,   32,   33,   34,   35,   36,   37,    0,    0,    0,
    0,    0,    0,  413,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  346,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    3,    4,    5,
    6,    0,    0,  190,    0,    7,    8,    9,    0,   10,
   11,   12,   13,    0,    0,   14,    0,    0,   15,   16,
   17,   18,  160,    0,   20,   21,   22,   23,   24,   25,
    0,    0,   26,   27,    0,    0,    0,   28,    0,    0,
   29,    0,    0,    0,    0,   30,   31,    0,    0,    0,
   32,   33,   34,   35,   36,   37,   41,    0,  761,    0,
   40,    0, 1067,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  346,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    3,    4,    5,    6,    0,    0,    0,    0,    7,    8,
    9,    0,   10,   11,   12,   13,    0,    0,   14,  190,
    0,   15,   16,   17,   18,  160,    0,   20,   21,   22,
   23,   24,   25,    0,    0,   26,   27,    0,  668,    0,
   28,    0,    0,   29,    0,    0,    0,    0,   30,   31,
    0,    0,    0,   32,   33,   34,   35,   36,   37,    0,
    0,    0,    0,    0,    0, 1091,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  346,    0,    3,
    4,    5,    6,    0,    0,    0,    0,    7,    8,    9,
    0,   10,   11,   12,   13,    0,    0,   14,    0,    0,
   15,   16,   17,   18,  160,    0,   20,   21,   22,   23,
   24,   25,    0,    0,   26,   27,    0,    0,    0,   28,
  668,    0,   29,    0,    0,    0,    0,    0,   31,    0,
    0,    0,   32,   33,   34,   35,   36,  104,    0,  306,
    0,  306,  306,  306,  710,  306,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  346,    0,    0,    0,
  306,    0,  306,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    3,    4,    5,    6,    0,
    0,    0,  306,    7,    8,    9,    0,    0,    0,  307,
   13,  307,  307,  307,    0,  307,    0,    0,    0,    0,
    0,    0,   20,   21,    0,    0,    0,    0,    0,  307,
  307,    0,  307,    0,  317,   28,    0,  306,    0,    0,
    0,    0,    0,    0,   31,    0,    0,    0,    0,    0,
    0,    0,    0,  104,    0,    0,    0,    0,    0,    0,
  184,    0,  307,  668,  668,  668,  668,    0,    0,    0,
    0,    0,  668,  668,  668,    0,  668,  668,  668,  668,
    0,    0,  668,  348,    0,  668,  668,  668,  668,  668,
    0,  668,  668,  668,  668,  668,  668,  307,    0,  668,
  668,    0,    0,    0,  668,    0,    0,  668,    0,    0,
    0,    0,    0,  668,    0,    0,    0,  668,  668,  668,
  668,  668,  668,    3,    4,    5,    0,    0,    0,  668,
    0,    7,    8,    9,    0,    0,   11,   12,   13,    0,
    0,   14,  668,  739,   15,    0,    0,   18,    0,    0,
   20,   21,   22,   23,   24,   25,    0,    0,   26,   27,
    0,    0,    0,   28,    0,    0,    0,  306,  306,  306,
  306,  306,   31,    0,    0,    0,  306,  306,  306,    0,
  306,  104,    0,  306,    0,    0,    0,    0, 1118,    0,
  306,  306,    0,  306,    0,  306,  306,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  306,    0,
    0,  306,    0,    0,    0,    0,  306,  306,    0,    0,
    0,  306,  306,  306,  306,  306,  306,  307,  307,  307,
  307,  307,    0,  306,    0,    0,  307,  307,  307,    0,
  307,    0,    0,  307,    0,  306,    0,    0,    0,    0,
  307,  307,    0,  307,  352,  307,  307,    0,    0,   41,
    0,  347,    0,   40,  349,    0,  350,    0,  307,    0,
    0,  307,    0,    0,    0,    0,  307,  307,    0,    0,
    0,  307,  307,  307,  307,  307,  307,    0,    0,    0,
    0,    0,    0,  307,    0,    0,    0,    0,    0,    3,
    4,    5,    0,    0,    0,  307,    0,    7,    8,    9,
    0,   10,   11,   12,   13,    0,    0,   14,    0,    0,
   15,   16,   17,   18,  160,    0,   20,   21,   22,   23,
   24,   25,    0,    0,   26,   27,    0,    0,    0,   28,
    0,    0,   29,    0,  441,   41,    0,  351,   31,   40,
    0,    0,   32,   33,   34,   35,   36,  104,    0,    3,
    4,    5,    0,    0,  710,    0,    0,    7,    8,    9,
    0,   10,   11,   12,   13,    0,  346,   14,    0,    0,
   15,   16,   17,   18,  160,    0,   20,   21,   22,   23,
   24,   25,    0,    0,   26,   27,    0,    0,    0,   28,
    0,    0,   29,    0,    0,    0,    0,    0,   31,    0,
    0,    0,   32,   33,   34,   35,   36,  104,    0,    0,
    0,    0,    0,    0,  710,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  352,  346,    0,    0,    0,
   41,    0,  347,    0,   40,  349,    0,  350,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    2,    3,    4,
    5,    6,    0,    0,    0,    0,    7,    8,    9,    0,
   10,   11,   12,   13,  938,    0,   14,  939,  940,   15,
   16,   17,   18,  160,  941,   20,   21,   22,   23,   24,
   25,  942,  943,   26,   27,  944,  945,  333,   28,  946,
  947,   29,  948,  334,  335,  336,   30,   31,  351,    0,
    0,   32,   33,   34,   35,   36,  949,  337,  338,  339,
  340,  341,  342,  950,  352,  344,  345,    0,    0,   41,
    0,  347,    0,   40,  349,    0,  350,    0,    0,    0,
    0,    0,    0,    0,    3,    4,    5,    6,    0,    0,
    0,    0,    7,    8,    9,    0,    0,   11,   12,   13,
    0,    0,   14,    0,    0,   15,    0,    0,   18,    0,
    0,   20,   21,   22,   23,   24,   25,    0,    0,   26,
   27,    0,    0,    0,   28,    0,    0,    0,    0,    0,
    0,    0,    0,   31,    0,    0,  352,    0,    0,    0,
    0,   41,  104, 1140,    0,   40,  349,    0,  350,  216,
    0,    0,    0,    0,    0,    0,    0,  351,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1129,    3,
    4,    5,    6,    0,    0,    0,    0,    7,    8,    9,
    0,   10,   11,   12,   13,    0,    0,   14,    0,    0,
   15,   16,   17,   18,  160,    0,   20,   21,   22,   23,
   24,   25,    0,    0,   26,   27,    0,    0,  333,   28,
    0,    0,   29,    0,  334,  335,  336,   30,   31,  351,
    0,    0,   32,   33,   34,   35,   36,   37,  337,  338,
  339,  340,  341,  342, 1130,  352,  344,  345,    0,    0,
   41,    0, 1140,    0,   40,  349,    0,  350,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    3,    4,
    5,    6,    0,    0,    0,    0,    7,    8,    9,    0,
    0,   11,   12,   13,    0,    0,   14,    0,    0,   15,
    0,    0,   18,    0,    0,   20,   21,   22,   23,   24,
   25,    0,    0,   26,   27,    0,    0,  333,   28,    0,
    0,    0,    0,  334,  335,  336,   30,   31,  351,    0,
   41,    0,  759,    0,   40,    0,   37,  337,  338,  339,
  340,  341,  342,  544,    0,  344,  345,    0,    0,    0,
    3,    4,    5,    6,    0,    0,    0,    0,    7,    8,
    9,    0,    0,   11,   12,   13,    0,    0,   14,    0,
    0,   15,    0,    0,   18,    0,    0,   20,   21,   22,
   23,   24,   25,  190,    0,   26,   27,    0,    0,  333,
   28,    0,    0,    0,    0,  334,  335,  336,   30,   31,
    0,    0,    0,    0,    0,    0,    0,    0,   37,  337,
  338,  339,  340,  341,  342, 1199,    0,  344,  345,    0,
  352,    0,    0,    0,    0,   41,    0,  743,    0,   40,
  349,    0,  350,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    3,
    4,    5,    6,    0,    0,    0,    0,    7,    8,    9,
    0,    0,   11,   12,   13,    0,    0,   14,  190,    0,
   15,    0,    0,   18,    0,    0,   20,   21,   22,   23,
   24,   25,    0,    0,   26,   27,    0,    0,  333,   28,
    0,    0,    0,    0,  334,  335,  336,   30,   31,    0,
    0,    0,    0,  351,    0,    0,    0,   37,  337,  338,
  339,  340,  341,  342, 1244,  352,  344,  345,    0,    0,
   41,    0,  894,    0,   40,  349,    0,  350,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    3,
    4,    5,    6,    0,    0,    0,    0,    7,    8,    9,
    0,    0,   11,   12,   13,    0,    0,   14,    0,    0,
    0,    0,    0,   18,    0,    0,   20,   21,   22,   23,
   24,   25,    0,  190,   26,   27,    0,    0,    0,   28,
    0,    0,    0,    0,  352,    0,    0,    0,   31,   41,
    0,  347,    0,   40,  349,    0,  350,  104,    0,    0,
    0,    0,    0,    0,  184,    0,    0,    0,  351,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    3,    4,    5,    6,    0,    0,
    0,    0,    7,    8,    9,    0,    0,   11,   12,   13,
    0,    0,   14,    0,    0,    0,    0,    0,   18,    0,
    0,   20,   21,   22,   23,   24,   25,    0,    0,   26,
   27,    0,    0,  333,   28,    0,    0,  351,    0,  334,
    0,  336,   30,   31,    0,    0,    0,    0,    0,    0,
    0,    0,   37,  337,  338,  339,  340,  341,  342,  888,
  352,  344,  345,    0,    0,   41,    0,  347,    0,   40,
  349,    0,  350,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    3,
    4,    5,    6,    0,    0,    0,    0,    7,    8,    9,
    0,    0,   11,   12,   13,    0,    0,   14,    0,    0,
    0,    0,    0,   18,    0,    0,   20,   21,   22,   23,
   24,   25,    0,    0,   26,   27,    0,    0,  333,   28,
    0,    0,    0,    0,  334,    0,  336,   30,   31,    0,
  734,    0, 1111,  351,    0,    0,    0,   37,  337,  338,
  339,  340,  341,  342,  398,    0,  344,  345,    3,    4,
    5,    6,    0,    0,  769,  770,    7,    8,    0,    0,
    0,   11,   12,   13,  352,    0,   14,    0,    0,   41,
    0,  347,   18,   40,  349,   20,  350,   22,   23,   24,
   25,    0,    0,   26,   27,    0,    0,  333,    0,    0,
    0,    0,    0,  334,  335,  336,   30,   31,    0,    0,
    0,    0,    0,    0,    0,    0,   37,  337,  338,  339,
  340,  341,  342,  398,    0,  344,  345,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  352,    0,    0,
    0,    0,   41,    0, 1200,    0,   40,  349,    0,  350,
    0,    0,    0,    0,    0,    0,    0,  351,    0,    0,
    0,    0,    0,    0,    3,    4,    5,    6,    0,    0,
    0,    0,    7,    8,    0,    0,    0,   11,   12,   13,
    0,    0,   14,    0,    0,    0,    0,    0,   18,    0,
    0,   20,    0,   22,   23,   24,   25,    0,    0,   26,
   27,    0,    0,  333,    0,    0,    0,    0,    0,  334,
  335,  336,   30,   31,    0,    0,    0,    0,    0,    0,
    0,    0,   37,  337,  338,  339,  340,  341,  342,  398,
  351,  344,  345,  352,    0,    0,    0,    0,   41,    0,
  347,    0,   40,  349,    0,  350,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    3,    4,
    5,    6,    0,  399,    0,    0,    7,    8,    9,    0,
    0,   11,   12,   13,    0,    0,   14,    0,    0,    0,
    0,    0,   18,    0,    0,   20,   21,   22,   23,   24,
   25,    0,    0,   26,   27,    0,  351,  333,   28,    0,
   41,    0,  761,  334,   40,  336,   30,   31,    0,    0,
    0,    0,    0,    0,    0,    0,   37,  337,  338,  339,
  340,  341,  342,  398,    0,  344,  345,    0,    0,    0,
    0,    3,    4,    5,    6,    0,    0,    0,    0,    7,
    8,    9,    0,    0,   11,   12,   13,    0,    0,   14,
    0,    0,    0,  190,    0,   18,    0,    0,   20,   21,
   22,   23,   24,   25,    0,    0,   26,   27,    0,    0,
  333,   28,    0,    0,    0,    0,  334,    0,  336,   30,
   31,    0,    0,    0,    0,    0,    0,    0,    0,   37,
  337,  338,  339,  340,  341,  342,  888,    0,  344,  345,
    0,    0,    0,  352,    0,    0,    0,    0,   41,    0,
  347,    0,   40,  349,    0,  350,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    3,    4,    5,
    6,    0,    0,    0,    0,    7,    8,    0,    0,    0,
   11,   12,   13,    0,    0,   14,    0,    0,    0,    0,
    0,   18,    0,    0,   20,    0,   22,   23,   24,   25,
    0,  600,   26,   27,    0,    0,  333,    0,    0,    0,
    0,    0,  334,  335,  336,   30,   31,    0,    0,    0,
    0,    0,    0,    0,    0,   37,  337,  338,  339,  340,
  341,  342,  398,  352,  344,  345,  351,    0,   41,    0,
  347,    0,   40,  349,    0,  350,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    3,
    4,    5,    6,    0,    0,    0,    0,    7,    8,    9,
    0,    0,   11,   12,   13,    0,    0,   14,    0,    0,
    0,    0,    0,   18,    0,    0,   20,   21,   22,   23,
   24,   25,    0,    0,   26,   27,    0,    0,    0,   28,
    0,    0,  352,    0,    0,    0,    0,   41,   31,  347,
  767,   40,  349,    0,  350,    0,    0,  104,    0,    0,
    0,    0,    0,  734,  184,    0,  351,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    3,    4,    5,
    6,    0,    0,    0,    0,    7,    8,    0,    0,    0,
   11,   12,   13,    0,    0,   14,    0,    0,    0,    0,
    0,   18,    0,    0,   20,  351,   22,   23,   24,   25,
    0,    0,   26,   27,    0,    0,  333,    0,    0,    0,
    0,    0,  334,  335,  336,   30,   31,    0,    0,    0,
    0,    0,    0,    0,    0,   37,  337,  338,  339,  340,
  341,  342,  398,    0,  344,  345,    0,  352,    0,    0,
    0,    0,   41,    0,  347,    0,   40,  349,    0,  350,
    0,    0,    0,    0,    0,    0,    0,    3,    4,    5,
    6,    0,    0,    0,    0,    7,    8,    0,    0,    0,
   11,   12,   13,    0,    0,   14,    0,    0,    0,    0,
    0,   18,    0,    0,   20,    0,   22,   23,   24,   25,
    0,    0,   26,   27,    0,    0,  333,  792,    0,    0,
    0,    0,  334,  335,  336,   30,   31,    0,    0,    0,
    0,    0,    0,    0,    0,   37,  337,  338,  339,  340,
  341,  342,  398,    0,  344,  345,    3,    4,    5,    6,
  351,    0,    0,    0,    7,    8,    0,    0,    0,   11,
   12,   13,    0,    0,   14,    0,    0,    0,    0,    0,
   18,    0,    0,   20,    0,   22,   23,   24,   25,    0,
    0,   26,   27,    0,    0,  333,    0,    0,    0,    0,
    0,  334,  335,  336,   30,   31,    0,    0,    0,    0,
    0,    0,    0,    0,   37,  337,  338,  339,  340,  341,
  342,  398,    0,  344,  345,    0,  352,    0,    0,    0,
    0,   41,    0,  347,  817,   40,  349,    0,  350,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    3,    4,    5,    6,    0,    0,    0,    0,    7,
    8,    0,    0,    0,   11,   12,   13,    0,    0,   14,
    0,    0,    0,    0,    0,   18,    0,    0,   20,  351,
   22,   23,   24,   25,    0,    0,   26,   27,    0,    0,
  333,    0,    0,    0,    0,    0,  334,  335,  336,   30,
   31,    0,    0,    0,    0,    0,    0,    0,    0,   37,
  337,  338,  339,  340,  341,  342,  398,    0,  344,  345,
    0,  352,    0,    0,    0,    0,   41,    0,  347,  818,
   40,  349,    0,  350,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  352,    0,    0,    0,    0,   41,    0,  347,  822,   40,
  349,    0,  350,    0,    0,    0,    0,    0,    0,    0,
    3,    4,    5,    6,  351,    0,    0,    0,    7,    8,
    0,    0,    0,   11,   12,   13,    0,    0,   14,    0,
    0,    0,    0,    0,   18,    0,    0,   20,    0,   22,
   23,   24,   25,    0,    0,   26,   27,    0,    0,  333,
    0,    0,    0,    0,    0,  334,  335,  336,   30,   31,
    0,    0,    0,    0,    0,    0,    0,    0,   37,  337,
  338,  339,  340,  341,  342,  398,    0,  344,  345,    0,
  352,    0,    0,  351,    0,   41,    0,  347,    0,   40,
  349,    0,  350,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  919,    0,    0,    0,    0,    3,    4,    5,    6,    0,
    0,    0,    0,    7,    8,    0,    0,    0,   11,   12,
   13,    0,    0,   14,    0,    0,  236,    0,  236,   18,
  236,    0,   20,  351,   22,   23,   24,   25,    0,    0,
   26,   27,    0,    0,  333,    0,  236,    0,    0,    0,
  334,  335,  336,   30,   31,    0,    0,    0,    0,    0,
    0,    0,    0,   37,  337,  338,  339,  340,  341,  342,
  398,    0,  344,  345,    3,    4,    5,    6,    0,    0,
    0,    0,    7,    8,    0,    0,    0,   11,   12,   13,
    0,    0,   14,    0,    0,    0,    0,    0,   18,    0,
    0,   20,    0,   22,   23,   24,   25,    0,    0,   26,
   27,    0,    0,  333,  236,    0,    0,    0,    0,  334,
  335,  336,   30,   31,    0,    0,    0,    0,    0,    0,
    0,    0,   37,  337,  338,  339,  340,  341,  342,  398,
  352,  344,  345,    0,    0,   41,    0,  347,  930,   40,
  349,    0,  350,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    3,    4,    5,    6,    0,    0,
    0,    0,    7,    8,    0,    0,    0,   11,   12,   13,
    0,    0,   14,    0,    0,    0,    0,    0,   18,    0,
    0,   20,    0,   22,   23,   24,   25,    0,    0,   26,
   27,    0,    0,  333,    0,    0,    0,    0,    0,  334,
  335,  336,   30,   31,    0,    0,    0,    0,    0,    0,
    0,    0,   37,  337,  338,  339,  340,  341,  342,  398,
  352,  344,  345,  351,    0,   41,    0,  347,  932,   40,
  349,    0,  350,    0,  236,  236,  236,  236,  236,    0,
    0,    0,    0,  236,  236,    0,    0,    0,    0,    0,
  236,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  236,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  236,  236,    0,    0,    0,    0,  352,
    0,    0,    0,  236,   41,    0,  347,  935,   40,  349,
  236,  350,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  351,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    3,    4,    5,    6,    0,    0,
    0,    0,    7,    8,    0,    0,    0,   11,   12,   13,
    0,    0,   14,    0,    0,    0,    0,    0,   18,    0,
    0,   20,  351,   22,   23,   24,   25,    0,    0,   26,
   27,    0,    0,  333,    0,    0,    0,    0,    0,  334,
  335,  336,   30,   31,    0,    0,    0,    0,    0,    0,
    0,    0,   37,  337,  338,  339,  340,  341,  342,  398,
    0,  344,  345,    0,  352,    0,    0,    0,    0,   41,
    0,  347, 1037,   40,  349,    0,  350,    0,    0,    0,
    0,    0,    0,    0,    3,    4,    5,    6,    0,    0,
    0,    0,    7,    8,    0,    0,    0,   11,   12,   13,
    0,    0,   14,    0,    0,    0,    0,    0,   18,    0,
    0,   20,    0,   22,   23,   24,   25,    0,    0,   26,
   27,    0,    0,  333,    0,    0,    0,    0,    0,  334,
  335,  336,   30,   31,    0,    0,    0,    0,    0,    0,
    0,    0,   37,  337,  338,  339,  340,  341,  342,  398,
    0,  344,  345,    3,    4,    5,    6,  351,    0,    0,
    0,    7,    8,    0,    0,    0,   11,   12,   13,  352,
    0,   14,    0,    0,   41,    0,  347,   18,   40,  349,
   20,  350,   22,   23,   24,   25,    0,    0,   26,   27,
    0,    0,  333,    0,    0,    0,    0,    0,  334,  335,
  336,   30,   31,    0,    0,    0,    0,    0,    0,    0,
    0,   37,  337,  338,  339,  340,  341,  342,  398,    0,
  344,  345,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  352,
    0,    0,    0,    0,   41,    0,  347,    0,   40,  349,
    0,  350,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  351,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    3,    4,
    5,    6,    0,    0,    0,    0,    7,    8,    0,    0,
    0,   11,   12,   13,    0,    0,   14,    0,    0,    0,
    0,    0,   18,    0,    0,   20,    0,   22,   23,   24,
   25,    0,    0,   26,   27,    0,    0,  333,    0,    0,
    0,    0,  351,  334,  335,  336,   30,   31,    0,    0,
    0,    0,    0,    0,    0,    0,   37,  337,  338,  339,
  340,  341,  342,  398,  352,  344,  345,    0,    0,   41,
    0, 1140,  817,   40,  349,    0,  350,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1124,    3,    4,    5,    6,    0,    0,    0,
    0,    7,    8,    0,    0,    0,   11,   12,   13,    0,
    0,   14,    0,    0,    0,    0,    0,   18,    0,    0,
   20,    0,   22,   23,   24,   25,    0,    0,   26,   27,
    0,    0,  333,    0,    0,    0,    0,    0,  334,  335,
  336,   30,   31,    0,   41,    0,  623,  351,   40,    0,
    0,   37,  337,  338,  339,  340,  341,  342,  398,    0,
  344,  345, 1137,    3,    4,    5,    6,    0,    0,    0,
    0,    7,    8,    0,    0,    0,   11,   12,   13,    0,
   41,   14,  623, 1157,   40,    0,    0,   18,    0,    0,
   20,    0,   22,   23,   24,   25,    0,  190,   26,   27,
    0,    0,  333,    0,    0,    0,    0,    0,  334,  335,
  336,   30,   31,    0,    0,    0,    0,    0,    0,    0,
    0,   37,  337,  338,  339,  340,  341,  342,  398,  352,
  344,  345,   42,  190,   41,    0, 1140,  818,   40,  349,
    0,  350,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   42,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    3,    4,
    5,    6,    0,    0,    0,    0,    7,    8,    0,    0,
    0,   11,   12,   13,    0,    0,   14,    0,    0,    0,
    0,    0,   18,    0,    0,   20,    0,   22,   23,   24,
   25,    0,    0,   26,   27,    0,    0,  333,    0,    0,
    0,    0,  351,  334,  335,  336,   30,   31,    0,    0,
    0,    0,    0,    0,    0,    0,   37,  337,  338,  339,
  340,  341,  342, 1139,  352,  344,  345,    0,    0,   41,
    0,  347,    0,   40,  349,    0,  350,    0,    0,    0,
    0,    0,    0,    3,    4,    5,    6,    0,    0,    0,
    0,    7,    8,    0,    0,    0,    0,    0,   13,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   20,    0,    0,    0,    0,    0,    0,    0,    0,    3,
    4,    5,    6,    0,    0,    0,    0,    7,    8,    0,
    0,   30,   31,  352,   13,    0,    0,    0,   41,    0,
  347,   37,   40,  349,    0,  350,   20,    0,  502,    0,
    0,    0,    0,    0,    0,    0,    0,  351,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   30,   31,    0,
    0,    0,    0,    3,    4,    5,    6,   37,    0,    0,
    0,    7,    8,    0,  502,    0,   11,   12,   13,    0,
    0,   14,    0,    0,    0,    0,    0,   18,    0,    0,
   20,    0,   22,   23,   24,   25,    0,    0,   26,   27,
    0,    0,  333,    0,    0,    0,    0,    0,  334,  335,
  336,   30,   31,   41,    0,  761,  351,   40,    0,    0,
    0,   37,  337,  338,  339,  340,  341,  342, 1139,  352,
  344,  345,    0,    0,   41,    0, 1140,    0,   40,  349,
    0,  350,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  190,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1238,    3,    4,
    5,    6,    0,    0,    0,    0,    7,    8,    0,    0,
    0,   11,   12,   13,    0,    0,   14,    0,    0,    0,
    0,    0,   18,    0,    0,   20,    0,   22,   23,   24,
   25,    0,    0,   26,   27,    0,    0,  333,    0,    0,
    0,    0,  351,  334,  335,  336,   30,   31,    0,    0,
    0,  241,    0,  241,  241,  241,   37,  337,  338,  339,
  340,  341,  342,  398,    0,  344,  345,    3,    4,    5,
    6,    0,    0,    0,    0,    7,    8,    0,    0,    0,
   11,   12,   13,    0,    0,   14,    0,    0,    0,    0,
    0,   18,    0,    0,   20,    0,   22,   23,   24,   25,
    0,    0,   26,   27,  241,    0,  333,    0,    0,    0,
    0,    0,  334,  335,  336,   30,   31,    0,    0,    0,
    0,    0,    0,    0,    0,   37,  337,  338,  339,  340,
  341,  342,  398,  352,  344,  345,    0,    0,   41,    0,
  528,    0,   40,  349,    0,  350,    0,    0,    0,    0,
    0,    0,    3,    4,    5,    6,    0,    0,    0,    0,
    7,    8,    0,    0,    0,    0,    0,   13,    0,    0,
    0,    0,    0,    3,    4,    5,    6,    0,    0,   20,
    0,    7,    8,    0,    0,    0,   11,   12,   13,    0,
    0,   14,    0,    0,    0,    0,    0,   18,    0,    0,
   20,   31,   22,   23,   24,   25,    0,    0,   26,   27,
  104,    0,  333,    0,    0,    0,    0,  184,  334,  335,
  336,   30,   31,    0,    0,    0,  351,    0,    0,    0,
    0,   37,  337,  338,  339,  340,  341,  342, 1139,  352,
  344,  345,    0,    0,   41,    0,  541,    0,   40,  349,
    0,  350,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  241,  241,  241,  241,    0,    0,    0,    0,  241,  241,
    0,    0,    0,    0,    0,  241,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  241,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  352,    0,
    0,    0,    0,   41,    0,  347,    0,   40,  349,  241,
  350,    0,    0,    0,    0,    0,    0,    0,  241,    0,
    0,    0,  351,    0,    0,  241,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    3,    4,    5,
    6,    0,    0,    0,    0,    7,    8,    0,    0,    0,
   11,   12,   13,    0,    0,   14,    0,    0,    0,    0,
    0,   18,    0,    0,   20,    0,   22,   23,   24,   25,
    0,    0,   26,   27,    0,    0,  333,    0,    0,    0,
    0,  351,  334,    0,  336,   30,   31,  240,    0,  240,
  240,  240,    0,    0,    0,   37,  337,  338,  339,  340,
  341,  342,  398,  352,  344,  345,    0,    0,   41,    0,
  347,    0,   40,  349,    0,  350,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  240,    0,    0,    3,    4,    5,    6,    0,    0,    0,
    0,    7,    8,    0,    0,    0,   11,   12,   13,    0,
    0,   14,    0,    0,    0,    0,    0,   18,    0,    0,
   20,    0,   22,   23,   24,   25,    0,    0,   26,   27,
    0,    0,  333,    0,  231,    0,    0,    0,  334,    0,
  336,   30,   31,    0,    0,    0,  351,    0,    0,  231,
    0,   37,  337,  338,  339,  340,  341,  342,  398,    0,
  344,  345,    3,    4,    5,    6,    0,    0,    0,    0,
    7,    8,    0,    0,    0,   11,   12,   13,    0,    0,
   14,    0,    0,    0,    0,    0,   18,    0,    0,   20,
    0,   22,   23,   24,   25,    0,    0,   26,   27,    0,
   41,  333,  672,    0,   40,    0,    0,  334,    0,  336,
   30,   31,    0,  665,    0,    0,    0,    0,    0,    0,
   37,  337,  338,  339,  340,  341,  342,  398,    0,  344,
  345,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  240,  240,  240,  240,
    0,    0,    0,    0,  240,  240,   41,    0,  672,    0,
   40,  240,    0,    0,    0,    0,    0,    3,    4,    5,
    6,    0,    0,  240,    0,    7,    8,  840,   42,    0,
   11,   12,   13,    0,    0,   14,    0,    0,    0,    0,
    0,   18,    0,    0,   20,  240,   22,   23,   24,   25,
    0,    0,   26,   27,  240,    0,  333,    0,    0,    0,
    0,  240,  334,    0,  336,   30,   31,    0,    0,    0,
    0,    0,    0,    0,    0,   37,  337,  338,  339,  340,
  341,  342,  559,    0,  344,  345,  665,  665,  665,  665,
    0,    0,    0,    0,   42,  665,  665,  665,    0,  665,
  665,  665,  665,    0,    0,  665,    0,    0,  665,  665,
  665,  665,  665,    0,  665,  665,  665,  665,  665,  665,
    0,    0,  665,  665,    0,    0,    0,  665,    0,    0,
  665,    0,    0,   41,    0,   39,  665,   40,    0,    0,
  665,  665,  665,  665,  665,  665,    0,    0,    0,    0,
    0,    0,  665,    0,    0,    0,    0,    0,    0,    3,
    4,    5,    6,  452,    0,  665,    0,    7,    8,    9,
    0,   10,   11,   12,   13,    0,    0,   14,    0,    0,
   15,   16,   17,   18,  160,    0,   20,   21,   22,   23,
   24,   25,    0,    0,   26,   27,    0,    0,    0,   28,
    0,   41,   29,   39,    0,   40,    0,   30,   31,  453,
  454,  455,   32,   33,   34,   35,   36,   37,  286,    0,
    0,   42,    0,    0,  839,    3,    4,    5,    6,  452,
    0,    0,    0,    7,    8,    9,    0,   10,   11,   12,
   13,    0,    0,   14,    0,    0,   15,   16,   17,   18,
  160,    0,   20,   21,   22,   23,   24,   25,    0,    0,
   26,   27,    0,    0,    0,   28,    0,    0,   29,    0,
    0,    0,    0,   30,   31,  453,  454,  455,   32,   33,
   34,   35,   36,   37,   41,    0,  571, 1154,   40,   42,
  839,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  190,    0,    0,
    0,    0,    0,   41,    0,  571,    0,   40,    0,    0,
    0,    2,    3,    4,    5,    6,    0,    0,    0,    0,
    7,    8,    9,    0,   10,   11,   12,   13,    0,    0,
   14,    0,   42,   15,   16,   17,   18,  160,    0,   20,
   21,   22,   23,   24,   25,    0,    0,   26,   27,    0,
    0,    0,   28,    0,    0,   29,  190,    0,    0,    0,
   30,   31,    0,    0,    0,   32,   33,   34,   35,   36,
   37,   41,    0,  571,    0,   40,    0,   38,    0,    2,
    3,    4,    5,    6,    0,    0,    0,    0,    7,    8,
    9,   42,   10,   11,   12,   13,    0,    0,   14,    0,
    0,   15,   16,   17,   18,   19,    0,   20,   21,   22,
   23,   24,   25,    0,    0,   26,   27,    0,    0,    0,
   28,    0,    0,   29,  190,    0,    0,    0,   30,   31,
    0,    0,    0,   32,   33,   34,   35,   36,   37,    0,
    0,    0,    0,    0,    0,   38,    0,    0,    0,    0,
   41,    0,  664,    0,   40,    0,    0,    0,    0,   42,
    0,    0,    0,    3,    4,    5,    6,    0,    0,    0,
  969,    7,    8,    9,    0,   10,   11,   12,   13,    0,
    0,   14,    0,    0,   15,   16,   17,   18,  160,    0,
   20,   21,   22,   23,   24,   25,    0,    0,   26,   27,
    0,    0,    0,   28,    0,    0,   29,    0,    0,    0,
    0,   30,   31,    0,    0,    0,   32,   33,   34,   35,
   36,   37,    3,    4,    5,    6,    0,    0,  216,    0,
    7,    8,    9,    0,   10,   11,   12,   13,   42,    0,
   14,    0,    0,   15,   16,   17,   18,  160,    0,   20,
   21,   22,   23,   24,   25,    0,    0,   26,   27,    0,
    0,    0,   28,    0,   41,   29,  672,    0,   40,    0,
   30,   31,    0,    0,    0,   32,   33,   34,   35,   36,
   37,    0,    0,    0,  969,    0,    0,  216,    0,    0,
    3,    4,    5,    6,    0,    0,    0,    0,    7,    8,
    9,    0,   10,   11,   12,   13,    0,    0,   14,    0,
    0,   15,   16,   17,   18,  160,    0,   20,   21,   22,
   23,   24,   25,    0,    0,   26,   27,    0,    0,    0,
   28,    0,    0,   29,    0,    0,    0,    0,   30,   31,
    0,    0,    0,   32,   33,   34,   35,   36,   37,    0,
    0,    0,   42,    0,   41,  235,  672,    0,   40,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  202,    3,
    4,    5,    6,    0,  969,    0,    0,    7,    8,    9,
    0,   10,   11,   12,   13,    0,    0,   14,    0,    0,
    0,   16,   17,   18,  160,    0,   20,   21,   22,   23,
   24,   25,    0,    0,   26,   27,    0,    0,    0,   28,
    0,    0,   29,    0,    0,    0,    0,   30,   31,    0,
    0,    0,   32,   33,   34,   35,   36,   37,   41,    0,
  623, 1150,   40,    0,  967,    0,    0,    0,    0,    0,
    0,    0,   42,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  190,    0,    3,    4,    5,    6,    0,    0,    0,
    0,    7,    8,    9,    0,   10,   11,   12,   13,    0,
    0,   14,    0,    0,   15,   16,   17,   18,  160,    0,
   20,   21,   22,   23,   24,   25,   42,    0,   26,   27,
    0,    0,    0,   28,    0,    0,   29,    0,    0,    0,
    0,   30,   31,    0,    0,    0,   32,   33,   34,   35,
   36,   37,    0,    0,    0,   41,    0,  162,  216,   40,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    3,    4,    5,    6,    0,    0,    0,
    0,    7,    8,    9,    0,   10,   11,   12,   13,    0,
    0,   14,    0,    0,   15,   16,   17,   18,  160,    0,
   20,   21,   22,   23,   24,   25,    0,    0,   26,   27,
    0,    0,    0,   28,    0,    0,   29,    0,    0,    0,
    0,   30,   31,    0,    0,    0,   32,   33,   34,   35,
   36,   37,   41,   42,  217,    0,   40,    0,  235,    0,
    0,    0,    0,    0,    0,    0,    0,    3,    4,    5,
    6,    0,    0,    0,    0,    7,    8,    9,    0,   10,
   11,   12,   13,    0,    0,   14,    0,    0,    0,   16,
   17,   18,  160,    0,   20,   21,   22,   23,   24,   25,
    0,    0,   26,   27,    0,    0,    0,   28,    0,    0,
   29,    0,    0,    0,    0,   30,   31,    0,    0,    0,
   32,   33,   34,   35,   36,   37,    0,    0,    0,   41,
    0,  217,  502,   40,    0,    0,    0,    0,    0,    0,
   42,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  202,    3,    4,    5,    6,    0,    0,
    0,    0,    7,    8,    9,    0,   10,   11,   12,   13,
    0,    0,   14,    0,    0,    0,   16,   17,   18,  160,
    0,   20,   21,   22,   23,   24,   25,   42,    0,   26,
   27,    0,    0,    0,   28,    0,    0,   29,    0,    0,
    0,    0,   30,   31,    0,    0,    0,   32,   33,   34,
   35,   36,   37,    0,   41,    0,  563,    0,   40,  161,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    3,    4,    5,    6,    0,    0,    0,    0,    7,
    8,    9,    0,   10,   11,   12,   13,    0,    0,   14,
    0,    0,   15,   16,   17,   18,  160,  190,   20,   21,
   22,   23,   24,   25,    0,    0,   26,   27,    0,    0,
    0,   28,    0,    0,   29,    0,    0,    0,    0,   30,
   31,    0,    0,    0,   32,   33,   34,   35,   36,   37,
    0,    0,   42,   41,    0,  623,  216,   40,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    3,    4,
    5,    6,    0,    0,    0,    0,    7,    8,    9,    0,
   10,   11,   12,   13,    0,    0,   14,    0,    0,   15,
   16,   17,   18,  160,    0,   20,   21,   22,   23,   24,
   25,    0,    0,   26,   27,    0,  190,    0,   28,    0,
    0,   29,    0,    0,    0,    0,   30,   31,    0,    0,
    0,   32,   33,   34,   35,   36,   37,    0,   41,    0,
  436,    0,   40,  235,    0,    0,    0,    0,    0,    0,
    0,   42,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    3,    4,    5,    6,    0,    0,    0,
    0,    7,    8,    9,    0,   10,   11,   12,   13,    0,
   41,   14,  436,    0,   40,   16,   17,   18,  160,    0,
   20,   21,   22,   23,   24,   25,   42,    0,   26,   27,
    0,    0,    0,   28,    0,    0,   29,    0,    0,    0,
    0,   30,   31,    0,    0,    0,   32,   33,   34,   35,
   36,   37,    0,    0,    0,    0,    0,    0,  502,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   41,    0,  430,    0,
   40,    0,    3,    4,    5,    6,    0,    0,    0,    0,
    7,    8,    9,    0,   10,   11,   12,   13,   42,    0,
   14,    0,    0,    0,   16,   17,   18,  160,    0,   20,
   21,   22,   23,   24,   25,    0,    0,   26,   27,    0,
    0,    0,   28,    0,    0,   29,    0,    0,    0,    0,
   30,   31,    0,    0,    0,   32,   33,   34,   35,   36,
   37,    0,    0,    0,    0,    0,   41,  502, 1060,    0,
   40,    0,    0,    0,    0,    0,    0,    3,    4,    5,
    6,    0,    0,    0,   42,    7,    8,    9,    0,   10,
   11,   12,   13,    0,    0,   14,    0,    0,   15,   16,
   17,   18,  160,    0,   20,   21,   22,   23,   24,   25,
    0,    0,   26,   27,    0,    0,    0,   28,    0,    0,
   29,    0,    0,    0,    0,   30,   31,    0,    0,    0,
   32,   33,   34,   35,   36,   37,    0,    0,    0,    0,
    0,    0,  216,   41,    0,  623,  496,   40,    0,    3,
    4,    5,    6,    0,   42,    0,    0,    7,    8,    9,
    0,   10,   11,   12,   13,    0,    0,   14,    0,    0,
   15,   16,   17,   18,  160,    0,   20,   21,   22,   23,
   24,   25,    0,    0,   26,   27,    0,    0,    0,   28,
    0,    0,   29,    0,    0,    0,  190,   30,   31,    0,
    0,    0,   32,   33,   34,   35,   36,   37,    0,    0,
    0,    0,    0,    0,  235,    3,    4,    5,    6,    0,
    0,    0,    0,    7,    8,    9,    0,   10,   11,   12,
   13,   42,    0,   14,    0,    0,    0,   16,   17,   18,
  160,    0,   20,   21,   22,   23,   24,   25,    0,    0,
   26,   27,    0,    0,    0,   28,    0,    0,   29,    0,
    0,    0,    0,   30,   31,    0,    0,    0,   32,   33,
   34,   35,   36,   37,    0,    0,    0,    0,    0,   41,
  161,  623, 1145,   40,    0,    3,    4,    5,    6,    0,
    0,    0,    0,    7,    8,    9,    0,   10,   11,   12,
   13,    0,    0,   14,    0,    0,    0,   16,   17,   18,
  160,    0,   20,   21,   22,   23,   24,   25,    0,    0,
   26,   27,    0,    0,    0,   28,    0,    0,   29,    0,
    0,    0,  190,   30,   31,    0,    0,    0,   32,   33,
   34,   35,   36,   37,    0,   41,    0,  623, 1152,   40,
  161,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    3,    4,    5,    6,    0,   42,    0,    0,
    7,    8,    9,    0,   10,    0,    0,   13,    0,    0,
    0,    0,    0,    0,   16,   17,    0,  160,    0,   20,
   21,    0,    0,    0,    0,    0,    0,    0,  190,    0,
    0,    0,   28,    0,   41,   29,  531,    0,   40,    0,
   30,   31,    0,    0,    0,   32,   33,   34,   35,   36,
   37,    0,    0,    0,    0,    0,    0,  502,    0,    0,
    0,    0,    0,   42,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  190,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   41,    0,  567,    0,   40,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   42,    0,    0,    0,    0,    0,    3,    4,
    5,    6,    0,    0,    0,    0,    7,    8,    9,    0,
   10,    0,    0,   13,    0,    0,    0,    0,    0,    0,
   16,   17,    0,  160,  190,   20,   21,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   28,    0,
   41,   29,  623,    0,   40,    0,   30,   31,    0,    0,
    0,   32,   33,   34,   35,   36,   37,    0,    0,   42,
    0,    0,    0,  502,    3,    4,    5,    6,    0,    0,
    0,    0,    7,    8,    9,    0,   10,    0,    0,   13,
    0,    0,    0,    0,    0,    0,   16,   17,    0,  160,
    0,   20,   21,  190,    0,    0,    0,    0,    0,   41,
    0,  209,    0,   40,   28,    0,    0,   29,    0,    0,
    0,    0,   30,   31,    0,    0,    0,   32,   33,   34,
   35,   36,   37,    3,    4,    5,    6,    0,   42,  502,
    0,    7,    8,    9,    0,   10,    0,    0,   13,    0,
    0,    0,    0,    0,    0,   16,   17,    0,  160,    0,
   20,   21,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   28,    0,   41,   29,  430,    0,   40,
    0,   30,   31,    0,    0,    0,   32,   33,   34,   35,
   36,   37,    0,    0,    0,    0,    0,   42,  502,    0,
    3,    4,    5,    6,    0,    0,    0,    0,    7,    8,
    9,    0,   10,    0,    0,   13,    0,    0,    0,    0,
    0,    0,   16,   17,    0,  160,    0,   20,   21,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   28,    0,    0,   29,    0,    0,    0,    0,   30,   31,
    0,    0,    0,   32,   33,   34,   35,   36,   37,    0,
   41,    0, 1059,   42,   40,  502,    0,    0,    0,    3,
    4,    5,    6,    0,    0,    0,    0,    7,    8,    9,
    0,   10,    0,    0,   13,    0,    0,    0,    0,    0,
    0,   16,   17,    0,  160,    0,   20,   21,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   28,
    0,    0,   29,    0,    0,    0,    0,   30,   31,    0,
    0,    0,   32,   33,   34,   35,   36,   37,    3,    4,
    5,    6,    0,    0,  502,    0,    7,    8,    9,    0,
   10,    0,   41,   13, 1061,    0,   40,    0,   42,    0,
   16,   17,    0,  160,    0,   20,   21,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   28,    0,
    0,   29,    0,    0,    0,    0,   30,   31,    0,    0,
    0,   32,   33,   34,   35,   36,   37,    0,    0,    0,
    0,    0,    0,  161,    3,    4,    5,    6,    0,    0,
    0,    0,    7,    8,    9,    0,   10,    0,    0,   13,
    0,  237,    0,  237,    0,  237,   16,   17,    0,  160,
    0,   20,   21,    0,    0,    0,    0,    0,    0,    0,
   42,  237,    0,    0,   28,    0,    0,   29,    0,    0,
    0,    0,   30,   31,    0,    0,    0,   32,   33,   34,
   35,   36,   37,    0,    0,    0,    0,    0,    0,  161,
    0,    0,   41,    0,  571,    0,   40,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    3,
    4,    5,    6,    0,    0,    0,    0,    7,    8,    9,
    0,   10,    0,    0,   13,    0,    0,    0,    0,  237,
    0,   16,   17,    0,  160,    0,   20,   21,    0,    0,
    0,    0,    0,    0,    0,  190,    0,    0,    0,   28,
    0,    0,   29,    0,    0,    0,    0,   30,   31,    0,
    0,    0,   32,   33,   34,   35,   36,   37,    0,   41,
    0,  664,    0,   40,  161,    0,    0,    0,    0,    0,
   42,    0,    0,    0,    0,    0,    0,    0,    0,  969,
    0,    3,    4,    5,    6,    0,    0,    0,    0,    7,
    8,    9,    0,   10,    0,   41,   13,  672,    0,   40,
    0,    0,    0,   16,   17,    0,  160,    0,   20,   21,
    0,    0,    0,    0,    0,  969,    0,    0,    0,    0,
    0,   28,    0,    0,   29,    0,    0,    0,    0,   30,
   31,    0,    0,    0,   32,   33,   34,   35,   36,   37,
    0,    0,    0,    0,    0,    0,  161,   42,    0,  237,
  237,  237,  237,  237,    0,    0,    0,    0,  237,  237,
    0,    0,    0,    0,  239,  237,  239,    0,  239,    0,
    0,    0,    0,    0,    0,    0,    0,  237,    0,    0,
    0,    0,    0,   42,  239,    0,    0,  240,    0,  240,
    0,  240,    0,    0,    0,    0,    0,    0,  237,  237,
    0,    3,    4,    5,    6,    0,    0,  240,  237,    7,
    8,    0,    0,    0,    0,  237,   13,    0,    0,    0,
    0,    0,    0,   41,    0,   39,    0,   40,   20,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   30,
   31,    0,  239,    0,    0,    0,    0,    0,   41,   37,
  162,    0,   40,    0,    0,    0,  184,    0,    0,    0,
    0,    0,    0,    0,    0,  240,    0,    0,    3,    4,
    5,    6,    0,    0,    0,    0,    7,    8,    0,    0,
   41,    0,  306,   13,   40,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   20,    0,    0,    0,    0,
    0,   42,    0,    0,    3,    4,    5,    6,    0,    0,
    0,    0,    7,    8,    0,    0,   30,   31,    0,   13,
    0,    0,    0,    0,    0,    0,   37,    0,    0,    0,
    0,   20,    0,  967,    0,    0,   42,    0,    0,   41,
    0,  315,    0,   40,    0,    0,    0,    0,    0,    0,
    0,    0,   30,   31,    0,    0,    0,    0,    0,    0,
    0,    0,   37,    0,    0,    0,    0,    0,   42,  184,
    0,    0,    0,  239,  239,  239,  239,    0,    0,    0,
    0,  239,  239,   41,    0,  217,    0,   40,  239,    0,
    0,    0,    0,    0,    0,    0,  240,  240,  240,  240,
  239,    0,    0,    0,  240,  240,    0,    0,    0,    0,
    0,  240,    0,    0,    0,   41,    0,  430,    0,   40,
    0,  239,  239,  240,    0,    0,    0,   42,    0,    0,
    0,  239,    3,    4,    5,    6,    0,    0,  239,    0,
    7,    8,    0,    0,  240,  240,    0,   13,    0,    0,
    0,   41,    0,  436,  240,   40,    0,    0,    0,   20,
    0,  240,    0,    0,    0,    0,    0,    3,    4,    5,
    6,   42,    0,    0,    0,    7,    8,    0,    0,    0,
   30,   31,   13,   41,    0,  306,    0,   40,    0,    0,
   37,    0,    0,    0,   20,    0,    0,  184,    0,    3,
    4,    5,    6,   42,    0,    0,    0,    7,    8,    0,
    0,    0,    0,    0,   13,   30,   31,    0,    0,    0,
   41,    0,  503,    0,   40,   37,   20,    0,    0,    0,
    0,    0,  161,    0,    0,    0,    0,    0,    0,   42,
    0,    0,    0,    0,    0,    0,    0,   30,   31,    0,
   41,    0,  306,    0,   40,    0,    0,   37,    3,    4,
    5,    6,    0,    0,  305,    0,    7,    8,    0,    0,
    0,   42,    0,   13,    0,    0,    0,    0,    0,    0,
   41,    0,  306,    0,   40,   20,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    3,    4,    5,    6,   30,   31,   42,    0,
    7,    8,    0,    0,    0,    0,   37,   13,    0,    0,
    0,    0,    0,  161,   41,    0,  664,    0,   40,   20,
    0,    0,    0,    0,    3,    4,    5,    6,   42,    0,
    0,    0,    7,    8,    0,    0,    0,    0,    0,   13,
   30,   31,    0,    0,    0,    0,    0,    0,    0,    0,
   37,   20,    0,    0,    0,    0,    0,  184,   42,    0,
    3,    4,    5,    6,    0,    0,    0,    0,    7,    8,
    0,    0,   30,   31,    0,   13,    0,    0,    0,    0,
    0,   41,   37,  669,    0,   40,    0,   20,    0,  161,
    0,    0,    3,    4,    5,    6,    0,    0,    0,    0,
    7,    8,   42,    0,    0,    0,    0,   13,   30,   31,
    0,   41,    0,  672,    0,   40,    0,    0,   37,   20,
    0,    0,    0,    0,    0,  184,    0,    0,    0,    3,
    4,    5,    6,    0,    0,    0,    0,    7,    8,    0,
   30,   31,    0,    0,   13,    0,    0,    0,    0,    0,
   37,    0,    0,    0,    0,    0,   20,  498,    0,    3,
    4,    5,    6,    0,    0,    0,    0,    7,    8,   42,
    0,   41,    0,  306,   13,   40,    0,   30,   31,    0,
    0,    0,    0,    0,    0,    0,   20,   37,    0,    3,
    4,    5,    6,    0,  502,    0,    0,    7,    8,   42,
    0,   41,    0,  306,   13,   40,    0,   30,   31,    0,
    0,    0,    0,    0,    0,    0,   20,   37,    0,    0,
    0,    0,    0,    0,  512,    0,    0,    0,    0,    0,
    0,    0,    0,    3,    4,    5,    6,   30,   31,    0,
    0,    7,    8,    0,    0,    0,    0,   37,   13,    0,
    0,    0,    0,   41,  514,  664,    0,   40,    0,   42,
   20,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   41,    0,  827,    0,   40,    0,    0,
    0,   30,   31,    0,    0,    0,    0,    0,    0,   42,
    0,   37,    0,    0,    0,    0,    0,    0,  305,    0,
    3,    4,    5,    6,    0,    0,    0,    0,    7,    8,
    0,    0,    0,    0,    0,   13,    0,    0,    0,    0,
    0,    0,    0,    0,   41,    0,  664,   20,   40,    0,
    3,    4,    5,    6,    0,    0,    0,    0,    7,    8,
    0,   42,    0,    0,    0,   13,    0,    0,   30,   31,
    0,    0,   41,    0,  664,    0,   40,   20,   37,    0,
    0,   42,    0,    0,    0,  161,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   30,   31,
    0,    0,    0,    0,    0,    0,    0,    0,   37,    0,
    3,    4,    5,    6,    0,  184,    0,    0,    7,    8,
    0,    0,    0,    0,    0,   13,    0,    0,    0,    0,
    0,    0,   42,    0,    0,    0,    0,   20,    0,    0,
    3,    4,    5,    6,    0,    0,    0,    0,    7,    8,
   41,    0,  664,    0,   40,   13,    0,    0,   30,   31,
   42,   41,    0,  664,    0,   40,    0,   20,   37,    0,
    0,    0,    0,    0,    0,  717,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   30,   31,
    0,    0,    3,    4,    5,    6,    0,    0,   37,    0,
    7,    8,    0,    0,    0,  719,    0,   13,    0,    0,
    0,    0,    3,    4,    5,    6,    0,    0,    0,   20,
    7,    8,   41,    0, 1078,    0,   40,   13,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   42,   20,
   30,   31,   41,    0, 1094,    0,   40,    0,    0,   42,
   37,    0,    0,    0,    0,    0,    0,  498,    0,    0,
   30,   31,    0,    3,    4,    5,    6,    0,    0,    0,
   37,    7,    8,    0,    0,    0,    0,  502,   13,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   20,    3,    4,    5,    6,    0,    0,    0,    0,    7,
    8,    0,    0,   41,    0,  664,   13,   40,    0,    0,
   42,   30,   31,    0,    0,    0,    0,    0,   20,    0,
    0,   37,    0,   41,    0,  664,    0,   40,  512,    0,
   42,    0,    0,    0,    0,    0,    0,    0,    0,   30,
   31,    0,    0,    0,    0,    0,    0,    0,    0,   37,
    0,    0,    0,    0,    0,    0,  514,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    3,
    4,    5,    6,    0,    0,    0,    0,    7,    8,    0,
    3,    4,    5,    6,   13,    0,    0,    0,    7,    8,
   41,   42,  664,    0,   40,   13,   20,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   20,    0,    0,
   41,   42,  664,    0,   40,    0,    0,   30,   31,    0,
    0,    0,    0,    0,    0,    0,    0,   37,   30,   31,
    0,    0,    0,    0,  717,    0,    0,    0,   37,    0,
    0,    3,    4,    5,    6,  719,    0,    0,    0,    7,
    8,    0,    0,    0,    0,    0,   13,    0,    0,    0,
    0,    3,    4,    5,    6,    0,    0,    0,   20,    7,
    8,  239,    0,  239,    0,  239,   13,    0,   42,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   20,   30,
   31,  240,    0,  240,    0,  240,    0,    0,   42,   37,
    0,    0,    0,    0,    0,    0,  502,    0,    0,   30,
   31,    0,    0,    0,    0,    0,    0,    0,    0,   37,
    0,    0,    3,    4,    5,    6,  502,    0,    0,    0,
    7,    8,    0,    0,    0,    0,    0,   13,    0,    0,
    0,    0,    3,    4,    5,    6,    0,    0,    0,   20,
    7,    8,    0,    0,    0,    0,    0,   13,    0,  239,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   20,
   30,   31,    0,    0,    0,    0,    0,    0,    0,  240,
   37,    0,    0,    0,    0,    0,    0, 1162,    0,    0,
   30,   31,    0,    0,    0,    0,    0,    0,    0,    0,
   37,    0,    0,    0,    0,    0,    0, 1165,    0,    3,
    4,    5,    6,    0,    0,    0,    0,    7,    8,    0,
    0,    0,    0,    0,   13,    0,    0,    0,    0,    3,
    4,    5,    6,    0,    0,    0,   20,    7,    8,    0,
    0,    0,    0,    0,   13,    0,    0,    0,  441,    0,
    0,    0,    0,    0,    0,    0,   20,   30,   31,    0,
    0,    0,    0,    0,    0,    0,    0,   37,    0,    0,
    0,    0,    0,    0, 1174,    0,    0,   30,   31,    0,
    0,    0,    0,    0,    0,    0,    0,   37,    0,    0,
  239,  239,  239,  239, 1177,    0,    0,    0,  239,  239,
    0,    0,    0,    0,    0,  239,    0,    0,    0,    0,
  240,  240,  240,  240,    0,    0,    0,  239,  240,  240,
    0,    0,    0,    0,    0,  240,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  240,  239,  239,
    0,    0,    0,   42,    0,    0,    0,    0,  239,    0,
 1085,    0,    0, 1086,    0,  239,    0,    0,  240,  240,
    0,    0, 1088,    0, 1089,    0, 1090,    0,  240,    0,
    0,    0,    0,    0, 1098,  240, 1099,    0, 1100,    0,
 1101,    2,    3,    4,    5,    0,    0,    0,    0,    0,
    7,    8,    9,    0,   10,   11,   12,   13,    0,    0,
   14,    0,    0,   15,   16,   17,   18,  160,    0,   20,
   21,   22,   23,   24,   25,    0,    0,   26,   27,    0,
    0,    0,   28,    0,    0,   29,    0,    0,    0,    0,
    0,   31,    0,    0,    0,   32,   33,   34,   35,   36,
  104,    0,    0,    0,    0,    0,    0,  480,    0,    0,
    0,    0,    0,    0,    0, 1164,    0, 1167,    0,    0,
    0,    0,    0, 1170,    0,    0,    0,    0,    0,    0,
    0, 1176,    0, 1179,    3,    4,    5,    0, 1180,    0,
 1181,    0,    7,    8,    9,    0,   10,   11,   12,   13,
    0,    0,   14,    0,    0,    0,   16,   17,   18,  160,
    0,   20,   21,   22,   23,   24,   25,    0,    0,   26,
   27,    0,    0,    0,   28,    0,    0,   29,    0,    0,
    0,    0,   30,   31,    0,    0,    0,   32,   33,   34,
   35,   36,   37,    0,    0,    0, 1219,    0,    0,  184,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1229,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1248,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1265, 1266,    0,    0, 1269, 1270, 1271,
 1272,    0, 1273, 1274, 1275,    0, 1276, 1277, 1278, 1279,
    3,    4,    5,    0,    0,    0,    0,    0,    7,    8,
    9,    0,   10,   11,   12,   13,    0,    0,   14,    0,
    0,   15,   16,   17,   18,  160,    0,   20,   21,   22,
   23,   24,   25,    0,    0,   26,   27,    0,    0,    0,
   28,    0,    0,   29,    0,    0,    0,    0,    0,   31,
    0,    0,    0,   32,   33,   34,   35,   36,  104,    0,
    0,    0,    0,    0,    0,  710,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  777,
};
short yycheck[] = {                                       1,
  190,   79,   52,   30,  376,   55,   79,   52,   30,  396,
   55,  456,    1,   30,   30,   30,   44,  734,   76,    1,
  524,  791,   52,   81,    1,   55,   60,   59,   30,   58,
   49,   50,   66,   67,   41,  695,  634,   63,   58,  371,
  772,   41,  125,   55,   63,   64,   44,   41,   44,    1,
   52,   41,  306,   55,   44,   78,   38,  257,  941,  125,
   58,   59,   59,   61,   50,  397,   41,   49,   50,   44,
   52,   53,   54,   55,   41,   41,   78,   63,   30,   41,
  158,   63,   64,   85,   58,   59,   61,   43,   59,   45,
  408,   44,  349,  350,  351,  352,   85,  591,   44,  157,
  178,  159,   44,   85,   41,  178,   40,  364,   85,   40,
   41,   44,   41,   44,   41,   44,   40,   44,   41,  177,
  695,   44,   59,  153,   59,  123,  123,   58,   59,  125,
   61,  153,   61,   85,   61,  306,   41,  153,  153,   44,
  634,  306,  844,  845,  146,  164,  165,   93,  918,  123,
   41,  153,  123,   44,  316,  347,   61,   91,   41,   41,
   93,   44,   41,   40,   41,   44,   41,   91, 1051,   44,
  220,  221,  125,   41,   40, 1058,   44,   59,   61,   44,
  912,  123,  164,  165,  782,   40,   41,  189,  190,   44,
   38,   40,  123,   41,   59,   59,   44,   40,  276,  249,
  336,  337,  123,   58,   59,  592,   61,  209,  220,  221,
   58,   59,   44,   40,   91,   63,   44,  275,  408,   44,
   44,  322,  300,  281,  302,   91,  278,   44,  247,   61,
  602,  603,   44,   44,   59,   59,   61,  249,  220,  221,
   41,  123,   91,   44,   61,   93,   94,   58,   91, 1132,
  695,   41,  335,   41,   44,   60,   44,   62,   59,   41,
   61,  125,   44,   44,   91,   93,   59,  269,  123,  335,
   44,   61,   61,   61,   58,  946,  124,  125,   59,   61,
   41,   93,   44,   44,  596,  123,  315,   61,  782,  291,
  685,   41,   41,  322,  689,   44,  298,  299,  123,   61,
   61,  303,  291,  335, 1021,  965,  334,  333, 1010,   59,
 1193,  313,   61,   59,  291,  335,  394,  335,  363,  306,
  347,  394,  123,  368,  326,  307,  308,  329,  335,  407,
  347,  333,  524,  363,  407,  335,  528,  335,  368,  291,
  329,  335,  344,  345,  334,  347,  373,  349,  350,  351,
  352,  373,  329,   38, 1237,  389,  373,  373,  373,  334,
  335,  363,  364,   44,   49,   50,  368,  261,  335,  335,
  393,  373,   44,  335,  376,  693, 1047,  329,   63,   64,
   61, 1052,  460,  406, 1116, 1117, 1057,  437,  438,   61,
  965,  393, 1063,  335,  315,  347,  335,   41, 1281,  591,
   44,  322,  594,  334,  406,  334,  408,  334,  740,   41,
  412,  334,   44,  432,  433,  473,  418,   61, 1188,  421,
  792,  373,   41,  412,  426,  437,  438,  429,   41,  334,
  335,   44,  421,  483,  484,  412,  459,  426,  483,  484,
  429,   93,  634,  334,  421,  447,  778,  779,  450,  426,
  347,  334,  429,  483,  484,  334, 1127,  459,  447,  334,
  412,  450,  481,  482,  968,   41,  334,  486,  487,  421,
  447,  335,  484,  450,  426,  787,  788,  429,  267,  334,
  153,  483,  484,   41,  332,  333,  334,  489,   91,   44,
  747,  995,  494,  495,  123,  447,  285,  884,  450,   40,
  489,  528,  334,  693,   59,  762,  551,   58,  297,  511,
  335,  528,  489,   44,  516,   41,   44,  334,   44,  521,
  965,  551,  524,  328,  329, 1196,  528,   58,   59,  531,
   58,   59,  123,  334,  335,   61,   40,  489,   41,  541,
   40,   44,  544,  335,  334,  335,  334,  549,  550,  551,
   91,  743,  334,  555,  632,  887,  928,   61,   61,  632,
  334,  563,  247,  641, 1235,  567,  596,  594,  641,  571,
 1241, 1242,  334,  334,  596,   40,  528,  594,  580,  581,
  596,  596,   40,  585,   44,  334,  588,   91,   40,  591,
  782,   91,  594,  595,  596,  123,   41,   40,  600,   59,
  602,  603,  604,  605,  606,  607,  608,  609,  610,  611,
  612,  613,  614,  615,  616,  617,  618,  619,  620,  621,
  622,  623,  940,   41,   44,  298,  299,   40,   44,  162,
   44,  528,  634,   91,   44,  637,  638,  639,  895,   91,
 1311,   61,  594,   41,  541,   61,   44,   61,   91,   59,
  652,  969,   44,  334,  656,   41, 1327,   40,   44,   44,
   58,   59,  334,  335,   41,   63,  668,   44,   41,   61,
  842,  843,   44,   59,   59,   61,  209,  849,  850,   41,
  326,  327,   44,  685,  581,  687,   61,  689,   44,   61,
  334,  693,   40,  695,  315,   93,  698,   59,   44,   61,
   44,  322,  894,  600,   41,   61,  316,   44,   91,  698,
   38,   41,   58,   59,   44,   61,  698,   61,  695,  315,
  722,  698,  724,  315,  726,  622,  322,  125,   58,   59,
  322,   41,  734,   63,   44,  330,  331,  123,  123,  929,
 1072,  743,   94,  695,   41,  747,  698,   44,   58,   59,
  940,   61,  754,  755,  756,  124,  758,  759,  760,  761,
  762,  123,  262,   93,  766,  329,   44, 1024,   41, 1156,
  772,   41,  332,  306,   44,   41,  968,  123,   44,  969,
  782,   59,  315,   61,  786,  787,  788,  320,   58,   59,
  792,   61,   58,   59,  124,  125,  481,  482,   40,  844,
  845,  486,  487,  995,   41,   40,   44,   44,  334,   40,
   41,  889,  846,  123,  844,  845,  889,  851,  820,  821,
   58,   59,  824,   61,  324,  325, 1144,   93,  906,   40,
  832,  334,   44,  906,  302,  303, 1008,   40,   41,  278,
   93, 1033,  844,  845,   44,  123,  743,   59,  412,   61,
   44, 1169,   44,  123,   40,  832,  310,  421,   44,  125,
   91,  863,  426,  302,  303,  429,  123,   59,   41,   61,
  872,   44,  874,   59,  876,   61,  878,  125,   40,   41,
  832,   40,   41,  447, 1141,  123,  450,   44,   91,  786,
  917,   61,  894,  895,   44,  917,  125,  430,   41,    1,
  917,  917,  917,   41,   46,   91,   44,   44,   58,   59,
  912,  123,   41,   41,  334,  917,   44,   41,  334,  335,
  334,  923,   59,  925,   61,   41,  928,  929,   30,   91,
   41,  123,   91,  952,  953,  333,  334,  123,  940,  941,
   93,   44,  334,  410,  946,   47,   40,   49, 1140,  416,
   52,  302,  303,   55, 1144,   58,   59,  424,   41,  302,
  427,   44,  334,  965,   66,  917,  968,  969,  323,  946,
  503,  504,  334,  123,   44,   58,   59,  444,  334, 1169,
   63,  448,   41,   85,   44,   44,  123,   40,  965,   59,
  334,   61,   44,  995,  946,   40,   40,  894,  531,   59,
   44,   61,  332,  333,  334,   40, 1033,   59, 1200,   61,
   93,   41,   44,  965,   40,   59, 1033,   61,   44, 1021,
  123,   41, 1024, 1025,  334,   40, 1071,   59,  925,   61,
  563, 1033,   40,   59,  567,   61,   41,   40,   41,   44,
   41, 1071,  125,   44, 1046, 1047,  148,   91,  150, 1051,
 1052,  153,   40,  123,   93, 1057, 1058, 1059, 1060, 1061,
   40, 1063, 1051,  123,  334,   91,   41,   44,  334, 1071,
 1047,  123,   41,   40, 1051, 1052,   41,   44,   41,  123,
 1057, 1033,   59,   41,   61,   41, 1063,  189,   91,   44,
  623,  123,   59,   41,   61, 1047,   44,  123,   93, 1051,
 1052,   40,   41,  267,   59, 1057,   61,  209,  531,   40,
   41, 1063,   44, 1140, 1116, 1117, 1118, 1119, 1120,   41,
   44,  285,   44, 1140,   91, 1127,   44,   59,    1,   61,
 1132,  664,   41,  297,   58,   59,  669,  670, 1140, 1141,
  563,   59, 1144,   61,  567,   40,  123,   91,  571, 1046,
 1127,   44,   91,   59,  839,   44,  123,  842,  843,   44,
   91,   58,   44,  125,  849,  850,   59, 1169,  123,  335,
   59,  278,   61, 1200,   59, 1127,   61,   59,   41,   61,
   59,   44,  262, 1200,   41,   40,   41,   44, 1140,  291,
   40, 1193,   59, 1195, 1196,  302,  303, 1199, 1200,  123,
  623,  303,   40,   41,  671,  123,   41,   44,  675,   44,
  743,  313,   85,   58,   44,   40,  361,  362,  363, 1196,
  302,  303,   59,  368,  326,   61,   40,  329,   44,   59,
  123,   61,   59, 1235,  123, 1237,   91,   59,  123, 1241,
 1242,  123, 1244, 1140, 1196,  347,  391,  392, 1200,  332,
  333,  334,  531,   91,   58, 1149,   58,   59, 1235,  361,
   44,  363,   61,   44, 1241, 1242,  368,  952,  953,  414,
  415,  373,   44,   41,  125,   59,   44,   61,   59, 1281,
   61,  278,   44, 1235,  563,   44,  123,   59,  567, 1241,
 1242,   37,  571,  123,  827,  828,   42,   59, 1195,   61,
   59,   47,   61, 1200,  278,  302,  303,   44, 1202, 1311,
  412,  126,  414,  126, 1208,   44, 1210,  126, 1212,  421,
  743, 1215,   59, 1008,  426, 1327, 1220,  429,  302,  303,
   59,  754,   61,  323, 1311,   58,  759,  760,  761,  123,
   41,  301,  123,   44,  623,  447,   58,   59,  450,    1,
 1327,  123,   59, 1247,   59, 1249, 1250,   58,   59, 1311,
 1254,  123,   63, 1257,  123,   44, 1260, 1261,   41,   44,
 1264,   44,  125,   41,   41, 1327,   44,   44,   30,  481,
   59,  483,  484,   41,   59,   41,  123,  489,  533,  534,
   58,   59,   93,  495,  123,   63,   41,   44,   44,   44,
   52,   58,   59,   55,  549,  550,  551,   58,   40,   41,
  555,   38,   59,   59,   41,  320,   41,   44,  291,   44,
   58,   59,  524,  124,  125,   93,  528,  572,  573,  531,
   58,   58,   59,   85,   41,  968,   63,   40,   41,   44,
  267,   41,  269,   41,  123,  547,   44,  549,  123,  551,
   58,   59,  279,  280,   59,  282,  329,  125,  285,   91,
   59,  563,  995,   44,  743,  567,   93,   94,   41,  571,
  297,  894,   40,  300,  274,  754,  123,  123,   59,   41,
  759,  760,  761,  310,  311,  312,  313,  314,   91,  591,
   40,   41,  594,  280,  596,   58,   59,  124,  125,   44,
   41,  153,  338,  339,  340,  341,  342,  343,  344,  345,
  346,  347,   59,   38,   59,   44,   41,   41,  123,   44,
   44,  623,   40,   41,   40,   41, 1059, 1060, 1061,   41,
   59,   41,  634,   58,   59,   40,   41,  189,   63,  412,
   41,   91,  123,  261,   41, 1078,   41, 1080,  421,   44,
   40,   41,   41,  426,   40,   41,  429,  209,   40,   41,
   41, 1094,   41, 1096,   41,   44,  668,   44,   93,   94,
   40,   41,    1,   91,  447,   91,   41,  450,  123,   58,
   59,   41,   41,   41,   63,   44,   91,   40,   41,  307,
  308,  309,   41,  695,  123,   44,  698,   58,   59,  124,
  125,   91,  747,   58,   59,   91,   41, 1140,   59,   91,
  755,  756,   58,   59,   93,  894,  489,  604,  605,  606,
  722,   91,  724,   41,  726,  611,  612,  613,  614,  607,
  608,  332,  333,  334,   58,   59,   58,   59,   91,  291,
   41,  743,   58,   59, 1067,   59,  125,   58,   59,   58,
   59,  303,  754,   58,   59,   41,   85,  759,  760,  761,
   59,  313,  302,  303,  766,  333,  334, 1200, 1091,  335,
  772,  609,  610,  335,  326,  615,  616,  329,  123,  123,
  782,  333,  278,  278,  278,   41,  123,  123,   41,   41,
   41,  125,  344,  345,  335,  347,   41,  349,  350,  351,
  352,   41,  125,  330,  331,  332,  333,  334,  123,  479,
   41,  363,  364,   44,   30,  369,  368,  617,  917,  618,
  621,  373,  620,  619,  836,  284,   76,   58,   59,  837,
  832,  692,   63,  687,  947,  945,  270,  271,   85,   85,
  842,  275,  844,  845,  849,  656,  332,  281,   -1,   -1,
  895,   -1,  286,  287,  288,  289,   -1,   -1,  292,  293,
  412,   38,   93,   94,   41,   -1,   43,   44,   45,  421,
   -1,   -1,   -1,   -1,  426,   -1,   -1,  429,   -1,   -1,
   -1,   58,   59,   60,   -1,   62,   63,   -1, 1067,   -1,
   -1,   -1,  894,  124,  125,  447,   -1,   -1,  450,    1,
   -1,   -1,   -1,  590,   -1,  330,  331,  332,  333,  334,
  912,   -1, 1091,   -1,   -1,  917,   93,   94,   -1,   -1,
   -1,   -1,  695,   -1,   -1,  698,   -1,   -1,   30,   -1,
   -1,  483,  484,   -1,   -1,   -1,   -1,  489,   -1,   -1,
   -1,   -1,   -1,  495,  946,   -1,  633,  124,  125,   -1,
  952,   -1,   54,  332,  333,  334,   -1,   -1,   -1,   -1,
   -1,   -1,  291,  965,   -1,   38,  968,   -1,   41,   -1,
   -1,   44,  524,   -1,   -1,   -1,  528,   -1,   -1,  531,
   -1,   -1,   -1,   85,   -1,   58,   59,   60,   -1,   62,
   63,   -1,   38,  995,   -1,   41,   -1,   -1,   44,  551,
  329,   -1,   42,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  563,   58,   59,   -1,  567,   -1,   63,  347,  571,
   93,   94,   -1, 1025, 1069, 1070, 1071,   -1, 1073,   -1,
   -1, 1033,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  591,
   -1,   -1,  594,   -1,  596, 1047,   -1,   93,   94, 1051,
 1052,  124,  125,   42,   -1, 1057,   -1,   -1,   -1,  832,
   -1, 1063,   -1,  165,   -1,   -1,   -1, 1069,   -1, 1071,
   -1,  623,   -1,   -1, 1119, 1120,   -1,   -1,  124,  125,
   -1,   -1,  634,  412,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  421,   -1,  781,   -1,   -1,  426,   -1,   -1,
  429,  332,  333,  334,   -1,   -1,   -1,   -1,   -1,   -1,
   -1, 1113,   -1,   -1, 1116, 1117,  668, 1119,  447,  221,
   -1,  450,   -1,   -1,   -1, 1127,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1, 1140,   -1,
   -1,   -1,   -1,  695,   -1,   -1,  698,   -1,   -1,  326,
  327,  328,  329,  330,  331,  332,  333,  334,   -1,   41,
  489,   -1,   44,   38,   -1,   40,   41,   42,   -1,   44,
  722,   -1,  724,  946,  726,   -1,   58,   59,  280,   -1,
   -1,   63,   -1,   58,   -1,   -1,   61,   -1,   -1,  291,
   -1,  743,  965,   -1, 1196,  747,   -1,  299, 1200,  528,
   -1,   -1,  754,   -1,   -1,   -1,  308,  759,  760,  761,
  762,   93,   94,   -1,   -1,   -1,   91,  257,  258,  259,
   -1,   -1,   -1,   -1,   -1,  265,  266,  329,   -1,   -1,
  782,   -1,  272, 1235,   -1,   -1,   -1,   -1,   -1, 1241,
 1242,   -1,  124,  125,  284,  347,  348,   -1,   -1,   -1,
   -1,  126,   -1,  326,  327,  328,  329,  330,  331,  332,
  333,  334,   -1,   -1,   -1,  594,  306,   -1,  257,  258,
  259,  373,   -1,   -1, 1047,  315,  265,  266, 1051, 1052,
  832,   -1,  322,  272, 1057,   -1,  332,  333,  334,   -1,
 1063,   38,  844,  845,   41,  284,   43,   44,   45,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1, 1311,
  412,   58,   59,   60,   -1,   62,   63,  306,   -1,  421,
   -1,   -1,   -1,   -1,  426, 1327,  315,  429,   -1,   -1,
   -1,  433,   -1,  322,   -1,   -1,  438, 1024,   -1,   -1,
   -1,   -1,  894,  895,   -1,  447,   93,   94,  450,   -1,
   -1,   -1,   -1,   -1, 1127,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  917,  695,   -1,   -1,  698,
   -1,  257,  258,  259,   -1,   -1,   -1,  124,  125,  265,
  266, 1068,  257,  258,  259,  260,  272,  489,   -1,   -1,
  265,  266,   -1,   -1,  946,   -1,   -1,  272,  284,   -1,
   -1,   38,   -1,   40,   41,   42,   -1,   44,   -1,  284,
   -1,   -1,   -1,  965,   -1,   -1,  968,   -1,   -1,   -1,
  306,   58,   -1, 1196,   61,   -1,  528,   -1,   -1,  315,
  305,  306,  534,   -1,   -1,   -1,  322,   -1,   -1,   -1,
  315,   -1,   -1,  995,   -1,   -1,   -1,  322,   -1,  335,
  332,  333,  334,   -1,   91,   -1,   -1,   -1, 1145,  334,
   -1,   -1, 1235, 1150,   -1, 1152,   -1, 1154, 1241, 1242,
 1157,  573, 1024, 1025, 1161,   -1,   -1,   -1,   -1,   -1,
   38, 1033,   40,   41,   42,   -1,   -1,   38,  590,  126,
   41,   -1,  594,   44,   -1, 1047,   -1,   -1,   -1, 1051,
 1052,   -1,   -1,  832,   -1, 1057,   -1,   58,   59,   -1,
   -1, 1063,   63,   -1,   -1,   -1, 1203, 1204, 1205, 1071,
   -1,   -1, 1209,   -1, 1211,   -1, 1213, 1214,   -1, 1216,
   -1,  633,   -1,   91,   -1,   -1,   -1,   -1, 1311, 1226,
   -1,   -1,   93,   94,   -1,   37,   38,   -1,   -1,   41,
   42,   43,   44,   45, 1327,   47,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  667,   58,   59,   60,   -1,
   62,   63,  674,  124,  125, 1127,   -1,   40,   -1,  326,
  327,  328,  329,  330,  331,  332,  333,  334, 1140, 1141,
   -1,   -1,   -1,  695,   -1,   -1,  698,   -1,    1,   -1,
   -1,   93,   94,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  946,   -1,  256,
  257,  258,  259,  260,   -1,   -1,   -1,   30,  265,  266,
   -1,   -1,  124,  125,   -1,  272,  965,   -1,   -1,  968,
   -1,   -1,  744,   -1, 1196,  747,   -1,  284, 1200,   52,
   -1,   -1,   55,   -1,  756,   -1,   -1,   38,   -1,   40,
   41,   42,  764,   44,  766,   -1,  995,   -1,  305,  306,
  772,   -1,   -1,   -1,   -1,   78,   79,   58,  315,  781,
   61,   -1,   85, 1235,   -1,  322,  788,   -1,   -1, 1241,
 1242,   -1,   -1,   -1,   -1,   -1,   -1,  334,   -1,  257,
  258,  259,  260,   -1, 1033,   -1,   -1,  265,  266,  267,
   91,   -1,   -1,   -1,  272,   -1,   -1,   -1, 1047,   -1,
   -1,   -1, 1051, 1052,   -1,   -1,  284,  285, 1057,   -1,
  832,   -1,   -1,   -1, 1063,   -1,   -1,   -1,   -1,  297,
   -1,   -1,   -1,   -1,   -1,  126,   -1,   -1,  306,   -1,
  153,   -1,   -1,   -1,   -1,  158,   -1,  315,   -1, 1311,
   -1,   -1,   -1,   -1,  322,   38,   -1,   40,   41,   42,
   -1,   44,   -1,   -1,   -1, 1327,   -1,   -1,   -1,  330,
  331,  332,  333,  334,   -1,   -1,  189,   -1,   61,   -1,
   -1,   -1,   -1,  895,  257,  258,  259,   -1, 1127,   -1,
   38,   -1,  265,  266,   42,   -1,  209,   -1,   -1,  272,
  912, 1140,   -1,   -1,   -1,  917,   -1,   -1,   91,   -1,
   -1,  284,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  326,  327,  328,  329,  330,  331,
  332,  333,  334,  306,  946,   38,   -1,   40,   41,   42,
   -1,   -1,  315,  126,   -1,   -1,   -1,   -1,   -1,  322,
   -1,   -1,   -1,  965,   -1,   -1,  968, 1196,   -1,  971,
   -1, 1200,   -1,  276,   -1,   -1,  257,  258,  259,  260,
   -1,  257,  258,  259,  265,  266,   -1,   -1,  291,  265,
  266,  272,   -1,  995,   -1,  997,  272,   -1,   91,  302,
  303,   -1,   -1,  284,   -1,   -1, 1235,   -1,  284,   -1,
  313,   -1, 1241, 1242,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1, 1024,  326,  305,  306,  329,   -1,   -1,   -1,
  306, 1033,   -1,   -1,  315,   -1,   -1,   -1,   -1,  315,
   -1,  322,   -1,   -1,  347, 1047,  322,   -1,   -1, 1051,
 1052,   -1,   -1,  334,   -1, 1057,   -1,   -1,   -1,  335,
  363, 1063,   -1,   -1,   -1,  368, 1068,   -1,   -1,    1,
  373,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1, 1311,  256,  257,  258,  259,  260,   -1,   -1,
  393,  394,  265,  266,   -1,   -1,   -1,   -1, 1327,  272,
   -1,   -1,   -1,   -1,   -1,   -1,    1,   -1,   -1,  412,
   -1,  284, 1114, 1115, 1116, 1117,   59,   -1,  421,  257,
  258,  259,  260,  426,   -1, 1127,  429,  265,  266,   -1,
   -1,   -1,  305,  306,  272,   30,   -1,   -1, 1140, 1141,
   -1,   -1,  315, 1145,  447,   -1,  284,  450, 1150,  322,
 1152,   -1, 1154,   85,   -1, 1157,   -1,   52,   -1, 1161,
   55,  334,   -1,   -1,  257,  258,  259,  260,  306,   -1,
   -1,   -1,  265,  266,   -1,   -1,   -1,  315,   -1,  272,
  483,  484,   -1,   -1,  322,   -1,  489,   -1,   -1,   -1,
   85,  284,  495,   -1, 1196,   -1,   -1,   -1, 1200,   -1,
   -1, 1203, 1204, 1205,   -1,   -1,   -1, 1209,   -1, 1211,
   -1, 1213, 1214,  306, 1216,   -1,   38,   -1,   40,   -1,
   42,  524,  315,   -1, 1226,  528,   -1,   -1,  531,  322,
   -1,   -1,   -1, 1235,   -1,   -1,   -1,   -1,   -1, 1241,
 1242,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  551,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  153,   -1,
  563,   -1,   -1,   -1,  567,   -1,   -1,   -1,  571,   91,
   -1,   -1,   -1,   -1,   -1,   -1,   37,   38,   -1,   -1,
   41,   42,   43,   44,   45,   -1,   47,   -1,  591,   -1,
   -1,  594,   -1,  596,  189,   -1,   -1,   58,   59,   60,
   -1,   62,   63,   -1,  126,   -1,   -1,   -1,   -1, 1311,
   -1,  164,  165,   -1,  209,   -1,   -1,   -1,    1,   -1,
  623,   -1,   -1,   -1,  267, 1327,  269,   -1,   -1,  632,
   -1,  634,   93,   94,   -1,   -1,  279,  280,   -1,  282,
   -1,   -1,  285,  267,   -1,  269,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  297,  279,  280,  300,  282,  291,
   -1,  285,   -1,  124,  125,  668,   -1,  310,  311,  312,
  313,  314,   -1,  297,  269,   -1,  300,   38,   -1,   40,
   41,   42,   -1,   44,   -1,   -1,  310,  311,  312,  313,
  314,   -1,  695,   -1,   -1,  698,  291,  329,   -1,   -1,
   61,   -1,   85,   -1,   -1,   -1,   -1,   -1,  303,   -1,
   -1,  335,   -1,   -1,   -1,   -1,   -1,   -1,  313,  722,
   -1,  724,   -1,  726,   -1,   -1,   -1,   -1,   -1,   -1,
   91,  326,   -1,   -1,  329,  257,  258,  259,  260,   -1,
  743,   -1,   -1,  265,  266,  267,   -1,   -1,   -1,   -1,
  272,  754,  347,   -1,  307,  308,  759,  760,  761,   -1,
   -1,   -1,  284,  285,   -1,  126,   -1,   -1,  363,   -1,
   -1,   -1,   -1,  368,   -1,  297,   -1,   -1,  373,  782,
  412,   -1,   -1,  305,  306,   -1,   -1,   -1,   -1,  421,
  343,   -1,   -1,  315,  426,   -1,   -1,  429,   -1,   -1,
  322,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  361,  362,
   -1,   -1,   -1,   -1,   -1,  447,   -1,  412,  450,   -1,
   -1,   -1,   -1,  418,   -1,   -1,  421,   -1,   -1,  832,
   -1,  426,   -1,   -1,  429,   -1,   -1,   -1,  391,  392,
   -1,  844,  845,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  447,   -1,   -1,  450,   -1,  489,   -1,   -1,
  413,  414,  415,   -1,   -1,  326,  327,  328,  329,  330,
  331,  332,  333,  334,   -1,  336,  337,   -1,   -1,  432,
  433,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  483,  484,
   -1,  894,   -1,   -1,  489,   -1,  257,  258,  259,  260,
  495,   -1,   -1,   -1,  265,  266,   -1,   -1,  291,   -1,
   -1,  272,   -1,   -1,  917,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   38,  284,   40,   -1,   42,   -1,    1,  524,
   -1,   -1,   -1,  528,   -1,   -1,  531,   -1,   -1,   -1,
  257,  258,  259,  946,  305,  306,  329,   -1,  265,  266,
   59,   -1,   -1,   -1,  315,  272,  551,   30,   -1,   -1,
   -1,  322,  965,   -1,  347,  968,   -1,  284,  563,   -1,
   -1,   -1,  567,  334,   -1,   91,  571,   -1,   -1,   52,
  533,  534,   55,   -1,   -1,   -1,   -1,   -1,   -1,  306,
   -1,   -1,  995,   -1,   -1,   -1,  591,   -1,  315,  594,
   -1,  596,   -1,   -1,   -1,  322,   -1,   -1,   -1,   -1,
  126,   -1,   85,   -1,   38,   -1,   40,   -1,   42,   -1,
   -1,   -1, 1025,   -1,   -1,   -1,   -1,   -1,  623,  412,
 1033,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  421,  634,
   -1,   -1,   -1,  426, 1047,   -1,  429,   -1, 1051, 1052,
  257,  258,  259,   -1, 1057,   -1,   -1,   -1,  265,  266,
 1063,  656,   -1,  695,  447,  272,  698,  450, 1071,   -1,
   -1,   -1,   -1,  668,   -1,   -1,   -1,  284,   -1,   -1,
  153,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  685,   -1,  687,   -1,  689,   -1,   -1,   -1,   38,  306,
  695,   41,  126,  698,   44,   -1,  489,   -1,  315,   -1,
   -1,   -1,   -1,  666,  667,  322,  189,   -1,   58,   59,
   60,   -1,   62,   63, 1127,   -1,   -1,  722,   -1,  724,
   -1,  726,   -1,   -1,  766,   -1,  209, 1140,   -1,   -1,
  772,  257,  258,  259,  260,  528,   -1,   -1,  743,  265,
  266,  267,   -1,   93,   94,   -1,  272,  710,  267,  754,
  269,   -1,   -1,   -1,  759,  760,  761,   -1,  284,  285,
  279,  280,   -1,  282,   -1,   -1,  285,   -1,   -1,   -1,
   -1,  297,   -1,   -1,  124,  125,   -1,  782,  297,  305,
  306,  300,   -1, 1196,  747,   -1,  269, 1200,   -1,  315,
  832,  310,  311,  312,  313,  314,  322,   -1,   -1,   -1,
   -1,  594,   -1,   -1,   -1,   -1,   -1,   -1,  291,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  303,   -1, 1235,  257,  258,  259,  260,  832, 1241, 1242,
  313,  265,  266,  267,   -1,   -1,   -1,   -1,  272,  844,
  845,   59,   -1,  326,   -1,   -1,  329,   -1,   -1,   -1,
  284,  285,   37,   38,   -1,   -1,   41,   42,   43,   44,
   45,   -1,   47,  297,  347,   -1,   -1,   -1,   -1,   -1,
  912,  305,  306,   58,   59,   60,  839,   62,   63,   -1,
  363,  315,   -1,   -1,   -1,  368,  849,   -1,  322,  894,
  373,   -1,   -1,   -1,   -1,   -1,   -1,   -1, 1311,   -1,
   -1,   -1,  695,   -1,  946,  698,   -1,   -1,   93,   94,
   -1,   -1,  917,   -1, 1327,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  965,   -1,   -1,   -1,   -1,   -1,  412,
   38,   -1,   -1,   41,   -1,  418,   44,   -1,  421,  124,
  125,  946,   -1,  426,   -1,   -1,  429,   -1,   -1,   -1,
   58,   59,   60,   -1,   62,   63,   -1,   -1,   -1,   -1,
  965,   -1,   -1,  968,  447,   -1,   -1,  450,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  326,  327,  328,  329,
  330,  331,  332,  333,  334,   93,   94,   -1,   -1,   -1,
  995,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  483,  484,   -1,   -1,   -1, 1047,  489,  970,  971, 1051,
 1052,   -1,  495,   -1,   -1, 1057,  124,  125,   -1,   -1,
 1025, 1063,   -1,   -1,  162,   -1,  164,  165, 1033,   -1,
   -1,   -1,   -1,  996,  997,   -1,   -1,   -1,   -1,  832,
   -1,  524, 1047,   -1,   -1,  528, 1051, 1052,  531,  267,
   -1,  269, 1057,   -1,   -1,   -1,   -1,   -1, 1063,   -1,
   -1,  279,  280,   -1,  282,   -1, 1071,  285,  551,   -1,
   -1,  209,   -1, 1115, 1116, 1117,   -1,   -1,   -1,  297,
  563,   -1,  300,   -1,  567, 1127,   -1,   -1,  571,   -1,
   -1,   -1,  310,  311,  312,  313,  314,   -1,   -1,   -1,
   -1,   -1,   -1,   -1, 1067,   -1, 1069, 1070,  591,   -1,
 1073,  594,   -1,  596,   -1,   -1,   -1,   38,   -1,   40,
   41,   42, 1127,   -1,   -1,   -1,   -1,   -1, 1091,   -1,
   -1,   -1,   -1,   -1,   -1, 1140,   -1,   -1,   -1,   -1,
  623,  326,  327,  328,  329,  330,  331,  332,  333,  334,
   -1,  634,   -1,  946, 1196,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  306,   -1,
   91,   -1,  965,  656,   -1,   -1,   -1,  315, 1141,   -1,
   -1,   -1,  320,   -1,   -1,  668,   -1,   -1,   -1,   -1,
   -1, 1196,   -1, 1235,   -1, 1200,   -1,   -1,   -1, 1241,
 1242,   -1,  685,   -1,  687,   -1,  689,   -1,   -1,   -1,
   -1,   -1,  695,   -1,   -1,  698,   -1,   -1,  326,  327,
  328,  329,  330,  331,  332,  333,  334,   -1,   -1,   -1,
 1235,   -1,   -1,   -1,   -1,   -1, 1241, 1242,   -1,  722,
 1033,  724,   -1,  726,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1, 1047,   -1,   -1,   -1, 1051, 1052,
  743,   -1,   -1,   -1, 1057,   -1,   -1,   -1,   -1, 1311,
 1063,  754,   -1,   -1,   -1,   -1,  759,  760,  761,   -1,
   -1,   -1,   -1,   -1,   -1, 1327,   -1,   -1,   -1,   38,
   -1,   40,  430,   42,  432,  433,   -1,   -1,   -1,  782,
   -1,   -1,   -1,   37,   38,   -1, 1311,   41,   42,   43,
   44,   45,   46,   47,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1, 1327,   -1,   58,   59,   60,   61,   62,   63,
   -1,   -1,   -1,   -1, 1127,    1,  257,  258,  259,  260,
   -1,   -1,   -1,   -1,  265,  266,  267, 1140,   -1,  832,
   -1,  272,   -1,   -1,   -1,   -1,   -1,   91,   -1,   93,
   94,  844,  845,  284,  285,  503,  504,   -1,   -1,   -1,
   -1,   -1,   38,   39,   -1,   -1,  297,  126,   -1,   -1,
   -1,   -1,   -1,   49,   50,  306,   52,   53,   54,   55,
  124,  125,   -1,   -1,  315,   -1,  267,   63,   64,  270,
  271,  322,   -1, 1196,  275,   -1,   -1, 1200,   -1,   -1,
  281,  894,   -1,   -1,  285,  286,  287,  288,  289,   85,
   -1,  292,  293,   -1,   -1,   -1,  297,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  917,   -1,   -1,   -1,   -1,   38,
   -1,   40, 1235,   42,   -1,   -1,   -1,   -1, 1241, 1242,
   38,   -1,   -1,   41,   -1,   43,   44,   45,   -1,   -1,
   -1,   -1,   -1,  946,   -1,   -1,   -1,   -1,   -1,   -1,
   58,   59,   60,   -1,   62,   63,   -1,   -1,   -1,   -1,
  146,   -1,  965,   -1,   -1,  968,   -1,  153,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  162,   -1,  164,  165,
   -1,   -1,   39,   -1,   -1,   93,   94,  256,  257,  258,
  259,  260,  995,   -1,   -1,   -1,  265,  266, 1311,   -1,
   -1,   -1,   -1,  272,   -1,   -1,  664,  126,  262,   -1,
   -1,  669,  670,   -1, 1327,  284,  124,  125,   -1,   -1,
   -1,   -1, 1025,  209,   -1,   -1,   -1,   -1,   -1,   -1,
 1033,  217,   -1,   -1,  220,  221,  305,  306,   -1,   -1,
   -1,   -1,   -1,   -1, 1047,   -1,  315,   -1, 1051, 1052,
   -1,   -1,   -1,  322, 1057,   -1,   -1,   -1,   -1,   -1,
 1063,  247,   -1,  249,   -1,   -1,   -1,   -1, 1071,  323,
  324,  325,  326,  327,  328,  329,  330,  331,  332,  333,
  334,  335,  336,  337,  338,  339,  340,  341,  342,  343,
  344,  345,  346,  347,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  162,   -1,   38,   -1,   40,
   -1,   42,  298,  299,   -1,   -1,   -1,   -1,   -1,   -1,
  306,  307,  308,   -1, 1127,   -1,   -1,   -1,   -1,  315,
   -1,   -1,   -1,   -1,  320,   -1,   -1, 1140,  257,  258,
  259,  260,   -1,   -1,   -1,   -1,  265,  266,  267,   -1,
   -1,   -1,  209,  272,   -1,   -1,   -1,  343,   -1,   -1,
  217,   -1,   -1,   -1,   -1,  284,  285,   -1,   -1,  827,
  828,   -1,   -1,   -1,   -1,  361,  362,  363,  297,   -1,
   -1,  839,  368,   -1,  842,  843,  305,  306,   -1,   42,
   -1,  849,  850, 1196,   -1,  126,  315, 1200,   -1,   -1,
   -1,   -1,   -1,  322,   -1,  391,  392,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  326,  327,
  328,  329,  330,  331,  332,  333,  334,  413,  414,  415,
   -1,   -1, 1235,   -1,   -1,   -1,   -1,   -1, 1241, 1242,
   -1,   -1,   -1,   -1,  430,   -1,  432,  433,   -1,  306,
  436,  437,  438,   -1,   -1,   -1,   38,   -1,  315,   41,
   -1,   -1,   44,  320,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  126,   -1,   -1,   58,   59,   60,   -1,
   62,   63,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  480,  481,  482,  483,  484,   -1,
  486,  487,   -1,   -1,  257,   -1,   -1,   -1, 1311,   -1,
  968,   93,   94,   -1,   -1,   -1,   -1,  503,  504,   -1,
   -1,   -1,   -1,   -1, 1327,   -1,  257,  258,  259,  260,
   -1,   -1,   -1,   -1,  265,  266,  267,  995,  291,   -1,
   -1,  272,  124,  125,   -1,  531,   -1,  533,  534,   -1,
 1008,   -1,   -1,  284,  285,   -1,   -1,   -1,  544,   -1,
   -1,   -1,   -1,  549,  550,  551,  297,   -1,   -1,  555,
   -1,   -1,  325,  430,  305,  306,  329,  563,   -1,  436,
   -1,  567,   -1,   -1,  315,  571,  572,  573,   -1,   -1,
   -1,  322,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1, 1059, 1060, 1061,  257,  258,  259,   -1,   -1,  595,
  596,   -1,  265,  266,   -1,   -1,   -1,   -1,   -1,  272,
 1078,   -1, 1080,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  284,   -1,   -1,   -1,   -1, 1094,  623, 1096,   -1,
  257,  258,  259,   -1,   -1,   -1,  503,  504,  265,  266,
   -1,   -1,  305,  306,   -1,  272,  409,   -1,  411,  412,
   -1,   -1,  315,   -1,  417,   -1,   -1,  284,  421,  322,
   -1,   -1,  425,  426,  531,  428,  429,   -1,  664,   -1,
  666,  667, 1140,  669,  670,   -1,  672,  673,  674,  306,
  443,   -1,  445,  446,  447,   -1,  449,  450,  315,   -1,
   -1,   -1,   -1,   -1,   -1,  322,  563,   -1,   -1,  695,
  567,   -1,  698,   -1,  571,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  710,   -1,   -1,   -1,   -1,   -1,
   -1,   38,   -1,   40,   41,   42,  489,   44,   -1,   -1,
   -1,   -1, 1200,   -1,   -1,   -1,  328,  329,  330,  331,
  332,  333,  334,   -1,   61,   -1,   -1,  743,   -1,   -1,
   -1,  747,   -1,   -1,   -1,  126,  623,   -1,  754,  755,
  756,   -1,   -1,  759,  760,  761,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   91,   38,   -1,   40,   -1,   42,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  787,  788,   -1,   -1,   38,   -1,  664,   41,   -1,
   -1,   44,  669,  670,   -1,  672,   -1,    1,   -1,  126,
   -1,   -1,   -1,   38,   -1,   58,   59,   60,   -1,   62,
   63,   46,   47,   48,   49,   50,   -1,   52,   -1,   -1,
   55,  827,  828,   -1,   -1,   60,   61,   -1,   -1,   -1,
   -1,   66,   67,  839,   38,   39,  842,  843,  844,  845,
   93,   94,   -1,  849,  850,   49,   50,   -1,   52,   53,
   54,   55,   -1,  126,   -1,   -1,   -1,   -1,   -1,   63,
   64,   -1,   -1,   -1,   -1,   -1,  743,   -1,   -1,   -1,
  105,  124,  125,   -1,   -1,   -1,  257,  258,  259,   -1,
   -1,   85,  655,   -1,  265,  266,   -1,   -1,  894,  895,
   -1,  272,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  284,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  147,  148,  149,  150,  151,   -1,  153,   -1,
   -1,   -1,   -1,   -1,  305,  306,   -1,   -1,   -1,   -1,
  257,  258,  259,  260,  315,   -1,   -1,   -1,  265,  266,
   -1,  322,  146,   -1,  950,  272,  952,  953,   -1,  153,
  827,  828,   -1,   -1,   -1,   -1,   -1,  284,  162,  965,
  164,  165,  968,   -1,  970,  971,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  305,  306,
   -1,   -1,   -1,   -1,  257,  258,  259,  260,  315,  995,
  996,  997,  265,  266,  267,  322,   -1,  232,   -1,  272,
   -1,   -1, 1008,   -1, 1010,  209,   -1,  334,   -1,   -1,
   -1,  284,  285,  217,   -1,   -1,  220,  221,   -1,   -1,
   -1,   -1,   -1,   -1,  297,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  305,  306,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  315,  247,   -1,  249,   -1,   -1,   -1,  322,
   -1,   -1,   -1, 1059, 1060, 1061,   -1,   -1,   -1,   -1,
   -1, 1067,   -1, 1069, 1070, 1071,   -1, 1073,   -1,   -1,
   -1,   -1, 1078,   -1, 1080,  328,  329,  330,  331,  332,
  333,  334,   -1,   -1,   -1, 1091,   -1,   -1, 1094,   -1,
 1096,  968,   -1,   -1,  298,  299,   -1,   -1,   -1,   -1,
   -1,   -1,  306,  307,  308,   -1,   -1,   -1,  343,   -1,
   -1,  315, 1118, 1119, 1120,   -1,  320,   -1,  995,   -1,
   -1,   -1,   -1,   -1, 1130,  360,  361,  362,  363,   -1,
   -1,   -1,   -1,  368, 1140, 1141,   -1,   -1,   -1,  343,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  389,  390,   -1,  361,  362,  363,
   -1,   -1,   -1,   -1,  368,   -1,   -1,   -1,   38,   -1,
   40,   41,   42,   -1,   44,   -1,   -1,   -1,  413,  414,
  415,   -1, 1059, 1060, 1061,   -1,   -1,  391,  392,   -1,
   -1,   61,   -1, 1199, 1200,   -1,   -1,   -1,   -1,   -1,
   -1, 1078,   -1, 1080,   -1,   -1,   -1,   -1,   -1,  413,
  414,  415,   -1,   -1,   -1,   -1,   -1, 1094,   -1, 1096,
   38,   91,   40,   -1,   42,   -1,   -1,   -1,  432,  433,
   -1,   -1,  436,  437,  438,   -1,   -1,   -1, 1244,  474,
   -1,   -1,   -1,   -1,   -1,  480,  481,  482,  483,  484,
   -1,   -1,   -1,   -1,   -1,   -1,  126,   -1,   -1,   -1,
   -1,   -1,   -1, 1140,   -1,   -1,   43,   -1,   -1,   38,
   -1,   -1,   41,   -1,   -1,   44,  480,  481,  482,  483,
  484,   -1,  486,  487,   -1,   -1,   -1,   -1,   -1,   58,
   59,   60,   -1,   62,   63,   -1,   -1,   -1,   -1,  503,
  504,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  126,  544,
   -1,  546,  547,  548,  549,  550,  551,   -1,   -1,  554,
   -1,   -1,   -1, 1200,   93,   94,   -1,  531,   -1,  533,
  534,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  544,   -1,   -1,   -1,   -1,  549,  550,  551,   -1,   -1,
   -1,  555,   -1,   -1,   -1,  124,  125,   -1,   -1,  563,
   -1,  596,   -1,  567,   -1,   -1,   -1,  571,  572,  573,
   -1,   38,   -1,   40,   -1,   42,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  161,   -1,  163,  257,  258,  259,
  260,  595,  596,   -1,  171,  265,  266,   -1,   -1,   -1,
   -1,   -1,  272,   -1,   -1,   37,   38,   -1,  185,   41,
   42,   43,   44,   45,  284,   47,   -1,   -1,   -1,  623,
   -1,   -1,   -1,   59,   -1,   -1,   58,   59,   60,   -1,
   62,   63,   -1,   -1,   -1,  305,  306,   -1,   -1,  257,
  258,  259,  260,   -1,   -1,  315,   -1,  265,  266,  267,
   -1,   -1,  322,   -1,  272,   -1,   -1,   -1,   -1,  126,
   -1,   93,   94,   -1,  334,   -1,  284,  285,  672,  673,
  674,   -1,   -1, 1246,   -1,  710,   -1,   -1, 1251,  297,
 1253,   -1,   -1, 1256,   -1,   -1, 1259,  305,  306,   -1,
 1263,  695,  124,  125,  698,   -1,   -1,  315,   -1,   -1,
   -1,   -1,   -1,   -1,  322,   -1,  710,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1, 1289,   -1, 1291,   59,
 1293,   -1,   -1,   -1, 1297,   -1,   -1, 1300,  305,   -1,
 1303,   -1,  309,   -1,   -1, 1308, 1309,   -1,   -1,  743,
  317,   -1,   -1,  747,   -1,   -1,   -1, 1320,   -1,   -1,
  754,  755,  756,   -1,  331,  759,  760,  761,   -1,  328,
  329,  330,  331,  332,  333,  334,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  787,  788,   -1,   -1,   -1,   -1,   -1,
  257,  258,  259,  260,   -1,   -1,   -1,   -1,  265,  266,
  267,   -1,   -1,   -1,  839,  272,  841,  842,  843,  844,
  845,  846,  847,   -1,   -1,   -1,  851,  284,  285,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  297,  267,   -1,  269,   -1,  839,  413,   -1,  305,  306,
  844,  845,   -1,  279,  280,  849,  282,   -1,  315,  285,
   -1,   -1,   -1,   -1,  431,  322,   -1,  256,  257,  258,
  259,  297,  261,   -1,  300,   -1,  265,  266,  903,   -1,
  905,  189,   -1,  272,  310,  311,  312,  313,  314,   -1,
   -1,   -1,   -1,   -1,   -1,  284,   -1,   -1,   -1,   -1,
  894,  895,   -1,   -1,  326,  327,  328,  329,  330,  331,
  332,  333,  334,   -1,   -1,   -1,   -1,  306,  307,  308,
  309,  310,   -1,   -1,   -1,  950,  315,  952,  953,   -1,
   -1,  498,  499,  322,   -1,  502,   -1,  267,   -1,  269,
  507,  508,  509,   -1,   -1,  512,  513,  514,  515,  279,
  280,   -1,  282,   -1,   -1,  285,  950,   -1,  952,  953,
   -1,   -1,   -1,   -1,  531,  532,   -1,  297,   -1,   -1,
  300,  965,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  310,  311,  312,  313,  314,   -1,   -1,   38,   -1,   40,
   -1,   42,   -1,   -1,   -1,  303,  563,   -1,   -1,   -1,
  567,   -1,   -1,   37,  571,  313,   40,   41,   -1,   43,
   44,   45,   46,   47,   -1,   -1, 1010,   -1,  326,   -1,
   -1,   -1,   -1,   -1,   58,   59,   60,   61,   62,   63,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   91,   -1, 1067,   -1, 1069, 1070, 1071,   38,   -1,   -1,
   41,   -1,   -1,   44,   -1,   -1,  623,   91,   -1,   93,
   94,   -1,   -1,   -1,   -1,   -1, 1091,   58,   59,   60,
   -1,   62,   63, 1067,   -1, 1069, 1070, 1071,   -1, 1073,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  123,
  124,  125,   -1, 1118, 1119, 1120,   -1, 1091,  665,   38,
   -1,   -1,   93,   94,   -1, 1130,   -1,   46,   47,   48,
   49,   50,   -1,   52,   -1,   -1,   55,   -1,   -1,   -1,
   -1,   60,   61,   -1, 1118, 1119, 1120,   66,   67,   -1,
   -1,   -1,   -1,  124,  125,   -1, 1130,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  714,  715,   -1,
  717,  718,  719,  720,   -1,   -1,   -1,   -1, 1183, 1184,
 1185,   -1,   -1,   -1,   38,   -1,   40,   41,   42,   -1,
   -1,   -1,   -1,   -1, 1199,   38,  743,   -1,   41,   -1,
   -1,   44,   -1,   -1,   -1,   -1,  494,  754,   -1,    1,
   -1,   -1,  759,  760,  761,   58,   59,   60,   -1,   62,
   63,   -1,   -1,  511,   -1, 1199,  257,  258,  259,  260,
   -1,   -1,   -1,  521,  265,  266,  267,   91,   -1, 1244,
   -1,  272,   -1,   -1,   -1,   -1,   38,   39,  262,   -1,
   93,   94,   -1,  284,  285,   -1,   -1,   49,   50,   -1,
   52,   53,   54,   55,   -1,   -1,  297,   -1,   -1,   -1,
 1244,   63,   64,   -1,   -1,  306,   -1,   -1,   -1,  567,
   -1,  124,  125,   -1,  315,   -1,   -1,   -1,   -1,   -1,
   -1,  322,  580,   85,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  594,   -1,   -1,  323,
  324,  325,  326,  327,  328,  329,  330,  331,  332,  333,
  334,  335,  336,  337,  338,  339,  340,  341,  342,  343,
  344,  345,  346,  347,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  888,   -1,   -1,   -1,  892,   -1,  894,   -1,   -1,
   -1,  639,   -1,   -1,   -1,   -1,   -1,  328,  329,  330,
  331,  332,  333,  334,  652,   -1,   -1,   -1,   -1,   -1,
  162,   -1,  164,  165,   -1,   37,   -1,   -1,   40,   41,
  668,   43,   44,   45,   -1,   47,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,   60,   61,
   62,   63,   -1,  257,  258,  259,  260,   -1,   -1,   -1,
   -1,  265,  266,   -1,   -1,   -1,   -1,  209,  272,   -1,
  967,   -1,   -1,   -1,  343,  217,   -1,   -1,  220,  221,
  284,   93,   94,   -1,  722,   -1,  724,   -1,  726,   -1,
   -1,  360,  361,  362,  363,   -1,   -1,   -1,   -1,  368,
   -1,   -1,  306,   -1,   -1,  247,   -1,  249,   -1,   -1,
   -1,  315,  124,  125,   -1,   -1,   -1,   -1,  322,   -1,
  389,  390,  760,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  328,  329,  330,  331,  332,
  333,  334,   -1,   -1,  413,  414,  415,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  306,  307,  308,   -1,   -1,   -1,
 1067,   -1,   -1,  315,   -1,   -1,   -1, 1074,  320,   -1,
   -1,   -1,  820,  821,   -1,   -1,  824,   -1,   -1,   -1,
   -1,   -1,   -1,   -1, 1091, 1092,   -1,   -1,   -1,   -1,
   -1,  343,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  480,  481,  482,  483,  484,   -1,   -1,   -1,  361,
  362,  363,   -1,   -1,   -1,  863,  368,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  872,   -1,  874,   -1,  876,   -1,
  878,   -1, 1139,   -1,   -1,   -1,   -1,   -1,   -1,  391,
  392,  393,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1, 1160,  406, 1162, 1163,   -1, 1165, 1166,
   42,  413,  414,  415,   -1,   -1, 1173, 1174, 1175,   -1,
 1177, 1178,   -1,   38,   -1,  923,   -1,   42,  430,   -1,
  432,  433,   -1,   -1,  436,  437,  438,   -1,   -1,   -1,
   -1,   -1, 1199,  126,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  326,  327,  328,  329,  330,  331,
  332,  333,  334,  335,  336,  337,  338,  339,  340,  341,
  342,  343,  344,  345,  346,  347,   91,   -1,  480,  481,
  482,  483,  484,   -1,  486,  487,   -1, 1244,   -1,   -1,
   -1,   -1,   -1,   -1,  126,   -1,   -1,   -1,   -1,   -1,
   37,  503,  504,   40,   41,   -1,   43,   44,   45,   46,
   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   58,   59,   60,   61,   62,   63,   59,   -1,  531,
   -1,  533,  534,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   91,   -1,   93,   94,   -1,   -1,
   -1,  563,   -1, 1061,   -1,  567,   -1,   -1,   -1,  571,
  572,  573,   -1,   -1,  257,  258,  259,   -1,   -1,   -1,
   -1,  710,  265,  266,   -1,   -1,  123,  124,  125,  272,
   37,   38,   -1,   -1,   41,   42,   43,   44,   45,   -1,
   47,  284,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   58,   59,   60,   -1,   62,   63,   -1,   -1,   -1,
   -1,  623,  305,  306,   -1,  257,  258,  259,   -1,   -1,
   -1,   -1,  315,  265,  266,   -1,   -1,   -1,   -1,  322,
  272,   -1,  257,  258,  259,  260,   93,   94,   -1,   -1,
  265,  266,  284,   -1,   -1,   -1,   -1,  272,   -1,   -1,
   -1,   -1,  664,   -1,  666,  667,   -1,  669,  670,  284,
  672,  673,  674,  305,  306,   38,   -1,  124,  125,   42,
   -1,   -1,   -1,  315,   -1,   -1,   -1,   -1,   -1,   -1,
  322,  306,   -1,  695,   -1,   -1,  698,   -1,   -1,   -1,
  315,   -1,   -1,   -1,   -1,   -1,   -1,  322,  710,   -1,
  839,   -1,  841,  842,  843,  844,  845,  846,  847,   -1,
   -1,   -1,  851,   -1,   -1,  262,   -1,   -1,   91,   -1,
   -1,   -1,   -1,   -1,   -1,  267,   -1,  269,   -1,   -1,
   -1,  743,   -1,   -1,   -1,  747,   -1,  279,  280,   -1,
  282,   -1,   -1,  285,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  766,  297,   -1,   -1,  300,   38,
  772,   40,   -1,   42,  903,   -1,  905,   -1,  310,  311,
  312,  313,  314,   -1,   -1,   -1,  323,  324,  325,  326,
  327,  328,  329,  330,  331,  332,  333,  334,   -1,  336,
  337,  338,  339,  340,  341,  342,  343,  344,  345,  346,
  347,   -1,   -1,   -1,   -1,    1,   -1,   -1,   -1,   -1,
   -1,  950,   -1,  952,  953,  827,  828,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  839,   -1,   -1,
  842,  843,  844,  845,   -1,   -1,   -1,  849,  850,   -1,
   -1,   -1,   38,   39,   -1,   -1,   -1,  126,   -1,   -1,
   -1,   -1,   -1,   49,   50,   -1,   52,   53,   54,   55,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   63,   64,  326,
  327,  328,  329,  330,  331,  332,  333,  334,   -1,   -1,
   -1,   -1,   -1,   -1,  257,  258,  259,  260,   -1,   85,
   -1,   -1,  265,  266,  267,   -1,   -1,  270,  271,  272,
  912,   -1,  275,   -1,   -1,  278,   -1,   -1,  281,   -1,
   -1,  284,  285,  286,  287,  288,  289,   -1,   -1,  292,
  293,   -1,   -1,   -1,  297,   -1,   -1,   -1, 1067,   -1,
 1069, 1070, 1071,  306,   -1,   -1,   -1,   -1,  950,   -1,
  952,  953,  315,   -1,   -1,   -1,   -1,   -1,   -1,  322,
   -1,   -1, 1091,  965,   -1,   -1,  968,   -1,  970,  971,
   -1,   -1,   -1,   -1,   -1,   -1,  162,   -1,  164,  165,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,  258,
  259,  260,   -1,  995,  996,  997,  265,  266,  267,   -1,
   -1, 1130,   -1,  272,   -1,   -1, 1008,   -1, 1010,   -1,
   -1,   -1,   -1,   -1,   -1,  284,  285,   -1,   -1,   -1,
   -1,   -1,   -1,  209,   -1,   -1,   -1,   -1,  297,   -1,
   -1,  217,   -1,   -1,  220,  221,  305,  306,   -1,   -1,
   -1,   -1,   -1,   38,   -1,   40,  315,   42,   -1,   -1,
   -1,   -1,   -1,  322,   -1, 1184, 1185, 1059, 1060, 1061,
   -1,  247,   -1,  249,   -1, 1067,   -1, 1069, 1070, 1071,
   -1, 1073,   -1,   -1,   -1,   -1, 1078,   -1, 1080,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1, 1091,
   -1,   -1, 1094,   -1, 1096,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1, 1116, 1117,   -1,   -1,   -1,   -1,
  306,  307,  308,   -1,   -1,   -1,   -1,   -1, 1130,  315,
   -1,  126,   -1,   -1,  320,  126,   -1,   -1, 1140, 1141,
   -1,   -1,   38,   -1,   40,   -1,   42,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   37,   38,  343,   40,   41,
   42,   43,   44,   45,   46,   47,   -1,   -1,   -1,   -1,
   -1,  267,   -1,  269,   -1,  361,  362,  363,   60,   61,
   62,   63,  368,  279,  280,   -1,  282,   -1,   -1,  285,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1, 1200,   -1,
   -1,  297,   -1,   -1,  300,  391,  392,  393,   -1,   91,
   -1,   -1,   94,   -1,  310,  311,  312,  313,  314,   -1,
  406,   -1,   -1,   -1,   -1,   -1,   -1,  413,  414,  415,
  126,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  335,
   -1,   -1,  124,   -1,  430,   -1,  432,  433,   -1,   -1,
  436,  437,  438,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  257,  258,  259,  260,  257,  258,  259,   -1,
  265,  266,  267,   -1,  265,  266,   -1,  272,   -1,   -1,
   -1,  272,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  284,
  285,   -1,   -1,  284,  480,  481,  482,  483,  484,   -1,
  486,  487,  297,   -1,   -1,   -1,    1,   -1,   -1,   -1,
  305,  306,   -1,   -1,  305,  306,   -1,  503,  504,   -1,
  315,   -1,   -1,   -1,  315,   -1,   -1,  322,   -1,   -1,
   -1,  322,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  531,   -1,  533,  534,   -1,
   38,   -1,   40,  162,   42,  164,  165,   52,   53,   54,
   55,  257,  258,  259,  260,   -1,   -1,   -1,   -1,  265,
  266,  267,   -1,   -1,   -1,   -1,  272,  563,   -1,   -1,
  262,  567,   -1,   -1,   -1,  571,  572,  573,  284,  285,
   85,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  209,  297,   -1,   91,   -1,   -1,   -1,   -1,   -1,  305,
  306,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  315,
   -1,   -1,   -1,   -1,   -1,   -1,  322,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  623,   -1,   -1,
   -1,  323,  324,  325,  326,  327,  328,  329,  330,  331,
  332,  333,  334,   -1,  336,  337,  338,  339,  340,  341,
  342,  343,  344,  345,  346,  347,   -1,    1,   -1,  164,
  165,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  664,   -1,
  666,  667,   -1,  669,  670,   -1,  672,  673,  674,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  306,  307,  308,
   -1,   -1,   -1,   -1,   38,   39,  315,   -1,   -1,  695,
   -1,  320,  698,   -1,   -1,   49,   50,   -1,   52,   53,
   54,   55,   -1,   -1,  710,  220,  221,   -1,   -1,   63,
   64,   38,   -1,   40,   -1,   42,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   85,   -1,   -1,  249,   -1,   -1,  743,   -1,   -1,
   -1,  747,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,
  258,  259,  260,   -1,   -1,   -1,   -1,  265,  266,  267,
  766,   -1,  270,  271,  272,   -1,  772,  275,   -1,   -1,
  278,   -1,   -1,  281,   -1,   -1,  284,  285,  286,  287,
  288,  289,   -1,   -1,  292,  293,   -1,   -1,   -1,  297,
   -1,   -1,  307,  308,   -1,   -1,   -1,   -1,  306,  126,
   -1,  430,   -1,  432,  433,   -1,   -1,  315,  162,   -1,
  164,  165,   -1,   -1,  322,   -1,   -1,   -1,   -1,   -1,
   -1,  827,  828,   -1,   -1,   -1,   -1,   -1,  343,   -1,
   -1,   -1,   -1,  839,   -1,   -1,  842,  843,  844,  845,
   -1,   -1,   -1,  849,  850,   -1,  361,  362,  363,   -1,
   -1,   -1,   -1,  368,   -1,  209,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  217,   -1,   -1,  220,  221,   -1,   -1,
   -1,   -1,   -1,   -1,  503,  504,  391,  392,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  247,   -1,  249,   -1,   -1,  413,  414,
  415,   -1,   -1,   -1,   -1,   -1,  912,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  432,  433,   -1,
   -1,   -1,  437,  438,   -1,   -1,   -1,   -1,   -1,   -1,
  257,  258,  259,  260,   -1,   -1,   -1,   -1,  265,  266,
  267,   -1,   -1,   -1,  950,  272,  952,  953,   -1,   -1,
   -1,   -1,  306,  307,  308,   -1,   -1,  284,  285,  965,
   -1,  315,  968,   -1,  970,  971,  320,   -1,  483,  484,
  297,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  305,  306,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  315,  995,
  996,  997,   -1,   -1,   -1,  322,   -1,   -1,   -1,   -1,
   -1,   -1, 1008,   -1, 1010,   -1,   38,   -1,   40,   41,
   42,   -1,   44,   -1,   -1,   -1,   -1,   -1,  533,  534,
   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,   -1,   61,
   -1,   -1,   -1,   -1,   -1,  664,   -1,  666,  667,   -1,
  669,  670,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1, 1059, 1060, 1061,   -1,  572,  573,   91,
   -1, 1067,   -1, 1069, 1070, 1071,   -1, 1073,   -1,   -1,
   -1,   -1, 1078,   -1, 1080,   -1,  430,   -1,  432,  433,
   -1,   -1,  436,  437,  438, 1091,   -1,   -1, 1094,   -1,
 1096,   -1,   -1,   -1,  126,   -1,   -1,   -1,   -1,   -1,
   -1,  190,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
 1116, 1117,   -1,   37,   38,   -1,   40,   41,   42,   43,
   44,   45,   46,   47, 1130,   -1,  480,  481,  482,  483,
  484,   -1,  486,  487, 1140, 1141,   60,   61,   62,   63,
   -1,   -1,  267,   -1,  269,   -1,   -1,   -1,   -1,  503,
  504,  666,  667,   -1,  279,  280,   -1,  282,  673,  674,
  285,   -1,   -1,   -1,   -1,   -1,   -1,   91,   -1,   -1,
   94,   -1,  297,   -1,   -1,  300,   -1,  531,   -1,   -1,
  695,   -1,   -1,  698,   -1,  310,  311,  312,  313,  314,
   -1,   -1,   -1,   -1, 1200,  710,   -1,   -1,  827,  828,
  124,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  563,
   -1,   -1,   -1,  567,   -1,   -1,   -1,  571,   -1,   -1,
   -1,   -1,   -1,   -1,  256,  257,  258,  259,  260,   -1,
   -1,   -1,  747,  265,  266,  267,   -1,  269,  189,   -1,
  272,   -1,   -1,   -1,  333,   -1,   -1,  279,  280,   -1,
  282,   -1,  284,  285,   -1,  344,  345,   -1,   -1,   -1,
  349,  350,  351,  352,   -1,  297,   -1,   -1,  300,  623,
   -1,   -1,   -1,  305,  306,  364,   -1,   -1,  310,  311,
  312,  313,  314,  315,   -1,   -1,   -1,  376,   -1,   -1,
  322,   -1,   -1,   -1,   -1,   -1,  257,  258,  259,   -1,
  261,   -1,  334,  335,  265,  266,   -1,   -1,   -1,   -1,
  664,  272,   -1,   -1,   -1,  669,  670,   -1,  672,  408,
   -1,   -1,   -1,  284,  839,   -1,   -1,  842,  843,  844,
  845,   -1,   -1,   -1,  849,  850,   -1,   -1,  262,  968,
   -1,  970,  971,   -1,  698,  306,  307,  308,  309,  310,
   -1,   -1,  303,   -1,  315,   -1,   -1,   -1,   -1,   -1,
   -1,  322,  313,   -1,   -1,   -1,  995,  996,  997,   -1,
   -1,   -1,   -1,   -1,   -1,  326,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  743,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  323,
  324,  325,  326,  327,  328,  329,  330,  331,  332,  333,
  334,   -1,  336,  337,  338,  339,  340,  341,  342,  343,
  344,  345,  346,  347,   -1,   -1,   -1,   -1,   -1,   -1,
 1059, 1060, 1061,   -1,   38,   -1,   40,   -1,   42,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1, 1078,
  965, 1080,   -1,   -1,   -1,  970,  971,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1, 1094,   -1, 1096,   -1,   -1,
   -1,   -1,   -1,  827,  828,   -1,   -1,   -1,   -1,   -1,
   -1,  996,  997,   -1,   -1,   -1,   -1,   91,   -1,   -1,
   -1,   -1,   -1, 1008,   -1, 1010,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1, 1140, 1141,  602,  603,  604,  605,  606,  607,  608,
  609,  610,  611,  612,  613,  614,  615,  616,  617,  618,
  619,  620,  621,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  494,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1, 1067,   -1, 1069, 1070, 1071,   -1, 1073,   -1,
  511,   -1,   -1,   -1,   -1,  516,   -1,   -1,   -1,   -1,
  521, 1200,   -1,   -1,   -1,   -1, 1091,   38,   -1,   40,
  531,   42,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  950,   58,  952,  953,
   -1,   -1,   -1,   -1,  693,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  563,   -1,  968,   -1,  567,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1, 1141,   -1,   -1,  580,
   -1,   -1,   -1,   -1,  585,   -1,   -1,  588,   -1,   -1,
   -1,  995,   -1,  594,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  257,  258,  259,  260,   -1,  747,   41,
   -1,  265,  266,  267,   -1,  126,   -1,   -1,  272,   -1,
   -1,   -1,   -1,  762,   -1,   -1,   -1,   -1,   -1,   -1,
  284,  285,   -1,   -1,   -1,   -1,  637,  638,  639,   -1,
   -1,   -1,   -1,  297,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  652,  306,  792,   -1, 1059, 1060, 1061,   -1,   -1,
   -1,  315,   -1,   -1,   -1,   -1,   -1,  668,  322,   -1,
   -1,   -1,   -1,   33, 1078,   -1, 1080,   37,   38,   -1,
   40,   -1,   42,   43,   44,   45,   46,   47,   -1,   -1,
 1094,  123, 1096,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   60,   61,   62,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  722,   -1,  724,   -1,  726, 1130,   -1,   -1,   -1,
   -1,   91,   -1,  734,   94,   -1, 1140,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  256,  257,  258,  259,  260,
   -1,   -1,   -1,  754,  265,  266,  895,  758,  759,  760,
   -1,  272,   -1,   -1,  124,   -1,  126,   -1,   -1,   -1,
   -1,   -1,   -1,  284,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  928,
  929,   -1,   -1,   -1,  305,  306, 1200,   -1,   -1,   -1,
   -1,  940,   -1,   -1,  315,   -1,   -1,   -1,   -1,   -1,
   -1,  322,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  820,
  821,   -1,   -1,  824,  256,  257,  258,  259,   -1,   -1,
  969,   -1,   -1,  265,  266,  267,   -1,  269,  270,  271,
  272,   -1,   -1,  275,   -1,   -1,  278,  279,  280,  281,
  282,   -1,  284,  285,  286,  287,  288,  289,   -1,   -1,
  292,  293,  863,   -1,   -1,  297,   -1,   -1,  300,   -1,
   -1,  872,   -1,  874,  306,  876,   -1,  878,  310,  311,
  312,  313,  314,  315,   -1, 1024,   -1,   -1,   -1,   -1,
  322,   -1,   -1,   -1,   -1,   -1,   38,  257,  258,  259,
   42,   -1,   -1,  335,   -1,  265,  266,  267,   -1,   -1,
  270,  271,  272,   -1,   -1,  275,   -1,   -1,  278,   -1,
   -1,  281,  923,   -1,  284,  285,  286,  287,  288,  289,
   -1,   -1,  292,  293,   -1,   -1,   -1,  297,   -1,   -1,
   -1,   -1,  302,  303,   -1,   -1,  306,   -1,   -1,   91,
   -1,   -1,   -1,   -1,   -1,  315,   -1,   -1,   -1,   -1,
   -1,   -1,  322,  323,  324,  325,  326,  327,  328,  329,
  330,  331,  332,  333,   -1,   -1,  336,  337,  338,  339,
  340,  341,  342,  343,  344,  345,  346,  347,   37,   38,
   -1,   40,   41,   42,   43,   44,   45,   46,   47,   -1,
   -1,   -1, 1141,   -1,   -1, 1144,   -1,   -1,   -1,   58,
   59,   60,   61,   62,   63,   -1,   -1,   -1,   -1,   -1,
 1021,   -1,   -1,   -1, 1025,   -1,   -1,   -1,   -1,   -1,
 1169,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   91,   -1,   93,   94,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1, 1059, 1060,
 1061,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  123,  124,  125,  126,   -1,   -1,
   37,   38,   -1,   40,   41,   42,   43,   44,   45,   46,
   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   58,   59,   60,   61,   62,   63,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  257,  258,  259,  260,   -1,
   -1,   -1,   -1,  265,  266,  267,   -1,   -1,   -1,   -1,
  272,   -1,   -1,   -1,   91,   -1,   93,   94,   -1,   -1,
   -1,   -1,  284,  285,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  297,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  306,   -1,  123,  124,  125,  126,
   -1,   -1,   -1,  315,   -1,   -1,   -1,   -1,   -1,   -1,
  322,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  256,  257,  258,
  259,  260,   -1,  262,   -1,   -1,  265,  266,  267,   -1,
  269,   -1,   -1,  272,   -1,   -1,   -1,   -1,   -1,   -1,
  279,  280,   -1,  282,   -1,  284,  285,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  297,   -1,
   -1,  300,   -1,   -1,   -1,   -1,  305,  306,   -1,   -1,
   -1,  310,  311,  312,  313,  314,  315,   -1,   -1,   -1,
   -1,   -1,   -1,  322,  323,  324,  325,  326,  327,  328,
  329,  330,  331,  332,  333,  334,  335,  336,  337,  338,
  339,  340,  341,  342,  343,  344,  345,  346,  347,  256,
  257,  258,  259,  260,   -1,  262,   -1,   -1,  265,  266,
  267,   -1,  269,   -1,   38,  272,   40,   -1,   42,   -1,
   -1,   -1,  279,  280,   -1,  282,   -1,  284,  285,   -1,
   -1,   -1,   -1,   -1,   58,   -1,   -1,   -1,   -1,   -1,
  297,   -1,   -1,  300,   -1,   -1,   -1,   -1,  305,  306,
   -1,   -1,   -1,  310,  311,  312,  313,  314,  315,   -1,
   -1,   -1,   -1,   -1,   -1,  322,  323,  324,  325,  326,
  327,  328,  329,  330,  331,  332,  333,  334,  335,  336,
  337,  338,  339,  340,  341,  342,  343,  344,  345,  346,
  347,   37,   38,   -1,   40,   41,   42,   43,   44,   45,
   46,   47,  126,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   58,   59,   60,   61,   62,   63,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   91,   -1,   93,   94,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  123,  124,  125,
  126,   -1,   -1,   37,   38,   -1,   40,   41,   42,   43,
   44,   45,   46,   47,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   58,   59,   60,   61,   62,   63,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  257,  258,  259,  260,   91,   -1,   93,
   94,  265,  266,  267,   -1,  269,   -1,   -1,  272,   -1,
   -1,   -1,   -1,   -1,   -1,  279,  280,   -1,  282,   -1,
  284,  285,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  123,
  124,  125,  126,  297,   -1,   -1,  300,   -1,   -1,   -1,
   -1,  305,  306,   -1,   -1,   -1,  310,  311,  312,  313,
  314,  315,   -1,   -1,   -1,   -1,   -1,   -1,  322,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  256,  257,  258,  259,  260,   -1,  262,   -1,   -1,  265,
  266,  267,   -1,  269,   -1,   -1,  272,   -1,   -1,   -1,
   -1,   -1,   -1,  279,  280,   -1,  282,   -1,  284,  285,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  297,   -1,   -1,  300,   -1,   -1,   -1,   -1,  305,
  306,   -1,   -1,   -1,  310,  311,  312,  313,  314,  315,
   -1,   -1,   -1,   -1,   -1,   -1,  322,  323,  324,  325,
  326,  327,  328,  329,  330,  331,  332,  333,  334,  335,
  336,  337,  338,  339,  340,  341,  342,  343,  344,  345,
  346,  347,  256,  257,  258,  259,  260,   -1,  262,   -1,
   -1,  265,  266,  267,   -1,  269,   -1,   38,  272,   40,
   -1,   42,   -1,   -1,   -1,  279,  280,   -1,  282,   -1,
  284,  285,   -1,   -1,   -1,   -1,   -1,   58,   -1,   -1,
   -1,   -1,   -1,  297,   -1,   -1,  300,   -1,   -1,   -1,
   -1,  305,  306,   -1,   -1,   -1,  310,  311,  312,  313,
  314,  315,   -1,   -1,   -1,   -1,   -1,   -1,  322,  323,
  324,  325,  326,  327,  328,  329,  330,  331,  332,  333,
  334,  335,  336,  337,  338,  339,  340,  341,  342,  343,
  344,  345,  346,  347,   37,   38,   -1,   40,   41,   42,
   43,   44,   45,   46,   47,  126,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   58,   59,   60,   61,   62,
   63,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   91,   -1,
   93,   94,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  123,  124,  125,  126,   -1,   -1,   37,   38,   -1,   40,
   41,   42,   43,   44,   45,   46,   47,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,   60,
   61,   62,   63,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  257,  258,  259,  260,
   91,   -1,   93,   94,  265,  266,  267,   -1,  269,   -1,
   -1,  272,   -1,   -1,   -1,   -1,   -1,   -1,  279,  280,
   -1,  282,   -1,  284,  285,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  123,  124,  125,  126,  297,   -1,   -1,  300,
   -1,   -1,   -1,   -1,  305,  306,   -1,   -1,   -1,  310,
  311,  312,  313,  314,  315,   -1,   -1,   -1,   -1,   -1,
   -1,  322,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  256,  257,  258,  259,  260,   -1,  262,
   -1,   -1,  265,  266,  267,   -1,  269,   -1,   -1,  272,
   -1,   -1,   -1,   -1,   -1,   -1,  279,  280,   -1,  282,
   -1,  284,  285,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  297,   -1,   -1,  300,   -1,   -1,
   -1,   -1,  305,  306,   -1,   -1,   -1,  310,  311,  312,
  313,  314,  315,   -1,   -1,   -1,   -1,   -1,   -1,  322,
  323,  324,  325,  326,  327,  328,  329,  330,  331,  332,
  333,  334,  335,  336,  337,  338,  339,  340,  341,  342,
  343,  344,  345,  346,  347,  256,  257,  258,  259,  260,
   -1,  262,   -1,   -1,  265,  266,  267,   -1,  269,   -1,
   -1,  272,   -1,   -1,   -1,   -1,   -1,   -1,  279,  280,
   -1,  282,   -1,  284,  285,   -1,   -1,   38,   -1,   40,
   -1,   42,   -1,   -1,   -1,   -1,  297,   -1,   -1,  300,
   -1,   -1,   -1,   -1,  305,  306,   -1,   -1,   -1,  310,
  311,  312,  313,  314,  315,   -1,   -1,   -1,   -1,   -1,
   -1,  322,  323,  324,  325,  326,  327,  328,  329,  330,
  331,  332,  333,  334,  335,  336,  337,  338,  339,  340,
  341,  342,  343,  344,  345,  346,  347,   37,   38,   -1,
   40,   41,   42,   43,   44,   45,   46,   47,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,
   60,   61,   62,   63,   -1,  126,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   91,   -1,   93,   94,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  123,  124,  125,  126,   -1,   37,   38,
   -1,   40,   41,   42,   43,   44,   45,   46,   47,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   58,
   59,   60,   61,   62,   63,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   91,   -1,   93,   94,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  257,  258,  259,  260,
   -1,   -1,   -1,   -1,  265,  266,  267,   -1,  269,   -1,
   -1,  272,   -1,   -1,  123,  124,  125,  126,  279,  280,
   -1,  282,   -1,  284,  285,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  297,   -1,   -1,  300,
   -1,   -1,   -1,   -1,  305,  306,   -1,   -1,   -1,  310,
  311,  312,  313,  314,  315,   -1,   -1,  257,  258,  259,
  260,  322,  262,   -1,   -1,  265,  266,  267,   -1,  269,
   -1,   -1,  272,   -1,   -1,   -1,   -1,   -1,   -1,  279,
  280,   -1,  282,   -1,  284,  285,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  297,   -1,   -1,
  300,   -1,   -1,   -1,   -1,  305,  306,   -1,   -1,   -1,
  310,  311,  312,  313,  314,  315,   -1,   -1,   -1,   -1,
   -1,   -1,  322,  323,  324,  325,  326,  327,  328,  329,
  330,  331,  332,  333,  334,  335,  336,  337,  338,  339,
  340,  341,  342,  343,  344,  345,  346,  347,  257,  258,
  259,  260,   -1,  262,   -1,   -1,  265,  266,   -1,   -1,
   -1,   -1,   -1,  272,   -1,  267,   -1,  269,  270,  271,
   -1,   -1,   -1,  275,   -1,  284,   -1,  279,  280,  281,
  282,   -1,   -1,  285,  286,  287,  288,  289,   -1,   -1,
  292,  293,   -1,   -1,   -1,  297,  305,  306,  300,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  315,   -1,  310,  311,
  312,  313,  314,  322,  323,  324,  325,  326,  327,  328,
  329,  330,  331,  332,  333,  334,   -1,  336,  337,  338,
  339,  340,  341,  342,  343,  344,  345,  346,  347,   37,
   38,   -1,   40,   41,   42,   43,   44,   45,   46,   47,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   58,   59,   60,   61,   62,   63,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   91,   -1,   93,   94,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  123,  124,  125,  126,   -1,
   37,   38,   -1,   40,   41,   42,   43,   44,   45,   46,
   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   58,   59,   60,   61,   62,   63,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   91,   -1,   93,   94,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  123,  124,  125,  126,
   -1,   -1,   -1,   37,   38,   -1,   40,   41,   42,   43,
   44,   45,   46,   47,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   58,   59,   60,   61,   62,   63,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,
  258,  259,  260,   -1,  262,   -1,   -1,  265,  266,   -1,
   -1,   -1,   -1,   -1,  272,   -1,   -1,   91,   -1,   93,
   94,   -1,   -1,   -1,   -1,   -1,  284,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  305,  306,  123,
  124,  125,   -1,   -1,   -1,   -1,   -1,  315,   -1,   -1,
   -1,   -1,   -1,   -1,  322,  323,  324,  325,  326,  327,
  328,  329,  330,  331,  332,  333,  334,   -1,  336,  337,
  338,  339,  340,  341,  342,  343,  344,  345,  346,  347,
  257,  258,  259,  260,   -1,  262,   -1,   -1,  265,  266,
   -1,   -1,   -1,   -1,   -1,  272,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  284,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  305,  306,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  315,   -1,
   -1,   -1,   -1,   -1,   -1,  322,  323,  324,  325,  326,
  327,  328,  329,  330,  331,  332,  333,  334,   -1,  336,
  337,  338,  339,  340,  341,  342,  343,  344,  345,  346,
  347,   -1,   -1,  257,  258,  259,  260,   -1,  262,   -1,
   -1,  265,  266,   -1,   -1,   -1,   -1,   -1,  272,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  284,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   37,   38,   -1,   40,   41,   42,   43,   44,   45,
   46,   47,  306,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  315,   58,   59,   60,   61,   62,   63,  322,  323,
  324,  325,  326,  327,  328,  329,  330,  331,  332,  333,
  334,  335,  336,  337,  338,  339,  340,  341,  342,  343,
  344,  345,  346,  347,   -1,   91,   -1,   93,   94,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  123,  124,  125,
   -1,   -1,   37,   38,   -1,   40,   41,   42,   43,   44,
   45,   46,   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   58,   59,   60,   61,   62,   63,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   91,   -1,   93,   94,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  123,  124,
  125,   -1,   -1,   -1,   -1,   37,   38,   -1,   40,   41,
   42,   43,   44,   45,   46,   47,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,   60,   61,
   62,   63,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  257,  258,  259,  260,   -1,  262,   -1,   -1,  265,
  266,   -1,   -1,   -1,   -1,   -1,  272,   -1,   -1,   91,
   -1,   93,   94,   -1,   -1,   -1,   -1,   -1,  284,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  306,  123,  124,  125,   -1,   -1,   -1,   -1,   -1,  315,
   -1,   -1,   -1,   -1,   -1,   -1,  322,  323,  324,  325,
  326,  327,  328,  329,  330,  331,  332,  333,  334,   -1,
  336,  337,  338,  339,  340,  341,  342,  343,  344,  345,
  346,  347,  257,  258,  259,  260,   -1,  262,   -1,   -1,
  265,  266,   -1,   -1,   -1,   -1,   -1,  272,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  284,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  306,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  315,   -1,   -1,   -1,   -1,   -1,   -1,  322,  323,  324,
  325,  326,  327,  328,  329,  330,  331,  332,  333,  334,
   -1,  336,  337,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,   -1,   -1,  257,  258,  259,  260,   -1,
  262,   -1,   -1,  265,  266,   -1,   -1,   -1,   -1,   -1,
  272,   -1,   -1,   -1,   38,   -1,   40,   -1,   42,   -1,
   -1,   -1,  284,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   37,   38,   -1,   40,   41,   42,   43,
   44,   45,   46,   47,  306,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  315,   58,   59,   60,   61,   62,   63,
  322,  323,  324,  325,  326,  327,  328,  329,  330,  331,
  332,  333,  334,   -1,  336,  337,  338,  339,  340,  341,
  342,  343,  344,  345,  346,  347,   -1,   91,   -1,   93,
   94,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  126,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  123,
  124,  125,   -1,   -1,   37,   38,   -1,   40,   41,   42,
   43,   44,   45,   46,   47,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   58,   59,   60,   61,   62,
   63,   37,   38,   -1,   40,   41,   42,   43,   44,   45,
   46,   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   58,   59,   60,   61,   62,   63,   91,   -1,
   93,   94,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   91,   -1,   93,   94,   -1,
  123,  124,  125,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  256,  257,  258,  259,  260,  123,  124,  125,
   -1,  265,  266,   -1,   -1,   -1,   -1,   -1,  272,   -1,
   -1,   -1,   -1,  257,  258,  259,  260,   -1,  262,   -1,
  284,  265,  266,   -1,   -1,   -1,   -1,   -1,  272,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  284,  305,  306,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  315,   -1,   -1,   -1,   -1,   -1,   -1,  322,   -1,
   -1,   -1,  306,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  315,   -1,   -1,   -1,   -1,   -1,   -1,  322,  323,
  324,  325,  326,  327,  328,  329,  330,  331,  332,  333,
  334,   -1,  336,  337,  338,  339,  340,  341,  342,  343,
  344,  345,  346,  347,  257,  258,  259,  260,   -1,  262,
   -1,   -1,  265,  266,   -1,   -1,   -1,   -1,   -1,  272,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  284,   -1,   -1,   -1,   -1,  262,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  306,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   38,  315,   -1,   -1,   42,   -1,   -1,   -1,  322,
  323,  324,  325,  326,  327,  328,  329,  330,  331,  332,
  333,  334,   -1,  336,  337,  338,  339,  340,  341,  342,
  343,  344,  345,  346,  347,   -1,   -1,  323,  324,  325,
  326,  327,  328,  329,  330,  331,  332,  333,  334,  335,
  336,  337,  338,  339,  340,  341,  342,  343,  344,  345,
  346,  347,   37,   38,   -1,   40,   41,   42,   43,   44,
   45,   46,   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   58,   59,   60,   61,   62,   63,   37,
   38,   -1,   40,   41,   42,   43,   44,   45,   46,   47,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   58,   59,   60,   61,   62,   63,   91,   -1,   93,   94,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   91,   -1,   93,   94,   -1,  123,  124,
  125,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   37,   38,   -1,   40,   41,   42,   43,   44,
   45,   46,   47,   -1,   -1,   -1,  124,  125,   -1,   -1,
   -1,   -1,   -1,   58,   59,   60,   61,   62,   63,   37,
   38,   -1,   40,   41,   42,   43,   44,   45,   46,   47,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   58,   59,   60,   61,   62,   63,   91,   -1,   93,   94,
  257,  258,  259,  260,   -1,   -1,   -1,   -1,  265,  266,
  267,   -1,   -1,   -1,   -1,  272,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   91,   -1,   93,   94,  284,  285,  124,
  125,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  297,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  306,
   -1,   -1,   -1,   -1,   -1,   -1,  124,  125,  315,   -1,
   -1,   -1,   -1,   -1,   -1,  322,   -1,  262,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  262,   -1,   -1,   37,   38,   -1,
   -1,   41,   42,   43,   44,   45,   46,   47,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,
   60,   61,   62,   63,   -1,   -1,   -1,   -1,  323,  324,
  325,  326,  327,  328,  329,  330,  331,  332,  333,  334,
  335,  336,  337,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,   93,   94,  323,  324,  325,  326,  327,
  328,  329,  330,  331,  332,  333,  334,  262,  336,  337,
  338,  339,  340,  341,  342,  343,  344,  345,  346,  347,
   -1,   -1,   -1,   -1,  124,  125,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  262,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  323,  324,
  325,  326,  327,  328,  329,  330,  331,  332,  333,  334,
   -1,  336,  337,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,   -1,   -1,  323,  324,  325,  326,  327,
  328,  329,  330,  331,  332,  333,  334,   -1,  336,  337,
  338,  339,  340,  341,  342,  343,  344,  345,  346,  347,
   37,   38,   -1,   40,   -1,   42,   43,   44,   45,   46,
   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   58,   59,   60,   61,   62,   63,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   37,   38,   -1,   40,   41,   42,   43,   44,   45,
   46,   47,   -1,   -1,   91,   -1,   -1,   94,   -1,   -1,
   -1,   -1,   -1,   -1,   60,   61,   62,   63,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  124,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   91,   -1,   -1,   94,   -1,
   -1,   -1,   -1,  323,   -1,   -1,  326,  327,  328,  329,
  330,  331,  332,  333,  334,   -1,  336,  337,  338,  339,
  340,  341,  342,  343,  344,  345,  346,  347,  124,   37,
   38,   -1,   40,   41,   42,   43,   44,   45,   46,   47,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   60,   61,   62,   63,   37,   38,   -1,   40,
   41,   42,   43,   44,   45,   -1,   47,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,   60,
   61,   62,   63,   91,   37,   38,   94,   -1,   41,   42,
   43,   44,   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   58,   59,   60,   61,   62,
   63,   -1,   93,   94,   -1,   -1,  124,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   37,  262,   -1,   40,   41,   -1,
   43,   44,   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,
   93,   94,   -1,  124,  125,   58,   59,   60,   61,   62,
   63,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  262,   -1,   -1,   -1,
   -1,  124,  125,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   93,   94,   -1,   -1,   -1,   -1,  323,  324,  325,  326,
  327,  328,  329,  330,  331,  332,  333,   -1,  335,  336,
  337,  338,  339,  340,  341,  342,  343,  344,  345,  346,
  347,  124,  125,   33,   -1,   -1,   -1,   -1,   38,   -1,
   40,   -1,   42,   43,   -1,   45,   -1,  323,  324,  325,
  326,  327,  328,  329,  330,  331,  332,  333,   -1,   59,
  336,  337,  338,  339,  340,  341,  342,  343,  344,  345,
  346,  347,   -1,   -1,  262,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  123,   -1,  125,  126,   -1,   40,   -1,
   -1,   -1,   -1,   -1,   -1,  323,  324,  325,  326,  327,
  328,  329,  330,  331,  332,  333,   -1,   -1,  336,  337,
  338,  339,  340,  341,  342,  343,  344,  345,  346,  347,
   -1,   -1,   -1,   -1,   -1,  326,  327,  328,  329,  330,
  331,  332,  333,  334,   -1,  336,  337,  338,  339,  340,
  341,  342,  343,  344,  345,  346,  347,   -1,   -1,   -1,
   -1,   -1,   -1,  326,  327,  328,  329,  330,  331,  332,
  333,  334,   -1,  336,  337,  338,  339,  340,  341,  342,
  343,  344,  345,  346,  347,   -1,   33,   -1,   -1,   -1,
   -1,   38,   -1,   40,   41,   42,   43,   -1,   45,   -1,
   -1,   -1,   -1,  326,  327,  328,  329,  330,  331,  332,
  333,  334,   -1,  336,  337,  338,  339,  340,  341,  342,
  343,  344,  345,  346,  347,   -1,  256,  257,  258,  259,
  260,   -1,   -1,   -1,   -1,  265,  266,  267,   -1,  269,
  270,  271,  272,  273,   91,  275,  276,  277,  278,  279,
  280,  281,  282,  283,  284,  285,  286,  287,  288,  289,
  290,  291,  292,  293,  294,  295,  296,  297,  298,  299,
  300,  301,  302,  303,  304,  305,  306,   -1,   -1,  126,
  310,  311,  312,  313,  314,  315,  316,  317,  318,  319,
  320,  321,  322,   -1,  324,  325,   -1,   -1,   -1,   33,
   -1,   -1,   -1,   -1,   38,  335,   40,   41,   42,   43,
   -1,   45,   -1,   -1,   -1,  257,  258,  259,   -1,   -1,
   -1,   -1,   -1,  265,  266,  267,   -1,   -1,  270,  271,
  272,   -1,   -1,  275,   -1,   -1,  278,   -1,   -1,  281,
   -1,   -1,  284,  285,  286,  287,  288,  289,   -1,   -1,
  292,  293,   -1,   -1,   -1,  297,   -1,   91,   -1,   -1,
   -1,   -1,   -1,   -1,  306,   -1,   -1,   -1,   -1,   33,
   -1,   -1,   -1,  315,   38,   -1,   40,   41,   42,   43,
  322,   45,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  126,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  257,  258,  259,  260,   -1,   -1,   -1,   -1,  265,  266,
  267,   -1,  269,  270,  271,  272,   -1,   91,  275,   -1,
   -1,  278,  279,  280,  281,  282,   -1,  284,  285,  286,
  287,  288,  289,   -1,   -1,  292,  293,   -1,   -1,  296,
  297,   -1,   -1,  300,   -1,  302,  303,  304,  305,  306,
   -1,   -1,  126,  310,  311,  312,  313,  314,  315,  316,
  317,  318,  319,  320,  321,  322,   -1,  324,  325,   -1,
   -1,   33,   -1,   -1,   -1,   -1,   38,  334,   40,   41,
   42,   43,   -1,   45,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  257,  258,  259,  260,   -1,   -1,   -1,
   -1,  265,  266,  267,   -1,  269,  270,  271,  272,   91,
   -1,  275,   -1,   -1,  278,  279,  280,  281,  282,   -1,
  284,  285,  286,  287,  288,  289,   -1,   -1,  292,  293,
   -1,   -1,  296,  297,   -1,   -1,  300,   40,  302,  303,
  304,  305,  306,   -1,  126,   -1,  310,  311,  312,  313,
  314,  315,  316,  317,  318,  319,  320,  321,  322,   -1,
  324,  325,   -1,  257,  258,  259,  260,   -1,   -1,   -1,
  334,  265,  266,  267,   -1,  269,  270,  271,  272,   -1,
   -1,  275,   -1,   -1,  278,  279,  280,  281,  282,   -1,
  284,  285,  286,  287,  288,  289,   -1,   -1,  292,  293,
   -1,   -1,  296,  297,   -1,   -1,  300,   -1,  302,  303,
  304,  305,  306,   -1,   -1,   -1,  310,  311,  312,  313,
  314,  315,  316,  317,  318,  319,  320,  321,  322,   -1,
  324,  325,   -1,   -1,   33,   -1,   -1,   -1,   -1,   38,
  334,   40,   41,   42,   43,   -1,   45,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  257,  258,  259,  260,   -1,
   -1,   -1,   -1,  265,  266,  267,   -1,  269,  270,  271,
  272,   -1,   91,  275,   -1,   -1,  278,  279,  280,  281,
  282,   -1,  284,  285,  286,  287,  288,  289,   -1,   -1,
  292,  293,   -1,   -1,  296,  297,   -1,   -1,  300,   -1,
  302,  303,  304,  305,  306,   -1,   -1,  126,  310,  311,
  312,  313,  314,  315,  316,  317,  318,  319,  320,  321,
  322,   33,  324,  325,   -1,   -1,   38,   -1,   40,   41,
   42,   43,  334,   45,  257,  258,  259,   -1,   -1,   -1,
   -1,   -1,  265,  266,  267,   -1,   -1,  270,  271,  272,
   -1,   -1,  275,   -1,   -1,  278,   -1,   -1,  281,   -1,
   -1,  284,  285,  286,  287,  288,  289,   -1,   -1,  292,
  293,   -1,   -1,   -1,  297,   -1,   -1,   -1,   -1,   91,
   -1,   -1,   -1,  306,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  315,   -1,   -1,   -1,   -1,   -1,   -1,  322,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   33,   -1,   -1,  126,   -1,   38,   -1,   40,   41,
   42,   43,   -1,   45,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,  258,
  259,  260,   -1,   -1,   -1,   -1,  265,  266,  267,   -1,
  269,  270,  271,  272,   -1,   -1,  275,   -1,   -1,  278,
  279,  280,  281,  282,   -1,  284,  285,  286,  287,  288,
  289,   -1,   -1,  292,  293,   -1,   -1,  296,  297,   -1,
   -1,  300,   -1,  302,  303,  304,  305,  306,   -1,   -1,
   -1,  310,  311,  312,  313,  314,  315,  316,  317,  318,
  319,  320,  321,  322,  126,  324,  325,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  334,   -1,   -1,   33,   -1,
   -1,   -1,   -1,   38,   -1,   40,   41,   42,   43,   -1,
   45,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  257,  258,  259,  260,   -1,
   -1,   -1,   -1,  265,  266,  267,   -1,  269,  270,  271,
  272,   -1,   -1,  275,   -1,   -1,  278,  279,  280,  281,
  282,   -1,  284,  285,  286,  287,  288,  289,   -1,   -1,
  292,  293,   -1,   -1,  296,  297,   -1,   -1,  300,   -1,
  302,  303,  304,  305,  306,   -1,   -1,   -1,  310,  311,
  312,  313,  314,  315,  316,  317,  318,  319,  320,  321,
  322,  126,  324,  325,   -1,   -1,   38,   -1,   40,   -1,
   42,   -1,  334,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  257,  258,  259,  260,   -1,
   -1,   -1,   -1,  265,  266,  267,   -1,  269,  270,  271,
  272,   -1,   -1,  275,   -1,   -1,  278,  279,  280,  281,
  282,   -1,  284,  285,  286,  287,  288,  289,   -1,   -1,
  292,  293,   -1,   -1,  296,  297,   -1,   -1,  300,   -1,
  302,  303,  304,  305,  306,   -1,   -1,   -1,  310,  311,
  312,  313,  314,  315,  316,  317,  318,  319,  320,  321,
  322,   -1,  324,  325,  126,   38,   -1,   40,   41,   42,
   -1,   -1,  334,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  257,  258,  259,  260,   -1,   -1,   -1,   -1,
  265,  266,  267,   -1,  269,  270,  271,  272,   91,   -1,
  275,   -1,   -1,  278,  279,  280,  281,  282,   -1,  284,
  285,  286,  287,  288,  289,   -1,   -1,  292,  293,   -1,
   -1,  296,  297,   -1,   -1,  300,   -1,  302,  303,  304,
  305,  306,   -1,  126,   -1,  310,  311,  312,  313,  314,
  315,  316,  317,  318,  319,  320,  321,  322,   -1,  324,
  325,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  334,
   38,   -1,   40,   41,   42,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  257,  258,  259,  260,   -1,
   -1,   -1,   -1,  265,  266,  267,   -1,  269,  270,  271,
  272,   -1,   -1,  275,   -1,   -1,  278,  279,  280,  281,
  282,   -1,  284,  285,  286,  287,  288,  289,   -1,   -1,
  292,  293,   -1,   91,   -1,  297,   -1,   -1,  300,   -1,
   -1,   -1,   -1,  305,  306,   -1,   -1,   -1,  310,  311,
  312,  313,  314,  315,   -1,   -1,   -1,   -1,   -1,   38,
  322,   40,   41,   42,   -1,   -1,   -1,   -1,  126,   -1,
   -1,   -1,   -1,  335,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  257,  258,  259,  260,   -1,   -1,
   -1,   -1,  265,  266,  267,   -1,  269,  270,  271,  272,
   -1,   -1,  275,   -1,   -1,  278,  279,  280,  281,  282,
   -1,  284,  285,  286,  287,  288,  289,   -1,   -1,  292,
  293,   -1,   -1,   -1,  297,   -1,   -1,  300,   -1,   -1,
   -1,   -1,  305,  306,   -1,   -1,   -1,  310,  311,  312,
  313,  314,  315,   -1,   -1,   -1,   -1,  126,   38,  322,
   40,   41,   42,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  334,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,
  258,  259,  260,   -1,   -1,   -1,   -1,  265,  266,  267,
   -1,  269,  270,  271,  272,   -1,   -1,  275,   -1,   -1,
  278,  279,  280,  281,  282,   -1,  284,  285,  286,  287,
  288,  289,   -1,   -1,  292,  293,  126,   -1,   -1,  297,
   -1,   38,  300,   40,   41,   42,   -1,  305,  306,   -1,
   -1,   -1,  310,  311,  312,  313,  314,  315,   -1,   -1,
   -1,   -1,   -1,   -1,  322,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  334,   -1,  257,  258,
  259,  260,   -1,   -1,   -1,   -1,  265,  266,  267,   -1,
  269,  270,  271,  272,   -1,   -1,  275,   -1,   -1,  278,
  279,  280,  281,  282,   -1,  284,  285,  286,  287,  288,
  289,   -1,   -1,  292,  293,   -1,   -1,   -1,  297,   -1,
   38,  300,   40,   41,   42,   -1,  305,  306,   -1,  126,
   -1,  310,  311,  312,  313,  314,  315,   -1,   -1,   -1,
   -1,   -1,   -1,  322,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  334,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,  258,  259,
  260,   -1,   -1,   91,   -1,  265,  266,  267,   -1,  269,
  270,  271,  272,   -1,   -1,  275,   -1,   -1,  278,  279,
  280,  281,  282,   -1,  284,  285,  286,  287,  288,  289,
   -1,   -1,  292,  293,   -1,   -1,   -1,  297,   -1,   -1,
  300,   -1,   -1,   -1,   -1,  305,  306,   -1,   -1,   -1,
  310,  311,  312,  313,  314,  315,   38,   -1,   40,   -1,
   42,   -1,  322,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  334,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  257,  258,  259,  260,   -1,   -1,   -1,   -1,  265,  266,
  267,   -1,  269,  270,  271,  272,   -1,   -1,  275,   91,
   -1,  278,  279,  280,  281,  282,   -1,  284,  285,  286,
  287,  288,  289,   -1,   -1,  292,  293,   -1,   41,   -1,
  297,   -1,   -1,  300,   -1,   -1,   -1,   -1,  305,  306,
   -1,   -1,   -1,  310,  311,  312,  313,  314,  315,   -1,
   -1,   -1,   -1,   -1,   -1,  322,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  334,   -1,  257,
  258,  259,  260,   -1,   -1,   -1,   -1,  265,  266,  267,
   -1,  269,  270,  271,  272,   -1,   -1,  275,   -1,   -1,
  278,  279,  280,  281,  282,   -1,  284,  285,  286,  287,
  288,  289,   -1,   -1,  292,  293,   -1,   -1,   -1,  297,
  123,   -1,  300,   -1,   -1,   -1,   -1,   -1,  306,   -1,
   -1,   -1,  310,  311,  312,  313,  314,  315,   -1,   38,
   -1,   40,   41,   42,  322,   44,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  334,   -1,   -1,   -1,
   59,   -1,   61,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  257,  258,  259,  260,   -1,
   -1,   -1,   91,  265,  266,  267,   -1,   -1,   -1,   38,
  272,   40,   41,   42,   -1,   44,   -1,   -1,   -1,   -1,
   -1,   -1,  284,  285,   -1,   -1,   -1,   -1,   -1,   58,
   59,   -1,   61,   -1,  123,  297,   -1,  126,   -1,   -1,
   -1,   -1,   -1,   -1,  306,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  315,   -1,   -1,   -1,   -1,   -1,   -1,
  322,   -1,   91,  256,  257,  258,  259,   -1,   -1,   -1,
   -1,   -1,  265,  266,  267,   -1,  269,  270,  271,  272,
   -1,   -1,  275,   41,   -1,  278,  279,  280,  281,  282,
   -1,  284,  285,  286,  287,  288,  289,  126,   -1,  292,
  293,   -1,   -1,   -1,  297,   -1,   -1,  300,   -1,   -1,
   -1,   -1,   -1,  306,   -1,   -1,   -1,  310,  311,  312,
  313,  314,  315,  257,  258,  259,   -1,   -1,   -1,  322,
   -1,  265,  266,  267,   -1,   -1,  270,  271,  272,   -1,
   -1,  275,  335,   41,  278,   -1,   -1,  281,   -1,   -1,
  284,  285,  286,  287,  288,  289,   -1,   -1,  292,  293,
   -1,   -1,   -1,  297,   -1,   -1,   -1,  256,  257,  258,
  259,  260,  306,   -1,   -1,   -1,  265,  266,  267,   -1,
  269,  315,   -1,  272,   -1,   -1,   -1,   -1,  322,   -1,
  279,  280,   -1,  282,   -1,  284,  285,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  297,   -1,
   -1,  300,   -1,   -1,   -1,   -1,  305,  306,   -1,   -1,
   -1,  310,  311,  312,  313,  314,  315,  256,  257,  258,
  259,  260,   -1,  322,   -1,   -1,  265,  266,  267,   -1,
  269,   -1,   -1,  272,   -1,  334,   -1,   -1,   -1,   -1,
  279,  280,   -1,  282,   33,  284,  285,   -1,   -1,   38,
   -1,   40,   -1,   42,   43,   -1,   45,   -1,  297,   -1,
   -1,  300,   -1,   -1,   -1,   -1,  305,  306,   -1,   -1,
   -1,  310,  311,  312,  313,  314,  315,   -1,   -1,   -1,
   -1,   -1,   -1,  322,   -1,   -1,   -1,   -1,   -1,  257,
  258,  259,   -1,   -1,   -1,  334,   -1,  265,  266,  267,
   -1,  269,  270,  271,  272,   -1,   -1,  275,   -1,   -1,
  278,  279,  280,  281,  282,   -1,  284,  285,  286,  287,
  288,  289,   -1,   -1,  292,  293,   -1,   -1,   -1,  297,
   -1,   -1,  300,   -1,  123,   38,   -1,  126,  306,   42,
   -1,   -1,  310,  311,  312,  313,  314,  315,   -1,  257,
  258,  259,   -1,   -1,  322,   -1,   -1,  265,  266,  267,
   -1,  269,  270,  271,  272,   -1,  334,  275,   -1,   -1,
  278,  279,  280,  281,  282,   -1,  284,  285,  286,  287,
  288,  289,   -1,   -1,  292,  293,   -1,   -1,   -1,  297,
   -1,   -1,  300,   -1,   -1,   -1,   -1,   -1,  306,   -1,
   -1,   -1,  310,  311,  312,  313,  314,  315,   -1,   -1,
   -1,   -1,   -1,   -1,  322,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   33,  334,   -1,   -1,   -1,
   38,   -1,   40,   -1,   42,   43,   -1,   45,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  256,  257,  258,
  259,  260,   -1,   -1,   -1,   -1,  265,  266,  267,   -1,
  269,  270,  271,  272,  273,   -1,  275,  276,  277,  278,
  279,  280,  281,  282,  283,  284,  285,  286,  287,  288,
  289,  290,  291,  292,  293,  294,  295,  296,  297,  298,
  299,  300,  301,  302,  303,  304,  305,  306,  126,   -1,
   -1,  310,  311,  312,  313,  314,  315,  316,  317,  318,
  319,  320,  321,  322,   33,  324,  325,   -1,   -1,   38,
   -1,   40,   -1,   42,   43,   -1,   45,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  257,  258,  259,  260,   -1,   -1,
   -1,   -1,  265,  266,  267,   -1,   -1,  270,  271,  272,
   -1,   -1,  275,   -1,   -1,  278,   -1,   -1,  281,   -1,
   -1,  284,  285,  286,  287,  288,  289,   -1,   -1,  292,
  293,   -1,   -1,   -1,  297,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  306,   -1,   -1,   33,   -1,   -1,   -1,
   -1,   38,  315,   40,   -1,   42,   43,   -1,   45,  322,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  126,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  256,  257,
  258,  259,  260,   -1,   -1,   -1,   -1,  265,  266,  267,
   -1,  269,  270,  271,  272,   -1,   -1,  275,   -1,   -1,
  278,  279,  280,  281,  282,   -1,  284,  285,  286,  287,
  288,  289,   -1,   -1,  292,  293,   -1,   -1,  296,  297,
   -1,   -1,  300,   -1,  302,  303,  304,  305,  306,  126,
   -1,   -1,  310,  311,  312,  313,  314,  315,  316,  317,
  318,  319,  320,  321,  322,   33,  324,  325,   -1,   -1,
   38,   -1,   40,   -1,   42,   43,   -1,   45,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,  258,
  259,  260,   -1,   -1,   -1,   -1,  265,  266,  267,   -1,
   -1,  270,  271,  272,   -1,   -1,  275,   -1,   -1,  278,
   -1,   -1,  281,   -1,   -1,  284,  285,  286,  287,  288,
  289,   -1,   -1,  292,  293,   -1,   -1,  296,  297,   -1,
   -1,   -1,   -1,  302,  303,  304,  305,  306,  126,   -1,
   38,   -1,   40,   -1,   42,   -1,  315,  316,  317,  318,
  319,  320,  321,  322,   -1,  324,  325,   -1,   -1,   -1,
  257,  258,  259,  260,   -1,   -1,   -1,   -1,  265,  266,
  267,   -1,   -1,  270,  271,  272,   -1,   -1,  275,   -1,
   -1,  278,   -1,   -1,  281,   -1,   -1,  284,  285,  286,
  287,  288,  289,   91,   -1,  292,  293,   -1,   -1,  296,
  297,   -1,   -1,   -1,   -1,  302,  303,  304,  305,  306,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  315,  316,
  317,  318,  319,  320,  321,  322,   -1,  324,  325,   -1,
   33,   -1,   -1,   -1,   -1,   38,   -1,   40,   -1,   42,
   43,   -1,   45,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,
  258,  259,  260,   -1,   -1,   -1,   -1,  265,  266,  267,
   -1,   -1,  270,  271,  272,   -1,   -1,  275,   91,   -1,
  278,   -1,   -1,  281,   -1,   -1,  284,  285,  286,  287,
  288,  289,   -1,   -1,  292,  293,   -1,   -1,  296,  297,
   -1,   -1,   -1,   -1,  302,  303,  304,  305,  306,   -1,
   -1,   -1,   -1,  126,   -1,   -1,   -1,  315,  316,  317,
  318,  319,  320,  321,  322,   33,  324,  325,   -1,   -1,
   38,   -1,   40,   -1,   42,   43,   -1,   45,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,
  258,  259,  260,   -1,   -1,   -1,   -1,  265,  266,  267,
   -1,   -1,  270,  271,  272,   -1,   -1,  275,   -1,   -1,
   -1,   -1,   -1,  281,   -1,   -1,  284,  285,  286,  287,
  288,  289,   -1,   91,  292,  293,   -1,   -1,   -1,  297,
   -1,   -1,   -1,   -1,   33,   -1,   -1,   -1,  306,   38,
   -1,   40,   -1,   42,   43,   -1,   45,  315,   -1,   -1,
   -1,   -1,   -1,   -1,  322,   -1,   -1,   -1,  126,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  257,  258,  259,  260,   -1,   -1,
   -1,   -1,  265,  266,  267,   -1,   -1,  270,  271,  272,
   -1,   -1,  275,   -1,   -1,   -1,   -1,   -1,  281,   -1,
   -1,  284,  285,  286,  287,  288,  289,   -1,   -1,  292,
  293,   -1,   -1,  296,  297,   -1,   -1,  126,   -1,  302,
   -1,  304,  305,  306,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  315,  316,  317,  318,  319,  320,  321,  322,
   33,  324,  325,   -1,   -1,   38,   -1,   40,   -1,   42,
   43,   -1,   45,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,
  258,  259,  260,   -1,   -1,   -1,   -1,  265,  266,  267,
   -1,   -1,  270,  271,  272,   -1,   -1,  275,   -1,   -1,
   -1,   -1,   -1,  281,   -1,   -1,  284,  285,  286,  287,
  288,  289,   -1,   -1,  292,  293,   -1,   -1,  296,  297,
   -1,   -1,   -1,   -1,  302,   -1,  304,  305,  306,   -1,
  123,   -1,  125,  126,   -1,   -1,   -1,  315,  316,  317,
  318,  319,  320,  321,  322,   -1,  324,  325,  257,  258,
  259,  260,   -1,   -1,  263,  264,  265,  266,   -1,   -1,
   -1,  270,  271,  272,   33,   -1,  275,   -1,   -1,   38,
   -1,   40,  281,   42,   43,  284,   45,  286,  287,  288,
  289,   -1,   -1,  292,  293,   -1,   -1,  296,   -1,   -1,
   -1,   -1,   -1,  302,  303,  304,  305,  306,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  315,  316,  317,  318,
  319,  320,  321,  322,   -1,  324,  325,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   33,   -1,   -1,
   -1,   -1,   38,   -1,   40,   -1,   42,   43,   -1,   45,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  126,   -1,   -1,
   -1,   -1,   -1,   -1,  257,  258,  259,  260,   -1,   -1,
   -1,   -1,  265,  266,   -1,   -1,   -1,  270,  271,  272,
   -1,   -1,  275,   -1,   -1,   -1,   -1,   -1,  281,   -1,
   -1,  284,   -1,  286,  287,  288,  289,   -1,   -1,  292,
  293,   -1,   -1,  296,   -1,   -1,   -1,   -1,   -1,  302,
  303,  304,  305,  306,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  315,  316,  317,  318,  319,  320,  321,  322,
  126,  324,  325,   33,   -1,   -1,   -1,   -1,   38,   -1,
   40,   -1,   42,   43,   -1,   45,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,  258,
  259,  260,   -1,   93,   -1,   -1,  265,  266,  267,   -1,
   -1,  270,  271,  272,   -1,   -1,  275,   -1,   -1,   -1,
   -1,   -1,  281,   -1,   -1,  284,  285,  286,  287,  288,
  289,   -1,   -1,  292,  293,   -1,  126,  296,  297,   -1,
   38,   -1,   40,  302,   42,  304,  305,  306,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  315,  316,  317,  318,
  319,  320,  321,  322,   -1,  324,  325,   -1,   -1,   -1,
   -1,  257,  258,  259,  260,   -1,   -1,   -1,   -1,  265,
  266,  267,   -1,   -1,  270,  271,  272,   -1,   -1,  275,
   -1,   -1,   -1,   91,   -1,  281,   -1,   -1,  284,  285,
  286,  287,  288,  289,   -1,   -1,  292,  293,   -1,   -1,
  296,  297,   -1,   -1,   -1,   -1,  302,   -1,  304,  305,
  306,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  315,
  316,  317,  318,  319,  320,  321,  322,   -1,  324,  325,
   -1,   -1,   -1,   33,   -1,   -1,   -1,   -1,   38,   -1,
   40,   -1,   42,   43,   -1,   45,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,  258,  259,
  260,   -1,   -1,   -1,   -1,  265,  266,   -1,   -1,   -1,
  270,  271,  272,   -1,   -1,  275,   -1,   -1,   -1,   -1,
   -1,  281,   -1,   -1,  284,   -1,  286,  287,  288,  289,
   -1,   91,  292,  293,   -1,   -1,  296,   -1,   -1,   -1,
   -1,   -1,  302,  303,  304,  305,  306,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  315,  316,  317,  318,  319,
  320,  321,  322,   33,  324,  325,  126,   -1,   38,   -1,
   40,   -1,   42,   43,   -1,   45,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,
  258,  259,  260,   -1,   -1,   -1,   -1,  265,  266,  267,
   -1,   -1,  270,  271,  272,   -1,   -1,  275,   -1,   -1,
   -1,   -1,   -1,  281,   -1,   -1,  284,  285,  286,  287,
  288,  289,   -1,   -1,  292,  293,   -1,   -1,   -1,  297,
   -1,   -1,   33,   -1,   -1,   -1,   -1,   38,  306,   40,
   41,   42,   43,   -1,   45,   -1,   -1,  315,   -1,   -1,
   -1,   -1,   -1,  123,  322,   -1,  126,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,  258,  259,
  260,   -1,   -1,   -1,   -1,  265,  266,   -1,   -1,   -1,
  270,  271,  272,   -1,   -1,  275,   -1,   -1,   -1,   -1,
   -1,  281,   -1,   -1,  284,  126,  286,  287,  288,  289,
   -1,   -1,  292,  293,   -1,   -1,  296,   -1,   -1,   -1,
   -1,   -1,  302,  303,  304,  305,  306,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  315,  316,  317,  318,  319,
  320,  321,  322,   -1,  324,  325,   -1,   33,   -1,   -1,
   -1,   -1,   38,   -1,   40,   -1,   42,   43,   -1,   45,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,  258,  259,
  260,   -1,   -1,   -1,   -1,  265,  266,   -1,   -1,   -1,
  270,  271,  272,   -1,   -1,  275,   -1,   -1,   -1,   -1,
   -1,  281,   -1,   -1,  284,   -1,  286,  287,  288,  289,
   -1,   -1,  292,  293,   -1,   -1,  296,   93,   -1,   -1,
   -1,   -1,  302,  303,  304,  305,  306,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  315,  316,  317,  318,  319,
  320,  321,  322,   -1,  324,  325,  257,  258,  259,  260,
  126,   -1,   -1,   -1,  265,  266,   -1,   -1,   -1,  270,
  271,  272,   -1,   -1,  275,   -1,   -1,   -1,   -1,   -1,
  281,   -1,   -1,  284,   -1,  286,  287,  288,  289,   -1,
   -1,  292,  293,   -1,   -1,  296,   -1,   -1,   -1,   -1,
   -1,  302,  303,  304,  305,  306,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  315,  316,  317,  318,  319,  320,
  321,  322,   -1,  324,  325,   -1,   33,   -1,   -1,   -1,
   -1,   38,   -1,   40,   41,   42,   43,   -1,   45,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  257,  258,  259,  260,   -1,   -1,   -1,   -1,  265,
  266,   -1,   -1,   -1,  270,  271,  272,   -1,   -1,  275,
   -1,   -1,   -1,   -1,   -1,  281,   -1,   -1,  284,  126,
  286,  287,  288,  289,   -1,   -1,  292,  293,   -1,   -1,
  296,   -1,   -1,   -1,   -1,   -1,  302,  303,  304,  305,
  306,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  315,
  316,  317,  318,  319,  320,  321,  322,   -1,  324,  325,
   -1,   33,   -1,   -1,   -1,   -1,   38,   -1,   40,   41,
   42,   43,   -1,   45,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   33,   -1,   -1,   -1,   -1,   38,   -1,   40,   41,   42,
   43,   -1,   45,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  257,  258,  259,  260,  126,   -1,   -1,   -1,  265,  266,
   -1,   -1,   -1,  270,  271,  272,   -1,   -1,  275,   -1,
   -1,   -1,   -1,   -1,  281,   -1,   -1,  284,   -1,  286,
  287,  288,  289,   -1,   -1,  292,  293,   -1,   -1,  296,
   -1,   -1,   -1,   -1,   -1,  302,  303,  304,  305,  306,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  315,  316,
  317,  318,  319,  320,  321,  322,   -1,  324,  325,   -1,
   33,   -1,   -1,  126,   -1,   38,   -1,   40,   -1,   42,
   43,   -1,   45,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   93,   -1,   -1,   -1,   -1,  257,  258,  259,  260,   -1,
   -1,   -1,   -1,  265,  266,   -1,   -1,   -1,  270,  271,
  272,   -1,   -1,  275,   -1,   -1,   38,   -1,   40,  281,
   42,   -1,  284,  126,  286,  287,  288,  289,   -1,   -1,
  292,  293,   -1,   -1,  296,   -1,   58,   -1,   -1,   -1,
  302,  303,  304,  305,  306,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  315,  316,  317,  318,  319,  320,  321,
  322,   -1,  324,  325,  257,  258,  259,  260,   -1,   -1,
   -1,   -1,  265,  266,   -1,   -1,   -1,  270,  271,  272,
   -1,   -1,  275,   -1,   -1,   -1,   -1,   -1,  281,   -1,
   -1,  284,   -1,  286,  287,  288,  289,   -1,   -1,  292,
  293,   -1,   -1,  296,  126,   -1,   -1,   -1,   -1,  302,
  303,  304,  305,  306,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  315,  316,  317,  318,  319,  320,  321,  322,
   33,  324,  325,   -1,   -1,   38,   -1,   40,   41,   42,
   43,   -1,   45,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  257,  258,  259,  260,   -1,   -1,
   -1,   -1,  265,  266,   -1,   -1,   -1,  270,  271,  272,
   -1,   -1,  275,   -1,   -1,   -1,   -1,   -1,  281,   -1,
   -1,  284,   -1,  286,  287,  288,  289,   -1,   -1,  292,
  293,   -1,   -1,  296,   -1,   -1,   -1,   -1,   -1,  302,
  303,  304,  305,  306,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  315,  316,  317,  318,  319,  320,  321,  322,
   33,  324,  325,  126,   -1,   38,   -1,   40,   41,   42,
   43,   -1,   45,   -1,  256,  257,  258,  259,  260,   -1,
   -1,   -1,   -1,  265,  266,   -1,   -1,   -1,   -1,   -1,
  272,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  284,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  305,  306,   -1,   -1,   -1,   -1,   33,
   -1,   -1,   -1,  315,   38,   -1,   40,   41,   42,   43,
  322,   45,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  126,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  257,  258,  259,  260,   -1,   -1,
   -1,   -1,  265,  266,   -1,   -1,   -1,  270,  271,  272,
   -1,   -1,  275,   -1,   -1,   -1,   -1,   -1,  281,   -1,
   -1,  284,  126,  286,  287,  288,  289,   -1,   -1,  292,
  293,   -1,   -1,  296,   -1,   -1,   -1,   -1,   -1,  302,
  303,  304,  305,  306,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  315,  316,  317,  318,  319,  320,  321,  322,
   -1,  324,  325,   -1,   33,   -1,   -1,   -1,   -1,   38,
   -1,   40,   41,   42,   43,   -1,   45,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  257,  258,  259,  260,   -1,   -1,
   -1,   -1,  265,  266,   -1,   -1,   -1,  270,  271,  272,
   -1,   -1,  275,   -1,   -1,   -1,   -1,   -1,  281,   -1,
   -1,  284,   -1,  286,  287,  288,  289,   -1,   -1,  292,
  293,   -1,   -1,  296,   -1,   -1,   -1,   -1,   -1,  302,
  303,  304,  305,  306,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  315,  316,  317,  318,  319,  320,  321,  322,
   -1,  324,  325,  257,  258,  259,  260,  126,   -1,   -1,
   -1,  265,  266,   -1,   -1,   -1,  270,  271,  272,   33,
   -1,  275,   -1,   -1,   38,   -1,   40,  281,   42,   43,
  284,   45,  286,  287,  288,  289,   -1,   -1,  292,  293,
   -1,   -1,  296,   -1,   -1,   -1,   -1,   -1,  302,  303,
  304,  305,  306,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  315,  316,  317,  318,  319,  320,  321,  322,   -1,
  324,  325,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   33,
   -1,   -1,   -1,   -1,   38,   -1,   40,   -1,   42,   43,
   -1,   45,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  126,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,  258,
  259,  260,   -1,   -1,   -1,   -1,  265,  266,   -1,   -1,
   -1,  270,  271,  272,   -1,   -1,  275,   -1,   -1,   -1,
   -1,   -1,  281,   -1,   -1,  284,   -1,  286,  287,  288,
  289,   -1,   -1,  292,  293,   -1,   -1,  296,   -1,   -1,
   -1,   -1,  126,  302,  303,  304,  305,  306,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  315,  316,  317,  318,
  319,  320,  321,  322,   33,  324,  325,   -1,   -1,   38,
   -1,   40,   41,   42,   43,   -1,   45,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  256,  257,  258,  259,  260,   -1,   -1,   -1,
   -1,  265,  266,   -1,   -1,   -1,  270,  271,  272,   -1,
   -1,  275,   -1,   -1,   -1,   -1,   -1,  281,   -1,   -1,
  284,   -1,  286,  287,  288,  289,   -1,   -1,  292,  293,
   -1,   -1,  296,   -1,   -1,   -1,   -1,   -1,  302,  303,
  304,  305,  306,   -1,   38,   -1,   40,  126,   42,   -1,
   -1,  315,  316,  317,  318,  319,  320,  321,  322,   -1,
  324,  325,  256,  257,  258,  259,  260,   -1,   -1,   -1,
   -1,  265,  266,   -1,   -1,   -1,  270,  271,  272,   -1,
   38,  275,   40,   41,   42,   -1,   -1,  281,   -1,   -1,
  284,   -1,  286,  287,  288,  289,   -1,   91,  292,  293,
   -1,   -1,  296,   -1,   -1,   -1,   -1,   -1,  302,  303,
  304,  305,  306,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  315,  316,  317,  318,  319,  320,  321,  322,   33,
  324,  325,  126,   91,   38,   -1,   40,   41,   42,   43,
   -1,   45,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  126,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,  258,
  259,  260,   -1,   -1,   -1,   -1,  265,  266,   -1,   -1,
   -1,  270,  271,  272,   -1,   -1,  275,   -1,   -1,   -1,
   -1,   -1,  281,   -1,   -1,  284,   -1,  286,  287,  288,
  289,   -1,   -1,  292,  293,   -1,   -1,  296,   -1,   -1,
   -1,   -1,  126,  302,  303,  304,  305,  306,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  315,  316,  317,  318,
  319,  320,  321,  322,   33,  324,  325,   -1,   -1,   38,
   -1,   40,   -1,   42,   43,   -1,   45,   -1,   -1,   -1,
   -1,   -1,   -1,  257,  258,  259,  260,   -1,   -1,   -1,
   -1,  265,  266,   -1,   -1,   -1,   -1,   -1,  272,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  284,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,
  258,  259,  260,   -1,   -1,   -1,   -1,  265,  266,   -1,
   -1,  305,  306,   33,  272,   -1,   -1,   -1,   38,   -1,
   40,  315,   42,   43,   -1,   45,  284,   -1,  322,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  126,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  305,  306,   -1,
   -1,   -1,   -1,  257,  258,  259,  260,  315,   -1,   -1,
   -1,  265,  266,   -1,  322,   -1,  270,  271,  272,   -1,
   -1,  275,   -1,   -1,   -1,   -1,   -1,  281,   -1,   -1,
  284,   -1,  286,  287,  288,  289,   -1,   -1,  292,  293,
   -1,   -1,  296,   -1,   -1,   -1,   -1,   -1,  302,  303,
  304,  305,  306,   38,   -1,   40,  126,   42,   -1,   -1,
   -1,  315,  316,  317,  318,  319,  320,  321,  322,   33,
  324,  325,   -1,   -1,   38,   -1,   40,   -1,   42,   43,
   -1,   45,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   91,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  256,  257,  258,
  259,  260,   -1,   -1,   -1,   -1,  265,  266,   -1,   -1,
   -1,  270,  271,  272,   -1,   -1,  275,   -1,   -1,   -1,
   -1,   -1,  281,   -1,   -1,  284,   -1,  286,  287,  288,
  289,   -1,   -1,  292,  293,   -1,   -1,  296,   -1,   -1,
   -1,   -1,  126,  302,  303,  304,  305,  306,   -1,   -1,
   -1,   38,   -1,   40,   41,   42,  315,  316,  317,  318,
  319,  320,  321,  322,   -1,  324,  325,  257,  258,  259,
  260,   -1,   -1,   -1,   -1,  265,  266,   -1,   -1,   -1,
  270,  271,  272,   -1,   -1,  275,   -1,   -1,   -1,   -1,
   -1,  281,   -1,   -1,  284,   -1,  286,  287,  288,  289,
   -1,   -1,  292,  293,   91,   -1,  296,   -1,   -1,   -1,
   -1,   -1,  302,  303,  304,  305,  306,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  315,  316,  317,  318,  319,
  320,  321,  322,   33,  324,  325,   -1,   -1,   38,   -1,
   40,   -1,   42,   43,   -1,   45,   -1,   -1,   -1,   -1,
   -1,   -1,  257,  258,  259,  260,   -1,   -1,   -1,   -1,
  265,  266,   -1,   -1,   -1,   -1,   -1,  272,   -1,   -1,
   -1,   -1,   -1,  257,  258,  259,  260,   -1,   -1,  284,
   -1,  265,  266,   -1,   -1,   -1,  270,  271,  272,   -1,
   -1,  275,   -1,   -1,   -1,   -1,   -1,  281,   -1,   -1,
  284,  306,  286,  287,  288,  289,   -1,   -1,  292,  293,
  315,   -1,  296,   -1,   -1,   -1,   -1,  322,  302,  303,
  304,  305,  306,   -1,   -1,   -1,  126,   -1,   -1,   -1,
   -1,  315,  316,  317,  318,  319,  320,  321,  322,   33,
  324,  325,   -1,   -1,   38,   -1,   40,   -1,   42,   43,
   -1,   45,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  257,  258,  259,  260,   -1,   -1,   -1,   -1,  265,  266,
   -1,   -1,   -1,   -1,   -1,  272,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  284,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   33,   -1,
   -1,   -1,   -1,   38,   -1,   40,   -1,   42,   43,  306,
   45,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  315,   -1,
   -1,   -1,  126,   -1,   -1,  322,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,  258,  259,
  260,   -1,   -1,   -1,   -1,  265,  266,   -1,   -1,   -1,
  270,  271,  272,   -1,   -1,  275,   -1,   -1,   -1,   -1,
   -1,  281,   -1,   -1,  284,   -1,  286,  287,  288,  289,
   -1,   -1,  292,  293,   -1,   -1,  296,   -1,   -1,   -1,
   -1,  126,  302,   -1,  304,  305,  306,   38,   -1,   40,
   41,   42,   -1,   -1,   -1,  315,  316,  317,  318,  319,
  320,  321,  322,   33,  324,  325,   -1,   -1,   38,   -1,
   40,   -1,   42,   43,   -1,   45,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   91,   -1,   -1,  257,  258,  259,  260,   -1,   -1,   -1,
   -1,  265,  266,   -1,   -1,   -1,  270,  271,  272,   -1,
   -1,  275,   -1,   -1,   -1,   -1,   -1,  281,   -1,   -1,
  284,   -1,  286,  287,  288,  289,   -1,   -1,  292,  293,
   -1,   -1,  296,   -1,   44,   -1,   -1,   -1,  302,   -1,
  304,  305,  306,   -1,   -1,   -1,  126,   -1,   -1,   59,
   -1,  315,  316,  317,  318,  319,  320,  321,  322,   -1,
  324,  325,  257,  258,  259,  260,   -1,   -1,   -1,   -1,
  265,  266,   -1,   -1,   -1,  270,  271,  272,   -1,   -1,
  275,   -1,   -1,   -1,   -1,   -1,  281,   -1,   -1,  284,
   -1,  286,  287,  288,  289,   -1,   -1,  292,  293,   -1,
   38,  296,   40,   -1,   42,   -1,   -1,  302,   -1,  304,
  305,  306,   -1,  123,   -1,   -1,   -1,   -1,   -1,   -1,
  315,  316,  317,  318,  319,  320,  321,  322,   -1,  324,
  325,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  257,  258,  259,  260,
   -1,   -1,   -1,   -1,  265,  266,   38,   -1,   40,   -1,
   42,  272,   -1,   -1,   -1,   -1,   -1,  257,  258,  259,
  260,   -1,   -1,  284,   -1,  265,  266,  125,  126,   -1,
  270,  271,  272,   -1,   -1,  275,   -1,   -1,   -1,   -1,
   -1,  281,   -1,   -1,  284,  306,  286,  287,  288,  289,
   -1,   -1,  292,  293,  315,   -1,  296,   -1,   -1,   -1,
   -1,  322,  302,   -1,  304,  305,  306,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  315,  316,  317,  318,  319,
  320,  321,  322,   -1,  324,  325,  256,  257,  258,  259,
   -1,   -1,   -1,   -1,  126,  265,  266,  267,   -1,  269,
  270,  271,  272,   -1,   -1,  275,   -1,   -1,  278,  279,
  280,  281,  282,   -1,  284,  285,  286,  287,  288,  289,
   -1,   -1,  292,  293,   -1,   -1,   -1,  297,   -1,   -1,
  300,   -1,   -1,   38,   -1,   40,  306,   42,   -1,   -1,
  310,  311,  312,  313,  314,  315,   -1,   -1,   -1,   -1,
   -1,   -1,  322,   -1,   -1,   -1,   -1,   -1,   -1,  257,
  258,  259,  260,  261,   -1,  335,   -1,  265,  266,  267,
   -1,  269,  270,  271,  272,   -1,   -1,  275,   -1,   -1,
  278,  279,  280,  281,  282,   -1,  284,  285,  286,  287,
  288,  289,   -1,   -1,  292,  293,   -1,   -1,   -1,  297,
   -1,   38,  300,   40,   -1,   42,   -1,  305,  306,  307,
  308,  309,  310,  311,  312,  313,  314,  315,  123,   -1,
   -1,  126,   -1,   -1,  322,  257,  258,  259,  260,  261,
   -1,   -1,   -1,  265,  266,  267,   -1,  269,  270,  271,
  272,   -1,   -1,  275,   -1,   -1,  278,  279,  280,  281,
  282,   -1,  284,  285,  286,  287,  288,  289,   -1,   -1,
  292,  293,   -1,   -1,   -1,  297,   -1,   -1,  300,   -1,
   -1,   -1,   -1,  305,  306,  307,  308,  309,  310,  311,
  312,  313,  314,  315,   38,   -1,   40,   41,   42,  126,
  322,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   91,   -1,   -1,
   -1,   -1,   -1,   38,   -1,   40,   -1,   42,   -1,   -1,
   -1,  256,  257,  258,  259,  260,   -1,   -1,   -1,   -1,
  265,  266,  267,   -1,  269,  270,  271,  272,   -1,   -1,
  275,   -1,  126,  278,  279,  280,  281,  282,   -1,  284,
  285,  286,  287,  288,  289,   -1,   -1,  292,  293,   -1,
   -1,   -1,  297,   -1,   -1,  300,   91,   -1,   -1,   -1,
  305,  306,   -1,   -1,   -1,  310,  311,  312,  313,  314,
  315,   38,   -1,   40,   -1,   42,   -1,  322,   -1,  256,
  257,  258,  259,  260,   -1,   -1,   -1,   -1,  265,  266,
  267,  126,  269,  270,  271,  272,   -1,   -1,  275,   -1,
   -1,  278,  279,  280,  281,  282,   -1,  284,  285,  286,
  287,  288,  289,   -1,   -1,  292,  293,   -1,   -1,   -1,
  297,   -1,   -1,  300,   91,   -1,   -1,   -1,  305,  306,
   -1,   -1,   -1,  310,  311,  312,  313,  314,  315,   -1,
   -1,   -1,   -1,   -1,   -1,  322,   -1,   -1,   -1,   -1,
   38,   -1,   40,   -1,   42,   -1,   -1,   -1,   -1,  126,
   -1,   -1,   -1,  257,  258,  259,  260,   -1,   -1,   -1,
   58,  265,  266,  267,   -1,  269,  270,  271,  272,   -1,
   -1,  275,   -1,   -1,  278,  279,  280,  281,  282,   -1,
  284,  285,  286,  287,  288,  289,   -1,   -1,  292,  293,
   -1,   -1,   -1,  297,   -1,   -1,  300,   -1,   -1,   -1,
   -1,  305,  306,   -1,   -1,   -1,  310,  311,  312,  313,
  314,  315,  257,  258,  259,  260,   -1,   -1,  322,   -1,
  265,  266,  267,   -1,  269,  270,  271,  272,  126,   -1,
  275,   -1,   -1,  278,  279,  280,  281,  282,   -1,  284,
  285,  286,  287,  288,  289,   -1,   -1,  292,  293,   -1,
   -1,   -1,  297,   -1,   38,  300,   40,   -1,   42,   -1,
  305,  306,   -1,   -1,   -1,  310,  311,  312,  313,  314,
  315,   -1,   -1,   -1,   58,   -1,   -1,  322,   -1,   -1,
  257,  258,  259,  260,   -1,   -1,   -1,   -1,  265,  266,
  267,   -1,  269,  270,  271,  272,   -1,   -1,  275,   -1,
   -1,  278,  279,  280,  281,  282,   -1,  284,  285,  286,
  287,  288,  289,   -1,   -1,  292,  293,   -1,   -1,   -1,
  297,   -1,   -1,  300,   -1,   -1,   -1,   -1,  305,  306,
   -1,   -1,   -1,  310,  311,  312,  313,  314,  315,   -1,
   -1,   -1,  126,   -1,   38,  322,   40,   -1,   42,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  256,  257,
  258,  259,  260,   -1,   58,   -1,   -1,  265,  266,  267,
   -1,  269,  270,  271,  272,   -1,   -1,  275,   -1,   -1,
   -1,  279,  280,  281,  282,   -1,  284,  285,  286,  287,
  288,  289,   -1,   -1,  292,  293,   -1,   -1,   -1,  297,
   -1,   -1,  300,   -1,   -1,   -1,   -1,  305,  306,   -1,
   -1,   -1,  310,  311,  312,  313,  314,  315,   38,   -1,
   40,   41,   42,   -1,  322,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  126,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   91,   -1,  257,  258,  259,  260,   -1,   -1,   -1,
   -1,  265,  266,  267,   -1,  269,  270,  271,  272,   -1,
   -1,  275,   -1,   -1,  278,  279,  280,  281,  282,   -1,
  284,  285,  286,  287,  288,  289,  126,   -1,  292,  293,
   -1,   -1,   -1,  297,   -1,   -1,  300,   -1,   -1,   -1,
   -1,  305,  306,   -1,   -1,   -1,  310,  311,  312,  313,
  314,  315,   -1,   -1,   -1,   38,   -1,   40,  322,   42,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  257,  258,  259,  260,   -1,   -1,   -1,
   -1,  265,  266,  267,   -1,  269,  270,  271,  272,   -1,
   -1,  275,   -1,   -1,  278,  279,  280,  281,  282,   -1,
  284,  285,  286,  287,  288,  289,   -1,   -1,  292,  293,
   -1,   -1,   -1,  297,   -1,   -1,  300,   -1,   -1,   -1,
   -1,  305,  306,   -1,   -1,   -1,  310,  311,  312,  313,
  314,  315,   38,  126,   40,   -1,   42,   -1,  322,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,  258,  259,
  260,   -1,   -1,   -1,   -1,  265,  266,  267,   -1,  269,
  270,  271,  272,   -1,   -1,  275,   -1,   -1,   -1,  279,
  280,  281,  282,   -1,  284,  285,  286,  287,  288,  289,
   -1,   -1,  292,  293,   -1,   -1,   -1,  297,   -1,   -1,
  300,   -1,   -1,   -1,   -1,  305,  306,   -1,   -1,   -1,
  310,  311,  312,  313,  314,  315,   -1,   -1,   -1,   38,
   -1,   40,  322,   42,   -1,   -1,   -1,   -1,   -1,   -1,
  126,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  256,  257,  258,  259,  260,   -1,   -1,
   -1,   -1,  265,  266,  267,   -1,  269,  270,  271,  272,
   -1,   -1,  275,   -1,   -1,   -1,  279,  280,  281,  282,
   -1,  284,  285,  286,  287,  288,  289,  126,   -1,  292,
  293,   -1,   -1,   -1,  297,   -1,   -1,  300,   -1,   -1,
   -1,   -1,  305,  306,   -1,   -1,   -1,  310,  311,  312,
  313,  314,  315,   -1,   38,   -1,   40,   -1,   42,  322,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  257,  258,  259,  260,   -1,   -1,   -1,   -1,  265,
  266,  267,   -1,  269,  270,  271,  272,   -1,   -1,  275,
   -1,   -1,  278,  279,  280,  281,  282,   91,  284,  285,
  286,  287,  288,  289,   -1,   -1,  292,  293,   -1,   -1,
   -1,  297,   -1,   -1,  300,   -1,   -1,   -1,   -1,  305,
  306,   -1,   -1,   -1,  310,  311,  312,  313,  314,  315,
   -1,   -1,  126,   38,   -1,   40,  322,   42,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,  258,
  259,  260,   -1,   -1,   -1,   -1,  265,  266,  267,   -1,
  269,  270,  271,  272,   -1,   -1,  275,   -1,   -1,  278,
  279,  280,  281,  282,   -1,  284,  285,  286,  287,  288,
  289,   -1,   -1,  292,  293,   -1,   91,   -1,  297,   -1,
   -1,  300,   -1,   -1,   -1,   -1,  305,  306,   -1,   -1,
   -1,  310,  311,  312,  313,  314,  315,   -1,   38,   -1,
   40,   -1,   42,  322,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  126,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  257,  258,  259,  260,   -1,   -1,   -1,
   -1,  265,  266,  267,   -1,  269,  270,  271,  272,   -1,
   38,  275,   40,   -1,   42,  279,  280,  281,  282,   -1,
  284,  285,  286,  287,  288,  289,  126,   -1,  292,  293,
   -1,   -1,   -1,  297,   -1,   -1,  300,   -1,   -1,   -1,
   -1,  305,  306,   -1,   -1,   -1,  310,  311,  312,  313,
  314,  315,   -1,   -1,   -1,   -1,   -1,   -1,  322,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   38,   -1,   40,   -1,
   42,   -1,  257,  258,  259,  260,   -1,   -1,   -1,   -1,
  265,  266,  267,   -1,  269,  270,  271,  272,  126,   -1,
  275,   -1,   -1,   -1,  279,  280,  281,  282,   -1,  284,
  285,  286,  287,  288,  289,   -1,   -1,  292,  293,   -1,
   -1,   -1,  297,   -1,   -1,  300,   -1,   -1,   -1,   -1,
  305,  306,   -1,   -1,   -1,  310,  311,  312,  313,  314,
  315,   -1,   -1,   -1,   -1,   -1,   38,  322,   40,   -1,
   42,   -1,   -1,   -1,   -1,   -1,   -1,  257,  258,  259,
  260,   -1,   -1,   -1,  126,  265,  266,  267,   -1,  269,
  270,  271,  272,   -1,   -1,  275,   -1,   -1,  278,  279,
  280,  281,  282,   -1,  284,  285,  286,  287,  288,  289,
   -1,   -1,  292,  293,   -1,   -1,   -1,  297,   -1,   -1,
  300,   -1,   -1,   -1,   -1,  305,  306,   -1,   -1,   -1,
  310,  311,  312,  313,  314,  315,   -1,   -1,   -1,   -1,
   -1,   -1,  322,   38,   -1,   40,   41,   42,   -1,  257,
  258,  259,  260,   -1,  126,   -1,   -1,  265,  266,  267,
   -1,  269,  270,  271,  272,   -1,   -1,  275,   -1,   -1,
  278,  279,  280,  281,  282,   -1,  284,  285,  286,  287,
  288,  289,   -1,   -1,  292,  293,   -1,   -1,   -1,  297,
   -1,   -1,  300,   -1,   -1,   -1,   91,  305,  306,   -1,
   -1,   -1,  310,  311,  312,  313,  314,  315,   -1,   -1,
   -1,   -1,   -1,   -1,  322,  257,  258,  259,  260,   -1,
   -1,   -1,   -1,  265,  266,  267,   -1,  269,  270,  271,
  272,  126,   -1,  275,   -1,   -1,   -1,  279,  280,  281,
  282,   -1,  284,  285,  286,  287,  288,  289,   -1,   -1,
  292,  293,   -1,   -1,   -1,  297,   -1,   -1,  300,   -1,
   -1,   -1,   -1,  305,  306,   -1,   -1,   -1,  310,  311,
  312,  313,  314,  315,   -1,   -1,   -1,   -1,   -1,   38,
  322,   40,   41,   42,   -1,  257,  258,  259,  260,   -1,
   -1,   -1,   -1,  265,  266,  267,   -1,  269,  270,  271,
  272,   -1,   -1,  275,   -1,   -1,   -1,  279,  280,  281,
  282,   -1,  284,  285,  286,  287,  288,  289,   -1,   -1,
  292,  293,   -1,   -1,   -1,  297,   -1,   -1,  300,   -1,
   -1,   -1,   91,  305,  306,   -1,   -1,   -1,  310,  311,
  312,  313,  314,  315,   -1,   38,   -1,   40,   41,   42,
  322,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  257,  258,  259,  260,   -1,  126,   -1,   -1,
  265,  266,  267,   -1,  269,   -1,   -1,  272,   -1,   -1,
   -1,   -1,   -1,   -1,  279,  280,   -1,  282,   -1,  284,
  285,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   91,   -1,
   -1,   -1,  297,   -1,   38,  300,   40,   -1,   42,   -1,
  305,  306,   -1,   -1,   -1,  310,  311,  312,  313,  314,
  315,   -1,   -1,   -1,   -1,   -1,   -1,  322,   -1,   -1,
   -1,   -1,   -1,  126,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   91,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   38,   -1,   40,   -1,   42,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  126,   -1,   -1,   -1,   -1,   -1,  257,  258,
  259,  260,   -1,   -1,   -1,   -1,  265,  266,  267,   -1,
  269,   -1,   -1,  272,   -1,   -1,   -1,   -1,   -1,   -1,
  279,  280,   -1,  282,   91,  284,  285,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  297,   -1,
   38,  300,   40,   -1,   42,   -1,  305,  306,   -1,   -1,
   -1,  310,  311,  312,  313,  314,  315,   -1,   -1,  126,
   -1,   -1,   -1,  322,  257,  258,  259,  260,   -1,   -1,
   -1,   -1,  265,  266,  267,   -1,  269,   -1,   -1,  272,
   -1,   -1,   -1,   -1,   -1,   -1,  279,  280,   -1,  282,
   -1,  284,  285,   91,   -1,   -1,   -1,   -1,   -1,   38,
   -1,   40,   -1,   42,  297,   -1,   -1,  300,   -1,   -1,
   -1,   -1,  305,  306,   -1,   -1,   -1,  310,  311,  312,
  313,  314,  315,  257,  258,  259,  260,   -1,  126,  322,
   -1,  265,  266,  267,   -1,  269,   -1,   -1,  272,   -1,
   -1,   -1,   -1,   -1,   -1,  279,  280,   -1,  282,   -1,
  284,  285,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  297,   -1,   38,  300,   40,   -1,   42,
   -1,  305,  306,   -1,   -1,   -1,  310,  311,  312,  313,
  314,  315,   -1,   -1,   -1,   -1,   -1,  126,  322,   -1,
  257,  258,  259,  260,   -1,   -1,   -1,   -1,  265,  266,
  267,   -1,  269,   -1,   -1,  272,   -1,   -1,   -1,   -1,
   -1,   -1,  279,  280,   -1,  282,   -1,  284,  285,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  297,   -1,   -1,  300,   -1,   -1,   -1,   -1,  305,  306,
   -1,   -1,   -1,  310,  311,  312,  313,  314,  315,   -1,
   38,   -1,   40,  126,   42,  322,   -1,   -1,   -1,  257,
  258,  259,  260,   -1,   -1,   -1,   -1,  265,  266,  267,
   -1,  269,   -1,   -1,  272,   -1,   -1,   -1,   -1,   -1,
   -1,  279,  280,   -1,  282,   -1,  284,  285,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  297,
   -1,   -1,  300,   -1,   -1,   -1,   -1,  305,  306,   -1,
   -1,   -1,  310,  311,  312,  313,  314,  315,  257,  258,
  259,  260,   -1,   -1,  322,   -1,  265,  266,  267,   -1,
  269,   -1,   38,  272,   40,   -1,   42,   -1,  126,   -1,
  279,  280,   -1,  282,   -1,  284,  285,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  297,   -1,
   -1,  300,   -1,   -1,   -1,   -1,  305,  306,   -1,   -1,
   -1,  310,  311,  312,  313,  314,  315,   -1,   -1,   -1,
   -1,   -1,   -1,  322,  257,  258,  259,  260,   -1,   -1,
   -1,   -1,  265,  266,  267,   -1,  269,   -1,   -1,  272,
   -1,   38,   -1,   40,   -1,   42,  279,  280,   -1,  282,
   -1,  284,  285,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  126,   58,   -1,   -1,  297,   -1,   -1,  300,   -1,   -1,
   -1,   -1,  305,  306,   -1,   -1,   -1,  310,  311,  312,
  313,  314,  315,   -1,   -1,   -1,   -1,   -1,   -1,  322,
   -1,   -1,   38,   -1,   40,   -1,   42,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,
  258,  259,  260,   -1,   -1,   -1,   -1,  265,  266,  267,
   -1,  269,   -1,   -1,  272,   -1,   -1,   -1,   -1,  126,
   -1,  279,  280,   -1,  282,   -1,  284,  285,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   91,   -1,   -1,   -1,  297,
   -1,   -1,  300,   -1,   -1,   -1,   -1,  305,  306,   -1,
   -1,   -1,  310,  311,  312,  313,  314,  315,   -1,   38,
   -1,   40,   -1,   42,  322,   -1,   -1,   -1,   -1,   -1,
  126,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   58,
   -1,  257,  258,  259,  260,   -1,   -1,   -1,   -1,  265,
  266,  267,   -1,  269,   -1,   38,  272,   40,   -1,   42,
   -1,   -1,   -1,  279,  280,   -1,  282,   -1,  284,  285,
   -1,   -1,   -1,   -1,   -1,   58,   -1,   -1,   -1,   -1,
   -1,  297,   -1,   -1,  300,   -1,   -1,   -1,   -1,  305,
  306,   -1,   -1,   -1,  310,  311,  312,  313,  314,  315,
   -1,   -1,   -1,   -1,   -1,   -1,  322,  126,   -1,  256,
  257,  258,  259,  260,   -1,   -1,   -1,   -1,  265,  266,
   -1,   -1,   -1,   -1,   38,  272,   40,   -1,   42,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  284,   -1,   -1,
   -1,   -1,   -1,  126,   58,   -1,   -1,   38,   -1,   40,
   -1,   42,   -1,   -1,   -1,   -1,   -1,   -1,  305,  306,
   -1,  257,  258,  259,  260,   -1,   -1,   58,  315,  265,
  266,   -1,   -1,   -1,   -1,  322,  272,   -1,   -1,   -1,
   -1,   -1,   -1,   38,   -1,   40,   -1,   42,  284,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  305,
  306,   -1,  126,   -1,   -1,   -1,   -1,   -1,   38,  315,
   40,   -1,   42,   -1,   -1,   -1,  322,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  126,   -1,   -1,  257,  258,
  259,  260,   -1,   -1,   -1,   -1,  265,  266,   -1,   -1,
   38,   -1,   40,  272,   42,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  284,   -1,   -1,   -1,   -1,
   -1,  126,   -1,   -1,  257,  258,  259,  260,   -1,   -1,
   -1,   -1,  265,  266,   -1,   -1,  305,  306,   -1,  272,
   -1,   -1,   -1,   -1,   -1,   -1,  315,   -1,   -1,   -1,
   -1,  284,   -1,  322,   -1,   -1,  126,   -1,   -1,   38,
   -1,   40,   -1,   42,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  305,  306,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  315,   -1,   -1,   -1,   -1,   -1,  126,  322,
   -1,   -1,   -1,  257,  258,  259,  260,   -1,   -1,   -1,
   -1,  265,  266,   38,   -1,   40,   -1,   42,  272,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  257,  258,  259,  260,
  284,   -1,   -1,   -1,  265,  266,   -1,   -1,   -1,   -1,
   -1,  272,   -1,   -1,   -1,   38,   -1,   40,   -1,   42,
   -1,  305,  306,  284,   -1,   -1,   -1,  126,   -1,   -1,
   -1,  315,  257,  258,  259,  260,   -1,   -1,  322,   -1,
  265,  266,   -1,   -1,  305,  306,   -1,  272,   -1,   -1,
   -1,   38,   -1,   40,  315,   42,   -1,   -1,   -1,  284,
   -1,  322,   -1,   -1,   -1,   -1,   -1,  257,  258,  259,
  260,  126,   -1,   -1,   -1,  265,  266,   -1,   -1,   -1,
  305,  306,  272,   38,   -1,   40,   -1,   42,   -1,   -1,
  315,   -1,   -1,   -1,  284,   -1,   -1,  322,   -1,  257,
  258,  259,  260,  126,   -1,   -1,   -1,  265,  266,   -1,
   -1,   -1,   -1,   -1,  272,  305,  306,   -1,   -1,   -1,
   38,   -1,   40,   -1,   42,  315,  284,   -1,   -1,   -1,
   -1,   -1,  322,   -1,   -1,   -1,   -1,   -1,   -1,  126,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  305,  306,   -1,
   38,   -1,   40,   -1,   42,   -1,   -1,  315,  257,  258,
  259,  260,   -1,   -1,  322,   -1,  265,  266,   -1,   -1,
   -1,  126,   -1,  272,   -1,   -1,   -1,   -1,   -1,   -1,
   38,   -1,   40,   -1,   42,  284,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  257,  258,  259,  260,  305,  306,  126,   -1,
  265,  266,   -1,   -1,   -1,   -1,  315,  272,   -1,   -1,
   -1,   -1,   -1,  322,   38,   -1,   40,   -1,   42,  284,
   -1,   -1,   -1,   -1,  257,  258,  259,  260,  126,   -1,
   -1,   -1,  265,  266,   -1,   -1,   -1,   -1,   -1,  272,
  305,  306,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  315,  284,   -1,   -1,   -1,   -1,   -1,  322,  126,   -1,
  257,  258,  259,  260,   -1,   -1,   -1,   -1,  265,  266,
   -1,   -1,  305,  306,   -1,  272,   -1,   -1,   -1,   -1,
   -1,   38,  315,   40,   -1,   42,   -1,  284,   -1,  322,
   -1,   -1,  257,  258,  259,  260,   -1,   -1,   -1,   -1,
  265,  266,  126,   -1,   -1,   -1,   -1,  272,  305,  306,
   -1,   38,   -1,   40,   -1,   42,   -1,   -1,  315,  284,
   -1,   -1,   -1,   -1,   -1,  322,   -1,   -1,   -1,  257,
  258,  259,  260,   -1,   -1,   -1,   -1,  265,  266,   -1,
  305,  306,   -1,   -1,  272,   -1,   -1,   -1,   -1,   -1,
  315,   -1,   -1,   -1,   -1,   -1,  284,  322,   -1,  257,
  258,  259,  260,   -1,   -1,   -1,   -1,  265,  266,  126,
   -1,   38,   -1,   40,  272,   42,   -1,  305,  306,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  284,  315,   -1,  257,
  258,  259,  260,   -1,  322,   -1,   -1,  265,  266,  126,
   -1,   38,   -1,   40,  272,   42,   -1,  305,  306,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  284,  315,   -1,   -1,
   -1,   -1,   -1,   -1,  322,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  257,  258,  259,  260,  305,  306,   -1,
   -1,  265,  266,   -1,   -1,   -1,   -1,  315,  272,   -1,
   -1,   -1,   -1,   38,  322,   40,   -1,   42,   -1,  126,
  284,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   38,   -1,   40,   -1,   42,   -1,   -1,
   -1,  305,  306,   -1,   -1,   -1,   -1,   -1,   -1,  126,
   -1,  315,   -1,   -1,   -1,   -1,   -1,   -1,  322,   -1,
  257,  258,  259,  260,   -1,   -1,   -1,   -1,  265,  266,
   -1,   -1,   -1,   -1,   -1,  272,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   38,   -1,   40,  284,   42,   -1,
  257,  258,  259,  260,   -1,   -1,   -1,   -1,  265,  266,
   -1,  126,   -1,   -1,   -1,  272,   -1,   -1,  305,  306,
   -1,   -1,   38,   -1,   40,   -1,   42,  284,  315,   -1,
   -1,  126,   -1,   -1,   -1,  322,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  305,  306,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  315,   -1,
  257,  258,  259,  260,   -1,  322,   -1,   -1,  265,  266,
   -1,   -1,   -1,   -1,   -1,  272,   -1,   -1,   -1,   -1,
   -1,   -1,  126,   -1,   -1,   -1,   -1,  284,   -1,   -1,
  257,  258,  259,  260,   -1,   -1,   -1,   -1,  265,  266,
   38,   -1,   40,   -1,   42,  272,   -1,   -1,  305,  306,
  126,   38,   -1,   40,   -1,   42,   -1,  284,  315,   -1,
   -1,   -1,   -1,   -1,   -1,  322,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  305,  306,
   -1,   -1,  257,  258,  259,  260,   -1,   -1,  315,   -1,
  265,  266,   -1,   -1,   -1,  322,   -1,  272,   -1,   -1,
   -1,   -1,  257,  258,  259,  260,   -1,   -1,   -1,  284,
  265,  266,   38,   -1,   40,   -1,   42,  272,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  126,  284,
  305,  306,   38,   -1,   40,   -1,   42,   -1,   -1,  126,
  315,   -1,   -1,   -1,   -1,   -1,   -1,  322,   -1,   -1,
  305,  306,   -1,  257,  258,  259,  260,   -1,   -1,   -1,
  315,  265,  266,   -1,   -1,   -1,   -1,  322,  272,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  284,  257,  258,  259,  260,   -1,   -1,   -1,   -1,  265,
  266,   -1,   -1,   38,   -1,   40,  272,   42,   -1,   -1,
  126,  305,  306,   -1,   -1,   -1,   -1,   -1,  284,   -1,
   -1,  315,   -1,   38,   -1,   40,   -1,   42,  322,   -1,
  126,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  305,
  306,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  315,
   -1,   -1,   -1,   -1,   -1,   -1,  322,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,
  258,  259,  260,   -1,   -1,   -1,   -1,  265,  266,   -1,
  257,  258,  259,  260,  272,   -1,   -1,   -1,  265,  266,
   38,  126,   40,   -1,   42,  272,  284,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  284,   -1,   -1,
   38,  126,   40,   -1,   42,   -1,   -1,  305,  306,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  315,  305,  306,
   -1,   -1,   -1,   -1,  322,   -1,   -1,   -1,  315,   -1,
   -1,  257,  258,  259,  260,  322,   -1,   -1,   -1,  265,
  266,   -1,   -1,   -1,   -1,   -1,  272,   -1,   -1,   -1,
   -1,  257,  258,  259,  260,   -1,   -1,   -1,  284,  265,
  266,   38,   -1,   40,   -1,   42,  272,   -1,  126,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  284,  305,
  306,   38,   -1,   40,   -1,   42,   -1,   -1,  126,  315,
   -1,   -1,   -1,   -1,   -1,   -1,  322,   -1,   -1,  305,
  306,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  315,
   -1,   -1,  257,  258,  259,  260,  322,   -1,   -1,   -1,
  265,  266,   -1,   -1,   -1,   -1,   -1,  272,   -1,   -1,
   -1,   -1,  257,  258,  259,  260,   -1,   -1,   -1,  284,
  265,  266,   -1,   -1,   -1,   -1,   -1,  272,   -1,  126,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  284,
  305,  306,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  126,
  315,   -1,   -1,   -1,   -1,   -1,   -1,  322,   -1,   -1,
  305,  306,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  315,   -1,   -1,   -1,   -1,   -1,   -1,  322,   -1,  257,
  258,  259,  260,   -1,   -1,   -1,   -1,  265,  266,   -1,
   -1,   -1,   -1,   -1,  272,   -1,   -1,   -1,   -1,  257,
  258,  259,  260,   -1,   -1,   -1,  284,  265,  266,   -1,
   -1,   -1,   -1,   -1,  272,   -1,   -1,   -1,  123,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  284,  305,  306,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  315,   -1,   -1,
   -1,   -1,   -1,   -1,  322,   -1,   -1,  305,  306,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  315,   -1,   -1,
  257,  258,  259,  260,  322,   -1,   -1,   -1,  265,  266,
   -1,   -1,   -1,   -1,   -1,  272,   -1,   -1,   -1,   -1,
  257,  258,  259,  260,   -1,   -1,   -1,  284,  265,  266,
   -1,   -1,   -1,   -1,   -1,  272,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  284,  305,  306,
   -1,   -1,   -1,  126,   -1,   -1,   -1,   -1,  315,   -1,
  974,   -1,   -1,  977,   -1,  322,   -1,   -1,  305,  306,
   -1,   -1,  986,   -1,  988,   -1,  990,   -1,  315,   -1,
   -1,   -1,   -1,   -1,  998,  322, 1000,   -1, 1002,   -1,
 1004,  256,  257,  258,  259,   -1,   -1,   -1,   -1,   -1,
  265,  266,  267,   -1,  269,  270,  271,  272,   -1,   -1,
  275,   -1,   -1,  278,  279,  280,  281,  282,   -1,  284,
  285,  286,  287,  288,  289,   -1,   -1,  292,  293,   -1,
   -1,   -1,  297,   -1,   -1,  300,   -1,   -1,   -1,   -1,
   -1,  306,   -1,   -1,   -1,  310,  311,  312,  313,  314,
  315,   -1,   -1,   -1,   -1,   -1,   -1,  322,   -1,   -1,
   -1,   -1,   -1,   -1,   -1, 1079,   -1, 1081,   -1,   -1,
   -1,   -1,   -1, 1087,   -1,   -1,   -1,   -1,   -1,   -1,
   -1, 1095,   -1, 1097,  257,  258,  259,   -1, 1102,   -1,
 1104,   -1,  265,  266,  267,   -1,  269,  270,  271,  272,
   -1,   -1,  275,   -1,   -1,   -1,  279,  280,  281,  282,
   -1,  284,  285,  286,  287,  288,  289,   -1,   -1,  292,
  293,   -1,   -1,   -1,  297,   -1,   -1,  300,   -1,   -1,
   -1,   -1,  305,  306,   -1,   -1,   -1,  310,  311,  312,
  313,  314,  315,   -1,   -1,   -1, 1160,   -1,   -1,  322,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1, 1173,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1, 1203,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1, 1217, 1218,   -1,   -1, 1221, 1222, 1223,
 1224,   -1, 1226, 1227, 1228,   -1, 1230, 1231, 1232, 1233,
  257,  258,  259,   -1,   -1,   -1,   -1,   -1,  265,  266,
  267,   -1,  269,  270,  271,  272,   -1,   -1,  275,   -1,
   -1,  278,  279,  280,  281,  282,   -1,  284,  285,  286,
  287,  288,  289,   -1,   -1,  292,  293,   -1,   -1,   -1,
  297,   -1,   -1,  300,   -1,   -1,   -1,   -1,   -1,  306,
   -1,   -1,   -1,  310,  311,  312,  313,  314,  315,   -1,
   -1,   -1,   -1,   -1,   -1,  322,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  334,
};
#define YYFINAL 1
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 347
#if YYDEBUG
char *yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
"'!'",0,0,0,"'%'","'&'",0,"'('","')'","'*'","'+'","','","'-'","'.'","'/'",0,0,0,
0,0,0,0,0,0,0,"':'","';'","'<'","'='","'>'","'?'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,"'['",0,"']'","'^'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,"'{'","'|'","'}'","'~'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"CHARE",
"BRANCHED","MESSAGE","HANDLE","ENTRY","DOUBLEARROW","ALL_NODES","LOCAL",
"ACCUMULATOR","MONOTONIC","READONLY","WRITEONCE","AUTO","DOUBLE","INT","STRUCT",
"BREAK","ELSE","LONG","SWITCH","CASE","ENUM","REGISTER","TYPEDEF","CHAR",
"EXTERN","RETURN","UNION","CONST","FLOAT","SHORT","UNSIGNED","WCHAR_TOKEN",
"CONTINUE","FOR","SIGNED","VOID","DEFAULT","GOTO","SIZEOF","VOLATILE","DO","IF",
"STATIC","WHILE","NEW","DELETE","THIS","OPERATOR","CLASS","PUBLIC","PROTECTED",
"PRIVATE","VIRTUAL","FRIEND","INLINE","UNDERSCORE_INLINE","OVERLOAD",
"IDENTIFIER","STRINGliteral","FLOATINGconstant","INTEGERconstant",
"CHARACTERconstant","OCTALconstant","HEXconstant","TYPEDEFname","ARROW","ICR",
"DECR","LS","RS","LE","GE","EQ","NE","ANDAND","OROR","ELLIPSIS","CLCL",
"DOTstar","ARROWstar","MULTassign","DIVassign","MODassign","PLUSassign",
"MINUSassign","LSassign","RSassign","ANDassign","ERassign","ORassign",
};
char *yyrule[] = {
"$accept : translation_unit",
"constant : INTEGERconstant",
"constant : FLOATINGconstant",
"constant : OCTALconstant",
"constant : HEXconstant",
"constant : CHARACTERconstant",
"string_literal_list : STRINGliteral",
"string_literal_list : string_literal_list STRINGliteral",
"paren_identifier_declarator : scope_opt_identifier",
"paren_identifier_declarator : scope_opt_complex_name",
"paren_identifier_declarator : '(' paren_identifier_declarator ')'",
"primary_expression : global_opt_scope_opt_identifier",
"primary_expression : global_opt_scope_opt_complex_name",
"primary_expression : THIS",
"primary_expression : constant",
"primary_expression : string_literal_list",
"primary_expression : '(' comma_expression ')'",
"non_elaborating_type_specifier : sue_type_specifier",
"non_elaborating_type_specifier : basic_type_specifier",
"non_elaborating_type_specifier : typedef_type_specifier",
"non_elaborating_type_specifier : basic_type_name",
"non_elaborating_type_specifier : TYPEDEFname",
"non_elaborating_type_specifier : global_or_scoped_typedefname",
"operator_function_name : OPERATOR any_operator",
"operator_function_name : OPERATOR type_qualifier_list operator_function_ptr_opt",
"operator_function_name : OPERATOR non_elaborating_type_specifier operator_function_ptr_opt",
"operator_function_ptr_opt :",
"operator_function_ptr_opt : unary_modifier operator_function_ptr_opt",
"operator_function_ptr_opt : asterisk_or_ampersand operator_function_ptr_opt",
"any_operator : '+'",
"any_operator : '-'",
"any_operator : '*'",
"any_operator : '/'",
"any_operator : '%'",
"any_operator : '^'",
"any_operator : '&'",
"any_operator : '|'",
"any_operator : '~'",
"any_operator : '!'",
"any_operator : '<'",
"any_operator : '>'",
"any_operator : LS",
"any_operator : RS",
"any_operator : ANDAND",
"any_operator : OROR",
"any_operator : ARROW",
"any_operator : ARROWstar",
"any_operator : '.'",
"any_operator : DOTstar",
"any_operator : ICR",
"any_operator : DECR",
"any_operator : LE",
"any_operator : GE",
"any_operator : EQ",
"any_operator : NE",
"any_operator : assignment_operator",
"any_operator : '(' ')'",
"any_operator : '[' ']'",
"any_operator : NEW",
"any_operator : DELETE",
"any_operator : ','",
"type_qualifier_list_opt :",
"type_qualifier_list_opt : type_qualifier_list",
"postfix_expression : primary_expression",
"postfix_expression : postfix_expression '[' comma_expression ']'",
"postfix_expression : postfix_expression '(' ')'",
"postfix_expression : postfix_expression '(' argument_expression_list ')'",
"$$1 :",
"postfix_expression : postfix_expression $$1 '.' member_name",
"$$2 :",
"$$3 :",
"postfix_expression : postfix_expression $$2 ARROW $$3 member_name",
"postfix_expression : postfix_expression ICR",
"postfix_expression : postfix_expression DECR",
"$$4 :",
"postfix_expression : postfix_expression '[' LOCAL ']' $$4 ARROW member_name",
"$$5 :",
"postfix_expression : postfix_expression DOUBLEARROW $$5 member_name",
"$$6 :",
"postfix_expression : postfix_expression '[' ALL_NODES ']' DOUBLEARROW $$6 member_name",
"postfix_expression : TYPEDEFname '(' ')'",
"postfix_expression : global_or_scoped_typedefname '(' ')'",
"postfix_expression : TYPEDEFname '(' argument_expression_list ')'",
"postfix_expression : global_or_scoped_typedefname '(' argument_expression_list ')'",
"postfix_expression : basic_type_name '(' assignment_expression ')'",
"member_name : scope_opt_identifier",
"member_name : scope_opt_complex_name",
"member_name : basic_type_name CLCL '~' basic_type_name",
"member_name : declaration_qualifier_list CLCL '~' declaration_qualifier_list",
"member_name : type_qualifier_list CLCL '~' type_qualifier_list",
"argument_expression_list : assignment_expression",
"argument_expression_list : argument_expression_list ',' assignment_expression",
"unary_expression : postfix_expression",
"unary_expression : ICR unary_expression",
"unary_expression : DECR unary_expression",
"unary_expression : asterisk_or_ampersand cast_expression",
"unary_expression : '-' cast_expression",
"unary_expression : '+' cast_expression",
"unary_expression : '~' cast_expression",
"unary_expression : '!' cast_expression",
"unary_expression : SIZEOF unary_expression",
"unary_expression : SIZEOF '(' type_name ')'",
"unary_expression : allocation_expression",
"allocation_expression : global_opt_scope_opt_operator_new '(' type_name ')' operator_new_initializer_opt",
"allocation_expression : global_opt_scope_opt_operator_new '(' argument_expression_list ')' '(' type_name ')' operator_new_initializer_opt",
"allocation_expression : global_opt_scope_opt_operator_new operator_new_type",
"allocation_expression : global_opt_scope_opt_operator_new '(' argument_expression_list ')' operator_new_type",
"global_opt_scope_opt_operator_new : NEW",
"global_opt_scope_opt_operator_new : global_or_scope NEW",
"operator_new_type : type_qualifier_list operator_new_declarator_opt operator_new_initializer_opt",
"operator_new_type : non_elaborating_type_specifier operator_new_declarator_opt operator_new_initializer_opt",
"operator_new_declarator_opt :",
"operator_new_declarator_opt : operator_new_array_declarator",
"operator_new_declarator_opt : asterisk_or_ampersand operator_new_declarator_opt",
"operator_new_declarator_opt : unary_modifier operator_new_declarator_opt",
"operator_new_array_declarator : '[' ']'",
"operator_new_array_declarator : '[' comma_expression ']'",
"operator_new_array_declarator : operator_new_array_declarator '[' comma_expression ']'",
"operator_new_initializer_opt :",
"operator_new_initializer_opt : '(' ')'",
"operator_new_initializer_opt : '(' argument_expression_list ')'",
"cast_expression : unary_expression",
"cast_expression : '(' type_name ')' cast_expression",
"deallocation_expression : cast_expression",
"deallocation_expression : global_opt_scope_opt_delete deallocation_expression",
"deallocation_expression : global_opt_scope_opt_delete '[' comma_expression ']' deallocation_expression",
"deallocation_expression : global_opt_scope_opt_delete '[' ']' deallocation_expression",
"global_opt_scope_opt_delete : DELETE",
"global_opt_scope_opt_delete : global_or_scope DELETE",
"point_member_expression : deallocation_expression",
"point_member_expression : point_member_expression DOTstar deallocation_expression",
"point_member_expression : point_member_expression ARROWstar deallocation_expression",
"multiplicative_expression : point_member_expression",
"multiplicative_expression : multiplicative_expression '*' point_member_expression",
"multiplicative_expression : multiplicative_expression '/' point_member_expression",
"multiplicative_expression : multiplicative_expression '%' point_member_expression",
"additive_expression : multiplicative_expression",
"additive_expression : additive_expression '+' multiplicative_expression",
"additive_expression : additive_expression '-' multiplicative_expression",
"shift_expression : additive_expression",
"shift_expression : shift_expression LS additive_expression",
"shift_expression : shift_expression RS additive_expression",
"relational_expression : shift_expression",
"relational_expression : relational_expression '<' shift_expression",
"relational_expression : relational_expression '>' shift_expression",
"relational_expression : relational_expression LE shift_expression",
"relational_expression : relational_expression GE shift_expression",
"equality_expression : relational_expression",
"equality_expression : equality_expression EQ relational_expression",
"equality_expression : equality_expression NE relational_expression",
"AND_expression : equality_expression",
"AND_expression : AND_expression '&' equality_expression",
"exclusive_OR_expression : AND_expression",
"exclusive_OR_expression : exclusive_OR_expression '^' AND_expression",
"inclusive_OR_expression : exclusive_OR_expression",
"inclusive_OR_expression : inclusive_OR_expression '|' exclusive_OR_expression",
"logical_AND_expression : inclusive_OR_expression",
"logical_AND_expression : logical_AND_expression ANDAND inclusive_OR_expression",
"logical_OR_expression : logical_AND_expression",
"logical_OR_expression : logical_OR_expression OROR logical_AND_expression",
"conditional_expression : logical_OR_expression",
"conditional_expression : logical_OR_expression '?' comma_expression ':' conditional_expression",
"assignment_expression : conditional_expression",
"assignment_expression : unary_expression assignment_operator assignment_expression",
"assignment_operator : '='",
"assignment_operator : MULTassign",
"assignment_operator : DIVassign",
"assignment_operator : MODassign",
"assignment_operator : PLUSassign",
"assignment_operator : MINUSassign",
"assignment_operator : LSassign",
"assignment_operator : RSassign",
"assignment_operator : ANDassign",
"assignment_operator : ERassign",
"assignment_operator : ORassign",
"comma_expression : assignment_expression",
"comma_expression : comma_expression ',' assignment_expression",
"constant_expression : conditional_expression",
"comma_expression_opt :",
"comma_expression_opt : comma_expression",
"declaration : declaring_list ';'",
"declaration : default_declaring_list ';'",
"declaration : sue_declaration_specifier ';'",
"declaration : sue_type_specifier ';'",
"declaration : sue_type_specifier_elaboration ';'",
"declaration : error ';'",
"$$7 :",
"default_declaring_list : declaration_qualifier_list identifier_declarator $$7 initializer_opt",
"$$8 :",
"default_declaring_list : type_qualifier_list identifier_declarator $$8 initializer_opt",
"$$9 :",
"default_declaring_list : default_declaring_list ',' identifier_declarator $$9 initializer_opt",
"default_declaring_list : declaration_qualifier_list constructed_identifier_declarator",
"default_declaring_list : type_qualifier_list constructed_identifier_declarator",
"default_declaring_list : default_declaring_list ',' constructed_identifier_declarator",
"$$10 :",
"declaring_list : declaration_specifier declarator $$10 initializer_opt",
"$$11 :",
"declaring_list : type_specifier declarator $$11 initializer_opt",
"$$12 :",
"declaring_list : basic_type_name declarator $$12 initializer_opt",
"$$13 :",
"declaring_list : TYPEDEFname declarator $$13 initializer_opt",
"$$14 :",
"declaring_list : global_or_scoped_typedefname declarator $$14 initializer_opt",
"$$15 :",
"declaring_list : declaring_list ',' declarator $$15 initializer_opt",
"declaring_list : declaration_specifier constructed_declarator",
"declaring_list : type_specifier constructed_declarator",
"declaring_list : basic_type_name constructed_declarator",
"declaring_list : TYPEDEFname constructed_declarator",
"declaring_list : global_or_scoped_typedefname constructed_declarator",
"declaring_list : declaring_list ',' constructed_declarator",
"constructed_declarator : nonunary_constructed_identifier_declarator",
"constructed_declarator : constructed_paren_typedef_declarator",
"constructed_declarator : simple_paren_typedef_declarator '(' argument_expression_list ')'",
"constructed_declarator : simple_paren_typedef_declarator postfixing_abstract_declarator '(' argument_expression_list ')'",
"constructed_declarator : constructed_parameter_typedef_declarator",
"constructed_declarator : asterisk_or_ampersand constructed_declarator",
"constructed_declarator : unary_modifier constructed_declarator",
"constructed_paren_typedef_declarator : '(' paren_typedef_declarator ')' '(' argument_expression_list ')'",
"constructed_paren_typedef_declarator : '(' paren_typedef_declarator ')' postfixing_abstract_declarator '(' argument_expression_list ')'",
"constructed_paren_typedef_declarator : '(' simple_paren_typedef_declarator postfixing_abstract_declarator ')' '(' argument_expression_list ')'",
"constructed_paren_typedef_declarator : '(' TYPEDEFname postfixing_abstract_declarator ')' '(' argument_expression_list ')'",
"constructed_parameter_typedef_declarator : TYPEDEFname '(' argument_expression_list ')'",
"constructed_parameter_typedef_declarator : TYPEDEFname postfixing_abstract_declarator '(' argument_expression_list ')'",
"constructed_parameter_typedef_declarator : '(' clean_typedef_declarator ')' '(' argument_expression_list ')'",
"constructed_parameter_typedef_declarator : '(' clean_typedef_declarator ')' postfixing_abstract_declarator '(' argument_expression_list ')'",
"constructed_identifier_declarator : nonunary_constructed_identifier_declarator",
"constructed_identifier_declarator : asterisk_or_ampersand constructed_identifier_declarator",
"constructed_identifier_declarator : unary_modifier constructed_identifier_declarator",
"nonunary_constructed_identifier_declarator : paren_identifier_declarator '(' argument_expression_list ')'",
"nonunary_constructed_identifier_declarator : paren_identifier_declarator postfixing_abstract_declarator '(' argument_expression_list ')'",
"nonunary_constructed_identifier_declarator : '(' unary_identifier_declarator ')' '(' argument_expression_list ')'",
"nonunary_constructed_identifier_declarator : '(' unary_identifier_declarator ')' postfixing_abstract_declarator '(' argument_expression_list ')'",
"declaration_specifier : basic_declaration_specifier",
"declaration_specifier : sue_declaration_specifier",
"declaration_specifier : typedef_declaration_specifier",
"type_specifier : basic_type_specifier",
"type_specifier : sue_type_specifier",
"type_specifier : sue_type_specifier_elaboration",
"type_specifier : typedef_type_specifier",
"declaration_qualifier_list : storage_class",
"declaration_qualifier_list : type_qualifier_list storage_class",
"declaration_qualifier_list : declaration_qualifier_list declaration_qualifier",
"type_qualifier_list : type_qualifier",
"type_qualifier_list : type_qualifier_list type_qualifier",
"declaration_qualifier : storage_class",
"declaration_qualifier : type_qualifier",
"type_qualifier : CONST",
"type_qualifier : VOLATILE",
"type_qualifier : READONLY",
"basic_declaration_specifier : declaration_qualifier_list basic_type_name",
"basic_declaration_specifier : basic_type_specifier storage_class",
"basic_declaration_specifier : basic_type_name storage_class",
"basic_declaration_specifier : basic_declaration_specifier declaration_qualifier",
"basic_declaration_specifier : basic_declaration_specifier basic_type_name",
"basic_type_specifier : type_qualifier_list basic_type_name",
"basic_type_specifier : basic_type_name basic_type_name",
"basic_type_specifier : basic_type_name type_qualifier",
"basic_type_specifier : basic_type_specifier type_qualifier",
"basic_type_specifier : basic_type_specifier basic_type_name",
"sue_declaration_specifier : declaration_qualifier_list elaborated_type_name",
"sue_declaration_specifier : declaration_qualifier_list elaborated_type_name_elaboration",
"sue_declaration_specifier : sue_type_specifier storage_class",
"sue_declaration_specifier : sue_type_specifier_elaboration storage_class",
"sue_declaration_specifier : sue_declaration_specifier declaration_qualifier",
"sue_type_specifier_elaboration : elaborated_type_name_elaboration",
"sue_type_specifier_elaboration : type_qualifier_list elaborated_type_name_elaboration",
"sue_type_specifier_elaboration : sue_type_specifier_elaboration type_qualifier",
"sue_type_specifier : elaborated_type_name",
"sue_type_specifier : type_qualifier_list elaborated_type_name",
"sue_type_specifier : sue_type_specifier type_qualifier",
"typedef_declaration_specifier : declaration_qualifier_list TYPEDEFname",
"typedef_declaration_specifier : declaration_qualifier_list global_or_scoped_typedefname",
"typedef_declaration_specifier : typedef_type_specifier storage_class",
"typedef_declaration_specifier : TYPEDEFname storage_class",
"typedef_declaration_specifier : global_or_scoped_typedefname storage_class",
"typedef_declaration_specifier : typedef_declaration_specifier declaration_qualifier",
"typedef_type_specifier : type_qualifier_list TYPEDEFname",
"typedef_type_specifier : type_qualifier_list global_or_scoped_typedefname",
"typedef_type_specifier : TYPEDEFname type_qualifier",
"typedef_type_specifier : global_or_scoped_typedefname type_qualifier",
"typedef_type_specifier : typedef_type_specifier type_qualifier",
"storage_class : EXTERN",
"storage_class : TYPEDEF",
"storage_class : STATIC",
"storage_class : AUTO",
"storage_class : REGISTER",
"storage_class : FRIEND",
"storage_class : OVERLOAD",
"storage_class : INLINE",
"storage_class : UNDERSCORE_INLINE",
"storage_class : VIRTUAL",
"basic_type_name : INT",
"basic_type_name : CHAR",
"basic_type_name : SHORT",
"basic_type_name : LONG",
"basic_type_name : FLOAT",
"basic_type_name : WCHAR_TOKEN",
"basic_type_name : DOUBLE",
"basic_type_name : SIGNED",
"basic_type_name : UNSIGNED",
"basic_type_name : VOID",
"elaborated_type_name_elaboration : aggregate_name_elaboration",
"elaborated_type_name_elaboration : enum_name_elaboration",
"elaborated_type_name : aggregate_name",
"elaborated_type_name : enum_name",
"$$16 :",
"$$17 :",
"$$18 :",
"aggregate_name_elaboration : aggregate_name derivation_opt $$16 '{' $$17 member_declaration_list_opt $$18 '}'",
"aggregate_name_elaboration : aggregate_key derivation_opt '{' member_declaration_list_opt '}'",
"aggregate_name : aggregate_key tag_name",
"aggregate_name : global_scope scope aggregate_key tag_name",
"aggregate_name : global_scope aggregate_key tag_name",
"aggregate_name : scope aggregate_key tag_name",
"derivation_opt :",
"derivation_opt : ':' derivation_list",
"derivation_opt : ':' error",
"derivation_list : parent_class",
"derivation_list : derivation_list ',' parent_class",
"parent_class : global_opt_scope_opt_typedefname",
"parent_class : VIRTUAL access_specifier_opt global_opt_scope_opt_typedefname",
"parent_class : access_specifier virtual_opt global_opt_scope_opt_typedefname",
"virtual_opt :",
"virtual_opt : VIRTUAL",
"access_specifier_opt :",
"access_specifier_opt : access_specifier",
"access_specifier : PUBLIC",
"access_specifier : PRIVATE",
"access_specifier : PROTECTED",
"access_specifier : ENTRY",
"aggregate_key : STRUCT",
"aggregate_key : UNION",
"aggregate_key : CLASS",
"aggregate_key : CHARE CLASS",
"aggregate_key : BRANCHED CHARE CLASS",
"aggregate_key : MESSAGE",
"aggregate_key : ACCUMULATOR CLASS",
"aggregate_key : MONOTONIC CLASS",
"member_declaration_list_opt :",
"member_declaration_list_opt : member_declaration_list_opt member_declaration",
"member_declaration : member_declaring_list ';'",
"member_declaration : member_default_declaring_list ';'",
"member_declaration : access_specifier ':'",
"member_declaration : new_function_definition",
"member_declaration : constructor_function_in_class",
"member_declaration : sue_type_specifier ';'",
"member_declaration : sue_type_specifier_elaboration ';'",
"member_declaration : identifier_declarator ';'",
"member_declaration : typedef_declaration_specifier ';'",
"member_declaration : sue_declaration_specifier ';'",
"member_default_declaring_list : type_qualifier_list identifier_declarator member_pure_opt",
"member_default_declaring_list : declaration_qualifier_list identifier_declarator member_pure_opt",
"member_default_declaring_list : member_default_declaring_list ',' identifier_declarator member_pure_opt",
"member_default_declaring_list : type_qualifier_list bit_field_identifier_declarator",
"member_default_declaring_list : declaration_qualifier_list bit_field_identifier_declarator",
"member_default_declaring_list : member_default_declaring_list ',' bit_field_identifier_declarator",
"member_declaring_list : type_specifier declarator member_pure_opt",
"$$19 :",
"member_declaring_list : basic_type_name declarator $$19 member_pure_opt",
"member_declaring_list : global_or_scoped_typedefname declarator member_pure_opt",
"member_declaring_list : member_conflict_declaring_item",
"member_declaring_list : member_declaring_list ',' declarator member_pure_opt",
"member_declaring_list : type_specifier bit_field_declarator",
"member_declaring_list : basic_type_name bit_field_declarator",
"member_declaring_list : TYPEDEFname bit_field_declarator",
"member_declaring_list : global_or_scoped_typedefname bit_field_declarator",
"member_declaring_list : declaration_specifier bit_field_declarator",
"member_declaring_list : member_declaring_list ',' bit_field_declarator",
"member_conflict_declaring_item : TYPEDEFname identifier_declarator member_pure_opt",
"member_conflict_declaring_item : TYPEDEFname parameter_typedef_declarator member_pure_opt",
"member_conflict_declaring_item : TYPEDEFname simple_paren_typedef_declarator member_pure_opt",
"member_conflict_declaring_item : declaration_specifier identifier_declarator member_pure_opt",
"member_conflict_declaring_item : declaration_specifier parameter_typedef_declarator member_pure_opt",
"member_conflict_declaring_item : declaration_specifier simple_paren_typedef_declarator member_pure_opt",
"member_conflict_declaring_item : member_conflict_paren_declaring_item",
"member_conflict_paren_declaring_item : TYPEDEFname asterisk_or_ampersand '(' simple_paren_typedef_declarator ')' member_pure_opt",
"member_conflict_paren_declaring_item : TYPEDEFname unary_modifier '(' simple_paren_typedef_declarator ')' member_pure_opt",
"member_conflict_paren_declaring_item : TYPEDEFname asterisk_or_ampersand '(' TYPEDEFname ')' member_pure_opt",
"member_conflict_paren_declaring_item : TYPEDEFname unary_modifier '(' TYPEDEFname ')' member_pure_opt",
"member_conflict_paren_declaring_item : TYPEDEFname asterisk_or_ampersand paren_typedef_declarator member_pure_opt",
"member_conflict_paren_declaring_item : TYPEDEFname unary_modifier paren_typedef_declarator member_pure_opt",
"member_conflict_paren_declaring_item : declaration_specifier asterisk_or_ampersand '(' simple_paren_typedef_declarator ')' member_pure_opt",
"member_conflict_paren_declaring_item : declaration_specifier unary_modifier '(' simple_paren_typedef_declarator ')' member_pure_opt",
"member_conflict_paren_declaring_item : declaration_specifier asterisk_or_ampersand '(' TYPEDEFname ')' member_pure_opt",
"member_conflict_paren_declaring_item : declaration_specifier unary_modifier '(' TYPEDEFname ')' member_pure_opt",
"member_conflict_paren_declaring_item : declaration_specifier asterisk_or_ampersand paren_typedef_declarator member_pure_opt",
"member_conflict_paren_declaring_item : declaration_specifier unary_modifier paren_typedef_declarator member_pure_opt",
"member_conflict_paren_declaring_item : member_conflict_paren_postfix_declaring_item",
"member_conflict_paren_postfix_declaring_item : TYPEDEFname '(' paren_typedef_declarator ')' member_pure_opt",
"member_conflict_paren_postfix_declaring_item : TYPEDEFname '(' simple_paren_typedef_declarator postfixing_abstract_declarator ')' member_pure_opt",
"member_conflict_paren_postfix_declaring_item : TYPEDEFname '(' TYPEDEFname postfixing_abstract_declarator ')' member_pure_opt",
"member_conflict_paren_postfix_declaring_item : TYPEDEFname '(' paren_typedef_declarator ')' postfixing_abstract_declarator member_pure_opt",
"member_conflict_paren_postfix_declaring_item : declaration_specifier '(' paren_typedef_declarator ')' member_pure_opt",
"member_conflict_paren_postfix_declaring_item : declaration_specifier '(' simple_paren_typedef_declarator postfixing_abstract_declarator ')' member_pure_opt",
"member_conflict_paren_postfix_declaring_item : declaration_specifier '(' TYPEDEFname postfixing_abstract_declarator ')' member_pure_opt",
"member_conflict_paren_postfix_declaring_item : declaration_specifier '(' paren_typedef_declarator ')' postfixing_abstract_declarator member_pure_opt",
"member_pure_opt :",
"member_pure_opt : '=' OCTALconstant",
"bit_field_declarator : bit_field_identifier_declarator",
"$$20 :",
"bit_field_declarator : TYPEDEFname $$20 ':' constant_expression",
"bit_field_identifier_declarator : ':' constant_expression",
"$$21 :",
"bit_field_identifier_declarator : identifier_declarator $$21 ':' constant_expression",
"enum_name_elaboration : global_opt_scope_opt_enum_key '{' enumerator_list '}'",
"enum_name_elaboration : enum_name '{' enumerator_list '}'",
"enum_name : global_opt_scope_opt_enum_key tag_name",
"global_opt_scope_opt_enum_key : ENUM",
"global_opt_scope_opt_enum_key : global_or_scope ENUM",
"enumerator_list : enumerator_list_no_trailing_comma",
"enumerator_list : enumerator_list_no_trailing_comma ','",
"enumerator_list_no_trailing_comma : enumerator_name enumerator_value_opt",
"enumerator_list_no_trailing_comma : enumerator_list_no_trailing_comma ',' enumerator_name enumerator_value_opt",
"enumerator_name : IDENTIFIER",
"enumerator_name : TYPEDEFname",
"enumerator_value_opt :",
"enumerator_value_opt : '=' constant_expression",
"parameter_type_list : '(' ')' type_qualifier_list_opt",
"parameter_type_list : '(' type_name ')' type_qualifier_list_opt",
"parameter_type_list : '(' type_name initializer ')' type_qualifier_list_opt",
"parameter_type_list : '(' named_parameter_type_list ')' type_qualifier_list_opt",
"old_parameter_type_list : '(' ')'",
"old_parameter_type_list : '(' type_name ')'",
"old_parameter_type_list : '(' type_name initializer ')'",
"old_parameter_type_list : '(' named_parameter_type_list ')'",
"named_parameter_type_list : parameter_list",
"named_parameter_type_list : parameter_list comma_opt_ellipsis",
"named_parameter_type_list : type_name comma_opt_ellipsis",
"named_parameter_type_list : type_name initializer comma_opt_ellipsis",
"named_parameter_type_list : ELLIPSIS",
"comma_opt_ellipsis : ELLIPSIS",
"comma_opt_ellipsis : ',' ELLIPSIS",
"parameter_list : non_casting_parameter_declaration",
"parameter_list : non_casting_parameter_declaration initializer",
"parameter_list : type_name ',' parameter_declaration",
"parameter_list : type_name initializer ',' parameter_declaration",
"parameter_list : parameter_list ',' parameter_declaration",
"parameter_declaration : type_name",
"parameter_declaration : type_name initializer",
"parameter_declaration : non_casting_parameter_declaration",
"parameter_declaration : non_casting_parameter_declaration initializer",
"non_casting_parameter_declaration : declaration_specifier",
"non_casting_parameter_declaration : declaration_specifier abstract_declarator",
"non_casting_parameter_declaration : declaration_specifier identifier_declarator",
"non_casting_parameter_declaration : declaration_specifier parameter_typedef_declarator",
"non_casting_parameter_declaration : declaration_qualifier_list",
"non_casting_parameter_declaration : declaration_qualifier_list abstract_declarator",
"non_casting_parameter_declaration : declaration_qualifier_list identifier_declarator",
"non_casting_parameter_declaration : type_specifier identifier_declarator",
"non_casting_parameter_declaration : type_specifier parameter_typedef_declarator",
"non_casting_parameter_declaration : basic_type_name identifier_declarator",
"non_casting_parameter_declaration : basic_type_name parameter_typedef_declarator",
"non_casting_parameter_declaration : TYPEDEFname identifier_declarator",
"non_casting_parameter_declaration : TYPEDEFname parameter_typedef_declarator",
"non_casting_parameter_declaration : global_or_scoped_typedefname identifier_declarator",
"non_casting_parameter_declaration : global_or_scoped_typedefname parameter_typedef_declarator",
"non_casting_parameter_declaration : type_qualifier_list identifier_declarator",
"type_name : type_specifier",
"type_name : basic_type_name",
"type_name : TYPEDEFname",
"type_name : global_or_scoped_typedefname",
"type_name : type_qualifier_list",
"type_name : type_specifier abstract_declarator",
"type_name : basic_type_name abstract_declarator",
"type_name : TYPEDEFname abstract_declarator",
"type_name : global_or_scoped_typedefname abstract_declarator",
"type_name : type_qualifier_list abstract_declarator",
"initializer_opt :",
"initializer_opt : initializer",
"initializer : '=' initializer_group",
"initializer_group : '{' initializer_list '}'",
"initializer_group : '{' initializer_list ',' '}'",
"initializer_group : assignment_expression",
"initializer_list : initializer_group",
"initializer_list : initializer_list ',' initializer_group",
"statement : labeled_statement",
"statement : compound_statement",
"statement : expression_statement",
"statement : selection_statement",
"statement : iteration_statement",
"statement : jump_statement",
"statement : declaration",
"labeled_statement : label ':' statement",
"labeled_statement : CASE constant_expression ':' statement",
"labeled_statement : DEFAULT ':' statement",
"$$22 :",
"$$23 :",
"compound_statement : '{' $$22 statement_list_opt $$23 '}'",
"declaration_list : declaration",
"declaration_list : declaration_list declaration",
"statement_list_opt :",
"statement_list_opt : statement_list_opt statement",
"expression_statement : comma_expression_opt ';'",
"selection_statement : IF if_cond statement",
"selection_statement : IF if_cond statement ELSE statement",
"selection_statement : SWITCH if_cond statement",
"if_cond : '(' comma_expression ')'",
"if_cond : '(' error ')'",
"$$24 :",
"iteration_statement : WHILE '(' comma_expression_opt ')' $$24 statement",
"$$25 :",
"iteration_statement : WHILE '(' error ')' $$25 statement",
"iteration_statement : DO statement WHILE '(' comma_expression ')' ';'",
"$$26 :",
"iteration_statement : DO statement WHILE '(' error ')' $$26 ';'",
"$$27 :",
"iteration_statement : FOR '(' comma_expression_opt ';' comma_expression_opt ';' comma_expression_opt ')' $$27 statement",
"iteration_statement : FOR '(' declaration comma_expression_opt ';' comma_expression_opt ')' statement",
"$$28 :",
"iteration_statement : FOR '(' error ')' $$28 statement",
"jump_statement : GOTO label ';'",
"jump_statement : CONTINUE ';'",
"jump_statement : BREAK ';'",
"jump_statement : RETURN comma_expression_opt ';'",
"label : IDENTIFIER",
"label : TYPEDEFname",
"translation_unit :",
"translation_unit : translation_unit external_definition",
"external_definition : function_declaration",
"external_definition : function_definition",
"external_definition : declaration",
"external_definition : linkage_specifier function_declaration",
"external_definition : linkage_specifier function_definition",
"external_definition : linkage_specifier declaration",
"$$29 :",
"$$30 :",
"external_definition : linkage_specifier '{' $$29 translation_unit $$30 '}'",
"linkage_specifier : EXTERN STRINGliteral",
"function_declaration : identifier_declarator ';'",
"function_declaration : constructor_function_declaration ';'",
"function_definition : new_function_definition",
"function_definition : old_function_definition",
"function_definition : constructor_function_definition",
"$$31 :",
"new_function_definition : identifier_declarator $$31 compound_statement",
"$$32 :",
"new_function_definition : declaration_specifier declarator $$32 compound_statement",
"$$33 :",
"new_function_definition : declaration_specifier error $$33 compound_statement",
"$$34 :",
"new_function_definition : type_specifier declarator $$34 compound_statement",
"$$35 :",
"new_function_definition : basic_type_name declarator $$35 compound_statement",
"$$36 :",
"new_function_definition : basic_type_name error $$36 compound_statement",
"$$37 :",
"new_function_definition : TYPEDEFname declarator $$37 compound_statement",
"$$38 :",
"new_function_definition : global_or_scoped_typedefname declarator $$38 compound_statement",
"$$39 :",
"new_function_definition : declaration_qualifier_list identifier_declarator $$39 compound_statement",
"$$40 :",
"new_function_definition : type_qualifier_list identifier_declarator $$40 compound_statement",
"$$41 :",
"old_function_definition : old_function_declarator $$41 old_function_body",
"$$42 :",
"old_function_definition : declaration_specifier old_function_declarator $$42 old_function_body",
"$$43 :",
"old_function_definition : type_specifier old_function_declarator $$43 old_function_body",
"$$44 :",
"old_function_definition : basic_type_name old_function_declarator $$44 old_function_body",
"$$45 :",
"old_function_definition : TYPEDEFname old_function_declarator $$45 old_function_body",
"$$46 :",
"old_function_definition : global_or_scoped_typedefname old_function_declarator $$46 old_function_body",
"$$47 :",
"old_function_definition : declaration_qualifier_list old_function_declarator $$47 old_function_body",
"$$48 :",
"old_function_definition : type_qualifier_list old_function_declarator $$48 old_function_body",
"old_function_body : declaration_list compound_statement",
"old_function_body : compound_statement",
"$$49 :",
"constructor_function_definition : global_or_scoped_typedefname parameter_type_list constructor_init_list_opt $$49 compound_statement",
"constructor_function_definition : declaration_specifier parameter_type_list constructor_init_list_opt compound_statement",
"constructor_function_declaration : global_or_scoped_typedefname parameter_type_list",
"constructor_function_declaration : declaration_specifier parameter_type_list",
"constructor_function_in_class : declaration_specifier constructor_parameter_list_and_body",
"constructor_function_in_class : TYPEDEFname constructor_parameter_list_and_body",
"constructor_parameter_list_and_body : '(' ')' type_qualifier_list_opt ';'",
"constructor_parameter_list_and_body : '(' type_name initializer ')' type_qualifier_list_opt ';'",
"constructor_parameter_list_and_body : '(' named_parameter_type_list ')' type_qualifier_list_opt ';'",
"$$50 :",
"constructor_parameter_list_and_body : '(' ')' type_qualifier_list_opt constructor_init_list_opt $$50 compound_statement",
"$$51 :",
"constructor_parameter_list_and_body : '(' type_name initializer ')' type_qualifier_list_opt constructor_init_list_opt $$51 compound_statement",
"$$52 :",
"constructor_parameter_list_and_body : '(' named_parameter_type_list ')' type_qualifier_list_opt constructor_init_list_opt $$52 compound_statement",
"constructor_parameter_list_and_body : constructor_conflicting_parameter_list_and_body",
"constructor_conflicting_parameter_list_and_body : '(' type_specifier ')' type_qualifier_list_opt ';'",
"constructor_conflicting_parameter_list_and_body : '(' basic_type_name ')' type_qualifier_list_opt ';'",
"constructor_conflicting_parameter_list_and_body : '(' TYPEDEFname ')' type_qualifier_list_opt ';'",
"constructor_conflicting_parameter_list_and_body : '(' global_or_scoped_typedefname ')' type_qualifier_list_opt ';'",
"constructor_conflicting_parameter_list_and_body : '(' type_qualifier_list ')' type_qualifier_list_opt ';'",
"constructor_conflicting_parameter_list_and_body : '(' type_specifier abstract_declarator ')' type_qualifier_list_opt ';'",
"constructor_conflicting_parameter_list_and_body : '(' basic_type_name abstract_declarator ')' type_qualifier_list_opt ';'",
"constructor_conflicting_parameter_list_and_body : '(' global_or_scoped_typedefname abstract_declarator ')' type_qualifier_list_opt ';'",
"constructor_conflicting_parameter_list_and_body : '(' type_qualifier_list abstract_declarator ')' type_qualifier_list_opt ';'",
"constructor_conflicting_parameter_list_and_body : '(' type_specifier ')' type_qualifier_list_opt constructor_init_list_opt compound_statement",
"constructor_conflicting_parameter_list_and_body : '(' basic_type_name ')' type_qualifier_list_opt constructor_init_list_opt compound_statement",
"constructor_conflicting_parameter_list_and_body : '(' TYPEDEFname ')' type_qualifier_list_opt constructor_init_list_opt compound_statement",
"constructor_conflicting_parameter_list_and_body : '(' global_or_scoped_typedefname ')' type_qualifier_list_opt constructor_init_list_opt compound_statement",
"constructor_conflicting_parameter_list_and_body : '(' type_qualifier_list ')' type_qualifier_list_opt constructor_init_list_opt compound_statement",
"constructor_conflicting_parameter_list_and_body : '(' type_specifier abstract_declarator ')' type_qualifier_list_opt constructor_init_list_opt compound_statement",
"constructor_conflicting_parameter_list_and_body : '(' basic_type_name abstract_declarator ')' type_qualifier_list_opt constructor_init_list_opt compound_statement",
"constructor_conflicting_parameter_list_and_body : '(' global_or_scoped_typedefname abstract_declarator ')' type_qualifier_list_opt constructor_init_list_opt compound_statement",
"constructor_conflicting_parameter_list_and_body : '(' type_qualifier_list abstract_declarator ')' type_qualifier_list_opt constructor_init_list_opt compound_statement",
"constructor_conflicting_parameter_list_and_body : constructor_conflicting_typedef_declarator",
"constructor_conflicting_typedef_declarator : '(' TYPEDEFname unary_abstract_declarator ')' type_qualifier_list_opt ';'",
"constructor_conflicting_typedef_declarator : '(' TYPEDEFname unary_abstract_declarator ')' type_qualifier_list_opt constructor_init_list_opt compound_statement",
"constructor_conflicting_typedef_declarator : '(' TYPEDEFname postfix_abstract_declarator ')' type_qualifier_list_opt ';'",
"constructor_conflicting_typedef_declarator : '(' TYPEDEFname postfix_abstract_declarator ')' type_qualifier_list_opt constructor_init_list_opt compound_statement",
"constructor_conflicting_typedef_declarator : '(' TYPEDEFname postfixing_abstract_declarator ')' type_qualifier_list_opt ';'",
"constructor_conflicting_typedef_declarator : '(' TYPEDEFname postfixing_abstract_declarator ')' type_qualifier_list_opt constructor_init_list_opt compound_statement",
"constructor_init_list_opt :",
"constructor_init_list_opt : constructor_init_list",
"constructor_init_list : ':' constructor_init",
"constructor_init_list : constructor_init_list ',' constructor_init",
"constructor_init : IDENTIFIER '(' argument_expression_list ')'",
"constructor_init : IDENTIFIER '(' ')'",
"constructor_init : TYPEDEFname '(' argument_expression_list ')'",
"constructor_init : TYPEDEFname '(' ')'",
"constructor_init : global_or_scoped_typedefname '(' argument_expression_list ')'",
"constructor_init : global_or_scoped_typedefname '(' ')'",
"constructor_init : '(' argument_expression_list ')'",
"constructor_init : '(' ')'",
"declarator : identifier_declarator",
"declarator : typedef_declarator",
"typedef_declarator : paren_typedef_declarator",
"typedef_declarator : simple_paren_typedef_declarator",
"typedef_declarator : parameter_typedef_declarator",
"parameter_typedef_declarator : TYPEDEFname",
"parameter_typedef_declarator : TYPEDEFname postfixing_abstract_declarator",
"parameter_typedef_declarator : clean_typedef_declarator",
"clean_typedef_declarator : clean_postfix_typedef_declarator",
"clean_typedef_declarator : asterisk_or_ampersand parameter_typedef_declarator",
"clean_typedef_declarator : unary_modifier parameter_typedef_declarator",
"clean_postfix_typedef_declarator : '(' clean_typedef_declarator ')'",
"clean_postfix_typedef_declarator : '(' clean_typedef_declarator ')' postfixing_abstract_declarator",
"paren_typedef_declarator : postfix_paren_typedef_declarator",
"paren_typedef_declarator : asterisk_or_ampersand '(' simple_paren_typedef_declarator ')'",
"paren_typedef_declarator : unary_modifier '(' simple_paren_typedef_declarator ')'",
"paren_typedef_declarator : asterisk_or_ampersand '(' TYPEDEFname ')'",
"paren_typedef_declarator : unary_modifier '(' TYPEDEFname ')'",
"paren_typedef_declarator : asterisk_or_ampersand paren_typedef_declarator",
"paren_typedef_declarator : unary_modifier paren_typedef_declarator",
"postfix_paren_typedef_declarator : '(' paren_typedef_declarator ')'",
"postfix_paren_typedef_declarator : '(' simple_paren_typedef_declarator postfixing_abstract_declarator ')'",
"postfix_paren_typedef_declarator : '(' TYPEDEFname postfixing_abstract_declarator ')'",
"postfix_paren_typedef_declarator : '(' paren_typedef_declarator ')' postfixing_abstract_declarator",
"simple_paren_typedef_declarator : '(' TYPEDEFname ')'",
"simple_paren_typedef_declarator : '(' simple_paren_typedef_declarator ')'",
"identifier_declarator : unary_identifier_declarator",
"identifier_declarator : paren_identifier_declarator",
"unary_identifier_declarator : postfix_identifier_declarator",
"unary_identifier_declarator : asterisk_or_ampersand identifier_declarator",
"unary_identifier_declarator : unary_modifier identifier_declarator",
"postfix_identifier_declarator : paren_identifier_declarator postfixing_abstract_declarator",
"postfix_identifier_declarator : '(' unary_identifier_declarator ')'",
"postfix_identifier_declarator : '(' unary_identifier_declarator ')' postfixing_abstract_declarator",
"old_function_declarator : postfix_old_function_declarator",
"old_function_declarator : asterisk_or_ampersand old_function_declarator",
"old_function_declarator : unary_modifier old_function_declarator",
"postfix_old_function_declarator : paren_identifier_declarator '(' argument_expression_list ')'",
"postfix_old_function_declarator : '(' old_function_declarator ')'",
"postfix_old_function_declarator : '(' old_function_declarator ')' old_postfixing_abstract_declarator",
"old_postfixing_abstract_declarator : array_abstract_declarator",
"old_postfixing_abstract_declarator : old_parameter_type_list",
"abstract_declarator : unary_abstract_declarator",
"abstract_declarator : postfix_abstract_declarator",
"abstract_declarator : postfixing_abstract_declarator",
"postfixing_abstract_declarator : array_abstract_declarator",
"postfixing_abstract_declarator : parameter_type_list",
"array_abstract_declarator : '[' ']'",
"array_abstract_declarator : '[' constant_expression ']'",
"array_abstract_declarator : array_abstract_declarator '[' constant_expression ']'",
"unary_abstract_declarator : asterisk_or_ampersand",
"unary_abstract_declarator : unary_modifier",
"unary_abstract_declarator : asterisk_or_ampersand abstract_declarator",
"unary_abstract_declarator : unary_modifier abstract_declarator",
"postfix_abstract_declarator : '(' unary_abstract_declarator ')'",
"postfix_abstract_declarator : '(' postfix_abstract_declarator ')'",
"postfix_abstract_declarator : '(' postfixing_abstract_declarator ')'",
"postfix_abstract_declarator : '(' unary_abstract_declarator ')' postfixing_abstract_declarator",
"asterisk_or_ampersand : '*'",
"asterisk_or_ampersand : '&'",
"asterisk_or_ampersand : HANDLE",
"unary_modifier : scope '*' type_qualifier_list_opt",
"unary_modifier : asterisk_or_ampersand type_qualifier_list",
"scoping_name : tag_name",
"scoping_name : aggregate_key tag_name",
"scope : scoping_name CLCL",
"scope : scope scoping_name CLCL",
"tag_name : IDENTIFIER",
"tag_name : TYPEDEFname",
"$$53 :",
"global_scope : $$53 CLCL",
"global_or_scope : global_scope",
"global_or_scope : scope",
"global_or_scope : global_scope scope",
"scope_opt_identifier : IDENTIFIER",
"scope_opt_identifier : scope IDENTIFIER",
"scope_opt_complex_name : complex_name",
"scope_opt_complex_name : scope complex_name",
"complex_name : '~' TYPEDEFname",
"complex_name : operator_function_name",
"global_opt_scope_opt_identifier : global_scope scope_opt_identifier",
"global_opt_scope_opt_identifier : scope_opt_identifier",
"global_opt_scope_opt_complex_name : global_scope scope_opt_complex_name",
"global_opt_scope_opt_complex_name : scope_opt_complex_name",
"scoped_typedefname : scope TYPEDEFname",
"global_or_scoped_typedefname : scoped_typedefname",
"global_or_scoped_typedefname : global_scope scoped_typedefname",
"global_or_scoped_typedefname : global_scope TYPEDEFname",
"global_opt_scope_opt_typedefname : TYPEDEFname",
"global_opt_scope_opt_typedefname : global_or_scoped_typedefname",
};
#endif
#ifndef YYSTYPE
typedef int YYSTYPE;
#endif
#define yyclearin (yychar=(-1))
#define yyerrok (yyerrflag=0)
#ifdef YYSTACKSIZE
#ifndef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#endif
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 600
#define YYMAXDEPTH 600
#endif
#endif
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short yyss[YYSTACKSIZE];
YYSTYPE yyvs[YYSTACKSIZE];
#define yystacksize YYSTACKSIZE
#line 3259 "t.y"
yyerror(string)
char*string;
{
	fprintf(stderr,"ERROR : %s, line %d : %s near \"%s\".\n", CurrentFileName,CurrentLine,string,prevtoken);
	ErrVal = TRUE ;
}


char *Concat2(s1,s2)
char *s1, *s2 ;
{
	int len = strlen(s1) + strlen(s2) + 1 ;
	char *s = (char *)malloc(sizeof(char)*len) ;
	sprintf(s,"%s%s",s1,s2) ;
/* 	free(s1) ; free(s2) ;  */
	
	return(s) ;
}

char *Concat3(s1,s2,s3)
char *s1, *s2, *s3 ;
{
	int len = strlen(s1) + strlen(s2) + strlen(s3) + 1 ;
	char *s = (char *)malloc(sizeof(char)*len) ;
	sprintf(s,"%s%s%s",s1,s2,s3) ;
/* 	free(s1) ; free(s2) ; free(s3)  */
	
	return(s) ;
}
#line 6415 "y.tab.c"
#define YYABORT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab
#if YYDEBUG
#ifndef YYDEBUG_LEXER_TEXT /* pointer to the text isolated by the lexer*/
#define YYDEBUG_LEXER_TEXT "YYDEBUG_LEXER_TEXT not defined"
#endif
#ifndef YYDEBUG_INDENT_STRING
#define YYDEBUG_INDENT_STRING  "|       "
#endif
#ifndef YYDEBUG_REDUCE_STRING
#define YYDEBUG_REDUCE_STRING  "+-------"
#endif
#ifndef YYDEBUG_INDENT
YYDEBUG_INDENT(yyindent)
int yyindent;
{
    while(yyindent-- > 0)
        printf("%s", YYDEBUG_INDENT_STRING);
}
#endif /* YYDEBUG_INDENT */
#ifndef YYDEBUG_REDUCE
YYDEBUG_REDUCE(yynew_state, yyrule_num, yyrule_string, yynew_indent, 
yyrhs_count)
int yynew_state;
int yyrule_num;
char * yyrule_string;
int yynew_indent;
int yyrhs_count;
{
    if (1 < yyrhs_count)
    {  /* draw the graphics for the reduction */
        YYDEBUG_INDENT(yynew_indent);
        while(1 < yyrhs_count--)
            printf("%s", YYDEBUG_REDUCE_STRING);
        putchar('+'); /* left rotated L would look nice */
        putchar('\n');
        YYDEBUG_INDENT(yynew_indent);
        putchar('|'); /* down arrow would look nice */
        putchar('\n');
    }
    YYDEBUG_INDENT(yynew_indent);
    /* Only print the resulting token name */
    while (*yyrule_string && ' ' != *yyrule_string)
        putchar(*yyrule_string++);
    putchar('\n');
}
#endif /* YYDEBUG_REDUCE */
#ifndef YYDEBUG_SHIFT_LEXEME
YYDEBUG_SHIFT_LEXEME(yyold_state, yynew_state, yytoken_string, yynew_indent)
int yyold_state;
int yynew_state;
char * yytoken_string;
int yynew_indent;
{
    YYDEBUG_INDENT(yynew_indent);
    printf("%s <-- `%s'\n", yytoken_string, YYDEBUG_LEXER_TEXT);
}
#endif /*  YYDEBUG_SHIFT_LEXEME */
#ifndef YYDEBUG_LOOK_AHEAD
YYDEBUG_LOOK_AHEAD(yynew_state, yytoken_num, yytoken_string, yyindent)
int yynew_state;
int yytoken_num;
char * yytoken_string;
int yyindent;
{
    YYDEBUG_INDENT(yyindent);
    printf("          .... look ahead at %s   `%s'\n",
           yytoken_string,
           (0 == yytoken_num)? "\0": YYDEBUG_LEXER_TEXT);
}
#endif /* YYDEBUG_LOOK_AHEAD */
#ifndef YYDEBUG_DISCARD_STATE
YYDEBUG_DISCARD_STATE(yynew_state, yyindent)
int yynew_state;
int yyindent;
{
    if (0 < yyindent)
    {  /* draw the graphics for the reduction */
        YYDEBUG_INDENT(yyindent-1);
        printf("%s", YYDEBUG_REDUCE_STRING);
        putchar('+'); /* left rotated L would look nice */
        printf("  discarding state\n");
        YYDEBUG_INDENT(yyindent-1);
        putchar('|'); /* down arrow would look nice */
        putchar('\n');
    }
    else
    {
        if (0 == yyindent)
            printf("discarding state\n");
        else
            printf("no more states to discard: parser will abort\n");
    }
}
#endif /* YYDEBUG_DISCARD_STATE */
#ifndef YYDEBUG_DISCARD_TOKEN
YYDEBUG_DISCARD_TOKEN(yynew_state, yytoken_num, yytoken_string, yyindent)
int yynew_state;
int yytoken_num;
char * yytoken_string;
int yyindent;
{
    YYDEBUG_INDENT(yyindent);
    printf("discarding token %s\n", yytoken_string);
}
#endif /* YYDEBUG_DISCARD_TOKEN */
#ifndef YYDEBUG_SHIFT_ERROR_LEXEME
YYDEBUG_SHIFT_ERROR_LEXEME(yyold_state, yynew_state, yyindent)
int yyold_state;
int yynew_state;
int yyindent;
{
    YYDEBUG_INDENT(yyindent);
    printf("error\n");
}
#endif /* YYDEBUG_SHIFT_ERROR_LEXEME */
#endif /* YYDEBUG */
int
yyparse()
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register char *yys;
    extern char *getenv();

    if (yys = getenv("YYDEBUG"))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if (yyn = yydefred[yystate]) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            if (5 > yydebug)
                printf("yydebug: state %d, reading %d (%s)\n", yystate,
                        yychar, yys);
            else
                YYDEBUG_LOOK_AHEAD(yystate, yychar, yys, yyssp-yyss);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            if (5 > yydebug)
                printf("yydebug: state %d, shifting to state %d\n",
                        yystate, yytable[yyn]);
            else
                YYDEBUG_SHIFT_LEXEME(yystate, yytable[yyn], yys, yyssp-yyss);
#endif
        if (yyssp >= yyss + yystacksize - 1)
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#ifdef lint
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#ifdef lint
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    if (5 > yydebug)
                        printf("yydebug: state %d, error recovery shifting\
 to state %d\n", *yyssp, yytable[yyn]);
                    else
                        YYDEBUG_SHIFT_ERROR_LEXEME(*yyssp, yytable[yyn], yyssp-yyss);
#endif
                if (yyssp >= yyss + yystacksize - 1)
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    if (5 > yydebug)
                        printf("yydebug: error recovery discarding state %d\n",
                            *yyssp);
                    else
                        YYDEBUG_DISCARD_STATE(*yyssp, yyssp-yyss-1);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            if (5 > yydebug)
                printf("yydebug: state %d, error recovery discards token %d (%s)\n",
                    yystate, yychar, yys);
            else 
                YYDEBUG_DISCARD_TOKEN(yystate, yychar, yys, yyssp-yyss);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
#if YYDEBUG
    if (yydebug)
        if (5 > yydebug)
            printf("yydebug: state %d, reducing by rule %d (%s)\n",
                    yystate, yyn, yyrule[yyn]);
        else
            YYDEBUG_REDUCE(yystate, yyn, yyrule[yyn], yyssp-yyss-yym, yym);
#endif
    switch (yyn)
    {
case 1:
#line 351 "t.y"
{ yyval = yyvsp[0] ; }
break;
case 2:
#line 352 "t.y"
{ yyval = yyvsp[0] ; }
break;
case 3:
#line 356 "t.y"
{ yyval = yyvsp[0] ; }
break;
case 4:
#line 357 "t.y"
{ yyval = yyvsp[0] ; }
break;
case 5:
#line 358 "t.y"
{ yyval = yyvsp[0] ; }
break;
case 8:
#line 403 "t.y"
{  yyval = yyvsp[0] ; }
break;
case 9:
#line 404 "t.y"
{ yyval = yyvsp[0] ; }
break;
case 11:
#line 432 "t.y"
{ yyval = yyvsp[0] ; }
break;
case 13:
#line 434 "t.y"
{ yyval = (char *)malloc(sizeof(char)*5);
					  strcpy(yyval,"this") ;
					}
break;
case 14:
#line 437 "t.y"
{ yyval = yyvsp[0] ; }
break;
case 16:
#line 439 "t.y"
{ yyval = Concat3("(",yyvsp[-1],")") ; }
break;
case 23:
#line 487 "t.y"
{ 	yyval = (char *)malloc(sizeof(char)*(9+strlen(yyvsp[0]))) ;
		sprintf(yyval,"operator %s",yyvsp[0]) ;	
	}
break;
case 63:
#line 580 "t.y"
{ yyval = yyvsp[0] ; }
break;
case 64:
#line 582 "t.y"
{	char *temp ;	
		strcpy(SendPe,yyvsp[-1]);
		strcpy(SendChare,yyvsp[-3]) ;
		SendMsgBranchPoss = TRUE ;
		temp = Concat3(yyvsp[-3],"[",yyvsp[-1]) ;
		yyval = Concat2(temp,"]") ;
	  }
break;
case 65:
#line 590 "t.y"
{ yyval = Concat3(yyvsp[-2],"(",")") ; 
	    if ( MakeGraph && ( InsideChareCode || CurrentAggType==CHARE 
				|| CurrentAggType==BRANCHED) )
		Graph_OutputPrivateCall(yyvsp[-2]) ; 
	  }
break;
case 66:
#line 596 "t.y"
{ char *charename, *scopestr, *temp ; 

	    if ( MakeGraph && ( strcmp(yyvsp[-3],"_CK_CreateBoc") == 0 
			        || strcmp(yyvsp[-3],"_CK_CreateChare") == 0)  ) 
		Graph_OutputCreate(yyvsp[-3],LastArg,LastChare,LastEP) ;
	    if ( SendType != -1 ) {
		char *sptr = Mystrstr(OutBuf,yyvsp[-1]) ;
		if ( sptr != NULL ) 
			*sptr = '\0' ;
		else 
			fprintf(stderr,"TRANSLATOR ERROR : %s, line %d : couldnt discard => etc.\n",CurrentFileName,CurrentLine) ;
		FLUSHBUF() ;
	
	    /* Now output the Send functions */
		scopestr = CheckSendError(SendChare,SendEP,yyvsp[-1],SendType,
								&charename) ;
		OutputSend(SendChare,SendEP,yyvsp[-1],SendType,charename,scopestr,
								SendPe) ;

		SendType = -1 ;
	    }
	    else if ( MakeGraph && ( InsideChareCode || CurrentAggType==CHARE 
				     || CurrentAggType==BRANCHED) )
		Graph_OutputPrivateCall(yyvsp[-3]) ; 

	    temp = Concat3(yyvsp[-3],"(",yyvsp[-1]) ;
	    yyval = Concat2(temp,")") ;
	  }
break;
case 67:
#line 625 "t.y"
{StructScope=1;}
break;
case 68:
#line 626 "t.y"
{ yyval = Concat3(yyvsp[-3],".",yyvsp[0]) ;StructScope=0; }
break;
case 69:
#line 627 "t.y"
{StructScope=1;}
break;
case 70:
#line 628 "t.y"
{ if ( strcmp(CurrentSharedHandle,"_CK_NOTACCHANDLE") != 0 ) {
	        int handleindex ;
	        char *sptr = Mystrstr(OutBuf,CurrentSharedHandle) ;

	        if ( sptr != NULL ) 
	            *sptr = '\0' ;
	        else 
	            fprintf(stderr,"TRANSLATOR ERROR in shared object handle use: %s, line %d: \n",CurrentFileName,CurrentLine) ;
	        FLUSHBUF() ;
	        handleindex = SearchHandleTable(AccHandleTable,
				AccHandleTableSize,CurrentSharedHandle) ;
	        if ( handleindex != -1 ) {
	            fprintf(outfile,"((%s *)(_CK_9GetAccDataPtr(_CK_9GetAccDataArea(%s))))",AccHandleTable[handleindex].typestr,CurrentSharedHandle) ;
		    IsAccCall = TRUE ;
	        }
	        else if ( (handleindex = SearchHandleTable(MonoHandleTable,
			      MonoHandleTableSize,CurrentSharedHandle)) != -1 )
	        {   fprintf(outfile,"((%s *)(_CK_9GetMonoDataPtr(_CK_9GetMonoDataArea(%s))))",MonoHandleTable[handleindex].typestr,CurrentSharedHandle) ;
		    IsMonoCall = TRUE ;
	        }
	        else if ( SearchHandleTable(WrOnHandleTable,
				WrOnHandleTableSize,CurrentSharedHandle) != -1)
	       		;  /* action taken at end of this rule */ 
	        else 
	            fprintf(stderr,"TRANSLATOR ERROR: %s, line %d, couldnt find acc/mono handle in table.\n",CurrentFileName,CurrentLine) ;


	        strcat(OutBuf,prevtoken) ; /* prevtoken now is "->" */
	        strcpy(prevtoken,"") ;  
	    }
	  }
break;
case 71:
#line 660 "t.y"
{	char *wovid ;
		StructScope = 0 ;
	        if ( SearchHandleTable(WrOnHandleTable,
				WrOnHandleTableSize,CurrentSharedHandle) != -1 )
		{	if ( strcmp(yyvsp[0],"DerefWriteOnce") != 0 )
				CharmError("writeonce variables have only the DerefWriteOnce method") ;
			else {	
				wovid = Mystrstr(OutBuf,CurrentSharedHandle) ;
				*wovid = '\0' ;
				strcat(OutBuf,"DerefWriteOnce(") ;
				strcat(OutBuf,CurrentSharedHandle) ;
				strcat(OutBuf,")") ;
			/*	strcpy(prevtoken,"") ;	*/
			}
		}
	        strcpy(CurrentSharedHandle,"_CK_NOTACCHANDLE") ;	
	  	yyval = Concat3(yyvsp[-4],"->",yyvsp[0]) ;
	  }
break;
case 72:
#line 679 "t.y"
{ yyval = Concat2(yyvsp[-1],"++") ; }
break;
case 73:
#line 681 "t.y"
{ yyval = Concat2(yyvsp[-1],"--") ; }
break;
case 74:
#line 686 "t.y"
{	char *sptr ; int i ; char str[64] ;
		sptr = Mystrstr(OutBuf,yyvsp[-3]) ;
		if ( sptr != NULL ) 
			*sptr = '\0' ;
		else 
			fprintf(stderr,"TRANSLATOR ERROR : %s, line %d : couldnt discard [LOCAL] etc.\n",CurrentFileName,CurrentLine) ;
	        i = SearchHandleTable(BOCHandleTable,BOCHandleTableSize,yyvsp[-3]) ;
		if ( i == -1 ) {
			fprintf(stderr,"ERROR : %s, line %d : %s is not a branched chare handle.\n",CurrentFileName,CurrentLine,yyvsp[-3]) ;
		}
		sprintf(str,"((%s *)GetBocDataPtr(%s))",BOCHandleTable[i].typestr,yyvsp[-3]);
		strcat(OutBuf,str) ;
		strcpy(prevtoken,"") ;   /* prevtoken is ']' */
		FLUSHBUF() ;

		if ( MakeGraph ) {
			fprintf(graphfile,"CALLBOC %s %s : %s", CurrentChare, 
					CurrentEP, BOCHandleTable[i].typestr) ;
		}
	  }
break;
case 75:
#line 707 "t.y"
{
		if ( MakeGraph ) 
			fprintf(graphfile," %s\n",yyvsp[0]) ;
	  }
break;
case 76:
#line 712 "t.y"
{	if ( !SendMsgBranchPoss ) {
			SendType = SIMPLE ;
			strcpy(SendChare,yyvsp[-1]) ;
		}
		else {
			SendType = BRANCH ;
			SendMsgBranchPoss = FALSE ;
		}
	  }
break;
case 77:
#line 722 "t.y"
{ 	char *sptr ;	
		strcpy(SendEP,yyvsp[0]) ; 
	    	/* discard all the CHARM++ `=>' stuff */
		sptr = Mystrstr(OutBuf,yyvsp[0]) ;
		if ( sptr != NULL ) 
			*sptr = '\0' ;
		sptr = Mystrstr(OutBuf,SendChare) ;
		if ( sptr != NULL ) 
			*sptr = '\0' ;
		else 
			fprintf(stderr,"TRANSLATOR ERROR : %s, line %d : couldnt discard => etc.\n",CurrentFileName,CurrentLine) ;
		strcpy(prevtoken,"") ;
		FLUSHBUF() ;
	  }
break;
case 78:
#line 738 "t.y"
{	strcpy(SendChare,yyvsp[-4]) ;
		SendType = BROADCAST ;
	  }
break;
case 79:
#line 742 "t.y"
{ 	char *sptr ;
		strcpy(SendEP,yyvsp[0]) ; 
	    	/* discard all the CHARM++ `=>' stuff */
		sptr = Mystrstr(OutBuf,yyvsp[0]) ;
		if ( sptr != NULL ) 
			*sptr = '\0' ;
		sptr = Mystrstr(OutBuf,SendChare) ;
		if ( sptr != NULL ) 
			*sptr = '\0' ;
		else 
			fprintf(stderr,"TRANSLATOR ERROR : %s, line %d : couldnt discard => etc.\n",CurrentFileName,CurrentLine) ;
		strcpy(prevtoken,"") ;
		FLUSHBUF() ;
	  }
break;
case 80:
#line 765 "t.y"
{ yyval = Concat3(yyvsp[-2],"(",")") ; }
break;
case 81:
#line 767 "t.y"
{ yyval = Concat3(yyvsp[-2],"(",")") ; }
break;
case 82:
#line 769 "t.y"
{ char *temp ;
	    temp = Concat3(yyvsp[-3],"(",yyvsp[-1]) ;
	    yyval = Concat2(temp,")") ;
	  }
break;
case 83:
#line 774 "t.y"
{ char *temp ;
	    temp = Concat3(yyvsp[-3],"(",yyvsp[-1]) ;
	    yyval = Concat2(temp,")") ;
	  }
break;
case 84:
#line 779 "t.y"
{ char *temp ;
	    temp = Concat3(yyvsp[-3],"(",yyvsp[-1]) ;
	    yyval = Concat2(temp,")") ;
	  }
break;
case 85:
#line 802 "t.y"
{	char *str ;	
		if ( IsMonoCall && strcmp(yyvsp[0],"Update")==0 ) {
		        str=Mystrstr(OutBuf,"Update") ;
			*str = '\0' ;
			strcat(OutBuf,"_CK_Update") ;
		}
		else 
			yyval = yyvsp[0];
		IsMonoCall = FALSE ;
		IsAccCall = FALSE ;
	}
break;
case 90:
#line 821 "t.y"
{ yyval = yyvsp[0] ; /* FLUSHBUF() ;*/ }
break;
case 91:
#line 823 "t.y"
{ yyval = Concat3(yyvsp[-2],",",yyvsp[0]) ; 
	    strcpy(LastArg,yyvsp[0]) ;
	  }
break;
case 92:
#line 830 "t.y"
{ 	yyval = yyvsp[0] ; 
		strcpy(CurrentSharedHandle,"_CK_NOTACCHANDLE") ; 
		SendMsgBranchPoss = FALSE ;
	}
break;
case 93:
#line 834 "t.y"
{ yyval = Concat2("++",yyvsp[0]) ; }
break;
case 94:
#line 835 "t.y"
{ yyval = Concat2("--",yyvsp[0]) ; }
break;
case 95:
#line 836 "t.y"
{ yyval = Concat2(CurrentAsterisk,yyvsp[0]) ; }
break;
case 96:
#line 837 "t.y"
{ yyval = Concat2("-",yyvsp[0]) ; }
break;
case 97:
#line 838 "t.y"
{ yyval = Concat2("+",yyvsp[0]) ; }
break;
case 98:
#line 839 "t.y"
{ yyval = Concat2("~",yyvsp[0]) ; }
break;
case 99:
#line 840 "t.y"
{ yyval = Concat2("!",yyvsp[0]) ; }
break;
case 100:
#line 841 "t.y"
{ yyval = Concat2("sizeof",yyvsp[0]) ; }
break;
case 101:
#line 842 "t.y"
{ char *temp = Concat3("sizeof","(",yyvsp[-1]) ;
					  yyval = Concat2(temp,")") ;
					}
break;
case 102:
#line 845 "t.y"
{ yyval = yyvsp[0] ; }
break;
case 121:
#line 917 "t.y"
{ yyval=yyvsp[0] ; }
break;
case 122:
#line 919 "t.y"
{ char *temp = Concat3("(",yyvsp[-2],")") ; 
	    yyval = Concat2(temp,yyvsp[0]) ;
	  }
break;
case 123:
#line 927 "t.y"
{ yyval=yyvsp[0] ; }
break;
case 129:
#line 943 "t.y"
{ yyval=yyvsp[0] ; }
break;
case 130:
#line 945 "t.y"
{ yyval = Concat3(yyvsp[-2],".*",yyvsp[0]) ; }
break;
case 131:
#line 947 "t.y"
{ yyval = Concat3(yyvsp[-2],"->*",yyvsp[0]) ; }
break;
case 132:
#line 951 "t.y"
{ yyval=yyvsp[0] ; }
break;
case 133:
#line 953 "t.y"
{ yyval = Concat3(yyvsp[-2],"*",yyvsp[0]) ; }
break;
case 134:
#line 955 "t.y"
{ yyval = Concat3(yyvsp[-2],"/",yyvsp[0]) ; }
break;
case 135:
#line 957 "t.y"
{ yyval = Concat3(yyvsp[-2],"%",yyvsp[0]) ; }
break;
case 136:
#line 961 "t.y"
{ yyval=yyvsp[0] ; }
break;
case 137:
#line 963 "t.y"
{ yyval = Concat3(yyvsp[-2],"+",yyvsp[0]) ; }
break;
case 138:
#line 965 "t.y"
{ yyval = Concat3(yyvsp[-2],"-",yyvsp[0]) ; }
break;
case 139:
#line 969 "t.y"
{ yyval=yyvsp[0] ; }
break;
case 140:
#line 971 "t.y"
{ yyval = Concat3(yyvsp[-2],"<<",yyvsp[0]) ; }
break;
case 141:
#line 973 "t.y"
{ yyval = Concat3(yyvsp[-2],">>",yyvsp[0]) ; }
break;
case 142:
#line 977 "t.y"
{ yyval=yyvsp[0] ; }
break;
case 143:
#line 979 "t.y"
{ yyval = Concat3(yyvsp[-2],"<",yyvsp[0]) ; }
break;
case 144:
#line 981 "t.y"
{ yyval = Concat3(yyvsp[-2],">",yyvsp[0]) ; }
break;
case 145:
#line 983 "t.y"
{ yyval = Concat3(yyvsp[-2],"<=",yyvsp[0]) ; }
break;
case 146:
#line 985 "t.y"
{ yyval = Concat3(yyvsp[-2],">=",yyvsp[0]) ; }
break;
case 147:
#line 989 "t.y"
{ yyval=yyvsp[0] ; }
break;
case 148:
#line 991 "t.y"
{ yyval = Concat3(yyvsp[-2],"==",yyvsp[0]) ; }
break;
case 149:
#line 993 "t.y"
{ yyval = Concat3(yyvsp[-2],"!=",yyvsp[0]) ; }
break;
case 150:
#line 997 "t.y"
{ yyval=yyvsp[0] ; }
break;
case 151:
#line 999 "t.y"
{ yyval = Concat3(yyvsp[-2],"&",yyvsp[0]) ; }
break;
case 152:
#line 1003 "t.y"
{ yyval=yyvsp[0] ; }
break;
case 153:
#line 1005 "t.y"
{ yyval = Concat3(yyvsp[-2],"^",yyvsp[0]) ; }
break;
case 154:
#line 1009 "t.y"
{ yyval=yyvsp[0] ; }
break;
case 155:
#line 1011 "t.y"
{ yyval = Concat3(yyvsp[-2],"|",yyvsp[0]) ; }
break;
case 156:
#line 1015 "t.y"
{ yyval=yyvsp[0] ; }
break;
case 157:
#line 1017 "t.y"
{ yyval = Concat3(yyvsp[-2],"&&",yyvsp[0]) ; }
break;
case 158:
#line 1021 "t.y"
{ yyval=yyvsp[0] ; }
break;
case 159:
#line 1023 "t.y"
{ yyval = Concat3(yyvsp[-2],"||",yyvsp[0]) ; }
break;
case 160:
#line 1027 "t.y"
{ yyval=yyvsp[0] ; }
break;
case 161:
#line 1031 "t.y"
{ char *temp = Concat3(yyvsp[-4],"?",yyvsp[-2]) ;
	    yyval = Concat3(temp,":",yyvsp[0]) ;
	  }
break;
case 162:
#line 1037 "t.y"
{ yyval=yyvsp[0] ; }
break;
case 163:
#line 1039 "t.y"
{ yyval = Concat3(yyvsp[-2],CurrentAssOp,yyvsp[0]) ; }
break;
case 164:
#line 1043 "t.y"
{ yyval = yyvsp[0] ; strcpy(CurrentAssOp,"=") ;}
break;
case 165:
#line 1044 "t.y"
{ yyval = yyvsp[0] ; strcpy(CurrentAssOp,"*=") ;}
break;
case 166:
#line 1045 "t.y"
{ yyval = yyvsp[0] ; strcpy(CurrentAssOp,"/=") ;}
break;
case 167:
#line 1046 "t.y"
{ yyval = yyvsp[0] ; strcpy(CurrentAssOp,"%=") ;}
break;
case 168:
#line 1047 "t.y"
{ yyval = yyvsp[0] ; strcpy(CurrentAssOp,"+=") ;}
break;
case 169:
#line 1048 "t.y"
{ yyval = yyvsp[0] ; strcpy(CurrentAssOp,"-=") ;}
break;
case 170:
#line 1049 "t.y"
{ yyval = yyvsp[0] ; strcpy(CurrentAssOp,"<<=") ;}
break;
case 171:
#line 1050 "t.y"
{ yyval = yyvsp[0] ; strcpy(CurrentAssOp,">>=") ;}
break;
case 172:
#line 1051 "t.y"
{ yyval = yyvsp[0] ; strcpy(CurrentAssOp,"&=") ;}
break;
case 173:
#line 1052 "t.y"
{ yyval = yyvsp[0] ; strcpy(CurrentAssOp,"^=") ;}
break;
case 174:
#line 1053 "t.y"
{ yyval = yyvsp[0] ; strcpy(CurrentAssOp,"|=") ;}
break;
case 175:
#line 1057 "t.y"
{ yyval=yyvsp[0] ; }
break;
case 176:
#line 1059 "t.y"
{ yyval = Concat3(yyvsp[-2],",",yyvsp[0]) ; }
break;
case 180:
#line 1089 "t.y"
{ 	
		strcpy(CurrentDeclType,"") ;
		FoundReadOnly = FALSE ;
	  }
break;
case 181:
#line 1095 "t.y"
{ 	
		strcpy(CurrentDeclType,"") ;
		FoundReadOnly = FALSE ;
	  }
break;
case 182:
#line 1099 "t.y"
{ /* this is constraint error, as it
                                        includes a storage class!?!*/ }
break;
case 185:
#line 1103 "t.y"
{ FLUSHBUF() ; }
break;
case 186:
#line 1127 "t.y"
{}
break;
case 188:
#line 1128 "t.y"
{}
break;
case 190:
#line 1129 "t.y"
{}
break;
case 195:
#line 1143 "t.y"
{	strcpy(CurrentDeclType,yyvsp[-1]) ;
		if ( CurrentStorage == TYPEDEF ) {
			InsertSymTable(yyvsp[0]) ;
			CurrentStorage = -1 ;
		}
		else if ( CurrentStorage == EXTERN && CurrentScope == 0 
			  && FoundParms )
			InsertFunctionTable(yyvsp[0],FALSE) ;
		else if ( FoundReadOnly ) {
			if ( FoundInMsgTable(yyvsp[-1]) != -1 )
                        	CurrentAggType = READMSG ;
                	else
                        	CurrentAggType = READONLY ;
                	InsertObjTable(yyvsp[0]) ;
		}
	}
break;
case 197:
#line 1161 "t.y"
{	strcpy(CurrentDeclType,yyvsp[-1]) ; 
		if ( FoundReadOnly ) {
			if ( FoundInMsgTable(yyvsp[-1]) != -1 )
                        	CurrentAggType = READMSG ;
                	else
                        	CurrentAggType = READONLY ;
                	InsertObjTable(yyvsp[0]) ;
		}
	  }
break;
case 199:
#line 1171 "t.y"
{strcpy(CurrentDeclType,yyvsp[-1]) ;}
break;
case 201:
#line 1173 "t.y"
{	strcpy(CurrentDeclType,yyvsp[-1]) ;
	  	if ( strcmp(yyvsp[-1],"table")==0 ) {
			CurrentAggType = DTABLE ;
                	InsertObjTable(yyvsp[0]) ;
		}
	  }
break;
case 203:
#line 1181 "t.y"
{strcpy(CurrentDeclType,yyvsp[-1]) ;}
break;
case 205:
#line 1183 "t.y"
{	if ( FoundReadOnly ) {
			if ( FoundInMsgTable(CurrentDeclType) != -1 )
                        	CurrentAggType = READMSG ;
                	else
                        	CurrentAggType = READONLY ;
                	InsertObjTable(yyvsp[0]) ;
		}
	  	else if ( strcmp(CurrentDeclType,"table")==0 ) {
                        CurrentAggType = DTABLE ;
                	InsertObjTable(yyvsp[0]) ;
		}
	  }
break;
case 235:
#line 1296 "t.y"
{yyval=yyvsp[0];}
break;
case 236:
#line 1298 "t.y"
{ yyval = (char *)malloc(sizeof(char)*2) ;
	    strcpy(yyval,"") ; 
          }
break;
case 237:
#line 1301 "t.y"
{yyval=yyvsp[0];}
break;
case 238:
#line 1305 "t.y"
{yyval = yyvsp[0];}
break;
case 241:
#line 1308 "t.y"
{yyval = yyvsp[0];}
break;
case 251:
#line 1331 "t.y"
{ if ( CurrentScope > 0 ) 
		CharmError("readonly variables allowed only at file scope") ;
	  else 
		FoundReadOnly = TRUE ;
	}
break;
case 252:
#line 1339 "t.y"
{ yyval = yyvsp[0] ; }
break;
case 253:
#line 1340 "t.y"
{ yyval = yyvsp[-1] ; }
break;
case 254:
#line 1341 "t.y"
{ yyval = yyvsp[-1] ; }
break;
case 255:
#line 1342 "t.y"
{ yyval = yyvsp[-1] ; }
break;
case 256:
#line 1343 "t.y"
{ yyval = yyvsp[-1] ; }
break;
case 257:
#line 1348 "t.y"
{ yyval = yyvsp[-1] ; }
break;
case 258:
#line 1349 "t.y"
{ yyval = yyvsp[-1] ; }
break;
case 259:
#line 1350 "t.y"
{ yyval = yyvsp[-1] ; }
break;
case 260:
#line 1351 "t.y"
{ yyval = yyvsp[-1] ; }
break;
case 261:
#line 1352 "t.y"
{ yyval = yyvsp[-1] ; }
break;
case 273:
#line 1376 "t.y"
{ yyval = yyvsp[0]; }
break;
case 274:
#line 1377 "t.y"
{ yyval = yyvsp[0]; }
break;
case 275:
#line 1378 "t.y"
{ yyval = yyvsp[-1]; }
break;
case 276:
#line 1379 "t.y"
{ yyval = yyvsp[-1]; }
break;
case 277:
#line 1380 "t.y"
{ yyval = yyvsp[-1]; }
break;
case 278:
#line 1381 "t.y"
{ yyval = yyvsp[-1]; }
break;
case 279:
#line 1385 "t.y"
{ yyval = yyvsp[0] ; }
break;
case 280:
#line 1386 "t.y"
{ yyval = yyvsp[0] ; }
break;
case 281:
#line 1388 "t.y"
{ yyval = yyvsp[-1] ; }
break;
case 282:
#line 1389 "t.y"
{ yyval = yyvsp[-1] ; }
break;
case 283:
#line 1391 "t.y"
{ yyval = yyvsp[-1] ; }
break;
case 284:
#line 1420 "t.y"
{ CurrentStorage = EXTERN ; }
break;
case 285:
#line 1421 "t.y"
{ CurrentStorage = TYPEDEF ; }
break;
case 286:
#line 1422 "t.y"
{ CurrentStorage = STATIC ; }
break;
case 287:
#line 1423 "t.y"
{ CurrentStorage = AUTO ; }
break;
case 288:
#line 1424 "t.y"
{ CurrentStorage = REGISTER ; }
break;
case 289:
#line 1425 "t.y"
{ CurrentStorage = FRIEND ; }
break;
case 290:
#line 1426 "t.y"
{ CurrentStorage = OVERLOAD ; }
break;
case 291:
#line 1427 "t.y"
{ CurrentStorage = INLINE ; }
break;
case 292:
#line 1428 "t.y"
{ CurrentStorage = INLINE ; }
break;
case 293:
#line 1429 "t.y"
{ CurrentStorage = VIRTUAL ; }
break;
case 294:
#line 1433 "t.y"
{ yyval = (char *)malloc(4) ; 
			  strcpy(yyval,"int") ;	   }
break;
case 295:
#line 1435 "t.y"
{ yyval = (char *)malloc(5) ; 
			  strcpy(yyval,"char") ;	   }
break;
case 296:
#line 1437 "t.y"
{ yyval = (char *)malloc(6) ; 
			  strcpy(yyval,"short") ;	   }
break;
case 297:
#line 1439 "t.y"
{ yyval = (char *)malloc(5) ; 
			  strcpy(yyval,"long") ;	   }
break;
case 298:
#line 1441 "t.y"
{ yyval = (char *)malloc(6) ; 
			  strcpy(yyval,"float") ;	   }
break;
case 299:
#line 1443 "t.y"
{ yyval = (char *)malloc(10) ; 
			  strcpy(yyval,"__wchar_t") ; }
break;
case 300:
#line 1445 "t.y"
{ yyval = (char *)malloc(7) ; 
			  strcpy(yyval,"double") ;	   }
break;
case 301:
#line 1447 "t.y"
{ yyval = (char *)malloc(7) ; 
			  strcpy(yyval,"signed") ;	   }
break;
case 302:
#line 1449 "t.y"
{ yyval = (char *)malloc(9) ; 
			  strcpy(yyval,"unsigned") ;  }
break;
case 303:
#line 1451 "t.y"
{ yyval = (char *)malloc(5) ; 
			  strcpy(yyval,"void") ;	   }
break;
case 308:
#line 1480 "t.y"
{	if ( CurrentAggType == CHARE ) {
			FLUSHBUF() ;	
			if ( numparents == 0  )
                        	fprintf(outfile," : public _CK_Object ") ;
		}
	 	else if ( CurrentAggType == BRANCHED ) {
			FLUSHBUF() ;	
			if ( numparents == 0  )
                        	fprintf(outfile," : public _CK_BOC ") ;
		}
	 	else if ( CurrentAggType == ACCUMULATOR ) {
			FLUSHBUF() ;	
			if ( numparents == 0  )
                        	fprintf(outfile," : public _CK_Accumulator ") ;
		}
	 	else if ( CurrentAggType == MONOTONIC ) {
			FLUSHBUF() ;	
			if ( numparents == 0  )
                        	fprintf(outfile," : public _CK_Monotonic ") ;
		}
	}
break;
case 309:
#line 1502 "t.y"
{	int num, i ;	
		ChareInfo *chare ;
		char *mymsg ;
		char *myacc ;

		FLUSHBUF() ;
		
		if ( CurrentAggType == CHARE || CurrentAggType == BRANCHED )
		{	
			if ( shouldprint ) fprintf(outfile,"%s",prevtoken) ;
			strcpy(prevtoken,"") ;

			if ( numparents == 0 ) {
			    if ( CurrentAggType == CHARE )
			    	fprintf(outfile,"\n\tpublic: %s(MAGIC_NUMBER_TYPE mn) : _CK_Object(mn) {}\n",CurrentChare) ;   
			    else
			    	fprintf(outfile,"\n\tpublic: %s(MAGIC_NUMBER_TYPE mn) : _CK_BOC(mn) {}\n",CurrentChare) ;   
			}
			else {
			    fprintf(outfile,"\n\tpublic: %s(MAGIC_NUMBER_TYPE mn) : ",CurrentChare) ;   
			    for ( i=0; i<numparents-1; i++ ) 
				fprintf(outfile,"%s(mn), ",ParentArray[i]) ;
			    fprintf(outfile,"%s(mn) {}\n",
						   ParentArray[numparents-1]) ;
			}
			if ( strcmp(CurrentChare,"main") != 0 )
			    fprintf(outfile,"\n\t        %s() {}\n",CurrentChare) ;   
			fprintf(outfile,"private:\n") ;
			fprintf(outfile,"#line %d \"%s\"\n",CurrentLine,CurrentFileName) ;
			 
			if ( CurrentAggType == CHARE )
		        	chare = ChareTable[FoundInChareTable(ChareTable,charecount+1,CurrentChare)] ;
			else
		        	chare = BOCTable[FoundInChareTable(BOCTable,boccount+1,CurrentChare)] ;

			for ( i=0; i<numparents; i++ ) {
			    if ( CurrentAggType == CHARE )
				InsertParent(chare,ParentArray[i],ChareTable,charecount+1) ;
			    else
				InsertParent(chare,ParentArray[i],BOCTable,boccount+1) ;
			}
			AddInheritedEps(chare) ;
		}	
		numparents = 0 ; /* so that sequential class derivations dont
				    affect us */

		CurrentAccess = PRIVATE ;
	}
break;
case 310:
#line 1550 "t.y"
{ FillPermanentAggTable(yyvsp[-5]) ; }
break;
case 311:
#line 1552 "t.y"
{   FLUSHBUF() ;	
	    if ( CurrentAggType == ACCUMULATOR || CurrentAggType == MONOTONIC )
	    {   if ( !FilledAccMsg ) 
	    	    CharmError("Unable to detect message in accumulator/monotonic class") ;
	        else {
	    	    fprintf(outfile,"\npublic:void * _CK_GetMsgPtr() {\n");
	    	    fprintf(outfile,"\t\treturn((void *)%s) ;\n\t}\n",
							     CurrentAcc->msg) ;
	    	    if ( CurrentAggType == ACCUMULATOR ) {
	    	    	fprintf(outfile,"\n       void _CK_Combine(void *msg) {\n");
	    	    	fprintf(outfile,"\t\tCombine((%s *)msg) ;\n\t}\n",
							 CurrentAcc->msgtype) ;
	    	    }
	    	    else { /*  MONOTONIC  */
	    	    	fprintf(outfile,"\n       void _CK_SysUpdate(void *msg) {\n");
	    	    	fprintf(outfile,"\t\tUpdate((%s *)msg) ;\n\t}\n",
							 CurrentAcc->msgtype) ;
	    	    	fprintf(outfile,"\n       %s *MonoValue() {\n",
							 CurrentAcc->msgtype) ;
	    	    	fprintf(outfile,"\t\treturn( (%s *)(::MonoValue(_CK_MyId)) ) ;\n\t}\n",CurrentAcc->msgtype) ;


	    	    	fprintf(outfile,"\n      int _CK_Update(%s *msg) {\n",
							 CurrentAcc->msgtype) ;
	    	    	fprintf(outfile,"\t\tint v ;\n") ;
			fprintf(outfile,"\t\t_CK_9LockMonoDataArea(_CK_9GetMonoDataArea(_CK_MyId)) ;\n") ;
			fprintf(outfile,"\t\tv = Update(msg) ;\n") ;
			fprintf(outfile,"\t\t_CK_9UnlockMonoDataArea(_CK_9GetMonoDataArea(_CK_MyId)) ;\n") ;
			fprintf(outfile,"\t\tif ( v )\n") ;
	    	    	fprintf(outfile,"\t\t\t_CK_BroadcastMono((void *)%s,_CK_MyId) ;\n",CurrentAcc->msg) ;
	    	    	fprintf(outfile,"\t\treturn v ;\n\t}\n") ;

	    	    }
	    	    fprintf(outfile,"#line %d \"%s\"\n",CurrentLine,CurrentFileName) ;
	        }
	    }
	    else if ( CurrentAggType == MESSAGE && 
				     MessageTable[TotalMsgs-1].numvarsize!=0 ) 
	    { /* Output the pack and unpack and alloc functions for varSize */
		int i ;

		MsgStruct *thismsg = &(MessageTable[TotalMsgs-1]) ;
		VarSizeStruct *vs = thismsg->varsizearray ;

		fprintf(outfile,"\nvoid *pack(int *length) \n\t{\n") ;

	      /*fprintf(outfile,"\n\t*length = _CK_3GetSizeOfMsg(this) ;\n");
		the length (size) parm is no longer used in the PACK macro
		in common/headers/communication.h : Sanjeev, 1 Sep 94 */
		fprintf(outfile,"\n\t*length = 0 ;\n") ;

		for ( i=0; i<thismsg->numvarsize; i++ ) 
			fprintf(outfile,"\n\t%s = (%s *) ((char *)%s - ((char *)&(%s)));\n",vs[i].name,vs[i].type,vs[i].name,vs[i].name) ;
		fprintf(outfile,"\treturn((void *)this) ;\n}\n") ;

		fprintf(outfile,"\nvoid unpack() \n\t{\n") ;
		for ( i=0; i<thismsg->numvarsize; i++ ) 
			fprintf(outfile,"\n\t%s = (%s *) ((char *)(&%s) + (int)(%s));\n",vs[i].name,vs[i].type,vs[i].name,vs[i].name) ;
		fprintf(outfile,"}\n") ;
	    	fprintf(outfile,"#line %d \"%s\"\n",CurrentLine,CurrentFileName) ;
	    }
		
		
	    CurrentAggType = -1 ; 
	    CurrentAccess = -1 ; 
	    strcpy(CurrentAggName,"") ;
	    strcpy(CurrentChare,"_CK_NOTACHARE") ;
	    CurrentCharePtr = NULL ;
	    InsideChareCode = 0 ;
	}
break;
case 313:
#line 1641 "t.y"
{	strcpy(CurrentAggName,yyvsp[0]);
	   	InsertSymTable(yyvsp[0]) ;
	   	InsertObjTable(yyvsp[0]) ;
	   	yyval = yyvsp[0] ;
	  }
break;
case 314:
#line 1647 "t.y"
{	if ( AddedScope > 0 ) {
			PopStack() ;	
			AddedScope = 0 ;
		}
		strcpy(CurrentAggName,yyvsp[0]);
	     	InsertSymTable(yyvsp[0]) ;
	     	InsertObjTable(yyvsp[0]) ;
	     	yyval = yyvsp[0] ;
	  }
break;
case 315:
#line 1657 "t.y"
{	strcpy(CurrentAggName,yyvsp[0]);
	    	InsertSymTable(yyvsp[0]) ;
	     	InsertObjTable(yyvsp[0]) ;
	     	yyval = yyvsp[0] ;
	  }
break;
case 316:
#line 1663 "t.y"
{	if ( AddedScope > 0 ) {
			PopStack() ;	
			AddedScope = 0 ;
		}
	  	strcpy(CurrentAggName,yyvsp[0]);
	     	InsertSymTable(yyvsp[0]) ;
	     	InsertObjTable(yyvsp[0]) ;
	     	yyval = yyvsp[0] ;
	  }
break;
case 319:
#line 1677 "t.y"
{FLUSHBUF(); SyntaxError("class defn header");}
break;
case 320:
#line 1682 "t.y"
{	ParentArray[numparents] = (char *)malloc(strlen(yyvsp[0])+1) ;
		strcpy(ParentArray[numparents],yyvsp[0]) ;
		numparents++ ;
	}
break;
case 321:
#line 1687 "t.y"
{	ParentArray[numparents] = (char *)malloc(strlen(yyvsp[0])+1) ;
		strcpy(ParentArray[numparents],yyvsp[0]) ;
		numparents++ ;
	}
break;
case 322:
#line 1694 "t.y"
{yyval=yyvsp[0];}
break;
case 323:
#line 1695 "t.y"
{yyval=yyvsp[0];}
break;
case 324:
#line 1696 "t.y"
{yyval=yyvsp[0];}
break;
case 329:
#line 1710 "t.y"
{ CurrentAccess = PUBLIC ; }
break;
case 330:
#line 1711 "t.y"
{ CurrentAccess = PRIVATE ; }
break;
case 331:
#line 1712 "t.y"
{ CurrentAccess = PROTECTED ; }
break;
case 332:
#line 1713 "t.y"
{ CurrentAccess = ENTRY ; }
break;
case 333:
#line 1717 "t.y"
{ CurrentAggType = STRUCT ; }
break;
case 334:
#line 1718 "t.y"
{ CurrentAggType = UNION ; }
break;
case 335:
#line 1719 "t.y"
{ CurrentAggType = CLASS ; }
break;
case 336:
#line 1720 "t.y"
{ CurrentAggType = CHARE ; }
break;
case 337:
#line 1721 "t.y"
{ CurrentAggType = BRANCHED ; }
break;
case 338:
#line 1722 "t.y"
{ CurrentAggType = MESSAGE ; }
break;
case 339:
#line 1723 "t.y"
{ CurrentAggType = ACCUMULATOR ; 
				  FilledAccMsg=FALSE; }
break;
case 340:
#line 1725 "t.y"
{ CurrentAggType = MONOTONIC ; 
				  FilledAccMsg=FALSE; }
break;
case 342:
#line 1738 "t.y"
{ FLUSHBUF() ;}
break;
case 343:
#line 1742 "t.y"
{ strcpy(CurrentDeclType,"") ;}
break;
case 344:
#line 1743 "t.y"
{ strcpy(CurrentDeclType,"") ;}
break;
case 359:
#line 1786 "t.y"
{strcpy(CurrentDeclType,yyvsp[-2]) ;	
	   if (FoundParms&&(CurrentAggType==CHARE||CurrentAggType==BRANCHED)) {
		if ( CurrentAccess == PRIVATE || CurrentAccess == PUBLIC )
		    ProcessFn(yyvsp[-1]) ;
	   }
	  }
break;
case 360:
#line 1793 "t.y"
{int ind ;
	   if ( FoundParms ) {
	     if (CurrentAggType==CHARE || CurrentAggType==BRANCHED) {
		if ( CurrentAccess == ENTRY )
		    ProcessEP(yyvsp[0],FALSE);
		else if ( CurrentAccess == PRIVATE||CurrentAccess == PUBLIC ) 
	   	    ProcessFn(yyvsp[0]) ;
	     }
	     else if ( CurrentAggType == MESSAGE ) {
		if ( strcmp(yyvsp[0],"pack")==0 || strcmp(yyvsp[0],"unpack")==0 ) {
		    if ( (ind=FoundInMsgTable(CurrentAggName)) != -1 )
			MessageTable[ind].pack = TRUE ;	
		    else 
		    	CharmError("TRANSLATOR : did not find message type in message table") ;
		}			
		else 
			CharmError("Messages are allowed to have only pack or unpack functions") ;
	     }
	     FoundParms = FALSE ;
	   }
	   else if ( CurrentAggType == MESSAGE && FoundVarSize ) {
		char *varname = Mystrstr(OutBuf,yyvsp[0]) ;
		*varname = '*' ;
		*(varname+1) = '\0' ;
		strcat(OutBuf,yyvsp[0]) ;
	  	
		InsertVarSize(yyvsp[-1],yyvsp[0]) ;
		FoundVarSize = FALSE ;
	   } 
	  }
break;
case 362:
#line 1826 "t.y"
{strcpy(CurrentDeclType,yyvsp[-2]) ;	
	   if (FoundParms&&(CurrentAggType==CHARE||CurrentAggType==BRANCHED)) {
		if ( CurrentAccess == PRIVATE || CurrentAccess == PUBLIC )
		    ProcessFn(yyvsp[-1]) ;
	   }
	  }
break;
case 371:
#line 1853 "t.y"
{ if ( (CurrentAggType==ACCUMULATOR || CurrentAggType==MONOTONIC) 
		&& !FilledAccMsg ) 
	  {	CurrentAcc->msgtype = (char *)malloc((strlen(yyvsp[-2])+1)*sizeof(char));
        	strcpy(CurrentAcc->msgtype,yyvsp[-2]) ;	

		CurrentAcc->msg = (char *)malloc((strlen(yyvsp[-1])+1)*sizeof(char)) ;
        	strcpy(CurrentAcc->msg,yyvsp[-1]) ;	
		FilledAccMsg = TRUE ;
	  }
	  else if ( CurrentAggType == MESSAGE && FoundVarSize ) {
		char *varname = Mystrstr(OutBuf,yyvsp[-1]) ;
		*varname = '*' ;
		*(varname+1) = '\0' ;
		strcat(OutBuf,yyvsp[-1]) ;
	  	
		InsertVarSize(yyvsp[-2],yyvsp[-1]) ;
		FoundVarSize = FALSE ;
	  } 
	  strcpy(CurrentDeclType,yyvsp[-2]) ;
	}
break;
case 372:
#line 1875 "t.y"
{	strcpy(CurrentDeclType,yyvsp[-2]) ;  	}
break;
case 373:
#line 1877 "t.y"
{     strcpy(CurrentDeclType,yyvsp[-2]) ;    }
break;
case 374:
#line 1880 "t.y"
{     strcpy(CurrentDeclType,yyvsp[-2]) ;    
		if ( CurrentStorage == TYPEDEF ) {
			InsertSymTable(yyvsp[-1]) ;
			CurrentStorage = -1 ;
		}
	   	else if ( FoundParms ) {
			if (CurrentAggType==CHARE || CurrentAggType==BRANCHED){
				if ( CurrentAccess == ENTRY ) {
		    			ProcessEP(yyvsp[-1],FALSE);
				}
				else if ( CurrentAccess == PRIVATE || 
				  	  CurrentAccess == PUBLIC )
		    			ProcessFn(yyvsp[-1]) ;
			}	
	     		FoundParms = FALSE ;
	   	}
	  }
break;
case 375:
#line 1898 "t.y"
{     strcpy(CurrentDeclType,yyvsp[-2]) ;    }
break;
case 376:
#line 1900 "t.y"
{     strcpy(CurrentDeclType,yyvsp[-2]) ;    }
break;
case 402:
#line 1992 "t.y"
{}
break;
case 405:
#line 2005 "t.y"
{}
break;
case 409:
#line 2025 "t.y"
{ InsertSymTable(yyvsp[0]) ; }
break;
case 421:
#line 2071 "t.y"
{ 	EpMsg=yyvsp[-2]; 
	  }
break;
case 455:
#line 2207 "t.y"
{ 	EpMsg=yyvsp[-1]; 
		strcpy(CurrentMsgParm,yyvsp[-1]) ;
	  }
break;
case 456:
#line 2211 "t.y"
{ 	EpMsg=yyvsp[-1]; 
		strcpy(CurrentMsgParm,yyvsp[-1]) ;
	  }
break;
case 462:
#line 2224 "t.y"
{ yyval = yyvsp[0] ; }
break;
case 488:
#line 2281 "t.y"
{	if ( FoundAccFnDef ) {
			strcat(OutBuf,prevtoken) ;
			strcpy(prevtoken,"") ;
			FLUSHBUF() ;
			fprintf(outfile,"\n_CK_9LockAccDataArea(_CK_9GetAccDataArea(_CK_MyId)) ;\n") ;
			fprintf(outfile,"#line %d \"%s\"\n",CurrentLine,CurrentFileName) ;
			AccFnScope = CurrentScope ;
			FoundAccFnDef = FALSE ;
		}
	}
break;
case 489:
#line 2292 "t.y"
{ 	if ( AccFnScope == CurrentScope+1 ) {
		/* +1 because the '}' has already been lexed at this point */
			FLUSHBUF() ;
			fprintf(outfile,"\n_CK_9UnlockAccDataArea(_CK_9GetAccDataArea(_CK_MyId)) ;\n") ;
			fprintf(outfile,"#line %d \"%s\"\n",CurrentLine,CurrentFileName) ;
			AccFnScope = -1 ;
		}
	}
break;
case 490:
#line 2300 "t.y"
{ FLUSHBUF() ; }
break;
case 491:
#line 2309 "t.y"
{ FLUSHBUF() ; }
break;
case 492:
#line 2310 "t.y"
{ FLUSHBUF() ; }
break;
case 494:
#line 2315 "t.y"
{ FLUSHBUF() ; }
break;
case 499:
#line 2329 "t.y"
{ FLUSHBUF(); }
break;
case 500:
#line 2330 "t.y"
{ FLUSHBUF(); 
			  SyntaxError("if/switch condition") ;}
break;
case 501:
#line 2335 "t.y"
{FLUSHBUF();}
break;
case 503:
#line 2336 "t.y"
{ FLUSHBUF() ; 
				  SyntaxError("while loop condition");}
break;
case 506:
#line 2341 "t.y"
{ FLUSHBUF() ; 
				    SyntaxError("do loop condition"); }
break;
case 508:
#line 2346 "t.y"
{FLUSHBUF();}
break;
case 511:
#line 2350 "t.y"
{ FLUSHBUF() ; 
				  SyntaxError("for loop header") ; }
break;
case 520:
#line 2376 "t.y"
{ FLUSHBUF() ; 
						  strcpy(CurrentAggName,"") ;
						}
break;
case 527:
#line 2388 "t.y"
{	
	    	if ( FoundLBrace ) 
			FoundLBrace = 0 ;
	  }
break;
case 528:
#line 2393 "t.y"
{
	    	if ( FoundRBrace ) 
			FoundRBrace = 0 ;
	  }
break;
case 533:
#line 2422 "t.y"
{ InsertFunctionTable(yyvsp[0],TRUE) ; }
break;
case 536:
#line 2447 "t.y"
{	AddScope(yyvsp[0]) ;	}
break;
case 537:
#line 2449 "t.y"
{ RemoveScope(yyvsp[-2]) ; yyval = yyvsp[-2] ;
	    if (CurrentAggType==CHARE || CurrentAggType==BRANCHED) {
		if ( CurrentAccess == PRIVATE || CurrentAccess == PUBLIC )
		    ProcessFn(yyvsp[-2]) ;
	    }
	  }
break;
case 538:
#line 2456 "t.y"
{if ( CurrentAggType==CHARE || CurrentAggType==BRANCHED ) {
                if ( CurrentAccess == ENTRY )
                        ProcessEP(yyvsp[0],TRUE);
		else if ( CurrentAccess == PRIVATE || CurrentAccess == PUBLIC )
			ProcessFn(yyvsp[0]) ;
		InsideChareCode = 1 ;
	   }
	   else 
		SetDefinedIfEp(yyvsp[0]) ;
	   AddScope(yyvsp[0]) ;		
	  }
break;
case 539:
#line 2468 "t.y"
{ RemoveScope(yyvsp[-2]) ; 
	    yyval = yyvsp[-2] ;
	    InsideChareCode = 0 ;
	  }
break;
case 540:
#line 2472 "t.y"
{ FLUSHBUF() ; 
			  	  	  SyntaxError("function header") ; }
break;
case 542:
#line 2477 "t.y"
{       AddScope(yyvsp[0]) ;  }
break;
case 543:
#line 2479 "t.y"
{ RemoveScope(yyvsp[-2]) ; 
	    yyval = yyvsp[-2] ;
	  }
break;
case 544:
#line 2484 "t.y"
{int ind ;
	   if ( CurrentAggType==CHARE || CurrentAggType==BRANCHED ) {
		if ( CurrentAccess == ENTRY )
			ProcessEP(yyvsp[0],TRUE);
		else if ( CurrentAccess == PRIVATE || CurrentAccess == PUBLIC )
			ProcessFn(yyvsp[0]) ;
		InsideChareCode = 1 ;
	   }
	   else if ( CurrentAggType == MESSAGE ) {
		if ( strcmp(yyvsp[0],"pack")==0 || strcmp(yyvsp[0],"unpack")==0 ) {
			if ( (ind=FoundInMsgTable(CurrentAggName)) != -1 )
				MessageTable[ind].pack = TRUE ;	
			else 
				CharmError("TRANSLATOR : did not find message type in message table") ;
		}			
		else 
			CharmError("Messages are allowed to have only pack or unpack functions") ;
	   }
	   else if ( CurrentAggType == ACCUMULATOR ) {
		if ( strcmp(yyvsp[0],"Accumulate")==0 && strcmp(yyvsp[-1],"void")==0 ) 
			FoundAccFnDef = TRUE ;
	   }
	   else 
		SetDefinedIfEp(yyvsp[0]) ;
	   FLUSHBUF() ;
	   AddScope(yyvsp[0]) ;		
	  }
break;
case 545:
#line 2512 "t.y"
{ RemoveScope(yyvsp[-2]) ; 
	    yyval = yyvsp[-2] ;
	    InsideChareCode = 0 ;
	  }
break;
case 546:
#line 2517 "t.y"
{ FLUSHBUF() ; 
			  	  SyntaxError("function header") ; }
break;
case 548:
#line 2522 "t.y"
{AddScope(yyvsp[0]) ;}
break;
case 549:
#line 2523 "t.y"
{ RemoveScope(yyvsp[-2]) ; 
	    yyval = yyvsp[-2] ;
	  }
break;
case 550:
#line 2527 "t.y"
{AddScope(yyvsp[0]) ;}
break;
case 551:
#line 2528 "t.y"
{ RemoveScope(yyvsp[-2]) ; 
	    yyval = yyvsp[-2] ;
	  }
break;
case 552:
#line 2532 "t.y"
{AddScope(yyvsp[0]) ;}
break;
case 553:
#line 2533 "t.y"
{ RemoveScope(yyvsp[-2]) ; 
	    yyval = yyvsp[-2] ;
	  }
break;
case 554:
#line 2537 "t.y"
{AddScope(yyvsp[0]) ;}
break;
case 555:
#line 2538 "t.y"
{ RemoveScope(yyvsp[-2]) ; 
	    yyval = yyvsp[-2] ;
	  }
break;
case 556:
#line 2551 "t.y"
{}
break;
case 558:
#line 2552 "t.y"
{}
break;
case 560:
#line 2553 "t.y"
{}
break;
case 562:
#line 2554 "t.y"
{}
break;
case 564:
#line 2555 "t.y"
{}
break;
case 566:
#line 2556 "t.y"
{}
break;
case 568:
#line 2557 "t.y"
{}
break;
case 570:
#line 2558 "t.y"
{}
break;
case 574:
#line 2589 "t.y"
{	int ind ;	

		SetDefinedIfEp(yyvsp[-2]) ;
	   	CheckConstructorEP(yyvsp[-2],TRUE) ; 

		if ( (ind=FoundInAccTable(AccTable,TotalAccs,yyvsp[-2])) != -1 ) {
		/* This is an Accumulator constructor */
			AccTable[ind]->initmsgtype = (char *)malloc((strlen(CurrentMsgParm)+1)*sizeof(char)) ;
			strcpy(AccTable[ind]->initmsgtype,CurrentMsgParm) ;
			AccTable[ind]->defined = 1 ;
		}
		else if ( (ind=FoundInAccTable(MonoTable,TotalMonos,yyvsp[-2])) != -1 ) {
		/* This is a Monotonic constructor */
			MonoTable[ind]->initmsgtype = (char *)malloc((strlen(CurrentMsgParm)+1)*sizeof(char)) ;
			strcpy(MonoTable[ind]->initmsgtype,CurrentMsgParm) ;
			MonoTable[ind]->defined = 1 ;
		}
	}
break;
case 579:
#line 2645 "t.y"
{ 	foundargs = FALSE ; }
break;
case 580:
#line 2647 "t.y"
{	int ind ;	

		if ( (ind=FoundInAccTable(AccTable,TotalAccs,yyvsp[-1])) != -1 ) {
		/* This is an Accumulator constructor */
			AccTable[ind]->initmsgtype = (char *)malloc((strlen(CurrentMsgParm)+1)*sizeof(char)) ;
			strcpy(AccTable[ind]->initmsgtype,CurrentMsgParm) ;
			AccTable[ind]->defined = FoundConstructorBody ;
		}
		else if ( (ind=FoundInAccTable(MonoTable,TotalMonos,yyvsp[-1])) != -1 ) {
		/* This is a Monotonic constructor */
			MonoTable[ind]->initmsgtype = (char *)malloc((strlen(CurrentMsgParm)+1)*sizeof(char)) ;
			strcpy(MonoTable[ind]->initmsgtype,CurrentMsgParm) ;
			MonoTable[ind]->defined = FoundConstructorBody ;
		}

		foundargs = FALSE ;
	  }
break;
case 581:
#line 2677 "t.y"
{ CheckConstructorEP(yyvsp[-4],FALSE) ; 
	     FoundConstructorBody = FALSE ; }
break;
case 582:
#line 2680 "t.y"
{ CheckConstructorEP(yyvsp[-6],FALSE) ; 
	     FoundConstructorBody = FALSE ; }
break;
case 583:
#line 2683 "t.y"
{ foundargs = TRUE ; 
	     CheckConstructorEP(yyvsp[-5],FALSE) ; 
	     FoundConstructorBody = FALSE ; }
break;
case 584:
#line 2689 "t.y"
{    CheckConstructorEP(yyvsp[-4],TRUE) ; }
break;
case 585:
#line 2691 "t.y"
{ FoundConstructorBody = TRUE ; }
break;
case 586:
#line 2694 "t.y"
{    CheckConstructorEP(yyvsp[-6],TRUE) ; }
break;
case 587:
#line 2696 "t.y"
{ 	FoundConstructorBody = TRUE ; }
break;
case 588:
#line 2699 "t.y"
{    foundargs = TRUE ; CheckConstructorEP(yyvsp[-5],TRUE) ; }
break;
case 589:
#line 2701 "t.y"
{ FoundConstructorBody = TRUE ; }
break;
case 628:
#line 2841 "t.y"
{ yyval = yyvsp[0]; }
break;
case 629:
#line 2842 "t.y"
{ yyval = yyvsp[0]; }
break;
case 632:
#line 2848 "t.y"
{yyval=yyvsp[0];}
break;
case 633:
#line 2852 "t.y"
{ yyval = yyvsp[0]; }
break;
case 634:
#line 2853 "t.y"
{ yyval = yyvsp[-1]; }
break;
case 654:
#line 2910 "t.y"
{ yyval = yyvsp[0]; }
break;
case 655:
#line 2911 "t.y"
{ yyval = yyvsp[0]; FoundParms = FALSE ;}
break;
case 656:
#line 2922 "t.y"
{ yyval = yyvsp[0]; }
break;
case 657:
#line 2924 "t.y"
{ if ( FoundHandle ) {
		if ( CurrentCharmType == CHARE ) 
			InsertHandleTable(ChareHandleTable,&ChareHandleTableSize,yyvsp[0]);
		else if ( CurrentCharmType == BRANCHED )
			InsertHandleTable(BOCHandleTable,&BOCHandleTableSize,yyvsp[0]) ;
		else if ( CurrentCharmType == ACCUMULATOR )
			InsertHandleTable(AccHandleTable,&AccHandleTableSize,yyvsp[0]) ;
		else if ( CurrentCharmType == MONOTONIC )
			InsertHandleTable(MonoHandleTable,&MonoHandleTableSize,yyvsp[0]) ;
		else if ( CurrentCharmType == WRITEONCE )
			InsertHandleTable(WrOnHandleTable,&WrOnHandleTableSize,yyvsp[0]) ;
		FoundHandle = FALSE ;
	    }
	    yyval = yyvsp[0] ;
	  }
break;
case 659:
#line 2945 "t.y"
{ yyval = yyvsp[-1]; }
break;
case 661:
#line 2948 "t.y"
{ yyval = yyvsp[-2] ; }
break;
case 674:
#line 2996 "t.y"
{ FoundParms = TRUE ; }
break;
case 686:
#line 3020 "t.y"
{ strcpy(CurrentAsterisk,"*") ; }
break;
case 687:
#line 3021 "t.y"
{ strcpy(CurrentAsterisk,"&") ; }
break;
case 688:
#line 3022 "t.y"
{	CheckCharmName() ;	
			if ( CurrentCharmType == -1 ) 
			   CharmError("sequential types can't have handles");
			else 
			   FoundHandle = TRUE ;
		   }
break;
case 689:
#line 3031 "t.y"
{ if ( AddedScope > 0 ) {
							AddedScope = 0 ;
							PopStack() ;
						  }
						}
break;
case 691:
#line 3063 "t.y"
{ 	yyval = yyvsp[0] ; 
		AddOneScope(yyvsp[0]) ;
	  }
break;
case 692:
#line 3067 "t.y"
{ 	yyval = yyvsp[0] ; 
		AddOneScope(yyvsp[0]) ;
	  }
break;
case 693:
#line 3075 "t.y"
{ 	yyval = (char *)malloc(sizeof(char)*(strlen(yyvsp[-1])+3)) ;
		strcpy(yyval,yyvsp[-1]) ;
		strcat(yyval,yyvsp[0]) ; 
	  }
break;
case 694:
#line 3080 "t.y"
{ 	yyval = (char *)malloc(sizeof(char)*(strlen(yyvsp[-2])+strlen(yyvsp[-1])+3)) ;
		strcpy(yyval,yyvsp[-2]) ;
		strcat(yyval,yyvsp[-1]) ; 
		strcat(yyval,yyvsp[0]) ; 
	  }
break;
case 695:
#line 3098 "t.y"
{ yyval = yyvsp[0] ; }
break;
case 696:
#line 3099 "t.y"
{ yyval = yyvsp[0] ; }
break;
case 697:
#line 3103 "t.y"
{ /*scan for upcoming name in file scope */ FoundGlobalScope=1 ; }
break;
case 700:
#line 3108 "t.y"
{ if ( AddedScope > 0 ) { 
				PopStack() ;		
				AddedScope = 0 ;
			  }
			}
break;
case 701:
#line 3113 "t.y"
{ if ( AddedScope > 0 ) { 
					PopStack() ;		
					AddedScope = 0 ;
			  	  }
				}
break;
case 702:
#line 3129 "t.y"
{ 	yyval = yyvsp[0] ; 
		CheckSharedHandle(yyvsp[0]);
	  }
break;
case 703:
#line 3133 "t.y"
{ 	char *sptr, *sptr2, *lastcoln ;
		int ch, bo ;	
		EP *ep ;
		char errstr[128] ;

                if ( AddedScope > 0 ) { 
			PopStack() ;		
			AddedScope = 0 ;
		}

		yyval = (char *)malloc(sizeof(char)*(strlen(yyvsp[-1])+strlen(yyvsp[0])+3)) ;
		strcpy(yyval,yyvsp[-1]) ;
		strcat(yyval,yyvsp[0]) ; 

		CheckSharedHandle(yyvsp[0]);
		if ( SendType == -1 ) {
		    lastcoln = Mystrstr(yyvsp[-1],"::") ;
		    *lastcoln = '\0' ;
	
		    ch = FoundInChareTable(ChareTable,charecount+1,yyvsp[-1]) ;
		    bo = FoundInChareTable(BOCTable,boccount+1,yyvsp[-1]) ;
		    if ( ch != -1 || bo != -1 )  {
		        
			/* Now we have a Chare::EP pair */
			if ( ch != -1 )
				ep = SearchEPList(ChareTable[ch]->eps,yyvsp[0]) ;
			else if ( bo != -1 )
				ep = SearchEPList(BOCTable[bo]->eps,yyvsp[0]) ;
			if ( ep != NULL ) {
			  sptr = Mystrstr(OutBuf,"&") ; 
			  if ( sptr != NULL ) {
				*sptr = ' ' ; /* remove ampersand */
			  	sptr2 = Mystrstr(sptr,yyvsp[-1]) ;
			  	if ( sptr2 != NULL ) 
				  	*sptr2 = '\0' ;
			  	else 
				  	fprintf(stderr,"TRANSLATOR ERROR in handle usage, %s, line %d\n",CurrentFileName,CurrentLine) ;
			  	FLUSHBUF() ;
			  	fprintf(outfile,"_CK_ep_%s_%s",yyvsp[-1],yyvsp[0]) ;
				
				strcpy(LastChare,yyvsp[-1]) ;
				strcpy(LastEP,yyvsp[0]) ;
			  }
			}
		    }
		}
	  }
break;
case 704:
#line 3183 "t.y"
{ 	yyval = yyvsp[0] ; }
break;
case 705:
#line 3184 "t.y"
{ 	if ( AddedScope > 0 ) { 
						PopStack() ;		
						AddedScope = 0 ;
					}
				}
break;
case 707:
#line 3193 "t.y"
{ yyval = yyvsp[0] ; }
break;
case 708:
#line 3210 "t.y"
{ yyval = yyvsp[0] ; }
break;
case 709:
#line 3211 "t.y"
{ yyval = yyvsp[0] ; }
break;
case 712:
#line 3228 "t.y"
{ yyval = (char *)malloc(sizeof(char)*(strlen(yyvsp[-1])+strlen(yyvsp[0])+1)) ;
	  strcpy(yyval,yyvsp[-1]) ;
	  strcat(yyval,yyvsp[0]) ; 
	  strcpy(CurrentTypedef,yyval) ;
          if ( AddedScope > 0 ) { 
		  PopStack() ;		
		  AddedScope = 0 ;
	  }
	}
break;
case 713:
#line 3240 "t.y"
{ yyval = yyvsp[0] ; }
break;
case 714:
#line 3242 "t.y"
{ 	yyval = yyvsp[0] ; 
		strcpy(CurrentTypedef,yyvsp[-1]) ;
		strcat(CurrentTypedef,yyvsp[0]) ;
	  }
break;
case 715:
#line 3247 "t.y"
{ 	yyval = yyvsp[0] ; 
		strcpy(CurrentTypedef,yyvsp[-1]) ;
		strcat(CurrentTypedef,yyvsp[0]) ;
	  }
break;
case 716:
#line 3254 "t.y"
{ yyval = yyvsp[0] ; }
break;
case 717:
#line 3255 "t.y"
{ yyval = yyvsp[0] ; }
break;
#line 8593 "y.tab.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug && 5 > yydebug)
            printf("yydebug: after reduction, shifting from state 0 to\
 state %d\n", YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                if (5 > yydebug)
                    printf("yydebug: state %d, reading %d (%s)\n",
                        YYFINAL, yychar, yys);
                else
                    YYDEBUG_LOOK_AHEAD(YYFINAL, yychar, yys, yyssp-yyss);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug && 5 > yydebug)
        printf("yydebug: after reduction, shifting from state %d \
to state %d\n", *yyssp, yystate);
#endif
    if (yyssp >= yyss + yystacksize - 1)
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
